<?php
	/*
		Author: Alex Nosurov
		Created: 13.01.20 
	*/
	
        require_once(dirname(__FILE__)."/path.php");
	require_once(proj_path."view/lang.php");
	require_once(proj_path."view/metadata.php");
	require_once(proj_path."contr/login.php");
	require_once(proj_path."utils/menu.php");

?>
<html lang="en">
	<head>
		<?php echo lang_html_load('html/standard_head.html', false, array("title" => project_title, "icon" => project_icon)); ?>
		<link href = 	"table_tree/css/style.css" rel="stylesheet">
		<link href = 	"table_tree/css/search.css" rel="stylesheet">
		<link href = 	"css/table.css" rel="stylesheet">
		<link href = 	"css/apap.css" rel="stylesheet">
		<?php echo lang_html_load('fu/index_head.html'); /* LOADSUB */ ?>
	</head>
	<body style='background: url("img/bg_<?php echo get_portal_name(); ?>.jpeg") no-repeat center center fixed;'> 
                <!-- table_tree -->
                <script src="js/table.js"></script>
	
		<div class='bg_cover'></div>
		<?php echo file_get_contents('html/standard_scripts.html'); ?>
		<div class="mc_page_cont" style="height: 100%;">  <!-- if put height to mc_page_cont - preview shown male -->
			<!-- header: row: logo, menu, login  -->
			<div class="mc_page_head">
				<?php echo lang_html_load('html/standard_body_start.html' ); ?>
			</div>
			<div class="mc_page_body mc_page_cont_hor" style="width: 100%;">  <!-- if put height to mc_page_cont - preview shown male -->
				<div class="mc_page_head" id="mi_main_menu_vert"></div>
				<div class="mc_page_body mc_page_cont">
					<div id="tt_table_tree_div" class='mc_page_body mc_tt_cont ttc_fullscreen'> <!-- NOTE: without this cont appears another horiz scr bar -->
						<?php echo lang_html_load('html/table.html' ); ?>
					</div>
				</div>
			</div>
		</div>

		<div id = 'kladovka' class='hidden'> <!-- just a div to hide stuff which is shown only temporarily; seems not nec, while add hidden instead -->
			<div id = "mi_load_image">  <?php echo lang_html_load('fu/index_html.html'); ?> </div> <!-- LOADSUB -->
		</div>

		<?php echo lang_html_load('fu/index_script.html'); /* LOADSUB */ ?>

		<script src="js/treeview.js"></script>
		<script type="text/javascript">
			var def_rec_id = <?php echo get_or_def($_GET,'id', get_or_def($_GET,'cid',0)); ?>; // use id or cid param DEFREC
			function show_edit_camp(id=0){
				var nu = call_php_sync("contr/main.php", {"action" : "show_edit_camp", "id" : id}, 'POST'); 
				var tabs = create_tabs([
					{name: "INFO", content: nu.resp_text, classname: "mc_info_tab"},
					{name: "COUNTRIES", content: "<div id = 'mi_set_country' class='mc_float_left'></div>", classname: "mc_country_tab"}
				]);
				ff_init(tabs);
				// 
				var troot = tabs.find("#mi_set_country");
				init_table_tree( troot );
				var resp = call_php_sync("contr/main.php", {"action" : "show_shops"}, 'POST');
				troot.html(resp.resp_text);
				tt_hide_all();
				//
				var ids = tabs.find("#nc_countries").val(); // hidden input in edit camp form
				select_ids( ids.split(";") );
				show_select_string(function(){ save_camp(id); }, '', tabs, lp("edit_camp"), check_upload_finished);
				if( id && !in_edit( camps.find_rec(id) ) )
					 $("#md_ss_ok").addClass("hidden");
			}

			function show_load_sub(client="mini"){
				fu_client = client; // goes to uh as json data
				show_select_string(update_detail, '', $("#mi_load_image"), lp("load_subjects"), check_upload_finished);
				set_fu_data();
			}
			function open_camp(){
				var rec = get_curr_camp();
				if(!rec.length) { alert(lp("no_campaign_selected"));return; } // NI
				var id = rec.data("id");
				var im_list = call_php_sync("contr/main.php", {"action" : "get_camp_subs", id: id}, 'POST');
				var sh_list = call_php_sync("contr/main.php", {"action" : "get_camp_shops",id: id}, 'POST');
				if(!rec.data("date_from")){ alert( "'"+lp("validity_date_from") + "' " + lp("not_set") ); return; }
				if(!rec.data("date_till")){ alert( "'"+lp("validity_date_till") + "' " + lp("not_set") ); return; }
				//if(!rec.data("dl_visual")){ alert( "'"+lp("visual_deadline") + "' " + lp("not_set") ); return; }
				//if(!rec.data("dl_produce")){ alert( "'"+lp("produce_deadline") + "' " + lp("not_set") ); return; }
				//if(!rec.data("dl_approve")){ alert( "'"+lp("approve_deadline") + "' " + lp("not_set") ); return; }
				if(im_list.resp_text.length<3) { alert(lp("no_images_added"));return; } // if no imgs - empty arr is returned "[]"
				if(!sh_list.resp_text) { alert(lp("no_stores_added")); return; }
				if( id && confirm(lpp("$open$ $campaign$ '$1'?", rec.data("name"))) ){ 
					wait_screen.add_operation("open_camp");
					$.ajax({
						method : 'POST',
						url : 'contr/main.php',
						data: {"action" : "open_camp", id: id}, 
						success: function(res){ 
							alert("Ok");
							camps.refresh(id);
						},
						complete: function(xhr, stat){	wait_screen.remove_operation("open_camp");	},
						error: function(j,e,p){ alert(lp("Error") + ": " + p); }
					});
				}
			}
			function close_camp(){
				var rec = get_curr_camp();
				if(!rec.length) { alert(lp("no_campaign_selected"));return; } // NI
				var id = rec.data("id");
				if( id && confirm(lpp("$close$ $campaign$ '$1'?", rec.data("name"))) ){
					wait_screen.add_operation("close_camp");
					$.ajax({
						method : 'POST',
						url : 'contr/main.php',
						data: {"action" : "close_camp", id: id}, 
						success: function(res){ 
							alert("Ok");
							camps.refresh(id);
						},
						complete: function(xhr, stat){	wait_screen.remove_operation("close_camp");	},
						error: function(j,e,p){ alert(lp("Error") + ": " + p); }
					});
				}
			}
			function save_camp(id){
				var panel = $("#md_ss_div");
				var fields = ff_params(panel);
				fields.countries = get_selected_files().join(";");
				$.ajax({
					"type": "POST",
					"url": "contr/main.php",
					"data": {action : "save_camp", id: id, fields: JSON.stringify(fields)},
					"success": function(res, dummy, request){
						camps.clear();
						camps.show(0, res);
					}
				});
			}
			function delete_camp(id, name){
				if(!confirm(lpp("$Delete$ $campaign$ '$1'?", name))) return;
				$.ajax({
					"type": "POST",
					"url": "contr/main.php",
					"data": {action : "delete_camp", id: id},
					"success": function(res, dummy, request){
						camps.clear();
						camps.show();
					}
				});
			}
			var camps;
			function in_edit(rec){return true; /*rec.data("camp_state")=="draft"; */} //   DEF EOC edit opened camp; fabr asked to enable edit opened camp; other opers are restricted in on_rec_sel()
			function set_upload_path(path){	$("#mi_user_path").val(path);} // LOADSUB
			function on_rec_sel(rec){
				set_upload_path("campaigns/" + rec.data("id") + "/"); 
				// BUL
				if(in_edit(rec)) 
					$(".bul_edit").removeClass("hidden"); 
				else
					$(".bul_edit").addClass("hidden"); 
				if( rec.data("camp_state")=="draft" ) $(".lbsp_open").removeClass("hidden"); else $(".lbsp_open").addClass("hidden"); // in EOC disable only 'open' btn if opened
				if( rec.data("camp_state")=="opened" ) $(".lbsp_close").removeClass("hidden"); else $(".lbsp_close").addClass("hidden"); 
				if( rec.data("camp_state")=="draft" ) $(".lbsp_del").removeClass("hidden"); else $(".lbsp_del").addClass("hidden");
			}
			// TODO: to main.js
			function on_show(){
				$("#table-"+alias_name).find(".td-"+alias_name+"-RES_detail").html("<button class='btn btn-primary mc_detail_btn'><i class='fas fa-caret-right'></i></button>");
				$(".td-"+alias_name+"-RES_detail").click( function(){ show_detail_click( $(this).closest(".data-row").data("id") ); } );
				// DEFREC
				if(def_rec_id){
					show_detail_click(def_rec_id);
					def_rec_id = 0; // avoid set def rec on each show
				}else
					$(".bul_edit").addClass("hidden"); // BUL; when no rec shown
			}

			// DETAIL_ROW
			// TODO: update/generalize this stuff in shops.php
			function render_lb(prm){ // TODO: move to main.js, used also by shops.php
					var header = $("<div class='lb_header'> <a href='contr/download.php?type=hires&id="+prm.id+"' title='"+lp("download_high_resolution")+"'> <i class='lb_dl_img fa fa-download hidden' ></i></a><i class='lb_del_img fa fa-trash' title='"+lp("delete")+"'></i><label class='lb_name' title='" + prm.name + "'>" + prm.name + "</label></div>");
					header.find(".lb_del_img").on("click", function(){  
						if(confirm(lpp("$Delete$ $image$?"))){
							if(!check_image_order(prm.id))return;
							call_php_sync("contr/main.php", {"action" : "delete_camp_sub", id: prm.id}, 'POST'); 
							$(".lb_div[data-id='" + prm.id + "']").remove();
						}
					});
					if(prm.hires_name){
						header.find(".lb_dl_img").removeClass("hidden");
					}
					var body = $("<div class='lb_tlbc_cont'></div>");
					body.click( function(){ show_preview(prm.id) } );
					var footer = $("<div class='mc_footer'><div class='lb_header'><label class='lb_name'>"+lp("category")+"</label><i class='mc_cat' title='"+lp("click_to_change")+"'>" + prm.category + "</i></div></div>");
					var footer1= $("<div class='lb_header'><label class='lb_name'>"+lp("priority")+"</label><i class='mc_pri_div' title='"+lp("click_to_change")+"'></i></div>");
					var footer2= $("<div class='lb_header'><label class='lb_name'>"+lp("usage")+"</label><i class='mc_usage_div' title='"+lp("image_usage_statistics")+"'>"+prm.usg+"</i></div>"); // USG
					footer.append(footer1);
					footer.append(footer2); // USG
					if("priority" in prm)
						draw_priority(prm.priority, footer1.find(".mc_pri_div"));
					var lb_div = $("<div class='lb_div' data-id='" + prm.id + "'>  </div>").append(header).append(body).append(footer);
					return lb_div;
			}
			function draw_priority(pri, parent){ 
				parent.find(".priority").remove();
				for(var i=1;i<5;i++) parent.append( $("<i class='cursor-pointer "+(i>pri?"far":"fas")+" priority fa-star' data-pri='" + i + "'></i>") );
				parent.data("pri", pri);
				parent.find(".priority").click(priority_click);
			}
			function category_click(){ 
				var id = $(this).closest(".lb_div").data("id"), cat = $(this).html();
				var resp = call_php_sync("contr/main.php", {"action" : "set_image_category", id: id, category: cat=="man"?"woman":"man"}, 'POST'); 
				$(this).html( resp.resp_text );
			}
			function priority_click(){ 
				var par = $(this).parent();
				var id = par.closest(".lb_div").data("id"), pri = par.data("pri"), prin = $(this).data("pri");
				pri = pri==prin?0:prin;
				call_php_sync("contr/main.php", {"action" : "set_image_priority", id: id, priority: pri}, 'POST'); 
				draw_priority(pri, par);
			}
			function show_detail(id){
				var dd = $(".ap_detail_div");
				dd.append("<div class='mc_subs_div lb_img_list_hor'></div>");
				var subs = dd.find(".mc_subs_div");
				var im_list = call_php_sync("contr/main.php", {"action" : "get_camp_subs", id: id}, 'POST');
				im_list = JSON.parse(im_list.resp_text);
				show_image_list(im_list, subs);
				subs.find(".lb_add").click( function(){ show_load_sub( "mini" ); });
				// BUL
				if(!in_edit(camps.find_rec(id)))
					dd.find(".lb_add").addClass("hidden");
			}
			function show_image_list(im_list, cont){
				cont.append( $("<div class='lb_add'><i class='fa fa-plus'></i> </div>") ); // add new
				for(var i = 0;i<im_list.length;i++){
					var lb = render_lb(im_list[i]);
					lb.find(".lb_tlbc_cont").append( create_boxed_image(im_list[i].src) );  // lb_toplb to find out top level lbc
					cont.append(lb);
				}
			}
			// additional data in json sent to fu (UploadHandler)
			var fu_client = "mini"; // mini/hires
			function set_fu_data(){
				//var id = cl_get_active_rec_id( $("#tt_table_tree_div") );
				var data = {category: $(".mc_man.active").length? "man":"woman", client: fu_client};
				$("#mi_fu_data").val( JSON.stringify(data) ); 
			}
			function check_image_order(id){
				var orders = JSON.parse(call_php_sync("contr/main.php", {"action" : "find_img_order", id:id}, 'POST').resp_text);
				if(orders.length){
					if(!confirm(lpp('$confirm_delete_orders$', orders.join(", "))))
						return 0;
					call_php_sync("contr/main.php", {"action" : "delete_orders", ids:JSON.stringify(orders) }, 'POST');
					alert("ok");
				}
				return 1;
			}

			var table_name = "camps", alias_name = "camps";
			function get_curr_camp(){ return $(".tc_thumbs_form").find(".data-row.active"); }
			$(document).ready( function(){
				set_ajax_error_handler(); // def err handler for ajax   ; 24.12.19 pass empty  because DEF FIND_ERR_MSG shows alert when find res empty
				//
				var fields = JSON.parse( call_php_sync("contr/main.php", {"action" : "get_table_fields", alias: alias_name, table: table_name}, 'POST').resp_text ); 
				camps = new Tablo(".tc_thumbs_form", $(".mc_search_panel"), table_name, fields.list, fields.search, 
					on_rec_sel, function(rec){show_edit_camp(rec.data("id"));}, alias_name);
				camps.ro_set("name", "asc");   // FIORD
				camps.on_show = on_show;
				camps.show(0, def_rec_id); // DEFREC

				// TODO: add clear wait_screen on ajax done
				// CRUD
				$(".lbsp_new").click( function(){show_edit_camp(0)} );
				$(".lbsp_edit").click( 
					function(){
						var rec = get_curr_camp();
						var sh_list = call_php_sync("contr/main.php", {"action" : "get_camp_shops",id: rec.data("id")}, 'POST');
						if(rec.length==1)
							show_edit_camp( rec.data("id") );
				});
				$(".lbsp_del").click( 
					function(){
						var rec = get_curr_camp();
						if(rec.length==1)
							delete_camp( rec.data("id"), rec.data("name") );
				});
				// LOADSUB
				$(".lbsp_rec_actions").append( $('<button type="button" class="lbsp_loadsub btn btn-primary btn-sm hidden"> <i class="fas fa-image mc_page_head" title="'+lp("subjects")+'"></i></button>') );
				$(".lbsp_rec_actions").append( $('<button type="button" class="lbsp_open btn btn-primary btn-sm hidden"> <i class="fa fa-play mc_page_head" title="'+lp("open")+'"></i></button>') );
				$(".lbsp_rec_actions").append( $('<button type="button" class="lbsp_close btn btn-primary btn-sm hidden"> <i class="fa fa-archive mc_page_head" title="'+lp("close")+'"></i></button>') );
				$(".lbsp_loadsub").click( function(){ if(get_rec_id()) show_load_sub( "mini" );	});
				$(".lbsp_open").click( open_camp );
				$(".lbsp_close").click( close_camp );
					
				var mw = create_tabs([ {name:"WOMAN", classname: "mc_woman", content: "<i></i>"}, {name:"MAN", classname: "mc_man", content: "<i></i>"} ]);
				mw.find(".mc_tab_tab").addClass("hidden");
				mw.find(".mc_tab_name").on("click", set_fu_data);
				set_fu_data();
				mw.insertBefore( $(".fileupload-buttonbar") );
				// BUL
				$(".lbsp_del, .lbsp_loadsub, .lbsp_open, .lb_add, .lb_close").addClass("bul_edit");  // .lbsp_edit: need it to see shops 
				// DEF SET_CAT set cat to already added img; done by cat click
				$(".tc_thumbs_form").on("click", ".mc_cat", category_click);
			});
		</script>
	</body>
</html>
