<?php
try{
	ob_start();
	require_once(dirname(__FILE__)."/../path.php");
	$temp_portal = isset($_GET["portal"])? $_GET["portal"]:""; // TEMP_USER
	require_once(proj_path."utils/db_mysql.php");
	require_once(proj_path."model/errors.php");  // register_error
	require_once(proj_path."model/db.php");
	require_once(proj_path."model/events.php"); // print_lbs
	require_once(proj_path."utils/log.php");
	require_once(proj_path."model/download.php"); // print_lbs
	ob_clean();

	log\set_log_file(log_path."download.log");


	if(isset($_POST["type"]) && $_POST["type"]=="triples"){
		$user_id = get_curr_user_id();
		$role = $user_id? ur_get_name():"";
		$camp_id = $_POST["camp_id"];
		$orders = json_decode( $_POST["orders"], true );
		$apps   = json_decode( $_POST["apps"], true );
		download_apps($apps, $orders, $camp_id, $role);
		return;
	}
	if(isset($_GET["link"])){ // EMAIL_LINK, dl whole order (now only for PRODUCTION)
		$link = read_link($_GET["link"]);
		if($link["target_type"]=="triples"){
			$order_id = $link["target_id"];
			$temp_user_id = $link["user_id"];
			$temp_user_role  = "PRODUCTION"; // NOTE: if need same links for other users - need put/get role to links table
			$camp_id = db\select_field("orders", "camp_id", "id=$order_id");
			download_apps([], [$order_id], $camp_id, "PRODUCTION");
		}else if( $link["target_type"]=="hires_zip"){
			download_hires_zip($link["target_id"]);
		}
		return;
	}

	if(!isset($_GET["type"]))
		throw new user_exception("download type not set");
	if(!isset($_GET["id"]))
		throw new user_exception("download target not set");
	$type = $_GET["type"];
	$id= $_GET["id"];
	log\debug("download action: $type");

	if($type=="hires"){
		download_hires($id);
	}else if($type=="hires_zip"){
		download_hires_zip($id);
	}else if($type=="pdf"){
		download_pdf($id);
	}else if($type=="triple"){ // used also for EMAIL_LINK
		download_triple($id);
	}
}catch(user_exception $e){
	if($msg=$e->getMessage())
		register_error("Download error: $msg", "download", "download", $e->getGravity());
	echo lpp("<h3>".$e->getUserMessage()."</h3>");
}catch(Exception $e){
	$code = generate_random_string(4, "123456789"); // just a random code informed to used and written to log; thus user can identify to admin what to search in logs
	register_error("Download error $code: ".$e->getMessage(), "download", "download", el_higher);
	echo lpp("<h3>".'$unknown_error$ $code$: '.$code."</h3>");
}
?>
