<?php
/*
	this page is either included to another page (which need auth) or is used as a controller (pass action and call by ajax)
	uses ../login.php which contains login html code
*/
try{
	ob_start();
        require_once(dirname(__FILE__)."/../path.php");
        require_once(proj_path."utils/log.php");
        require_once(proj_path."model/errors.php");
        require_once(proj_path."model/db.php");
        require_once(proj_path."view/lang.php");
	ob_clean();

	log\set_log_file(log_path."contr.log");

if(session_id() == '')
	session_start();

$js_action = get_or_def($_POST, 'action', 'login');
log\info("controller action request: $js_action");

// DEF PARC page access right control
$page = basename($_SERVER['PHP_SELF'], ".php");
if( $r=ur_get_user_role_name() ) // if role already set
	if(in_array($page, get_restricted_pages()) && !in_array( $page, get_role_pages($r))){ // and page not allowed for the role
		//log\debug("PARC: ", $page);
		//log\debug( get_role_pages($r) );
		header("Location: ".base_url.proj_path_rel."index.php"); // go to index
	}
		

$is_admin = get_or_def($_SESSION, 'admin', false);
$is_worker = get_or_def($_SESSION, 'worker', false);
$ask_admin = isset($need_admin);	// each page which needs admin rights to be loaded needs just assign (to some value) $need_admin variable (before including this page)
//$ask_worker = isset($need_worker); DEF TDN temporarily disable in new proj but may be used later ; also To Do in New
$user_email = get_or_def($_SESSION, 'user_name');

//log\debug("LOGIN ACTION: ", $js_action, "lc: ", $_SESSION['LOGIN_CHECK']);

// this code forces to make login before showing original page; it's not called by ajax - just included into the original page
if($js_action=='login'){  // ~ check logged in?
	$domain = base_url;
	// params of request (if any)
	//$portal = get_or_def($_GET, "p");
	$portal = "depedrini";
	$role = get_role_name(get_or_def($_GET, "r"));
	$user_id = get_or_def($_GET, "uid");
	// DEF LOGINOUT: if login and request different portal/role/user - log out before login
	if( isset( $_SESSION['user_id'] ) && ur_get_name() ){ // NOTE: role is set after setting user_id, so need avoid this check in phase after login & before sel role
		if($portal && get_portal_name()!=$portal || $role && ur_get_name()!=$role || $user_id && !same_user($user_id, $_SESSION['user_id'] ) ){
			log\debug($portal, get_portal_name(), $role, ur_get_name(), $user_id, $_SESSION['user_id']); // DEF INOUT; used to logout if user clicks url with different credentials; NOTE: if url contains not allowed role - causes infinite login
			if( isset( $_SESSION['LOGIN_CHECK'] ) && $_SESSION['LOGIN_CHECK'] ){ // ININOUT ; user has just logged in ok, but requested params not correspond to 
				header("Location: $domain".proj_path_rel."index.php");
				exit(); 
			}else
				logout();
		}
	}
	// PLCP
	// PORTAL  NOTE: can't use db until set portal
	if( !get_portal_name() && !isset( $_SESSION['user_id'] ) && isset($_GET["p"]) ) 
		try_set_portal( $_GET["p"] );
	if( !get_portal_name() ){
		$location = ltrim( $_SERVER['REQUEST_URI'], "/" ); // already contains proj relative path (and unnecessary foreslash)
		header("Location: $domain".proj_path_rel."portal.php?location=".urlencode($location));
		exit(); // NEX
	}
	if( !isset( $_SESSION['user_id'] ) ){
		$location = ltrim( $_SERVER['REQUEST_URI'], "/" ); // already contains proj relative path (and unnecessary foreslash)
		// DEF REGNEW register if new ; if user clicks link and it's a new user (subscriber) - redirect it to the register page ; also mechanism to pass the requested link everywhere
		$log_user = preg_match("/[\?&]log_user=([^&]+)/", $location, $m)? $m[1] : ""; // TODO: why not use $_GET? 
		if($log_user && !user_exists($log_user)){ // TODO: here need not register
			header("Location: $domain".proj_path_rel."register.php?location=".urlencode($location)."&need_admin=$ask_admin");
			exit(); // TODO: DEF NEX necessary? this says yes: https://stackoverflow.com/questions/768431/how-to-make-a-redirect-in-php
		}
		header("Location: $domain".proj_path_rel."login.php?location=".urlencode($location)."&need_admin=$ask_admin");
		exit(); // NEX
	}
	// DEF SET_PERM_PASS if user has only temp path - oblige to set perm pass
	if(get_curr_user_id() && !db\select_field("users", "pass", "id=".get_curr_user_id()))
		header("Location: $domain".proj_path_rel."pass.php?location=".urlencode($location)."&need_admin=$ask_admin");
	// SEL_ROLE
	if( !isset( $_SESSION['role'] ) && isset($_GET["uid"]) && $role ){
		try_set_user_role($_GET["uid"], $role);
	}
	if( !isset( $_SESSION['role'] ) ){
		$location = ltrim( $_SERVER['REQUEST_URI'], "/" ); // already contains proj relative path (and unnecessary foreslash)
		header("Location: $domain".proj_path_rel."rolein.php?location=".urlencode($location)."&need_admin=$ask_admin");
		exit(); // NEX
	}
	// ?? means that if page requests admin but is not - then go to index?
	if($ask_admin&&!$is_admin){
		header("Location: $domain".proj_path_rel."index.php");
		exit(); // NEX
	}
	//else log\debug("already logged in ", $_SESSION["user_id"]); // TODO: TEMP
	// 24.08.22; moved it here (from PLCP); situation: user logs by url wir PIR but wants to use another credentials; new role not corresponds to url role, so sel role section is hit; it happens when LC = 0 (try_set_user_role fails)
	$_SESSION["LOGIN_CHECK"] = 0; // DEF ININOUT: if url contains role not allowed for user - then in INOUT happens infinite re-logout; set this flag to make INOUT know that it's passed after login check (not for the first time when user was logged in ok)
}

if($js_action=='print_logout'){ // TODO: this may be joined to login; need be called inside logout div; not forget that archive.js sets onlogout click
	if( isset( $_SESSION['user_id']) ){
		echo "<span class = 'mc_user'>".$_SESSION['user_name']."</span>";
		//echo "<div><span>".$_SESSION['user_name']."</span><i class='mc_user fas fa-user'></i>  <i id='tt_logout' title='log out' class = 'fas fa-sign-out-alt'></i> </div>";
	}
}

if($js_action=='logout'){
	logout();
}
// SET_PERM_PASS
if($js_action=="change_pass"){
	db\execute("update users set pass_temp='', pass='".$_POST["password"]."' where id = ".get_curr_user_id());
	/*$location = trim( get_or_def($_POST, 'location') ); TODO: not works
	if(!$location) */$location = base_url.proj_path_rel."index.php";
	header("Location: $location");  // go to source page (index); it will pass again "login" block;
}

// PORTAL ; now it only adds portal to url continues to the requested page
if($js_action=='set_portal'){
	$portal = $_POST["portal"];
	//$_SESSION["portal"] = $portal;
	$location = trim( get_or_def($_POST, 'location') );
	if(!$location) $location = proj_path_rel."index.php";
	$domain = base_url;
	header("Location: $domain$location".(strpos($location, "?")?"&":"?")."p=$portal");  // go to source page (index); it will pass again "login" block;
}
// this is called by form from login.php (no ajax) and redirects to the $_POST['location'] page
if($js_action=='login_check'){
	$_SESSION["LOGIN_CHECK"] = 1; // ININOUT
	/*
		input: POST:
			user
			pass
			location - that which need to hit login.php
		result:
			saves id to session
			recalls source page
	*/
	// form data
	$user = $_POST['user_name'];
	$pass= $_POST['password'];
	$location = get_or_def($_POST, 'location', proj_path_rel.'index.php');
	$user_id = find_user($user,$pass);
	if($user_id){
		setup_user_session($user_id); // TODO: if user logs in but requested port/role not corresp to factual - logs out again (infinitely); only need to empty req params to avoid it (which user may not guess); by idea need remove portal/role params from req in XX 
	}else
		$_SESSION["login_fail"] = 1; // LOGIN_FAIL
	// return to source page
	$domain = base_url; // location (from REQUEST_URI) already contains leading slash
	// each page includes contr/login.php, so the control goes gere again, with def action = login; if id is empty - login page will be called again  XX
	header("Location: $domain$location"); 
}
// SEL_ROLE
if($js_action=='set_role'){
	$role = $_POST["role"]; // group id or user id
	$id = $_POST["id"]; // group id or user id
	try_set_user_role($id, $role);
	$location = get_or_def($_POST, 'location', proj_path_rel.'index.php');
	$domain = base_url;
	header("Location: $domain$location");  // go to source page (index); it will pass again "login" block;
}
if($js_action=='register'){
	$name = db\escape2($_POST['user_name']);
	$email = db\escape2($_POST['user_email']);
	$location = get_or_def($_POST, "location"); // REGNEW
	if($location) $location = base_url.$location;
	log\info("create new user request: '$name' '$email'");
	if( db\exists("users", "email='$email' and  pass is not null") )
		throw new user_exception('email_use');
	/*if( db\exists("users", "name='$name' and  pass is not null") )
		//throw new Exception(lp("name_use"));
		throw new Exception("name_use");*/
	register_user($name, $email, $admin=0, $worker=0, $location);
}
if($js_action=='check_logged_in'){ 
	echo session_id() && isset( $_SESSION['user_id'] ) ? "1" : "0";
}
if($js_action=='restore_pass'){  // DEF FORGOT_PASS stuff to restore password
	$email = db\escape2($_POST['user_email']); // TDN: in login used name, get email from db
	$name = db\escape2($_POST['user_name']); // RESTORE_PASS_NAME
	try{
		restore_pass($email,$name);
	}catch(user_exception $e){
		echo lp($e->getUserMessage());
		return;
	}
	echo lp("password_sent");
}

}catch(user_exception $e){
	if($msg=$e->getMessage())
		log\error("user error: '$msg'");
	header($_SERVER['SERVER_PROTOCOL'].' 500 '.$e->getUserMessage(), true, 500);
}catch(Exception $e){
	$code = generate_random_string(4, "123456789"); // just a random code informed to used and written to log; thus user can identify to admin what to search in logs
	log\error("controller error $code; POST dump: ", array_to_str($_POST), $e->getTraceAsString() );
	register_error("Controller error $code: ".$e->getMessage(), "controller", "controller", el_higher);
	header($_SERVER['SERVER_PROTOCOL'].' 500 $unknown_error$ $code$: '.$code, true, 500);
	//return;
}

?>
