<?php
/*
        Author: Alex Nosurov
        Date: 29.08.19
        Description: main data necessary to build a page (like menu/footer...)
        Input: 
                'action': obligatory; specifies which data; values: 'menu'
        Using such scheme allows to use same ajax-call code in the main form for all menu handlers
        menu items codes are defined and used only here
*/
try{
	ob_start();
        require_once(dirname(__FILE__)."/../path.php");
        require_once(proj_path."view/lang.php"); // should be first
        require_once(proj_path."utils/utils.php");
        require_once(proj_path."utils/menu.php");
        require_once(proj_path."utils/view.php");
        require_once(proj_path."utils/filter_fields.php");
        require_once(proj_path."utils/table.php");
        require_once(proj_path."view/metadata.php"); 
        require_once(proj_path."model/errors.php");
        require_once(proj_path."model/db.php");
        require_once(proj_path."model/lb.php");
        require_once(proj_path."model/apap.php");
		require_once(proj_path."model/events.php");
		require_once(proj_path."model/utils.php");
        require_once(proj_path."view/apap.php");
        require_once(proj_path."table_tree/view/show_dir.php"); // show_tree_id
        require_once(proj_path."table_tree/model/db.php"); // tt data_fields
	ob_clean();

	function _show_table($table, $fields, $where='', $order='', $alias='', $limit='', $start=''){
		if( $alias=='' ) $alias = $table; // may be convenient to change source table name
		$fnames = array_keys( $fields );
		array_walk($fnames, function(&$val, $key){ if(starts_with($val, "RES_")) $val = "'' as $val"; }); // CB_SEL_REC_WS: CB_SEL_REC support: cols named RES_* are dummy cols to display checkboxes, so do not fetch data from db for them
		db\select($table, join(',',$fnames), $where, $order, "", $limit, $start); 
		echo render_table($alias, $fields, db\response_to_array() );
	}
	// TODO: move this func to tt/project.php
	function set_table_fields($table, $alias, &$search_fields, &$list_fields){
		if($alias=="users"){ global $user_search_fields, $user_list_fields; $search_fields = $user_search_fields; $list_fields = $user_list_fields; }
		if($alias=="shops"||$alias=="shops_camp"){ 
			global $shop_list_fields; $list_fields = $shop_list_fields; 
			//log\debug( ur_get_user_role()["shops"] );
			$search_fields = get_shop_search_fields(db\select_to_array("shops","area,country,city,name,id", db\id_in(ur_get_user_role()["shops"]), "area") ) ;
		}
		if($alias=="shops"){  $search_fields = array_merge($search_fields, get_shop_search_fields_admin( db\select_field_to_array("groups", "name", "user_role='LOCAL_VISUAL'"), db\select_field_to_array("groups", "name", "user_role='PRODUCTION'")  ) ); }
		if($alias=="shops_camp"){ global $shop_search_fields_camp; $search_fields = array_merge($search_fields, $shop_search_fields_camp); }
		if($alias=="shops"){
			unset($list_fields["lbc_todo_count"]);
			unset($list_fields["lbc_count"]);
			unset($list_fields["order_id"]);
		}else{ // shops_camp
			unset($list_fields["visual"]);
			unset($list_fields["production"]);
		}
		if($alias=="camps"){ global $camp_search_fields, $camp_list_fields; $search_fields = $camp_search_fields; $list_fields = $camp_list_fields; }
		if($alias=="apv"  ){ global $apf_search_fields,  $apf_list_fields;  $search_fields = $apf_search_fields;  $list_fields = $apf_list_fields; } // TODO: not used now
		if($alias=="app_lbs"){ global $triple_search_fields,  $triple_list_fields;  $search_fields = $triple_search_fields;  $list_fields = $triple_list_fields; } 
		if($table=="v_orders_state" || $table=="v_orders_state1" || $table=="v_orders_state1_arch"){
			$search_fields = get_order_search_fields(db\select_to_array("shops","area,country,city,name,id", db\id_in(ur_get_user_role()["shops"]), "area,country,city,name") ) ;
			$list_fields = get_order_list_fields($alias);
		}
		//
		if($alias=="groups"){ global $group_list_fields, $user_search_fields; $list_fields = $group_list_fields; $search_fields=$user_search_fields; }
		if($alias=="events"){ global $event_list_fields, $event_search_fields; $list_fields = $event_list_fields; $search_fields=$event_search_fields; }
	}

	function mse($var){ return must_be_set($_POST, $var); }
	function gde($var, $def=''){ return get_or_def($_POST, $var, $def); }
	function ise($name){ return isset($_POST[$name]); }

	log\set_log_file(log_path."contr.log");

	$action = mse('action');
	log\info("controller action request: $action");
        $cond = gde('cond'); // it's here while many use it; where it's obligatory - must be duplicated with mse()
	//
	if( isset( $_POST['quiet'] ) )
		log\set_log_level('quiet');

	//if(isset($_SESSION['user_id'])){unset($_SESSION['user_id']);	unset($_SESSION['user_name']);}  // TEMP TEST LOGONEXP TODO: not works unset!

while(true){ // this is only to use break
	// LANG  lang funcs may be requested without user, so it must be before user_id check
	// read translations
	if($action=="lang_read"){
		$lang_tr = lang_read();
		echo json_encode( $lang_tr );
		break;
	}
	if($action=="lang_list"){
		global $lang_list;
		$res = array();
		foreach($lang_list as $code => $capt)
			$res[] = array("code" => $code, "name" => $capt, "img" => "img/$code.png");
		echo json_encode($res);
		return;
	}
	if($action=="lang_change"){
		lang_set(mse("lang"));
		if( get_curr_user_id() )
			save_settings(  get_curr_user_id(), array( "lang" => mse("lang") ) ) ; // 5/5/2022 save lang in db
		return;
	}
	if($action=="lang_get"){
		echo lang_get(); 
		return;
	}
	if($action=="lang_get_db"){
		$db = lang_get_db(get_curr_user_id()); 
		echo $db? $db : lang_def;
		return;
	}

	$user_id = get_curr_user_id();
	if(!$user_id || session_status()==PHP_SESSION_NONE) // LOGONEXP
		throw new user_exception('no_user');
		//throw new user_exception('$no_user$');
	
        // MAIN MENU
	if( $action=='menu'){
		$is_admin = check_admin($user_id);
		echo render_menu(get_main_menu($is_admin));
		break;
	}
	if( $action=='menu_vert'){
		global $mainmenu;
		$role = ur_get_user_role();
		$menu_items = array_intersect_key( $mainmenu, array_flip( get_role_pages( $role["role"] ) ) );
		//log\debug(get_role_pages( $role["role"] ));
		echo render_menu_hl($menu_items); // UR
		break;
	}
	if( $action=='mobile_menu_list' ){ // this only issues list (not html); then js builds a standard popup menu; NOTE: TODO:  would be better to use a menu that works both in mobile and desktop mode, only that in momo need incapsulate whole menu in single root item;
		echo json_encode( get_main_menu_mobile() ); break;
	}

	if( $action=='menu_click'){
		$handler = mse('handler');
		echo "$handler was clicked\n";
		break;
	}
	// SET_ADMIN  checks if user is admin
	if($action=="admin"){
		if(session_id() == '')
			session_start();
		echo get_or_def($_SESSION, 'admin', 0)? '1': '0'; break;
	}
	// UR
	if( $action=='ur_get_user_role'){
		echo json_encode(ur_get_user_role());
		break;
	}
	if( $action=='tips'){
		break;
	}
	
	// ----------------------- TT TABLETREE -----------------------------

	if($action=="show_table"){
		$table = mse("table");
		$alias = gde("alias", $table); // eg may use view v_shop_camp_1 but want fields for "shops"; alias must be "shops"
		$where = gde("where");
		set_table_fields($table, $alias, $search_fields, $list_fields);
		if($where){
			$where_arr = json_decode($where, true);
			$where = db\compile_where(  get_where_array( $search_fields , $where_arr ) );
			// DEF FULLTEXT: used to make search in all fields by given crit; used for quicksearch field; it should have id = 'FULLTEXT'
			if( sizeof($where_arr)==1 && isset($where_arr["FULLTEXT"]) ){
				foreach($search_fields as &$sf){
					$sf["operation"] = "like"; 
					$sf["string"] = "1"; 
					$sf["value"] = $where_arr["FULLTEXT"]; 
				}
				log\debug("FULLTEXT");
				//log\debug($search_fields);
				$where = db\compile_where( $search_fields , "OR" );
				log\debug($where);
			}
		}
		//log\debug($search_fields);
		$cond = gde("cond"); $wc = array(); if($cond) $wc[]="($cond)"; if($where) $wc[]="($where)"; $where=join(" and ",$wc );
		// TABCOL
		//log\debug($list_fields);
		//log\debug(gde("columns"));
		filter_user_cols($list_fields, gde("columns"));
		//
		if(gde("get_count"))
			header("count:".db\select_field($table, "count(*)", $where) );
		// if($table=="shops" && check_unblock_flag("update_shop_roles")) update_shop_roles(); // USR   NOT USED IN SHOP_SINGLE_GROUP version
		echo _show_table($table, $list_fields, $where, gde("order"), $alias, gde("limit"), gde("start") );
		return;
	}

	// DEF DEF_PAGE: 31.05.22 found a bug: if def rec isn't on the first page - it's not shown;
	// this call is made to determine page num
	// params: id, table, where, order
	if($action=="get_rec_pos"){
		$where = gde("where");
		if($where){
			$where_arr = json_decode($where, true);
			$where = db\compile_where(  get_where_array( $search_fields , $where_arr ) );
		}
		$cond = gde("cond"); $wc = array(); if($cond) $wc[]="($cond)"; if($where) $wc[]="($where)"; $where=join(" and ", $wc);
		//
		$ids = db\select_field_to_array( mse("table"), "id", $where, gde("order") );
		//log\debug($ids);
		$pos = array_search( mse("id"), $ids );
		echo $pos? $pos : "0";
		return;
	}

	// -------------------- USERS --------------------------

	// CRUD USER
	// DEF EDIT_USER stuff to add/edit user
	if($action=="show_edit_user"){
		global $new_user;
		$id = gde("id"); // if id = 0 => create new; else - edit exiting
		$values = null;
		if($id){
			$usr = db\select_record("users", "*", "id=$id");
			$values = array(
				array("id" => "nu_name", "default" => $usr["name"]),
				array("id" => "nu_email", "default" => $usr["email"]),
				array("id" => "nu_pass", "default" => $usr["pass"]),
				//array("id" => "nu_user_role", "default" => $usr["user_role"])
				array("id" => "nu_user_role", "default" => preg_split("/;/", $usr["user_role"], -1, PREG_SPLIT_NO_EMPTY))  // MULTI_ROLE
			);
			$ugr=db\select_field_to_array("groups", "id", db\in_list("email", $usr["email"]) ); // SEL_GROUP_ROLES
			//$values[]=array("id" => "nu_user_group_role", "default" => join(";",$ugr)); // SHOW_GROUP_ROLES
			$values[]=array("id" => "nu_user_group_role", "default" => $ugr); // SEL_GROUP_ROLES
		}
		$values[]= array("id" => "nu_lang", "default" => lang_get_db($id, lang_def));  // ADM_EDIT_LANG
		find_array_key_val($new_user, "id", "nu_user_group_role")["keyval"] = db\select_id_field_to_array("groups", "id", "name", "user_role in ('LOCAL_VISUAL', 'PRODUCTION')", "name");
		echo render_search_form($new_user, $values, "plain");
		return;
	}
	// NOTE: now is used for groups
	if($action=="get_user_shops"){
		$user_id = mse("id");
		$role = mse("role");
		$field = role_to_field($role);
		echo json_encode( db\select_field_to_array("shops", "id", "$field=$user_id") );
		return;
	}
	// NOTE: now is used for groups
	if($action=="set_user_shops"){
		$user_id = mse("id");
		$role = mse("role");
		$field = role_to_field($role);
		$shops = json_decode( mse("shops"), true );
		$shops = preg_split("/;/", $shops, -1, PREG_SPLIT_NO_EMPTY);
		//   may happen role changed db\execute("update shops set $field=0 where $field=$user_id"); // remove prev selection (user may have unselected some shops)
		reset_user_shops($user_id);
		if(sizeof($shops))
			db\execute("update shops set $field=$user_id where ". db\id_in($shops)) ;
		return;
	}

	if($action=="save_user"){
		$user_id = mse("id");
		$users_table = array( "name" => array("length" => 50, "can_truncate"=>1) );
		$fields = json_decode( mse("fields"), true );
		//log\debug($fields); return;
		// SEL_GROUP_ROLES
		$ugr = get_or_def($fields, "user_group_role", array());
		unset( $fields["user_group_role"] );
		// ADM_EDIT_LANG
		$lang = get_or_def($fields, "lang", lang_def);
		unset( $fields["lang"] );
		//
		if(isset($fields["user_role"]) && is_array($fields["user_role"]) ) // DEF MULTI_ROLE user may have several roles; js passes as array
			$fields["user_role"] = join(";", $fields["user_role"]);
		if(!isset($fields["user_role"]) ) // js not passes empty role, so it not goes to sql and not emptied
			$fields["user_role"] = "";
		//log\info($fields);
		if(db\exists("users_users", "name='".$fields["name"]."' and id<>$user_id")) throw new user_exception('$user$ $name_exists$');
		if(db\exists("users_users", "email='".$fields["email"]."' and id<>$user_id")) throw new user_exception('$user_email_exists$');
		if($user_id){
			db\execute("update users set ".db\compile_update($fields, $users_table)." where id='$user_id'"); 
		}else{
			$fields["pass_temp"] = $fields["pass"]; $fields["pass"] = "";
			db\execute("insert into users ".db\compile_insert($fields, $users_table));
			$user_id = db\get_last_id();
		}
		// SEL_GROUP_ROLES
		$groups = db\select_id_field_to_array("groups", "id", "email", "user_role in ('LOCAL_VISUAL', 'PRODUCTION')", "name");
		$user_email = db\select_field("users", "email", "id=$user_id");
		// iterate and correct if necessary all groups
		foreach($groups as $group_id => $email){
			if( in_array( $group_id, $ugr) ){ // if user must be in group
				if( strpos($email, $user_email)===false) // but is not
					db\execute("update groups set email = '".add_sep_elem($email, $user_email)."' where id = $group_id");
			}else{ // if user mustn't be in group
				if ( strpos($email, $user_email)!==false ) // but is in
					db\execute("update groups set email = '".remove_sep_elem($email, $user_email)."' where id = $group_id");
			}
		}
		// ADM_EDIT_LANG
		save_settings($user_id, array("lang" => $lang));
		echo $user_id;
		return;
	}
	if($action=="delete_user"){
		$id = mse("id");
		// delete from groups
		$email = db\select_field("users", "email", "id=$id");
		$ugs = db\select_to_array("groups", "id,email", "email like '%$email%'");
		foreach($ugs as $ug){
			$ge = preg_split("/;/", $ug["email"], -1, PREG_SPLIT_NO_EMPTY);
			$ge = array_diff($ge, array($email));
			$ge = join(";", $ge);
			db\execute("update users set email = '$ge' where id = ".$ug["id"]);
		}
		db\execute("delete from users where id='$id'"); 
		return;
	}
	// checks which restriction has deleting user; now returns arr of groups where it partic
	if($action=="check_user_delete"){
		$email = db\select_field("users", "email", "id=".mse("id"));
		$groups = db\select_field_to_array("groups", "name", db\in_list("email", $email) );
		echo json_encode( array("groups" => $groups) );
		return;
	}
	if($action=="send_credentials"){
		send_credentials(mse("id"));
		return;
	}

	// -------------------- SHOP --------------------------

	// CRUD SHOP 

	// DEF EDIT_SHOP stuff to add/edit shop
	if($action=="shop_edit_dialog"){
		$new_shop = get_new_shop_fields( 
			db\select_id_field_to_array("groups", "id", "name", "user_role='LOCAL_VISUAL'", "name"),
			db\select_id_field_to_array("groups", "id", "name", "user_role='PRODUCTION'", "name")
		);
		$id = gde("id");
		$val = null;
		if($id){
			$rec = db\select_record("shops", "*", "id=$id");
			$val = array(); foreach($rec as $fn=>$fv) $val[]=array("id"=>"ns_$fn", "default"=>$fv);
		}
		log\debug($val);
		echo render_search_form($new_shop, $val, "plain");
		return;
	}
	if($action=="locations"){
		echo json_encode( array("area" => 	db\select_field_to_array("shops", "distinct area x", "area is not null", "x"),
								"country" => 	db\select_field_to_array("shops", "distinct country x", "country is not null", "x"),
								"city" => 	db\select_field_to_array("shops", "distinct city x", "city is not null", "x")
							) );
		return;
	}

	if($action=="shop_save"){
		$id = mse("id");
		$shops_table = array( "name" => array("length" => 50, "can_truncate"=>1) );
		$fields = json_decode( mse("fields"), true );
		//log\info($fields);
		if(db\exists("shops", "code='".$fields["code"]."' and id<>$id")) throw new user_exception('$store_code_exists$');
		if(db\exists("shops", "name='".$fields["name"]."' and city='".$fields["city"]."' and id<>$id")) throw new user_exception('$store_name_city_exists$');
		if($id){
			db\execute("update shops set ".db\compile_update($fields, $shops_table)." where id='$id'"); 
		}else{
			db\execute("insert into shops ".db\compile_insert($fields, $shops_table));
			$id = db\get_last_id();
		}
		echo $id;
		return;
	}
	if($action=="shop_delete"){
		$id = mse("id");
		db\execute("delete from shops where id='$id'"); 
		db\execute("delete from lbc where shop_id='$id'"); 
		// lbs are deleted in DELBS
		return;
	}
	// DOO
	if($action=="find_shop_order"){
		$order = db\select_record("v_orders", "id, camp_name", "shop_id=".gde("id"));
		if($order) echo json_encode($order);
		return;
	}

	if($action=="find_img_order"){
		$orders = db\select_field_to_array("v_orders", "id", "shop_id in (select shop_id from v_lbs where img_id=".gde("id").")");
		echo json_encode($orders);
		return;
	}

	if($action=="get_table_fields"){
		set_table_fields(gde("table"), gde("alias"), $search_fields, $list_fields);
		//$fields = array("list" => array_keys($list_fields), "search" => render_search_form($search_fields) );
		$fields = array("list" => $list_fields, "search" => render_search_form($search_fields) );
		echo json_encode($fields);
		return;
	}
	if( $action=='create_shop_camp_view'){
		echo create_shop_camp_view(mse("camp_id"));
		return;
	}

	// APPROVES DEF APAP
	if($action=="ap_image"){
		$id = mse("id");
		$scale_num = mse("scale_num");
		$img = db\select_record("approves", "*", "id=$id");
		$scales = array("100", "75", "50", "25");
		$scale = $scales[$scale_num];
		$img["url"] = $scale_num==0? get_files_path().$img["path"] : get_files_path().add_suffix($img["path"], "_".$scale );
		$img["width"] = $img["width"]*$scale/100;
		$img["height"] = $img["height"]*$scale/100;
		$img["zoom"] = $scale;
		echo json_encode($img);
		return;
	}
	if($action=="ap_pages"){
		$name = db\select_field("approves", "name", "id=".mse("id"));
		$pages = db\select_to_array("approves", "page,path,id", "name='".db\escape($name)."'"); // TODO: thus gives all files with this name; need also check path
		$res = array();
		foreach($pages as $page){
			$res[]= array( "id" => $page["id"], "url" => add_suffix(get_files_path().$page["path"], "_25") );
			break; // now only first page TODO TEMP?
		}
		echo json_encode($res);
		return;
	}

	if($action=="pin_render_empty"){
		$pin = json_decode( mse("pin") , true);
		$pin["owner"] = get_user_info("name");
		db\execute("insert into pins " . db\compile_insert($pin));
		$pin = db\select_record("pins", "*", "id = " . db\get_last_id() );
		echo pin_render($pin);
		return;
	}

	if($action=="pin_read_all"){
		$pid = mse("app_id");
		$pins = db\select_to_array("pins", "*", "app_id=$pid and txt<>'' and txt is not null");
		foreach($pins as $pin)
			echo pin_render($pin);
		return;
	}

	if($action=="pin_save"){
		$pin = json_decode( mse("pin"), true );
		db\execute("update pins set " . db\compile_update($pin) . "where id = ".$pin["id"]);
		//db\execute("insert into pins " . db\compile_insert($pin));
		return;
	}
	// as new emtpy pin is added on image - also empty rec inserted into db; need del not saved
	if($action=="pin_del_empty"){
		db\execute("delete from pins where txt='' or txt is null");
		return;
	}
	if($action=="pin_delete"){
		db\execute("delete from pins where id = " . mse("id"));
		return;
	}

	if($action=="draw_save"){
		$draw = json_decode( mse("draw"), true );
		$id = $draw["id"];
		unset($draw["id"]);
		if($id)
			db\execute("update draws set " . db\compile_update($draw) . "where id = $id");
		else{
			db\execute("insert into draws" . db\compile_insert($draw));
			echo db\get_last_id();
		}
		return;
	}
	if($action=="draw_read_all"){
		$app_id = mse("app_id");
		echo json_encode( db\select_to_array("draws","*","app_id=$app_id") );
		return;
	}
	if($action=="draw_delete"){
		db\execute("delete from draws where id = " . mse("id"));
		return;
	}


	if($action=="get_img_list"){
		$camp_id = mse("camp_id");
		$imgs = db\select_to_array("files", "id,path,name,priority,category", "path like '%/$camp_id/'", "priority desc,name");
		array_unshift($imgs, db\select_record("files", "id,path,name,0 as priority, 'noimage' as category", "id=0")); // DEF NOIMAGE - indicate that img not changes in an order; TODO: show prev images instead
		$res = "";
		foreach($imgs as $img){
			$img["url"] = get_files_path().$img["path"].get_file_thumb_path($img["id"], $img["name"]);
			$img["pri_img"] = str_repeat("<i class='cursor-pointer fas fa-star'></i>", $img["priority"]);
			$res .= lpp_html(replace_keys(file_get_contents(template_path."image"), $img, 3));
		}
		echo $res;
		return;
	}
	if($action=="set_image_priority"){
		db\execute("update files set priority=".mse("priority")." where id = ".mse("id"));
		return;
	}
	if($action=="set_image_category"){
		db\execute("update files set category='".mse("category")."' where id = ".mse("id"));
		echo mse("category"); // if ok - return new val
		return;
	}

	// -------------------- LB LBC ------------------------------
	// create / edit lbc
	if($action=="lb_save"){
		$lb = json_decode(mse("data"), true);
		$id = $lb["id"];
		if($id)
			lb_update($lb, $id);
		else
			$id = lb_create($lb);
		return;
	}
	if( $action=='lb_delete'){
		lb_remove( mse("id") );
		return;
	}
	if($action=="get_shop_lbc"){
		echo json_encode( lb_get_shop(mse("shop_id")) );
		return;
	}
	if($action=="get_cont_childs"){
		echo json_encode( lb_get_childs(mse("id")) );
		return;
	}
	if($action=="lb_join"){
		lb_join(mse("lb1_id"), mse("lb2_id"), mse("isvert"));
		return;
	}

	if($action=="lbs_create"){
		lbs_create( mse("data") );
		return;
	}
	if($action=="lbs_update"){
		lbs_update_image(mse("id"), mse("img_id") );
		return;
	}
	if($action=="get_lbs"){
		echo json_encode( lbs_get_lb(mse("lb_id"), mse("camp_id") ) );
		return;
	}
	if( $action=='lbs_delete'){
		lbs_remove(mse("id"));
		return;
	}


	// SEL_CITY cities 
	if($action=="show_shops"){
		$cond= gde("cond");
		//$group_id=mse("group_id"); $role=mse("group_role"); $field = $role=="LOCAL_VISUAL"? "visual" : "production"; $cond="$field=0 or $field=$group_id";
		$cs = db\select_to_array("shops_path","*",$cond,"path");
		$cst = explode_tree_id($cs, false); // utils.php
		$csd = array("files" => $cs);
		show_tree_id($cst, $csd, $show_files=true, $show_root=false);
		return;
	}
		
	// -------------------- CAMPAIGN CAMP --------------------------

	// CRUD SHOP 
	// DEF EDIT_SHOP stuff to add/edit camp
	if($action=="show_edit_camp"){
		global $new_camp;
		$id = gde("id");
		$val = null;
		if($id){
			$rec= db\select_record("camps", "*", "id=$id");
			$val = array(); foreach($rec as $fn=>$fv) $val[]=array("id"=>"nc_$fn", "default"=>$fv);
		}
		echo render_search_form($new_camp, $val, "plain");
		return;
	}
	if($action=="save_camp"){
		$id = mse("id");
		$camps_table = array( "name" => array("length" => 50, "can_truncate"=>1) );
		$fields = json_decode( mse("fields"), true );
		global $new_camp;
		correct_date($fields, $new_camp);
		//log\info($fields);
		if($id){
			db\execute("update camps set ".db\compile_update($fields, $camps_table)." where id='$id'"); 
		}else{
			db\execute("insert into camps ".db\compile_insert($fields, $camps_table));
			$id = db\get_last_id();
		}
		echo $id;
		return;
	}
	// when all subjects are added - admin opens camp;
	if($action=="open_camp"){
		open_camp(mse("id"));
		return;
	}
	if($action=="close_camp"){
		close_camp(mse("id"));
		return;
	}
	if($action=="delete_camp"){
		$id = mse("id");
		if(!db\exists("camps", "id=$id AND camp_state='draft'")) return; // TODO: throw
		db\execute("delete from camps where id='$id'"); 
		return;
	}
	if($action=="get_all_camp_fields"){
		echo json_encode(array_keys($camp_list_fields));
		return;
	}

	if($action=="get_camp_subs"){
		$id = mse("id");
		$files = array();
		$hr="";
		$files = db\select_to_array("files f", "path,name,id,category,priority,(select count(*) from lbs where lbs.img_id=f.id) usg", "path like 'campaigns/$id/%'"); // DEF USG show img usage
		foreach($files as &$file) $file["src"] = get_files_path().$file["path"].$file["name"];
		echo json_encode($files);
		return;
	}

	if($action=="delete_camp_sub"){
		db\execute("delete from files where id = ".mse("id"));
		db\execute("delete from lbs where img_id = ".mse("id"));
		return;
	}

	if($action=="get_camps_cb"){
		/*$role = ur_get_user_role["role"];
		if( is_group_role( $role ) )
			$camps = array_filter( $camps, function($camp){ return sizeof(array_intersect( preg_split("/;/", $camp["cities"]), $role["shops"] )); } );*/
		$cs = gde("state", "opened");
		$camps = db\select_id_field_to_array("camps", "id", "name", $cs? "camp_state='$cs'":"", "date_from");
		if($camps)
			echo  "<select id='mi_camp'>".render_select_opts($camps, array_key_last($camps) )."</select>";
		return;
	}
	// TODO: instead list of ids - save camp shops as paths/ids (as was in groups)
	if($action=="get_camp_shops"){
		$shops = get_camp_shops( mse("id") );
		echo sizeof($shops)? " id in (".join(",", $shops).")" : "";
		return;
	}

	if($action=="get_lbs_todo"){
		echo json_encode(db\select_record("v_shop_camp_".mse("camp_id"), "lbc_count, lbc_todo_count", "id=".mse("shop_id")));
		return;
	}

	if($action=="get_shop_maps"){
		$id = mse("id");
		$files = array();
		$files = db\select_to_array("shops_maps", "name,id", "shop_id=$id");
		foreach($files as &$file) $file["src"] = get_files_path()."maps/".$file["name"];
		echo json_encode($files);
		return;
	}

	if($action=="delete_shop_map"){
		db\execute("delete from shops_maps where id = ".mse("id"));
		return;
	}

	// -------------- ORDERS ------------------
	if($action=="order_create"){
		echo create_order(json_decode( mse("fields"), true ), $user_id);
		return;
	}
	if($action=="order_delete"){
		delete_order_email( mse("id") ); // this is called normally by a visual, so need email
		return;
	}
	if($action=="delete_orders"){
		$ids = json_decode( mse("ids"), true);
		foreach($ids as $id){
			log\info("deleting order $id");
			order_delete($id);
		}
		return;
	}
	if($action=="get_lbs_state"){
		echo json_encode( db\select_record("app_lbs", "app_state, app_id", "id=".mse("id")) );
		return;
	}
	if($action=="get_order_state"){
		echo json_encode( db\select_record("v_orders_state1", "uploaded,approved,printed,order_state,order_state1,date_done", "id=".mse("id")) ); // OS1
		return;
	}
	// input: js passes 2 lists: lists of apps (ids) and list of ordrs (ids_ords); output: single array which contains input apps and added apps from input ords
	function get_app_ids(){
		if( gde("app_id") )
			$ids = array( gde("app_id") );
		else
			$ids = json_decode( mse("ids") );
		//
		if( gde("ids_ords") && sizeof($ids_ords = json_decode( gde("ids_ords") ) ) )
			$ids = array_merge($ids, db\select_field_to_array("app_lbs", "id", db\id_in($ids_ords, "", "order_id")));
		return $ids;
	}	
	if($action=="accept_lbs"){
		if(sizeof($ids = get_app_ids()))
			db\execute("update app_lbs set app_state = 'accepted' where app_state='draft' and ".db\id_in($ids));
		return;
	}
	if($action=="get_app_info"){
		$lbs = db\select_record("app_lbs", "name, lbs_width width, lbs_height height, app_state state, shop_id, camp_id", "app_id=".mse("app_id"));
		$order = get_lbs_order($lbs["camp_id"], $lbs["shop_id"]);
		$lbs["order_state"] = $order["order_state1"];
		$lbs["order_id"] = $order["id"];
		echo json_encode( $lbs );
		return;
	}
	if($action=="approve_lbs"){
	log\debug(get_app_ids());
		foreach(get_app_ids()as $id)
			set_lbs_state($id, "approved", "Order approved", "PRODUCTION"); 
		return;
	}
	if($action=="reject_lbs"){
		reject_lbs(mse("app_id"), mse("receivers"), gde("subject"), gde("message"));
		return;
	}
	// happens when prod-int downloads lbs; that means that lbs gets state 'printed'
	if($action=="print_lbs"){ 
		print_lbs(mse("id"));
		return;
	}


	// ---------------- GROUPS -------------------------
	if($action=="get_all_users"){
		echo json_encode( db\select_field_to_array("users_users", "email", "", "email") );
		return;
	}
	// USR NOTE: this code must be before other group crud actions	if($action=="segr_save" || $action=="segr_remove"){	set_flag("update_shop_roles");	}   NOT USED IN SHOP_SINGLE_GROUP version
	//   /USR
	if($action=="segr_save"){
		$id = gde("id"); $fields = json_decode(mse("fields"), true); // email/name
		if(db\exists("users", "name='".$fields["name"]."' and id<>$id")) throw new user_exception('$group$ $name_exists$');
		if($id)
			db\execute("update groups set ".db\compile_update($fields)." where id='$id'"); 
		else{
			$fields["user_type"] = "group";
			db\execute("insert into groups ".db\compile_insert($fields));
			$id = db\get_last_id();
		}
		echo $id;
		return;
	}
	if($action=="segr_remove"){
		$id = mse("id");
		reset_user_shops($id);
		db\execute("delete from groups where id=$id");
		return;
	}
	if($action=="read_group"){
		echo json_encode( db\select_record("groups", "*", "id=".mse("id")) );
		return;
	}

	// PREVIEW
	if($action=="get_img_url"){
		echo get_img_url(mse("id"));
		return;
	}
	if($action=="rename_hires"){
		$id = mse("id");
		$name_new = mse("new_name") ;
		if( db\exists("hires", "id<>$id and name='".db\escape2($name_new)."'") )
			throw new user_exception('$file_already_exists$');
		// actual move
		$file = db\select_record("hires", "path,name", "id=$id"); // remember for the mv cmd
		$path = get_source_path().hires_path_rel;
		$name_old = $file["name"];
		exec_cmd("mv", $path.$name_old, $path.$name_new) ;
		db\execute("update hires set name = '$name_new' where id = $id"); // TODO: check user_dir, move to model
		return;
	}
	if($action=="delete_hires"){
		$files = json_decode(mse("files"));
		//$files = tt_find_selection($start_dir, json_decode(mse("paths"), true), , true), "id, path, name" );
		$summary = gde( 'summary' , 1);
		if(!sizeof($files))
			throw new user_exception('$no_file_sel$');
		if($summary)
			echo sizeof($files);
		else{
			foreach($files as $id){
				$file = db\select_record("hires", "path,name", "id=$id"); // remember for the mv cmd
				db\execute("delete from hires where id = $id");
				exec_cmd("rm", get_source_path().hires_path_rel.$file["path"].$file["name"]) ;
			}
		}
		return;
	}
	// IMG_USAGE
	if($action=="img_usage"){
		echo json_encode( db\select_to_array("v_lbs", "img_id, count(*) img_count", "camp_id=".mse("camp_id")." and shop_id=".mse("shop_id"), "", "img_id" ) );
		return;
	}

	if($action=="get_event_users"){
		echo json_encode( db\select_field_to_array("v_event_users", "concat(dest_group_role,': ',dest_group) x", "event_id=".mse("event_id"), 'x') );
		return;
	}
	// TODO: quickfix: DEF USER_LINK: links to pages are in event_users; shown is events; can't find way to show link as a field of events (need find the rec corresp to curr user); so decided to use this cb
	if($action=="get_event_links"){
		$ids = json_decode(mse("ids"), true); // ids of events
		$links = array();
		if(sizeof($ids))
			$links = db\select_id_field_to_array("event_users", "event_id", "order_link", db\id_in($ids, "dummy", "event_id")." and dest_group_id=".mse("role_id"));
		echo json_encode($links);
		return;
	}
	if($action=="stats1"){
		$camps = db\select_to_array("camps", "id,name", "camp_state='opened'");
		$res = "";
		foreach($camps as $camp){
			$stats = print_user_stats($camp["id"]);
			if(!$stats) continue; // TEMP now happens
			$res.= "<div class='mc_us_camp'>".$camp["name"]."</div>\n";
			foreach( $stats["stats"] as $stat)
				$res.= "<div class='mc_us_sd'> <label>".$stat[0].":</label><i>".$stat[1]."</i><a href='".$stat[2]."'>page link</a></div>\n";
		}
		echo "<div class='mc_page_head mc_us_div'>$res</div>";
		return;
	}

	if($action=="stats"){
		$camps = db\select_to_array("camps", "id,name", "camp_state='opened'");
		$res = "";
		foreach($camps as $camp){
			$ch = "";
			$stats = print_user_stats($camp["id"]);
			if(!$stats) continue; // TEMP now happens
			$ref = $stats["page_link"];
			$ch .= "<tr> <th class='mc_us_camp'><a href='$ref'>".$camp["name"]."</a></th></tr>\n";
			foreach( $stats["stats"] as $stat)
				$ch.= "<tr> <td class='mc_us_sd'>".$stat[0].": <a href='".$stat[2]."'>".$stat[1]."</a></td></tr>\n";
			$res.= "<table class='mc_us_cc'>$ch</table>";
		}
		echo "<div class='mc_page_head mc_us_div'>$res</div>";
		return;
	}
	if($action=="get_logged_users"){
		exec_log("sudo /usr/bin/php ".proj_path."contr/lu.php ".get_portal_name(), $o, $r) ;
		//log\debug($o);
		$un = array(); foreach(preg_split("/,/", $o[0], -1, PREG_SPLIT_NO_EMPTY) as $u) $un[]=db\select_field("users", "name", "id=$u"); sort($un);
		$ch = "<tr> <th class='mc_us_camp'>".lp("users")."</th></tr>\n";
		foreach( $un as $user)
			$ch.= "<tr> <td class='mc_us_sd'>$user</td></tr>\n";
		echo "<table class='mc_us_lu'>$ch</table>";
		return;
	}

	// SETTINGS CONTR
	if( $action=='save_settings'){
		$sj = mse("settings");
		$settings = json_decode($sj, $convert_to_array=true);
		save_settings($user_id, $settings);
		return; 
	}

	if($action=="get_user_settings"){
		$email = mse("email");
		if( $uid = find_email_id($email) )
			echo json_encode( get_user_settings($uid) );
		return;
	}
		
	if($action=="change_user_pass"){
		$params = mse("params");
		$params = json_decode($params, $convert_to_array=true);
		$old = $params["passold"];
		$new = $params["passnew"];
		$old_db = db\select_record("users", "pass", "id=$user_id");
		if($old!=$old_db["pass"])	
			throw new Exception("wrong old password!");
		db\execute("update users set pass='$new' where id = $user_id");
		echo "OK!";
		return;
	}
	// CHANGE_ROLE
	if($action=="ur_get_user_roles"){
		$roles = array();
		foreach( $_SESSION["roles"] as $role)
			$roles[]= $role["role"];
		echo json_encode($roles);
		return;
	}
	if($action=="ur_change_role"){
		try_set_user_role(get_curr_user_id(), mse("role"));
		return;
	}

	//----------------------------------------------------------------------------------------------------
        // if here - some wrong action 
	throw new Exception("Wrong or empty action: $action");

} // end of while

}catch(user_exception $e){
	if($msg=$e->getMessage())
		log\error("user error: '$msg'");
	header($_SERVER['SERVER_PROTOCOL'].' 500 '.$e->getUserMessage(), true, 500);
}catch(Exception $e){
	$code = generate_random_string(4, "123456789"); // just a random code informed to used and written to log; thus user can identify to admin what to search in logs
	log\error("controller error $code; POST dump: ", array_to_str($_POST), $e->getTraceAsString() );
	register_error("Controller error $code: ".$e->getMessage(), "controller", "controller", el_higher);
	header($_SERVER['SERVER_PROTOCOL'].' 500 $unknown_error$ $code$: '.$code, true, 500);
	//return;
}
?>
