<?php
	/*
		Author: Alex Nosurov
		Created: 27.01.22 
		managing groups; groups used to set shop's LV/P
	*/
	
	require_once(dirname(__FILE__)."/path.php");
	require_once(proj_path."view/lang.php");
	require_once(proj_path."view/metadata.php");
	require_once(proj_path."contr/login.php");
	require_once(proj_path."utils/menu.php");
	require_once(proj_path."utils/view.php");


?>
<html lang="en">
	<head>
		<?php echo lang_html_load('html/standard_head.html', false, array("title" => project_title, "icon" => project_icon)); ?>
		<link href = 	"table_tree/css/style.css" rel="stylesheet">
		<link href = 	"table_tree/css/search.css" rel="stylesheet">
		<link href = 	"css/table.css" rel="stylesheet">
		<link href = 	"css/apap.css" rel="stylesheet">
		<style type='text/css'>
			.mc_segr_user_del { margin: 3px 5px 0px 5px; }
		</style>
	</head>
	<body style='background: url("img/bg_<?php echo get_portal_name(); ?>.jpeg") no-repeat center center fixed;'> 
                <!-- table_tree -->
                <script src="js/table.js"></script>
	
		<div class='bg_cover'></div>
		<?php echo file_get_contents('html/standard_scripts.html'); ?>
		<div class="mc_page_cont" style="height: 100%;">  <!-- if put height to mc_page_cont - preview shown male -->
			<!-- header: row: logo, menu, login  -->
			<div class="mc_page_head">
				<?php echo lang_html_load('html/standard_body_start.html' ); ?>
			</div>
			<!-- vert menu + main content -->
			<div class="mc_page_body mc_page_cont_hor">  <!-- if put height to mc_page_cont - preview shown male -->
				<div class="mc_page_head" id="mi_main_menu_vert"></div>
				<!-- MAIN CONTENT -->
				<div class="mc_page_body mc_page_cont_hor" style="background-color: var(--bgcol); padding: 20px;">
					<!-- groups-->
					<!-- table of groups -->
					<div class="mc_page_body mc_page_cont">
						<div id="tt_table_tree_div" class='mc_page_body mc_tt_cont ttc_fullscreen mc_clickable'> <!-- NOTE: without this cont appears another horiz scr bar -->
							<?php echo lang_html_load('html/table.html' ); ?>
						</div>
					</div>
				</div>
			</div>
		</div>

		<div id = 'kladovka' class='hidden'>
			<div id="mi_edit_group" class="mc_page_body mc_page_cont_hor" style="background-color: var(--bgcol); padding: 20px;">
				<!-- SEGR part copied from settings.php - crate new group -->
				<div class='mc_page_head mc_page_cont mc_edit mc_float_left' style='min-width: 300px; padding-top: 20px;'>
					<input type='hidden' id='mi_segr_edit_id'>
					<div id='mi_segr_edit' style='min-height:600px;'> <!-- min h is necessary for autocomplete list to have enough space -->
						<div><label><?php echo lp("role"); ?></label></div>
						<div class='container' style='width: 100%; display: flex; flex-direction: column; margin: 0px 0px 10px 0px;' id='rg_role'>
							<?php echo render_radio_group(get_user_roles(), "role"); // AGRO ?>
						</div>
						<div><label><?php echo lp("name"); ?></label></div>
						<div><input id='mi_segr_name' class='mc_input' style='margin-bottom: 10px;'></div>
						<div><label><?php echo lp("users"); ?></label></div>
						<div><input id='mi_segr_new_user' class='mc_input' title="new user" placeholder="<?php echo lp("new_user"); ?>"></div>
						<div id='mi_segr_users' style='flex: 1 1 auto; overflow-y: auto;'></div> 
					</div>
				</div>
				<!-- tree of shops -->
				<div class="mc_page_head mc_float_left mc_page_cont" style="width: 350px; overflow: auto;" id="mi_shops_div">
					<div class= 'mc_page_head' style='padding-bottom: 15px;'> <button onclick='show_not_used()'> <?php echo lp("show_unassigned_stores"); ?> </button> </div>
					<div class= 'mc_page_body mc_shops'> </div>
				</div>
			</div>
		</div>

		<script src="js/treeview.js"></script>
		<script type="text/javascript">

			var alias_name = "groups", table_name = "groups";
			// -------------------------------------------------------------------------------
			// -----------------------------------  INIT -------------------------------------
			// -------------------------------------------------------------------------------

			// SEGR
			var segr_all_users, users;
			function get_curr_group_role(){var r=$("input[name='role']:checked"); return r.length? r.val():"";}
			function get_curr_group_id(){return $("#mi_segr_edit_id").val();}
			// read list of all users to use in autocomplete list to add new group user
			function segr_append_group_user(email){
				$("#mi_segr_users").append( $("<div style='display:flex'> <input class='mc_input mc_segr_user' value='" + email + "'> <i class='mc_segr_user_del fas fa-times'></i> </div>") );
			}
			function adder_on_enter(adder){ 
				segr_append_group_user( adder.value );
				adder.value = '';
				$("#mi_segr_new_user").val(""); // prev not works if called from autocomplete.js 
			}			
			function segr_init(){
				// autocomplete
				var users = JSON.parse(call_php_sync("contr/main.php", {"action" : "get_all_users"}).resp_text);  
				var adder = $("#mi_segr_new_user");
				adder.parent().addClass("autocomplete"); autocomplete(adder[0], users, adder_on_enter);  // AUTOCOMPLETE autocomplete.js
				// save in cache info about all lists
				adder.keypress( function(e){ 
					if(e.which==13 && adder.val())
						adder_on_enter(adder[0]);
				});
				$("#mi_segr_users").on("click", ".mc_segr_user_del", function(){  
					$(this).parent().remove();
				} );
			}
			// now used as onclose from md_ss
			function check_group(ok){
				$("#tt_table_tree_div").addClass("mc_focused");
				return 1;
			}

			function segr_show_group(id=0, name="new group name", emails="", role="", shops=""){ 
				$("#tt_table_tree_div").removeClass("mc_focused"); // DEF NOKEY: when dialog shown - tables shouldn't react on key strokes
				fh_init_table(users.mainform); // or else get resized only table body
				$("#mi_segr_users").html("");
				$("#mi_segr_name").val(name);
				$("#mi_segr_edit_id").val(id);
				$("#mi_segr_new_user").val("");
				emails = emails.split(";");
				for(var i=0;i<emails.length;i++)
					if(emails[i]!="")
						segr_append_group_user(emails[i]);
				if(id>0)
					$("#mi_segr_new_user").focus();
				else
					$("#mi_segr_name").focus();
				// role
				$("#rg_role .rg_item").prop("checked", false);
				$("#rg_role .rg_" + role).prop("checked", true);
				set_shops_visible(); // AGRO
				// shops
				show_shops(); // DEF OFS show only free shops ; not used while in this case folders are always fully selected ; correction 12.7.22 - need re-show while NNA sets cond
				select_shops(shops);
				//
				show_select_string(segr_save, '', $("#mi_edit_group"), lp("edit_group"), check_group);
			}
			function show_group_rec(elem){
				if(!elem.length) return;
				var id = elem.data("id");
				var group = JSON.parse( call_php_sync("contr/main.php", {"action" : "read_group", id: id }).resp_text );
				var ids = call_php_sync("contr/main.php", {"action" : "get_user_shops", id: id, role: group.user_role}, 'POST');
				segr_show_group(group.id, group.name, group.email, group.user_role, JSON.parse(ids.resp_text) );
			}
			function show_not_used(){
				var role = get_curr_group_role();
				if(!role){ alert(lp("role_not_selected")); return false;}
				// DEF NNA - new not assigned; instead of showing not assigned as selection - show subtree of not assigned
				/*var ids = call_php_sync("contr/main.php", {"action" : "get_user_shops", id: 0, role: role}, 'POST');
				select_shops( JSON.parse(ids.resp_text) );*/
				show_shops( role=="LOCAL_VISUAL"?"visual_id=0":"production_id=0" );
			}

			function segr_save(){
				var role = get_curr_group_role();
				if(!role){ alert(lp("role_not_selected")); return false;}
				var ul = collect_val(".mc_segr_user").join(";");
				if(!ul) { alert(lp("no_users_added")); return false; }
				var shops = "";
				if(need_shops()){ // AGRO only for not LV,P
					shops = get_selected_files().join(";");
					if(!shops) { alert(lp("no_stores_added")); return false; }
				}
				var id = get_curr_group_id();
				var res = true, fields = {"name": $("#mi_segr_name").val(), "email": ul, user_role: role};
				$.ajax({
					"type": "POST",
					"async": false,
					"url": "contr/main.php",
					"data": {action : "segr_save", id: id, fields: JSON.stringify(fields)},
					"success": function(res, dummy, request){
						if(id==0) id = res;
						//if(need_shops())   need it anyway, while may happen that gr role changed - need reset prev assignment
						call_php_sync("contr/main.php", {"action" : "set_user_shops", id: id, role: role, shops: JSON.stringify(shops)}, 'POST');
						users.refresh(id);
					},
					"error": function(jqxhr, settings, thrownError){
						res = false; // using async=false and ret res false to not close the dialog
					}
				});
				return res;
			}
			function segr_remove(id, name){
				if(confirm(lpp("$Delete$ $group$ '$1'?", name))){
					call_php_sync("contr/main.php", {"action": "segr_remove", "id": id} ) ;
					users.refresh();
				}
			}

			function show_shops(cond=""){
				var resp = call_php_sync("contr/main.php", {"action" : "show_shops", "cond": cond}, 'POST');
				$(".mc_shops").html(resp.resp_text);
			}
			function need_shops(){var r=get_curr_group_role(); return (r=="PRODUCTION"||r=="LOCAL_VISUAL"); } 
			function set_shops_visible(){ if(need_shops()) $("#mi_shops_div").removeClass("hidden"); else $("#mi_shops_div").addClass("hidden"); } // AGRO
			function select_shops(shops=""){
				deselect_all();
				tt_hide_all();
				if(shops){
					select_ids( shops );
					tt_open_indeterminate();
				}
			}


			$(document).ready( function(){
				set_ajax_error_handler();
				// shops
				init_table_tree( $(".mc_shops") );
				tt_hide_all();
				show_shops();
				select_shops();
				//$("#rg_role").on("click", ".rg_item", show_shops); // OSF
				// users/groups
				segr_init();
				// Tablo groups
				var fields = JSON.parse( call_php_sync("contr/main.php", {"action" : "get_table_fields", alias: alias_name, table: table_name}, 'POST').resp_text ); 
				users = new Tablo("#tt_table_tree_div", $(".mc_search_panel"), table_name, fields.list, fields.search, null, show_group_rec, alias_name);
				users.ro_set("name", "asc");   // FIORD
				users.show();
				$(".lbsp_new").click( function(){segr_show_group();} );
				$(".lbsp_del").click( function(){ 
					var rec = users.get_active_rec(); 
					if(!rec.length){ alert( lp("no_record_selected") ); return; }
					segr_remove( rec.data("id"), rec.data("name") );
				} );
				$(".lbsp_edit").click( function(){show_group_rec( users.get_active_rec() );} );
				if(ur_role.role=="ADMIN")
					$(".lbsp_del, .lbsp_edit").removeClass("hidden"); // TODO: donno why now in html/table.html they are hidden by default
				// move roles V,P to top DEF AGRO any group role - group may have any role; need show list of all and need adjust visibility of shops - only for P,LV
				$(".rg_LOCAL_VISUAL").parent().prependTo("#rg_role").addClass("mc_bold");
				$(".rg_PRODUCTION").parent().prependTo("#rg_role").addClass("mc_bold");
				$("#rg_role").click(".radio", set_shops_visible);
			});

		</script>
	</body>
</html>
