<?php
	/*
		Author: Alex Nosurov
		Created: 13.01.20 
	*/
	
	require_once(dirname(__FILE__)."/path.php");
	require_once(proj_path."view/lang.php");
	require_once(proj_path."view/metadata.php");
	require_once(proj_path."contr/login.php");
	require_once(proj_path."utils/menu.php");

?>
<html lang="en">
	<head>
		<?php echo lang_html_load('html/standard_head.html', false, array("title" => project_title, "icon" => project_icon)); ?>
		<link href = 	"table_tree/css/search.css" rel="stylesheet">
		<link href =    "table_tree/css/style.css" rel="stylesheet">
		<link href = 	"css/apap.css" rel="stylesheet">
		<link href = 	"css/hires.css" rel="stylesheet">
		<?php echo lang_html_load('fu/index_head.html'); /* LOADSUB  TODO: move this stuff to standard to be used by all pages*/ ?>
		<style>
			.mc_page_cont > .mc_page_body{	overflow-y: auto; }
		</style>
	</head>
	<body style='background-color: white!important;'> 
                <!-- table_tree -->
		<script src="table_tree/js/main.js"></script>
	
		<div class='bg_cover'></div>
		<?php echo file_get_contents('html/standard_scripts.html'); ?>
		<div class="mc_page_cont" style="height: 100%;">  <!-- if put height to mc_page_cont - preview shown male -->
			<!-- header: row: logo, menu, login  -->
			<div class="mc_page_head">
				<?php echo lang_html_load('html/standard_body_start.html' ); ?>
			</div>
			<div class="mc_page_body mc_page_cont_hor" style="width: 100%; overflow:auto;">  <!-- if put height to mc_page_cont - preview shown male -->
				<div class="mc_page_head" id="mi_main_menu_vert"></div>
				<div class="mc_page_body mc_page_cont">
					<div id="tt_table_tree_div" class='mc_page_body mc_tt_cont ttc_fullscreen'> <!-- NOTE: without this cont appears another horiz scr bar -->
					</div>
				</div>
			</div>
			<div class="mc_page_head mc_puh_div mc_page_cont_hor hidden"><div class='mc_puh_msg mc_page_body'></div><i class='mc_puh_close fas fa-times'></i></div>  <!-- DEF PUH Pop Up Help: shown as user does sms; depends on curr user action -->
		</div>

		<div id = 'kladovka' class='hidden'> <!-- just a div to hide stuff which is shown only temporarily; seems not nec, while add hidden instead -->
			<div id = "mi_load_image">  <?php echo lang_html_load('fu/index_html.html'); ?> </div> <!-- LOADSUB -->
		</div>

		<?php echo lang_html_load('fu/index_script.html'); /* LOADSUB */ ?>

		<script type="text/javascript">
			var portal = "<?php echo get_portal_name(); ?>";
			// from space.js
			function make_download_req(paths, files){ return {'paths': JSON.stringify(paths), 'files': JSON.stringify(files), "user_dir": "", "table": "hires", "files_path": tt.files_path}; } // TODO: what's the user_dir? from tt? - then use get_user_dir; maybe not used at all in 'space'

			function _download_selection(data){
				$.ajax({
					"type": "POST",
					"url": "table_tree/contr/main.php",
					"data": {"action": "cdr", "data": JSON.stringify(data)}, // CDR
					"success": function(res){
						download_file("table_tree/download_zip.php?cdr=" + res);
						//tt.open_root_dir()
					}
				})
				//load_file("table_tree/download_zip.php", data, "POST");
			}
			function download_selection(){
				var sel = tt.find_selection(true);
				if(!sel.files.length && !sel.paths.length){
					alert(lp("no_file_sel"));
					return;
				}
				// DEF DOBO DOwnload By One, to avoid create zip
				if(sel.files.length>1 && !confirm(lpp("$download$ $as_single_zip$?")))
					for(var i = 0; i<sel.files.length; i++)
						_download_selection( make_download_req([], [sel.files[i]] ) );
				else
					_download_selection( make_download_req(sel.paths, sel.files) );
			}
			function download_all(){
				load_file("contr/download.php?type=hires_zip&id="+get_camp_id());
			}
			//

			function set_camp(id){
				//tt.set_root_dir(portal + "/"+id+"/"); // this is the virtual dir from db which is same for all shown files;
				tt.set_root_dir(id+"/"); // this is the virtual dir from db which is same for all shown files;
				tt.open_root_dir();
			}
			// HRNEW
			function show_load_sub(){
				var data = {client: "hires"};
				$("#mi_fu_data").val( JSON.stringify(data) ); 
				$("#mi_user_path").val(tt.get_root_dir());
				show_select_string(function(){tt.open_root_dir()}, '', $("#mi_load_image"), lp("load_subjects"), check_upload_finished);
			}
			//
			function show_rename_dialog(elem){ 
				elem = elem.closest(".thumb");
				var id = elem.data("id");
				var name = elem.data("name");
				show_select_string(
					function(new_name){
						$.ajax({
							"type": "POST",
							"url": "contr/main.php",
							"data": {"action": "rename_hires", "id": id, "new_name": new_name},
							"success": function(res){tt.open_root_dir()}
						})
					},
					name);
			}

			var def_camp_id = <?php echo get_or_def($_GET,'cid',0); ?>;
			var table_name = 'hires';
			var can_edit = true;
			var tt;
			var checkUnprocessedTimer = null;
			$(document).ready( function(){
				set_ajax_error_handler(); // def err handler for ajax   ; 24.12.19 pass empty  because DEF FIND_ERR_MSG shows alert when find res empty
				//
				tt = new table_tree("hires", '#tt_table_tree_div', table_name, "thumbs"); // init tree table NOTE: set table before (used by def_search_fields) 
				tt.hide_tree();
				tt.set_paths(portal + "/hires/", "thumb_small_" + portal + "/", "thumb_medium_" + portal + "/"); // DEF HRTHP
				// popup menu (now using that of tt)
				tt.add_popup_item(lpp('$download$ $selected$'), download_selection, true, true, true);
				//tt.add_popup_item(lpp('$download$ $all$'), download_all, true, true, true);
				can_edit = ur_role.role == "ADMIN";
				if(can_edit){
					tt.add_popup_item(lp('delete_selected'), function(){tt.selection_action("delete_hires")}, true, true, true);
					tt.add_popup_item(lp('rename'), show_rename_dialog, true, true); // RENAME
					// HRNEW
					$(".tt_thumbs_header").append("<i class='fas fa-upload mc_upload_hires' title='" + lp("upload") + "'></i>");
					$(".mc_upload_hires").click( show_load_sub );
				}
				// add download button (for humanitarian guys which can't use popup menu)
				//tt.add_action("download_all", download_selection, lp("download_all"));
				$(".tt_thumbs_header").append("<div class='mc_download_all' title="+lpp('$download$ $selected$')+"><i class='fas fa-download'></i></div>");
				$(".mc_download_all").click( download_selection );
				//tt.set_on_select( function(sel){ var l=sel.files.length||sel.paths.length, b=$(".mc_download_all"); if(l)b.removeClass("hidden");else b.addClass("hidden");} );
				// need this stuff while normall tt calls show_detail on focus, so if use popup wind for show detail - it's shown on each focus
				//tt.set_show_details(function(){});
				// 
				show_sel_camp("opened", ".tt_thumbs_header").addClass("lbsp_input");	// SETCAMP
				//var fields = JSON.parse( call_php_sync("contr/main.php", {"action" : "get_table_fields", alias: alias_name, table: table_name}, 'POST').resp_text ); 
				var cid = def_camp_id? def_camp_id : get_camp_id(); // TODO: as def camp may be passed a closed camp
				if(cid){
					$("#mi_camp").val(cid);
					set_camp(cid); // calls show() and sets def rec
				}else
					alert(lp("no_campaigns_found")+"!");

				// DEF CUP check unprocessed thumbs TODO: move to tt?
				tt.set_on_show_plain( function(){ 
					if( tt.get_thumb_form().find(".mc_wait_thumb").length && !checkUnprocessedTimer )
						checkUnprocessedTimer = setInterval( function(){tt.open_root_dir()}   , 10000);
					if( !tt.get_thumb_form().find(".mc_wait_thumb").length && checkUnprocessedTimer ){
						clearInterval(checkUnprocessedTimer);
						checkUnprocessedTimer = 0;
					}
					tt.get_thumb_form().find(".thumb").append("<div class='mc_dl_thumb'></div>"); // DLTHUMB
					$(".mc_dl_thumb").click(function(){ _download_selection( make_download_req([], [$(this).closest(".thumb").data("id")]) ); });
				});
			});
		</script>
	</body>
</html>
