<?php
	/*
		Author: Alex Nosurov
		Created: 13.01.20 
	*/
	
	require_once(dirname(__FILE__)."/path.php");
	require_once(proj_path."view/lang.php");
	require_once(proj_path."view/metadata.php");
	require_once(proj_path."contr/login.php");
	require_once(proj_path."utils/menu.php");

	// HRR HIRES role shouldn't see index page
	if(ur_get_name()=="HIRES"){
		$location = base_url.proj_path_rel."hires.php";
		header("Location: $location");  
	}
?>
<html lang="en">
	<head>
		<?php echo lang_html_load('html/standard_head.html', false, array("title" => project_title, "icon" => project_icon)); ?>
		<link href = 	"table_tree/css/style.css" rel="stylesheet">
		<link href = 	"table_tree/css/search.css" rel="stylesheet">
		<link href = 	"css/table.css" rel="stylesheet">
		<link href = 	"css/apap.css" rel="stylesheet">
	</head>
	<body style='background: url("img/bg_<?php echo get_portal_name(); ?>.jpeg") no-repeat center center fixed;'> 
                <!-- table_tree -->
                <script src="js/table.js"></script>
	
		<div class='bg_cover'></div>
		<?php echo file_get_contents('html/standard_scripts.html'); ?>
		<div class="mc_page_cont" style="height: 100%;">  <!-- if put height to mc_page_cont - preview shown male -->
			<!-- header: row: logo, menu, login  -->
			<div class="mc_page_head">
				<?php echo lang_html_load('html/standard_body_start.html' ); ?>
			</div>
			<div class="mc_page_body mc_page_cont_hor" style="width: 100%;">  <!-- if put height to mc_page_cont - preview shown male -->
				<div class="mc_page_head" id="mi_main_menu_vert"></div>
				<div class="mc_page_body mc_page_cont">
					<div id="tt_table_tree_div" class='mc_page_body mc_tt_cont ttc_fullscreen'> <!-- TODO maybe non need this cont -->
						<?php echo lang_html_load('html/table.html' ); ?>
					</div>
				</div>
			</div>
			<div class="mc_page_head mc_puh_div hidden"></div> <!-- DEF PUH Pop Up Help: shown as user does sms; depends on curr user action -->
		</div>
		<script>
			// EVENTS
			var events;
			var table_name = "v_events", alias_name = "events";
			function on_show(){
				var events_ids = [];
				$("#table-"+alias_name).find(".tr-"+alias_name).each(function(){ events_ids.push( $(this).data("id") ); });
				var links = JSON.parse( call_php_sync("contr/main.php", {"action" : "get_event_links", ids: JSON.stringify(events_ids), role_id: ur_role.id}, 'POST').resp_text );
				$("#table-"+alias_name).find(".tr-"+alias_name).each(function(){ 
					var id = $(this).data("id");
					var out = $(this).data("source_group_id")==ur_role.id; // if curr user is event's source
					var _in = id in links;
					if( _in ){
						$(this).find(".td-"+alias_name+"-RES_link").html("<a target='_blank' href='"+links[id]+"'>order page</a>");
						$(this).css("background-color", "#a9cce3");
					}
					if(out){
						$(this).find(".td-"+alias_name+"-RES_link").html("<a target='_blank' href='"+$(this).data("source_order_link")+"'>order page</a>");
						$(this).css("background-color", "#a9dfbf");
					}
					$(".th-"+alias_name+"-RES_dest").html(lp("to"));
				} );
				// dest
				$("#table-" + alias_name).find(".td-" + alias_name + "-RES_dest").html("<i class='fas fa-list'></i>");
				// TODO: ajax called for each rec; get it in one call instead
				$(".td-" + alias_name + "-RES_dest").click( function(){ 
					var id = $(this).closest(".tr-"+alias_name).data("id");
					var users = JSON.parse( call_php_sync("contr/main.php", {"action" : "get_event_users", event_id: id}, 'POST').resp_text ); 
					show_select_string(null, "", render_ul(users), "list of receivers");
					//alert(users.join("\n"));
				} );
			}
			$(document).ready( function(){
				set_ajax_error_handler(); 
				var fields = JSON.parse( call_php_sync("contr/main.php", {"action" : "get_table_fields", alias: alias_name, table: table_name}, 'POST').resp_text ); 
				events = new Tablo(".tc_thumbs_form", $(".mc_search_panel"), table_name, fields.list, fields.search,null,null,alias_name);
				events.on_show = on_show;
				if(ur_role.role!="ADMIN") // admin sees all events
					events.set_cond("source_group_id=" + ur_role.id + " or exists (select 1 from event_users where dest_group_id=" + ur_role.id + " and event_users.event_id=v_events.id)" );
				events.ro_set("date_event", "desc");
				events.show();
				if(ur_role.role == "PRODUCTION")
					$(".tc_thumbs_form").addClass("hidden");

				// STATS
				var stats = call_php_sync("contr/main.php", {"action" : "stats"}, 'POST').resp_text; 
				$(stats).insertAfter("#mi_main_menu_vert");
				//$(".tc_thumbs_form").prepend(stats);
				$(".lbsp_rec_actions").remove();
				if(ur_role.role=="ADMIN")
					$(".mc_us_div").append( call_php_sync("contr/main.php", {"action" : "get_logged_users"}, 'POST').resp_text );
			});
		</script>
	</body>
</html>
