// allows to set one handler to handle all ajax errors
// DEF LOGONEXP  if session expires - controller should raise error on ajax requests; client should process them and redirect to login page
function set_ajax_error_handler(fun=null){
	$(document).ajaxError( function(event, jqxhr, settings, thrownError){ 
		// TODO: cancell all ajax requests
		if(thrownError=="no_user"){ // LOGONEXP
			show_login();
			return;
		}else if(fun)
			fun(event, jqxhr, settings, lpp(thrownError));
		else
			alert(lp("error") + ": " + lpp(thrownError));
	} );
}

function set_upload_frame(len="70"){var fs = parent.document.getElementsByTagName( 'frameset' ); if(fs.length) fs[0].rows = len + '%,*';} // TODO: move to space.js (& show_login)
function show_login(base_url=""){
	set_upload_frame("100"); // hide upload frame
	var w = window;
	if(w.parent)
		w = w.parent; // if inside frame - open in parent window
	w.open(base_url + "login.php", "_self"); // handlers are set in contr/main
}
function check_logged_in(){
	var result = 0;
	$.ajax({async: false, type: "POST", url: "contr/login.php", data: {"action": "check_logged_in"}, success: function(res){	result = res=="1"? true : false; } });
	//return result;
	if(!result) show_login();
}
	
// create menu
function menu_item_click(){
	var item_handler = $(this).data('handler'); //item id(name) is set in menu definition and passed to the renderer which saves it as data-handler
	if( item_handler=='fullscreen'){ // DEF FULLSCREEN if a page supports full screen - should have the element with ttc_fullscreen class with is expanded
		var e = document.getElementsByClassName("ttc_fullscreen");
		if(e.length)
			fullscreen(e[0]);
			//e[0].webkitRequestFullscreen();
		else
			alert(lp("no_fullscreen"));
		return;
	}
	// CON_HELP
	if( item_handler=='context_help'){ // DEF FULLSCREEN if a page supports full screen - should have the element with ttc_fullscreen class with is expanded
		con_help_start();
		return;
	}
	var w = window;
	if(w.parent)
		w = w.parent; // if inside frame - open in parent window
	w = w.open(item_handler, "_self"); // handlers are set in contr/main
	//w.mi_caption = $(this).data('caption'); w==window if using _self
}
function logout(){
	call_php_sync("contr/login.php", {'action': 'logout'}); 
	var w = window;
	if(w.parent)
		w = w.parent; // if inside frame - open in parent window
	w.open("login.php", "_self"); // handlers are set in contr/main
}

// POPUPALERT
function show_alerts(){
	$.ajax({
		method : 'POST',
		url : 'contr/main.php',
		data : {action : 'popup_alert', quiet: 1},
		success : function(res){ 
			var alerts = JSON.parse(res); // array of objects
			//$("#tt_alerts_div").html(""); // necessary only in debug mode
			for(i=0;i<alerts.length;i++){
				var ale = alerts[i];
				$("#tt_alerts_div").append("<div class='ttc_alert_div'>  <div class='ttc_alert_time'>" + ale.date_alert + "</div> <span class='ttc_alert_msg'>"  + ale.message + "</span> </div>");
			}
			toggle_alerts_contr();
		}
	});
}
function toggle_alerts_contr(){
	if( $("#tt_alerts_div .ttc_alert_div").size() ) $("#tt_alerts_control_div").removeClass("hidden"); else $("#tt_alerts_control_div").addClass("hidden");
}

// to adjust pages according to if is admin (hide some elems)  DEF SET_ADMIN 
function is_admin(){
	return call_php_sync("contr/main.php", {'action' : 'admin', 'quiet':1} ).resp_text=="1"? true : false;
}
// this is called for all pages; pages also may call is_admin individually and make necessary adjustments
function set_admin(){
}


// new 23.11.18 STATS   NOTE: that works only with table_tree
function show_stats(elem){ show_path_stats(get_data(elem, 'path'), 1); } // elem = LI from tree; first call: from popup menu; shows the stats page
// STATS  works with condition that table_tree is included (uses tt_thumbs_form as output, show_panels, wait_screen, get_table, get_where)
function show_path_stats(path, brief, table, cond){
	wait_screen.add_operation("stats");
	$.ajax({
		type: "POST",
		url: 'contr/main.php',
		data: {'action' : 'file_stats', 'path' : path, 'brief' : brief, "table" : get_table(), 'cond' : get_where()},
		success: function(res){
			// show stats instead of thumbs 
			$('#tt_thumbs_form').html(res);
			show_panels(); // unless - res isn't seen if panels were hidden
			fh_init_table( $('#tt_thumbs_form'));
			// insert level up
			var lu = call_php_sync("contr/main.php", {'action' : 'level_up', 'path' : brief? dir_name(path) : path}); if(lu.resp_text!="") 
				$(lu.resp_text).insertAfter('#tt_thumbs_form .fh-header');
			// pool click
			$('#tt_thumbs_form').on('click','.ttc_pool_info',function(e){
				var code = $(this).data('code');
				window.open('pools.php?code='+code, "Pool info");
			});
			// folder click - show its stats
			//$('#tt_thumbs_form').on('click','.tree-item-dir',function(e){  // TODO: why this work wrong: called many times (more with each call)
			$('.tt_stat_dir').on('click', function(e){
				var child_path = $(this).data('path');
				show_path_stats(child_path, 0, table, cond);
			});
		},
		complete: function(xhr, stat){
			wait_screen.remove_operation("stats");
		}
	});
}

function set_selected(elem, callback, state=-1){  // false/true/-1=toggle
	if(state==-1)
		elem.toggleClass("selected");
	else if(state)
		elem.addClass("selected");
	else
		elem.removeClass("selected");
	if(callback)
		callback( elem.hasClass("selected"), elem.data("id"), elem.data("path") ); // =on_row_select TODO: maybe just pass elem.. or (elem, selected)
}
// elem is js
function scroll_to_view(elem){
	if(!elem) return null; // happened on orders page donno why TODO
	if( typeof elem.scrollIntoViewIfNeeded === 'function' )
		elem.scrollIntoViewIfNeeded(true);
	else
		elem.scrollIntoView(true); // TODO: if this is called on mouse click - it's unnecessary and moreover makes records jump
}
function set_active(elem, callback){
	elem.parent().children(".active").removeClass("active");
	elem.parents(".mc_clickable").each(  function(){ 
		$(this).find(".clickable-row").removeClass("active") 
	} ) ; // SINGLE_ACTIVE works only for nested tables; remove active not only in this container but in whole stalk; works if .mc_clickable conts have data-elem_selector=<selector> set
	elem.addClass('active');
	//scroll_to_view( elem[0] );
	if(callback)
		callback( elem);
}
// TODO: added 4.01.2022 ; what is cl_ prefix? for clickable?
function cl_get_active_rec_id(table){
	var rec = table.find(".clickable-row.active"); return rec.length? rec.data("id") : 0;
}
 // DEF SINGLE_KEYDOWN (TODO: can't use keydown for an elem instead?) while there is only on single window.onkeydown - cant re-assign it for each table, so need save correspondence sel-action here
var cl_onenter = [];
function cl_get_class(elem){
	if(elem==null) return null; 
	var cont = null; // in case of nested tables an elem may have several parents-clickables which contain it; need choose the closest one
	var cl_item = null;
	for(i=0;i<cl_onenter.length;i++){
		var some_cont = elem.closest(cl_onenter[i].clas);
		if( some_cont.length && (cont==null || !some_cont.find(cont).length )){ 
			cont = some_cont;
			cl_item = cl_onenter[i]; 
		}
	}
	return cl_item;
}
function cl_add_class(c,a,e,s=null){cl_onenter.push({"clas":c,"active":a,"enter":e,"select":s}); }
function cl_init(){
	window.onkeydown = function(e){
		e = e || window.event;
		var fot = $(".mc_focused"); // mc_focused is class used in tt to indicate which panel (files/thumbs) is active (last mouseclicked) and should accept onkeydown NOTE: mouse used to focuse, keyboard to move
		if(!fot.length) return;
		if( $(e.target).hasClass("ttc_search_field") ) return; // TODO: QSE quickfix to solve problem that need avoid this handler call when press enter in quick search field; problem is that it's now within mc_focused so UNF focues it
		 // selectors - which elem may be used as a focused (active) elem (empty means all); TODO: in tree .active is assigned to <li>, better use tree-cont; besides next/prev not work for inner hierarchy, besides need skip hidden, so no for tree not used
		var selectors = fot.data("elem_selector"); if(!selectors) selectors=""; // DEF CLICKABLE_ELEM_SEL 24.08.20 now this data is stored in clickable container to allow each cont to have its own sel (so this must be in html); seems cumbersome to pass it in params
		var prev_active = fot.find(".active" + selectors); // thus mc_focused must have only the container ; TODO: 5.06.22: added "+selectors" to avoid adding other stuff with .active, not sure it alwyas works
		var code = e.keyCode;
		var actions = cl_get_class(fot);
		if( prev_active.length && (code>=37 && code<=40) ){
			var top = prev_active.position().top;
			var active = prev_active;
			if(code==37) active = prev_active.prev(selectors); // left
			if(code==39) active = prev_active.next(selectors); // right
			/*if(code==38 || code==40){ // up/down   found out that next() returns empty if next hasn't given sel (instead of finding nearest that has it)
				while(active.length && active.position().top == top)
					active = code==38? active.prev(selectors) : active.next(selectors);  */
			if(code==40 && active.next().length && active.next().find(".mc_clickable " + selectors).length ){
				active = $( active.next().find(".mc_clickable " + selectors)[0] );
			}else if(code==38 || code==40){
				var pc = code==38? prev_active.prevAll(selectors) : prev_active.nextAll(selectors);
				for(var i = 0; i<pc.length; i++) if( $(pc[i]).position().top != top ) { active = $(pc[i]); break; }
			}
			if(active.length && !active.is(prev_active) )
				set_active(active, actions.active);
		}
		if(prev_active.length && code==13 && actions.enter)
			actions.enter( prev_active );
		// 27.07.22 select by space click
		if( prev_active.length && code==32 ){
			e.preventDefault(); // or else - scrolls down
			set_selected(prev_active, actions.select) ;
		}
	};
}

// 29.06.22 DEF SINGLE_ACTIVE: only single active for all clickables

// onselect: (new_state, id, path) 
// NOTE: to handle arrows need trace what is focused; to make it in autom. should identify the top container and add to it the class mc_focused and need remove focused from all other clickable tables;
// thus need two difernt selectors (both in same container!) - this container and all clickables (using .mc_clickable for that); thus if using >1 clickable in page - should use sms different than ".mc_clickable" for the cont_sel (to differ from other clickables)
// NOTE: that all clickables thus should be within .mc_clickable container
// TODO: is called many times - each time a table is formed dynamically; instead, better put those tables into some div (constantly present): class='some class' and add handler to that class
function make_clickable( onselect=null , onactive=null, cont_sel='.mc_clickable', elem_sel='.clickable-row', onenter=null){ // function edit_rec(rec){ var id = rec.data("id"); ... }
	//$(cont_sel).on('click', elem_sel, function(e){  XY
	$("*").on('click', function(e){ // replaces XY and other handler while need have all click handlers in same func or else the call order undefined
		//e.preventDefault();  if uncomment this - even links not work
		// tracing the focused clickable table
		if( !this.matches( cont_sel ) ) return; // problem is that this handler is called for each container of elem_sel and elem_self itself; this is to call it only once, in latter case
		$(cont_sel).removeClass("mc_focused"); // de-focus all
		$(e.target).closest(cont_sel).addClass("mc_focused"); // UNF
		//
		var target = $(e.target).closest(elem_sel);
		if(!target.length || !target.closest(cont_sel).length) return; // instead of XY
		var prev_active = target.parent().children(".active"); // SEMUR  TODO: add elem_sel to .active (sms else may be active)
		var active = target;
		var is_check_box = $(e.target).closest('[class*=RES_checked]').length; // CB_SEL_REC
		if(!is_check_box)
			set_active(active, onactive);

		// DEF SEMUR SElect MUltiple REcords. selecting multiple recs in table view. 'selected' is another parameter, independent on 'active'.
		// no keys: sel curr, unsel other
		if( !e.ctrlKey && !e.shiftKey)
			if(is_check_box)
				set_selected( target, onselect );
			// else $(this).addClass('selected').siblings().removeClass('selected'); commenting this - means select only on checkbox click or when ctr/shift used
		// ctrl: flip curr
		if( e.ctrlKey && !e.shiftKey)
			set_selected( target, onselect );
		// shift: sel curr and flip all (curr,prev_active]
		var started = false, finished=false;
		if( !e.ctrlKey && e.shiftKey){
			if(prev_active.length){
				target.parent().children().each( function(){
					if(finished)
						return;
					var child= $(this);
					var limit = child[0]==active[0] || child[0]==prev_active[0];
					if( started && limit)
						return false; // finished
					if(!started && limit )  // first limit
						started = true;
					if(started)
						set_selected( child, onselect );
				});
			}
			set_selected( active, onselect );
		}
	});
	// DEF ARROW_MOVE move with arrows; call onenter on enter click
	cl_add_class(cont_sel, onactive, onenter, onselect);
	// 22.01.22 ; dbl click not works, donno if new bug or haven't been realized; added this for dblclick
	$(cont_sel).on('dblclick', elem_sel, function(e){
		if(onenter) onenter($(this));
	});
}
// new version which also uses onenter ; must replace make_clickable
function make_clickable1( onselect=null , onactive=null, onenter=null, cont_sel='.mc_clickable', elem_sel='.clickable-row'){
	make_clickable( onselect, onactive, cont_sel, elem_sel,onenter);
}

$(document).ready( function(){
	// help
	var lang = call_php_sync("contr/main.php", {'action': 'lang_get'});
	$('#heading_right').append("<a target='_blank' href='help/" + lang.resp_text + "/help.html'><i class='mc_help_btn fa fa-question-circle' title='" + lp("help") + "'></i></a>");
	// login
	var m = call_php_sync("contr/login.php", {'action': 'print_logout'}); 
	$('#heading_right').append(m.resp_text);
	$('#tt_logout').click(logout); // DEF LOGOUT now in popup menu
	/*var user_menu = create_popup_div("tt_popup_user"); 
	init_popup(user_menu, "mc_user"); // TODO: may setup items
	add_popup_item( user_menu, "log out", logout);  version with pm, not finished (problem: show pm on left click) */

	// build main menu
	//var m = call_php_sync("contr/main.php", {'action': 'menu'}); // can use this instead
	$.ajax({
		type: 'POST',
		url: 'contr/main.php',
		data: {action: 'menu'},
		success: function(menu_html){
			$('#cssmenu').html(menu_html);
			$('.mc_item').click( menu_item_click );
			// logo: the first menu item is logo and the text is to be replaced with img
			var h = $('#cssmenu').css("height");
			$("*[data-caption='logo']").html('<a href="index.php" ><img src="img/logo_menu_white.png" alt="home" title="home" style="height: '+h+'; max-height:46px;"></a>'); // TODO: height 100% not works, probably because parent pos=relative
			$("*[data-caption='logo'] a").css("padding-top", "0px");  $("*[data-caption='logo'] a").css("padding-bottom", "0px"); // this is the trick to cut menu's items' padding from logo
			$("#cssmenu").find("ul").append('<li><img src="portal_icon.php" style="height: '+h+'; max-height:46px;"></li>');
			if(!is_admin()) // SET_ADMIN
				$("#cssmenu li[data-caption='persi']").css("display", "none");
			// CON_HELP  make menu item a button
			$('a:contains("context_help")').html("<i class='fa fa-question-circle' title='" + lp("context_help") + "'></i>");
		}
	}); // end of ajax-menu call
	$('.mc_item').click( menu_item_click ); // this for the case then menu created by php in-line TODO: need it? not causes twice call?

	/* TDN donno why it was active
	// mobile menu
	var list = call_php_sync("contr/main.php", {'action': 'mobile_menu_list'}); 
	var list = JSON.parse(list.resp_text);
	var mm = create_popup_div();
	init_popup(mm, "simplemenu", null, true);
	for(let name in list)
		var item = add_popup_item( mm, name, function(){ window.open(list[name], "_self"); });
	*/
	// error handler ; handler for uncaught js errors (not ajax errors)
	window.onerror = function(msg, url, line, col, err)
	{
	  var req = new XMLHttpRequest();
	  // alert(lp("error_hap") + ":\n" + msg + "\n " + lp("rep_sent"));  commented 10.10.22; this scares user; besides, shown on no_user; call_php_sync returns '' and error shown before login.php shown
	  var params = "msg=" + encodeURIComponent(msg) + ';  url=' + encodeURIComponent(url);
	  if(typeof err != 'undefined' && err!=null) params += ";  stack: " + err.stack; // Error err - not standard but supported by all modern bro (Android not supports)
	  //var params = "msg=" + encodeURIComponent(msg) + '&amp;url=' + encodeURIComponent(url) + "&amp;line=" + line;
	  req.open("POST", "jserror.php");
	  req.send(params);
	};

	/* commented; it duplicates set_ajax_error_handler (called manually)
	$( document ).ajaxError(function( event, jqxhr, settings, thrownError ) {
		if(thrownError=="no_user"){ // LOGONEXP
			// TODO: cancell all ajax requests
			window.open("login.php", "_self"); // handlers are set in contr/main
			return;
		}
		else if(thrownError!="not_found") //  FIND_ERR_MSG
			alert(thrownError);
	});*/


	//spinner = new Spinner();  // WAITSCREEN TODO: duplication of table_tree.js ; moved init to wait_screen

	set_admin();  // SET_ADMIN
	// SEL_ROLE
	ur_role = JSON.parse( call_php_sync("contr/main.php", {"action" : "ur_get_user_role"}, 'POST').resp_text ); 
	$(".mc_user").html( $(".mc_user").html()+" ("+ur_role.role + ")" ); // mc_user returned by print_logout
	
	// SHOW_INFO DEF  a div used to show some briefly importan msg (like qnt of found files); disappears after a while or on click
	$("#tt_info_div").on("click", function(){ $(this).addClass("hidden"); } );

	// TIPS
	set_tips(); // should be called when all html is ready

	//make_clickable(); // clickable row behaviour NOTE: for dynamically added clickable tables need call it each time table created ; 9.01.20 commented; need assign it only once; if twice - is called twice (toggles selected twice)

	// USERNAME actions (mainly logout) to see on user name click
	var un = create_popup_div();
	init_popup(un, "mc_user", null, true);
	add_popup_item( un, lp("logout"), logout);
	add_popup_item( un, lp("settings"), function(){  window.open("settings.php");  });
	// DEF CHANGE_ROLE - change it after login; roles are in account menu 
	var roles = JSON.parse( call_php_sync("contr/main.php", {"action" : "ur_get_user_roles"}, 'POST').resp_text ); 
	if(roles.length>1)
		for(var i=0;i<roles.length;i++){
			var role = roles[i];
			var item = add_popup_item( un, role, function(t,e){  
				var r= $(e.target).data("role");
				call_php_sync("contr/main.php", {"action" : "ur_change_role", "role": r}, 'POST');
				location.reload();  //  TODO: check if page allowed for user
			});
			item.data("role", role);
		}	
	// LANG
	lang_create_menu("mc_set_lang");
	$('#heading_right').append($('<span style="padding: 5px;"><img class="mc_set_lang" src="img/' + lang_get() + '.png"></span>'));
	//
	cl_init(); // make_clickable (only details, only files (to avoid bug: open folder when gets active (after arrow click))

}); // end of ready function

function set_page_title(c){
	$('#heading_left').append("<span>" + c + "</span>");
}

function redirect_error(){
	var p = window.location.pathname;
	p = p.substr(0, p.lastIndexOf('/')+1);
	window.open(p + "error.html", "_self");
}

// state is 0/1;  sets flag (in flags dir)
function ar_set_flag(name, state, msg=""){
	call_php_sync('contr/main.php', {'action': 'set_flag', 'flag': name, 'state': state, 'msg' : msg});
}
function ar_get_flag(name){
	var res = call_php_sync('contr/main.php', {'action': 'check_flag', 'flag': name});
	return res.resp_text;
}

function show_info(msg){
	$("#tt_info_div").html(msg);
	$("#tt_info_div").removeClass("hidden");
	$("#tt_info_div").stop(); // cancel animation if still runs (from prev time)
	$("#tt_info_div").fadeIn( {duration:0} ); // cancel fadeout
	$("#tt_info_div").fadeOut({duration:10000});
}

// DEF TIPS to set tips to elems needing tips (elem need have tt_tip tt_tip_<name>)
function set_tips(){ 
	var tips_ids = [];
	$("[data-tip]").each( function(){ tips_ids.push( $(this).data("tip") ); } );
	if( tips_ids.length )
		$.ajax({
			method : 'POST',
			url : 'contr/main.php',
			data : {action : 'tips', names : JSON.stringify(tips_ids), quiet: 1},
			success : function(res){ 
				if(!res) return;
				var tips = JSON.parse(res); // map: tip name - tip value
				for( var tip in tips)
					$("[data-tip='"+tip+"']").attr("title", tips[tip]);
			}
		});
}
	
// find all elems which are 'sel' and makes them references; supposed that each sel's html is its code and the 'page' accepts GET param code=<code>
function make_ref( sel, page ){	
	$(sel).each( function(){ $(this).html( "<a href='" + page + "?code=" + $(this).html() + "'>" + $(this).html() + "</a>" ); } );
}

// DEF MD_SS Moda Dialog Select String; show a div with input to let user enter a string; passed callback for 'ok' button
// validate(ok), ok=true if ok pressed; a cb to make some checks before dialog closed and maybe cancel closing
function show_select_string(cb, def='', content=null, caption='', validate=null){
        show_id("md_ss_div");
        //$("#md_ss_content input").val(def); // this may be used even if hidden (in SEL_FOL)
        document.getElementById("md_ss_content_input").value = def;
        $("#md_ss_caption").html(caption); // this may be used even if hidden (in SEL_FOL)
		var cont = content, cont_parent;
		$("#md_ss_content_custom").html("");
        if(content){ // allow to show custom content
                $("#md_ss_content").addClass("hidden");
				cont_parent = content.parent();
                $("#md_ss_content_custom").append(content);
                $("#md_ss_content_custom").removeClass("hidden");
        }else{
                $("#md_ss_content_custom").addClass("hidden");
                $("#md_ss_content").removeClass("hidden");
        }
        $("#md_ss_ok").unbind("click");
        $("#md_ss_ko").unbind("click");
        $("#md_ss_ok").click(function(){ 
			if(validate && !validate(true)) return;
			if(cb){ 
				var res = cb( get_selected_string() ); 
				if(res==0) return; // new 11.05.22; it's convenient to validate in callback
			}
			if(cont) cont_parent.append(cont); // move content back
			hide_id("md_ss_div"); 
		});
        $("#md_ss_ko").click(function(){ 
			if(validate && !validate(false)) return;
			if(cont) cont_parent.append(cont); // move content back
			hide_id("md_ss_div"); 
		});
        $("#md_ss_ok").removeClass("hidden"); $("#md_ss_ko").removeClass("hidden"); // may happen user has disabled some buttons before
}
function get_selected_string(){ return $("#md_ss_content_input").val(); }
function set_selected_string(val){ $("#md_ss_content_input").val(val); }

// CON_HELP
var con_help_list = [];
//function con_help_add(selector, help_id){ $(selector).addClass("mc_helpable"); $(selector).data("help_id", help_id); }
function con_help_add(selector, help_id, frame=''){ con_help_list.push( {"sel":selector, "id":help_id, "frame": frame} ); }
function con_help_click(event){
	//$(".mc_helpable").removeClass("mc_helping"); 
	//$("*").removeClass("mc_helping"); 
	document.removeEventListener("click", con_help_click);
	//$(".mc_helping").off("click", con_help_click);
	event.stopImmediatePropagation();
	event.stopPropagation();
	event.preventDefault();
	if(window.parent.frames["upload"])
		$("*", window.parent.frames["upload"].document).removeClass("mc_helping"); 
	//
	var target = $(event.target).closest(".mc_helping");
	$("*").removeClass("mc_helping"); 
	if(!target.length)
		return;
	var help_id = target.data("help_id");
	window.open("help/index.php#" + help_id);
}
function con_help_start(){
	for(var i=0;i<con_help_list.length;i++){
		var selector = con_help_list[i]["sel"];
		var help_id = con_help_list[i]["id"];
		var frame = con_help_list[i]["frame"];
		var doc = frame? window.parent.frames[frame].document : document;
		$(selector, doc).addClass("mc_helping");
		$(selector, doc).data("help_id", help_id);
		$(selector).data("help_id", help_id);
	}
	//$(".mc_helpable").addClass("mc_helping"); 
	event.stopImmediatePropagation();
	event.stopPropagation();
	event.preventDefault();
	document.addEventListener("click", con_help_click);
	//$(".mc_helping").on("click", con_help_click);
	if(window.parent.frames["upload"])
		$(".mc_helping", window.parent.frames["upload"].document).on("click", con_help_click);
}

function dlpro_progress(prodiv, name, per){
	//prodiv.find(".ttc_alert_msg").html(name + ": " + String(pro)+"%");
	for (var i = 0; i < prodiv.childNodes.length; i++) 
		if (prodiv.childNodes[i].className == "ttc_alert_msg") {
			prodiv.childNodes[i].innerHTML = name + ": " + String(per);
			break;
		}
}
function dlpro_error(prodiv, name, error=""){ dlpro_progress(prodiv,name,error?error:"error"); }
//function dlpro_done(prodiv, name){ if(name) dlpro_progress(prodiv,name,"Ok"); else prodiv.remove(); }
function dlpro_done(prodiv, name){ if(name) {dlpro_progress(prodiv,name,"Ok");$(prodiv).find(".mc_cd").remove();$(prodiv).on("click", function(){prodiv.remove();});} else prodiv.remove(); }
	//var prodiv = $("<div class='ttc_alert_div'> <i class='fas fa-download'/><span class='ttc_alert_msg'/>0 %</span><i class='mc_cd fas fa-times'/> </div>"); TODO: not works, seems fontawesome is problem
	// jquery variant
	/*var prodiv = $("<div class='ttc_alert_div'> <span class='ttc_alert_msg'/>0 %</span><img class='mc_cd' src='img/cancel.png'></img></div>");
	prodiv.find(".mc_cd").on("click", function(){request.abort(); prodiv.remove();});
	$("#tt_alerts_div").append(prodiv);*/
	// js variant (no img yet)
	//var dl = document.createElement("i"); dl.classList.add("fas"); dl.classList.add("fa-download"); prodiv.appendChild(dl);
	//var cl = document.createElement("i"); cl.classList.add("fas");cl.classList.add("fa-times"); prodiv.appendChild(cl);
	//var cl = document.createElement("img"); cl.src = "img/cancel_small_black.png"; cl.classList.add("mc_cd"); cl.onclick = function(){request.abort(); prodiv.remove();};

function load_file_pro(url, data=null, method="GET"){  // load file and show progress
	//
	var name = "";
	var request = new XMLHttpRequest();
	request.open(method, url, true);
	request.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded; charset=UTF-8');
	request.responseType = 'blob';
	request.onload = function(a){  // save_file()
		if(request.status==200){
			var cd = request.getResponseHeader("content-disposition"); // eg: attachment; filename="image001_2.jpg"
			var mt = /="?([^"]*)"?$/.exec(cd);
			if(mt==null) return;
			blob = new Blob([request.response], {type: request.getResponseHeader("content-type")} );
			var link = document.createElement('a');
			link.href = window.URL.createObjectURL(blob);
			link.download = mt[1];
			document.body.appendChild(link);
			link.click();
			document.body.removeChild(link);
		}else if(request.status==500){
			alert(lp("file_not_found")); // TODO: could find a way to get the error message
		}
	};
	// DLPRO
	var prodiv = document.createElement("div"); prodiv.classList.add("ttc_alert_div");
	var alm = document.createElement("span"); alm.classList.add("ttc_alert_msg"); alm.innerHTML = "0 %";
	var cl = document.createElement("span"); cl.innerHTML="X"; cl.classList.add("mc_cd"); cl.onclick = function(){request.abort(); prodiv.remove();};
	document.getElementById("tt_alerts_div").appendChild(prodiv);
	prodiv.appendChild(alm);
	prodiv.appendChild(cl);
	request.onerror = function(a,b,c){ 
		dlpro_error(prodiv, name); // DLPRO
	};
	// DLPRO
	request.onprogress = function(e){  
		if(!e.total) return;
		if(e.total==e.loaded){
			dlpro_done(prodiv, name);
			return;
		}
		var pro = Math.round((e.loaded*100)/e.total);
		var cd = request.getResponseHeader("content-disposition"); 
		var mt = /="?([^"]*)"?$/.exec(cd);
		name = mt? mt[1] : "download";
		dlpro_progress(prodiv, name, pro+"%");
	};
	/*var form_data = new FormData();
	if(data)
		for ( var key in data) 
		    form_data.append(key, JSON.stringify(data[key]));
	*/
	var postdata = ""; // NOTE: that is need form a GET-like string; which is then tranformed into POST 'key: value' format; if value is an obj - must be already jsoned
	if(data)
		for ( var key in data){
		    if(postdata!="") postdata += "&";
		    postdata += key + "=" + data[key];
		}
	//var postdata = data? JSON.stringify(data) : "";
	request.send(postdata);
}
	//window.open(url); return; // works
	//$.post(url, {"path" : path }, save_file); // not works, probably need set responseType

	// DEF IMG_HINT a hint-image; used to show file's big thumb in aw or logo in sp
function img_hint_show(src,x,y,sel='#tt_file_popup'){ // call in mouseenter
	$(sel).html( "<img src='" + src + "'>");      // <<< use pageX and pageY
	$(sel).css('left',x + 100);      // <<< use pageX and pageY
	$(sel).css('top',y);   // TODO: thumb may be below page edge
	$(sel).css('display','inline');     
}
function img_hint_hide(sel='#tt_file_popup'){ // call in mouseleave
	$(sel).css('display','none');     
}


function download_file(path){
	//var win = window.open(encodeURI("download_path.php?path=" + path), "download"); return; // DEF DLTAB opens new tab to download; but anyway makes page inresponsive
	var links = document.createElement('a');
	document.body.appendChild(links);
	links.download = "download";
	links.href = path;
	links.click();
	document.body.removeChild(links);
}

// CB_SEL_REC JS INIT
function cbsr_init(table_id, td_class, th_class){
	cbsr_class($("#" + table_id), td_class, th_class);
	cbsr_click($("#" + table_id));
} 
function cbsr_class(table, td_class, th_class){table.find("." + th_class + "," + "." + td_class).addClass("RES_checked");} // TODO: why this class not added on table create?
// passing table name allows to engage only certain table, avoiding nested tables
function cbsr_click(table, table_name=""){
	// SELALL - stuff to select all recs (checkbox in header) TODO: make same for thumbs?
	var ths = table_name==""? "th.RES_checked" : ".th-" + table_name + "-RES_checked";
	var trs = table_name==""? "tbody tr" : ".tr-" + table_name;
	table.on("click", ths, function(){
		$(this).toggleClass("selected");
		var sel = $(this).hasClass("selected");
		table.find(trs).each( function(){
			if(sel) $(this).addClass("selected"); else $(this).removeClass("selected");
		});
	} );
}
