<?php
/*
	Created: 20.02.2018
	Author: Alex Nosurov
	Description: db model functions for the archive
*/
	require_once(dirname(__FILE__)."/../path.php");
	require_once(proj_path."utils/db_mysql.php");
	require_once(proj_path."view/lang.php");
	require_once(proj_path."model/email.php");

	// DEF TEMP_USER: problem: if eg sms is downloaded by link in email - need register event as performed by link-user (may happen that currently used is logged in syst by another account); therefore need a way to supply to funcs, which return curr user info, this temp user info
	// NOTE: first, include the module with var, then set it, then use it
	// note: while there may be diff user/group - temp user must be same as temp group
	$temp_user_id = 0;
	$temp_user_role = "";

	function exec_cmd($cmd, $a, $b="", $c=""){
		exec_log("sudo /usr/bin/php ".proj_path."contr/$cmd.php \"$a\" \"$b\" $c", $o, $r) ;
		return $r;
	}

	function find_user($name, $pass){ // used by login controller
		if(!$pass) return false;
		$user = db\select_record("users","id, pass, pass_temp","name='$name'");
		if(!$user || !($user["pass"]==$pass || !$user["pass"]&&$user["pass_temp"]==$pass)) // TODO: pass_temp should be used only once
			return false;
		// update last login date
		$now = new DateTime("NOW");
		$now = $now->format( db\get_date_format() );
		db\execute("update users set date_login='$now' where id=".$user["id"]); // save pass in db; this is necessary to connect by imap to user mailbox (now used in delete_old_mails)
		return $user["id"];
	}
	function check_admin($user_id){
		//return db\select_field("users", "admin", "id=$user_id");
		return isset($_SESSION['role']) && role_is_admin( $_SESSION['role'] );
	}
	// $user_id: each role has underlying user (=curr user) or group (=some group of user)
	// teoretically, user may have several groups with same role and they will have different list of shops
	function try_set_user_role($user_id, $role){ // set_role set_user_role
		//log\debug("HER", $role);
		foreach($_SESSION["roles"] as $r)
			if( $r["id"]==$user_id && $r["role"]==$role){
				set_user_role( $r );
				return true;
			}
		return false;
	}
	// SEL_ROLE ; this should be called only when it's checked that user has $role ; otherwise use try_set_user_role()
	function set_user_role($role){
		$_SESSION['role'] = $role; // array: role => str, shops => array
		log\info("user role set to ".$role["role"]);
		//log\debug($role);
	}

	function try_set_portal($portal){
		global $portal_list;
		//log\debug("PPP", $portal);
		if(in_array($portal, $portal_list)){
			$_SESSION["portal"] = $portal;
			return true;
		}
		return false;
	}
	// called to setup session for a successfully logged in user
	function setup_user_session($user_id){
		//session_destroy();
		$user_name = db\select_field("users","name","id=$user_id");
		// DEF NO_LOGOUT problem that if have many big files to upload - automatic logout cancells upload
		if(session_status()==PHP_SESSION_NONE){ // or else gives error 'Session ini settings cannot be changed when a session is active' when LOGINOUT 
			ini_set('session.cookie_lifetime', 60 * 60 * 24 * 100);
			ini_set('session.gc_maxlifetime', 60 * 60 * 24 * 100);
		}
		$_SESSION['user_name'] = $user_name;
		$_SESSION['user_id'] = $user_id;
		// SEL_ROLE
		$_SESSION['roles'] = ur_find_roles($user_id); // UR
		if( sizeof( $_SESSION['roles'] ) == 1 )
			set_user_role($_SESSION['roles'][0]);
		$_SESSION['admin'] = check_admin( $user_id ); // indicates if the uses is admin NOTE: in lightbox need call it after set roles
		/*// need guest to allow to logout (need show initial page with logout icon)
		if( sizeof( $_SESSION['roles'] ) == 0 )
			set_user_role( array("role" => "GUEST", "shops" => array()));*/
		lang_reset();
		lang_get(); // read lang (not using that of curr session, which was used during login)
		log\info("User $user_name $user_id logged in");
		//log\debug("admin: ", $_SESSION['admin']);
		unset($_SESSION["login_fail"]); // LOGIN_FAIL
	}
	function logout(){
		$user = get_or_def($_SESSION, 'user_name');
		unset($_SESSION['user_id']);
		unset($_SESSION['user_name']);
		unset($_SESSION['role']); // DEF SEL_ROLE - stuff to select role (if user has several roles)
		unset($_SESSION['portal']); // PORTAL
		lang_reset();
		log\info("User $user logged out");
	}
	// needs session started
	function get_curr_user_id(){
		global $temp_user_id; if($temp_user_id) return $temp_user_id; // TEMP_USER
		if(session_id() == '')
			session_start();
		return get_or_def($_SESSION, "user_id");
	}
	// root dir for user (uploaded) files; without end-slash
	function get_user_dir(){
		$user_id = get_curr_user_id();
		return db\select_field("users","email","id=$user_id" )  ;
	}
	function get_user_name(){
		$user_id = get_curr_user_id();
		return db\select_field("users","name","id=$user_id" )  ;
	}
	function get_user_info($param=""){
		if(!($user_id = get_curr_user_id())) return "";
		if(!$param)
			return db\select_record("users","*","id=$user_id" )  ;
		return db\select_field("users", $param, "id=$user_id" )  ;
	}
	function get_user_settings($user_id){
		$sett = db\select_to_array("settings", "*", "user_id=$user_id");
		$params = array();
		foreach($sett as $s)
			$params[$s["pname"]] = $s["pvalue"];
		return $params;
	}
	// find user by email; while 'find_user' func already exists - need use another name 
	function find_email_id($email){
		//return db\select_field("users", "id", "email='$email'");
		return db\select_field("users", "id", db\in_list("email", $email) ); // version when account may be associated to several emails
	}

	function create_user($name, $email, $pass, $admin=0, $worker=0){
		if(user_exists($email))
			throw  new Exception("user '$email' already exists");
		db\execute("delete from users where email='$email' and pass is null"); // delete prev registration attempt
		$name = db\escape($name);
		$email = db\escape($email);
		$pass = db\escape($pass);
		$admin = $admin? '1' : '0';
		$worker = $worker? '1' : '0';
		$lang = lang_get_curr(); // that which is selected in reg form
		db\execute("insert into users(name,email,pass_temp,user_dir,admin,worker) values('$name', '$email', '$pass', '$email/', $admin, $worker)");
		$id = db\get_last_id();
		save_settings($id, array("lang" => $lang));
		ua_register($email, $id, "user", $email, "create", "admin: $admin, worker: $worker");
		return $id;
	}
	function delete_user($id){
		/* TODO: this is code to delete ws users, for now leave it inactive (admin should del itself)
		$wss = db\select_field_to_array("ws", "id", "owner_id=$id");
		foreach($wss as $ws_id){
			ws_delete($ws_id);
		}*/
		$user = db\select_record("users", "*", "id=$id");
		db\execute("delete from users where id=$id");
		db\execute("delete from settings where user_id=$id");
		ua_register($user["email"], $id, "user", $user["email"], "delete");
	}
	function user_exists($email){return db\exists("users", "email='$email' and pass is not null");}
	function restore_pass($email, $name){ // FORGOT_PASS
		$cond=array(); if($email) $cond[]=db\in_list("email", $email); if($name)$cond[]="name='$name'"; $cond=join(" AND ",$cond);
		if(!$cond || !($users = db\select_to_array("users", "email,name,pass,pass_temp", $cond )))
			throw new user_exception('user_not_exists');
		// send mail
		$settings = get_settings();
		$sm = $settings["alerts"];
		foreach($users as $user){
			if(!$user["pass"]) $user["pass"] = $user["pass_temp"];
			$email = $user["email"];
			$message = lang_html_load("templates/restore_pass", false, array("php_name" => $user["name"], "php_project" => project_name, "php_pass" => $user["pass"], "php_link" => base_url.proj_path_rel."login.php?log_user=".$user["name"]));  //  RESTORE_PASS_NAME version
			send_mail($sm["noreply_email"], "no reply", lp("restoring_password"), $email, $message, $sm, $is_html=true, $img_path="img/");
		}
	}
	function send_credentials($user_id){
		$settings = get_settings();
		$sm = $settings["alerts"];
		$user = db\select_record("users","*","id=$user_id");
		$lang = lang_get_db($user_id, lang_def);
		//log\debug($lang);
		if(!$user["pass"]) $user["pass"] = $user["pass_temp"];
		if(!$user["pass"]) { $pt = generate_random_string(); db\execute("update users set pass_temp = '$pt' where id = $user_id"); $user["pass"] = $pt;}
		$message = lang_html_load("templates/access_credentials", false, array("php_name" => $user["name"], "php_email" => $user["email"], "php_project" => project_name, "php_pass" => $user["pass"], "php_link" => base_url.proj_path_rel."index.php", "php_sett" => base_url.proj_path_rel."settings.php", "portal_link" => base_url.proj_path_rel."portal_icon.php?dark"), $lang);
		log\debug($message);
		send_mail($sm["noreply_email"], "no reply", lp("access_credentials"), $user["email"], $message, $sm, $is_html=true, $img_path="img/");
	}
	function register_user($name, $email, $admin=0, $worker=0, $location=""){
		$pass = generate_random_string();
		$id = create_user($name, $email, $pass, $admin, $worker);
		// send mail
		$settings = get_settings();
		$sm = $settings["alerts"];
		$message = lang_html_load("html/register_confirm.html", false, array("php_name" => $name, "php_email" => $email, "php_project" => project_name, "php_pass" => $pass, "php_link" => $location ));
		send_mail($sm["noreply_email"], "no reply", "registrazione su ".project_name, $email, $message, $sm, $is_html=true, $img_path="img/");
		return $id;
	}
	// check if new login is same that curr login; 
	function same_user($new_user_id, $curr_user_id){
		if($new_user_id==$curr_user_id) return true;
		// only possible case - if curr user is user and new is group that contains it
		$curr_user = db\select_record("users", "*", "id=$curr_user_id");
		if($curr_user["user_type"]!="user") return false;
		$new_user = db\select_record("users", "*", "id=$new_user_id");
		if($new_user["user_type"]!="group") return false;
		return strpos( $new_user["email"].";", $curr_user["email"].";" )!==false;
	}

	function get_mail_settings(){
		$settings = get_settings();
		return $settings = $settings["alerts"];
	}

	function on_end_session(){ // TODO: use it as cb
		exec_log("xx -rf ".proj_path."/fu/server/php/files/".session_id()) ;
	}

	function order_delete($order_id){
		/*foreach(db\select_field_to_array("app_lbs", "id", "order_id=$order_id") as $lbs_id)
			lbs_delete($lbs_id); commented 25.10.22; donno why should del them; lbs is assigned even before order create */
		db\execute("delete from orders where id=$order_id");
	}


	// SETTINGS MODEL
	function read_settings($user_id, $param=""){
		if($param) 
		return db\select_field("settings", "pvalue", "user_id=$user_id AND pname='$param'");
		return db\select_to_array("settings", "pname,pvalue", "user_id=$user_id");
	}
	function save_settings($user_id, $settings){
		foreach($settings as $name => $val){
			if( db\exists("settings", "user_id=$user_id AND pname='$name'") )
				db\execute("update settings set pvalue='".db\escape($val)."' where user_id=$user_id AND pname='$name'");
			else
				db\execute("insert into settings (user_id,pname,pvalue) values ($user_id, '$name', '".db\escape($val)."')");
		}
	}
	// DEF USER_ACTIONS: stuff to register (log) in db main user actions
	//ua_register($target_user, $target_id, $target_type, $target, $action_type, $action, $action_user);
	function ua_register($target_user, $target_id, $target_type, $target, $action_type, $action="", $action_user=NULL, $size=0){ // action_type: upload/download/
		if($action_user===NULL) $action_user = get_or_def($_SESSION, "user_name");
		$target = substr(db\escape($target), 0, 49);
		$date = db\now();
		try{db\execute("insert into user_actions(date_action, action_user, target_user, action_type, action, target_id, target_type, target, size) values ('$date', '$action_user', '$target_user', '$action_type', '$action', '$target_id', '$target_type', '$target', $size)");}catch(Exception $e){}
	}

	// LINK
	function compile_link($ap_id, $code=""){ return base_url.proj_path_rel."apap.php?id=$ap_id&link=$code"; }
	/* EXLINK function find_link_user($ap_id, $code){
		log\info("searching link $ap_id $code...");
		$email = db\select_field("links", "email", "app_id=$ap_id and code='$code'");
		// TODO: here make check - if already loggin in by another account, maybe force him exit manually
		if(!$email) {
			log\error("link not found $ap_id $code");
			echo "link not valid";
			exit();
		}else
			log\info("link found: $email");
		$user_id = find_email_id($email);
		if(!$user_id){
			log\info("registering new user");
			$user_id = register_user(get_mail_user($email), $email);
		}
		if(session_id() == '')
			session_start();
		setup_user_session($user_id);
		//log\debug($_SESSION);
	}*/

    // SHOPER_VIEW
    function create_shop_camp_view($camp_id){
		// if(!$camp_id) return "shops";
		// LBC from certain camp
		db\execute("CREATE VIEW IF NOT EXISTS v_lbc_camp_$camp_id as SELECT *, (select sum(lb_count) from lbs s where s.camp_id = $camp_id and s.lb_id = c.id)  AS lb_done_count from lbc c where c.istop=1");
		$name = "v_shop_camp_$camp_id";
        $req = "CREATE VIEW IF NOT EXISTS $name as SELECT sh.*, ";
        //$req.= "(select count(*) from lbc where lbc.shop_id = sh.id ) as lbc_count, ";
        //$req.= "(select count(*) from v_lbc_camp_$camp_id where v_lbc_camp_$camp_id.shop_id = sh.id and (lb_done_count is null or lb_done_count<lb_count)) as lbc_todo_count, ";
		// version where lbc_todo_count is 0/1; thus convenient to make filter done/not-done
        $req.= "if((select count(*) from v_lbc_camp_$camp_id where v_lbc_camp_$camp_id.shop_id = sh.id and (lb_done_count is null or lb_done_count<lb_count))>0, 1, 0) as lbc_todo_count, ";
        $req.= "(select count(*) from v_lbc_camp_$camp_id where v_lbc_camp_$camp_id.shop_id = sh.id) as lbc_count, ";
        $req.= "orders.id order_id ";
        $req.= "from shops sh ";
		$req.= " left join orders on orders.shop_id = sh.id and orders.camp_id = $camp_id";
        $req.= " where (select count(*) from v_lbc_camp_$camp_id where v_lbc_camp_$camp_id.shop_id = sh.id) > 0";
		db\execute($req);
		return $name;
	}


	// UR
	// get rights of a certain user
	function ur_find_roles($id){
		$roles = array();
		$user = db\select_record("users", "*", "id=$id");
		if($user["user_type"]=="user"){ // has its own rights and from its groups
			// role from users table:  'ADMIN','ENGINEERING','VISUAL_ADMINISTRATOR','GRAPHIC','PRODUCTION_INTERNAL'
			$urs = preg_split('/;/', $user["user_role"], -1, PREG_SPLIT_NO_EMPTY); // now users.user_role is a ';' separated string list of roles
			foreach($urs as $ur){
				$roles[] = array("role" => $ur, "shops" => array(), "id" => $user["id"] );
			}
			// roles from groups table: 'LOCAL_VISUAL','PRODUCTION'
			$email = $user["email"];
			$groups = db\select_to_array("groups", "id, name, user_role", db\in_list("email", $email) ); // TODO: gives false positives for emails like <stuff>$email
		}else{ // user is group => has rights only from this group
			$groups = array($user);
		}
		// NOTE: user's current role may be group's role, so this is the role which belongs to another user (user-group) TODO: why actually need it; seems now it's used for some reason as: get_curr_group_id
		foreach($groups as $group){
			$gid = $group["id"];
			$shop_ids = db\select_field_to_array("shops", "id", "visual_id=$gid or production_id=$gid");
			$roles[] = array("role" => $group["user_role"], "shops" => $shop_ids, "group" => $group["name"], "id" => $group["id"] );
		}
		return $roles;
	}
	// role is array (see ur_find_roles)
	function ur_get_user_role_name(){ global $temp_user_role; return $temp_user_role? $temp_user_role : get_or_def2($_SESSION, "role", "role", "GUEST"); } // TEMP_USER proof
	//function ur_get_user_role_name(){ global $temp_user_role; return $temp_user_role? $temp_user_role : $_SESSION["role"]["role"]; } // TEMP_USER proof
	// returns array with role params: ( role => name, shops =>, id ? )
	function ur_get_user_role(){ return $_SESSION["role"]; } // get_role; call only when logged
	function get_curr_group_id(){ global $temp_user_id; return $temp_user_id? $temp_user_id : ur_get_user_role()["id"]; } // TEMP_USER
	function ur_get_name(){ return isset($_SESSION["role"])? $_SESSION["role"]["role"]:""; } // call only when logged
	//var_dump(ur_find_roles(75));

	// for each role: return list of available pages; 
	// NOTE: each page also has different functions; at the moment each page does it by itself; maybe incapsulate it here too
	function get_role_pages($role){
		if($role=='ADMIN') return array("home","campaigns","shops","orders","users", "groups", "hires", "archive"); // all pages TODO: add here other (settings)
		if($role=='ENGINEERING') return array("home","campaigns","shops","orders", "hires"); 
		if($role=='LOCAL_VISUAL' || $role=='VISUAL_ADMINISTRATOR') return array("home","shops"); 
		if($role=='PRODUCTION') return array("home","orders", "hires"); 
		if($role=='GRAPHIC') return array("home","orders", "hires"); 
		if($role=='PRODUCTION_INTERNAL') return array("home","orders", "hires"); 
		if($role=='HIRES') return array("hires");  // HRR
		return array();
	}
	function get_restricted_pages(){ return array("campaigns","shops","orders","users","groups","hires", "archive"); } // PARC
	// in lightbox it means that if user has access to page - it sees it as admin, eg for shops page - it sees interface to modify shops (not to assign subjects)
	function role_is_admin($role){ return $role=='ADMIN' || $role=='ENGINEERING'; } 
	// get field name of shops table corresponding to given role; role = LOCAL_VISUAL, PRODUCTION
	function role_to_field($role){ return $field = $role=="LOCAL_VISUAL"? "visual_id" : "production_id"; } 
	function is_group_role($role){ return $role=="LOCAL_VISUAL" || $role="PRODUCTION" ; }


	// NOTE TODO: in SHOP_SINGLE_GROUP this is not used; used only once to move info from groups table to shops table
	// GROUPS  DEF USR
	// now visual/production is saved in groups; yet may need to control shops - which groups are assigned to them
	// this util is used to refresh the cache-field of shops
	function update_shop_roles(){
		update_shop_role("visual_id", "LOCAL_VISUAL");
		update_shop_role("production_id", "PRODUCTION");
	}
	function update_shop_role($field, $role){
		db\execute("update shops set $field=0");
		$groups = db\select_to_array("groups", "id,shop_paths,shop_ids", "user_role='$role'");
		foreach($groups as $group){
			$sid = $group["shop_ids"]; $sid=str_replace(";",",",$sid);
			$gid = $group["id"];
			if($sid)
				//db\execute("update shops set $field = concat($field,'$name',';') where id in($sid)");
				db\execute("update shops set $field = $gid where id in($sid)");
			$sps = $group["shop_paths"];
			if($sps){
				$sps = preg_split("/;/", $sps, -1, PREG_SPLIT_NO_EMPTY);
				foreach($sps as $path)
					//db\execute("update shops set $field = concat($field,'$name',';') where concat('world/',area,'/',country,'/',city) like '$path%'");
					db\execute("update shops set $field = $gid where concat('world/',area,'/',country,'/',city) like '$path%'");
			}
		}
	}
	// FILE_THUMB ; the way thumb name for a file is made
	function get_file_thumb_path($file_id, $file_name){if(!$file_id) return $file_name;  return $file_id.".jpg"; }
	//function get_file_thumb_path($file_id, $file_name){ return $file_name; } // def case - use file itself

	function get_img_url($img_id){ 
		if( $file = db\select_record("files", "path,name", "id=$img_id") )
			return get_files_path().$file["path"].$file["name"];
	}

	// get arr of shops ids
	function get_camp_shops($camp_id){
		return preg_split("/;/", db\select_field("camps", "countries", "id=$camp_id"), -1, PREG_SPLIT_NO_EMPTY );
	}
	//
	function get_user_shops($user_id, $user_role){
		if($user_role=="PRODUCTION" || $user_role=="LOCAL_VISUAL")
			return db\select_field_to_array("shops", "id", ($user_role=="LOCAL_VISUAL"?"visual_id":"production_id")."=$user_id");
		return array();
	}
	// works even if group role was changed TOTEST
	function reset_user_shops($user_id){ db\execute("update shops set visual_id=0 where visual_id=$user_id"); db\execute("update shops set production_id=0 where production_id=$user_id"); }

	// TODO: replace it with table links
	function page_link($camp_id, $rec_id=0, $page="orders", $role="", $user_id=0){
		if(!$role) $role = ur_get_user_role_name();
		if(!$user_id) $user_id = get_curr_user_id(); // DEF EMUID: insert user id in link
		$role = get_role_code($role);
		return base_url.proj_path_rel."$page.php?cid=$camp_id&r=$role&p=".get_portal_name().($rec_id?"&id=$rec_id":"")."&uid=$user_id";
	}
	function create_link($target_id, $target_type, $user_id=0){
		$code = generate_random_string();
		db\execute("insert into links(code, target_id, target_type, user_id) values ('$code', $target_id, '$target_type', $user_id)");
		return $code;
	}
	function read_link($code){ return db\select_record("links","*","code='$code'");}

	function get_admin_users(){ return db\select_to_array("users", "*", db\in_list("user_role", "ADMIN")." AND ".db\in_list("user_role", "ENGINEERING") ); }


	$stat_conds = array(
		"total" => "true",
		"tosel" => "lbc_todo_count<>0",
		"toorder" => "lbc_todo_count=0 and order_id is null",
		"toacc" => "order_state1 = 'draft'",
		"toupl" => "order_state1 in ('draft', 'accepted', 'rejected')",
		"reject" => "order_state1 = 'rejected'",
		"toapp" => "order_state1 = 'uploaded'",
		"toprint" => "order_state1 = 'approved'",
		"printed" => "order_state1 = 'printed'"
	);

	function add_stat_cond($capt, $table, $filter, $link, $cond){
		global $stat_conds;
		$cnt = db\select_field($table, "count(*)", $stat_conds[$filter]." and $cond");
		return array(lpp($capt), $cnt, $link."&filter=$filter"); 
	}
	function print_user_stats($camp_id){
		$role = ur_get_user_role();
		$camp_shops = get_camp_shops($camp_id);
		$user_shops = $role["shops"]; // get_user_shops(get_curr_user_id(), $role["role"]);
		$res = array();
		// 1 VISUALS
		if($role["role"]=="LOCAL_VISUAL" || $role["role"]=="VISUAL_ADMINISTRATOR"){
			$user_camp_shops = $role["role"]=="LOCAL_VISUAL"? array_intersect($camp_shops, $user_shops) : $camp_shops;
			//log\debug($user_camp_shops);
			if(!sizeof($user_camp_shops)) return ""; // TODO: TEMP happens now.. maybe artefacts
			$view = create_shop_camp_view($camp_id); // seems it contains camp_id condition
			$link = page_link($camp_id, 0, "shops");
			$cond = db\id_in($user_camp_shops);
			$res[]=	add_stat_cond('$total$', $view, "total", $link, $cond);
			$res[]= add_stat_cond('$to_do$', $view, "tosel", $link, $cond);
			$res[]= add_stat_cond('$to_order$',$view, "toorder", $link, $cond);
		}
		// 2 PRODUCTION_INTERNAL (all shops)
		if($role["role"]=="PRODUCTION_INTERNAL"){
			$cond = "camp_id=$camp_id";
			$link = page_link($camp_id, 0, "orders");
			$res[]=	add_stat_cond('$total$', "orders", "total", $link, $cond);
			$res[]=	add_stat_cond('$to_accept$', "v_orders_state1", "toacc", $link, $cond);
			$res[]=	add_stat_cond('$to_upload$', "v_orders_state1", "toupl", $link, $cond);
			$res[]=	add_stat_cond('$rejected$', "v_orders_state1", "reject", $link, $cond);
		}
		// 3 GRAPHIC (all shops)
		if($role["role"]=="GRAPHIC"){
			$cond = "camp_id=$camp_id";
			$link = page_link($camp_id, 0, "orders");
			$res[]=	add_stat_cond('$total$', "orders", "total", $link, $cond);
			$res[]=	add_stat_cond('$to_approve$', "v_orders_state1", "toapp", $link, $cond);
		}
		// 4 PRODUCTION
		if($role["role"]=="PRODUCTION"){
			//$user_camp_shops = array_intersect($camp_shops, $user_shops); // TODO: actually needn't sel by camp shops - orders with camp_id cont only shops of camp
			if(!sizeof($user_shops)) return ""; // TODO: TEMP happens now.. maybe artefacts
			$link = page_link($camp_id, 0, "orders");
			$cond = db\id_in($user_shops, "", "shop_id")." AND camp_id=$camp_id";
			$res[]=	add_stat_cond('$total$', "v_orders_state1", "total", $link, $cond);
			$res[]= add_stat_cond('$to_print$', "v_orders_state1", "toprint", $link, $cond);
		}
		if($role["role"]=="ADMIN" || $role["role"]=="ENGINEERING"){
			// shops
			if(!sizeof($camp_shops)) return ""; // TODO: TEMP happens now.. maybe artefacts
			$view = create_shop_camp_view($camp_id); // seems it contains camp_id condition
			$link = page_link($camp_id, 0, "shops");
			$cond = db\id_in($camp_shops);
			$res[]=	add_stat_cond('$shops$ $total$', $view, "total", $link, $cond);
			$res[]= add_stat_cond('$shops$ $to_do$', $view, "tosel", $link, $cond);
			$res[]= add_stat_cond('$shops$ $to_order$',$view, "toorder", $link, $cond);
			// orders
			$link = page_link($camp_id, 0, "orders");
			$cond = "camp_id=$camp_id";
			$res[]=	add_stat_cond('$orders$ $total$', "orders", "total", $link, $cond);
			$res[]=	add_stat_cond('$orders$ $to_accept$', "v_orders_state1", "toacc", $link, $cond);
			$res[]=	add_stat_cond('$orders$ $to_upload$', "v_orders_state1", "toupl", $link, $cond);
			$res[]=	add_stat_cond('$orders$ $to_approve$', "v_orders_state1", "toapp", $link, $cond);
			$res[]= add_stat_cond('$orders$ $to_print$', "v_orders_state1", "toprint", $link, $cond);
			$p1 = db\select_field("lbc", "count(*)", "iscont=0 and ".db\id_in($camp_shops, "id", "shop_id"));
			$p2 = db\select_field("app_lbs", "sum(lb_count)", "camp_id=$camp_id and img_id<>0 and shop_id in (select shop_id from v_orders_state1 where order_state1='printed')");
			if(!$p2) $p2="0";
			$res[] = array(lp('progress'), "$p2/$p1", $link."&filter=printed");
		}
		return sizeof($res)? array("page_link" => $link, "stats" => $res) : false;
	}
	function get_triple_path($camp_id, $lbs_id){ return camp_path."$camp_id/lbs/$lbs_id/"; }
	function clear_pdf($lbs_id){
		db\execute("delete from draws where app_id = $lbs_id");
		db\execute("delete from pins  where app_id = $lbs_id");
	}
?>
