	<?php
		function create_files_zip($start_dir, $files=array(), $zip_name=""){ // NOTE: pass where possible zip_name to avoid another copy (with random name?)
			if(!$zip_name)
				$zip_name = temp_path.generate_random_string().".zip"; // now this file is temp, hope no collisions NOTE: some clients expect zip to be exactly in temp_path (download.php) to control if zip was created (or original was returned)
			log\debug($zip_name);
			$zip = new ZipArchive; // apt-get install php5.6-zip
			if(! $zip->open($zip_name, ZipArchive::CREATE | ZipArchive::OVERWRITE))
				throw new Exception("create zip fail"); // NOTE: this may happen if file is busy (possible in ic3)
			set_time_limit(0);
			foreach($files as $file){
				$path = $start_dir.$file;
				$zpath = $file;
				log\debug("added $path $zpath");
				if( is_file($path) )
					$zip->addFile($path, $zpath);
				else
					log\error("file not found: '$path'");
			}
			if(!$zip->close())
				throw new Exception("failed to write zip");
			return $zip_name;
		}
		function download_apps($apps, $orders, $camp_id, $role){
			ob_start();
			$files = array(); // $apps is what is passed in POST and found in db; $files - what is actually present in the dir
			$path = get_source_path()."campaigns/$camp_id/lbs/";

			if(sizeof($orders))
				$apps = array_unique(array_merge($apps, 
					db\select_field_to_array("app_lbs", "id", "app_state in ('uploaded','approved','printed') and ".db\id_in($orders, "", "order_id") ) ));

			if(!sizeof($apps))
				throw new user_exception("no lbs to download");

			foreach($apps as $app_id){
				if(!is_dir($path.$app_id)) { log\debug("dir not found: '$path $ap_id'"); continue; }
				$af = scandir($path.$app_id);  
				$app_files = array(); foreach($af as $f) $app_files[]="$app_id/$f";
				$files = array_merge($files, $app_files );
				if($role=="PRODUCTION")
					print_lbs($app_id); // NOTE: if download from web-int - print_lbs is requested by js to contr, which is better; although this unit may also be considered a contr of dl req
			}
			$files = array_filter($files, function($f){ return in_array(extract_ext($f), array("pdf","indd","idml")); }); // TODO: now the dir contains all stuff including scales; maybe use a dedicated dir for triples
			log\debug($files);
			if(sizeof($apps)) $shop_name = db\select_field("v_lbs", "shop_name", "id=$app_id"); else return;  // 18.08.22 added shop name to zip file name
			$zip = create_files_zip($path, $files); // uses source_path from path.php
			ob_clean();
			download_file_path( $zip, $shop_name."_$camp_id.zip" );
			unlink($zip);
		}
		function download_hires($file_id){
			ob_start();
			$target = db\select_record("hires", "path,name", "id=$file_id");
			$path = get_source_path().hires_path_rel.$target["path"].$target["hires_name"];
			ob_clean();
			download_file_path( $path, "HR_".basename($path) );
			log\info("download ok '$path'");
		}
		// NOTE: by idea not used; it would contain 200GB of stuff
		function download_hires_zip($camp_id){
			ob_start();
			$camp_path = "campaigns/$camp_id/"; $zip_name = "hires_cache.zip"; $sp = proj_path.get_files_path();
			$files_all = db\select_to_array("files", "path, hires_name name", "hires_name<>'' and hires_name is not null and path = '$camp_path'");
			foreach($files_all as &$file) $file["path"] = $file["path"].hires_path_rel;
			update_zip($files_all, $sp, $camp_path.hires_path_rel, $zip_name);
			ob_clean();
			download_file_path( $sp.$camp_path.hires_path_rel.$zip_name, "HR_$camp_id.zip" );
		}
		function get_lbs_path($lbs_id){
			$camp_id = db\select_field("lbs", "camp_id", "id=$lbs_id"); // TODO: better pass from js
			return  get_source_path()."campaigns/$camp_id/lbs/$lbs_id/";
		}
		function download_triple($lbs_id){
			ob_start();
			$path = get_lbs_path($lbs_id);
			$files = scandir($path);
			$files = array_filter($files, function($f){ return in_array(extract_ext($f), array("pdf","indd","idml")); }); // TODO: now the dir contains all stuff including scales; maybe use a dedicated dir for triples
			$zip = create_files_zip($path, $files); // uses source_path from path.php
			$app  = db\select_record("v_lbs", "shop_name, name", "id=$lbs_id");  // 18.08.22 added shop name to zip file name
			ob_clean();
			download_file_path( $zip, $app["shop_name"]."_".$app["name"]."_$lbs_id.zip" );
			unlink($zip);
		}
		function download_pdf($lbs_id){
			ob_start();
			$path = get_lbs_path($lbs_id);
			$files = scandir($path);
			foreach($files as $file) 
				if(extract_ext($file)=="pdf"){
					ob_clean();
					download_file_path( $path.$file, $file );
					log\info("download ok '$path$file'");
				}
		}
?>
