<?php
/*
	Created: 19.01.2022 
	Author: Alex Nosurov
	Description: prepare data to send emails
*/
	require_once(dirname(__FILE__)."/../path.php");
	require_once(proj_path."utils/db_mysql.php");
	require_once(proj_path."view/lang.php");


	function email_camp_start($event_id, $camp_id){
		$camp = db\select_record("camps", "id, name camp_name, season camp_season, date_from, date_till, countries", "id=$camp_id");
		$shid = str_replace(";", ",", $camp["countries"]);
		// show list of areas in email
		$areas = db\select_field_to_array("shops", "distinct area", "id in ($shid)");
		$a="";foreach($areas as $ar)$a.="<div>$ar</div>";
		$camp["camp_areas"] = $a;
		$subj = '$New_campaign_started$: '.$camp["camp_name"];
		send_user_emails($event_id, $camp, $subj, "camp_start");
	}
	function render_lbs_list($lbs_list, $lang){
		$lbs_html = "";
		foreach($lbs_list as $lbs){
			//$lbs["url"] = base_url.proj_path_rel.files_path.$lbs["path"].$lbs["name_mini"]; works for html page
			$lbs["url"] = $lbs["path"].get_file_thumb_path($lbs["img_id"], $lbs["name_mini"]); // images are imbedded (is used absolute img_path and each img rel path) ; using FILE_THUMB
			$lbs["w"] = $lbs["r"]-$lbs["l"]+1;
			$lbs["h"] = $lbs["b"]-$lbs["t"]+1;
			//$lbs["delivery_date"] = $order["delivery_date"];
			$lbs_html .= lpp_html(replace_keys(file_get_contents(template_path."lbs_info"), $lbs, 3), $lang);
		}
		return $lbs_html;
	}

	// subj must be in lpp format to be translated
	function send_user_emails($event_id, $data, $subj, $template, $msg=''){
		$settings = get_mail_settings();
		$users = db\select_to_array("v_event_users", "dest_group_id, dest_group_email, order_link, apap_link, triple_link", "event_id = $event_id");
		$emails = array(); // DEF EDEM Excl Double EMails
		foreach($users as $user){
			$email_list = $user["dest_group_email"];
			$email_list = preg_split('/;/', $email_list, -1, PREG_SPLIT_NO_EMPTY); $email_list=array_diff($email_list, $emails); $emails = array_merge($emails, $email_list);  $email_list = join(";", $email_list);  // EDEM
			//$data["tmp"]=$email_list; // TEMP
			$data["url"] = $user["order_link"];
			$data["url_subj"] = $user["apap_link"];
			$data["message"] = $msg;
			if($user["triple_link"])
				$data["durl"] = base_url.proj_path_rel.$user["triple_link"]; // EMAIL_LINK ; individual for each user
			$lang = lang_get_db( $user["dest_group_id"] , lang_def);
			if(isset($data["lbs_list"])) // del order mail not contains lbs list
				$data["lbs_info"] = render_lbs_list($data["lbs_list"], $lang); // lbs info; depends on lang, so personal for each email 
			$subj = lpp($subj, lang_read($lang));
			$html = lpp_html(replace_keys(file_get_contents(template_path.$template), $data, 3), $lang);
			if(!$email_list){
				log\debug("empty email list");
				continue;
			}
			send_mail($sender=$settings["noreply_email"], project_name, $subj, $email_list, $html, $settings, $is_html=true, $img_path = proj_path.get_files_path());
			log\debug($html);
		}
	}
	function send_order_email($event_id, $order_id, $lbs_id=0, $msg='', $data=null){ // data is used to pass apap link (assoc arr)
		$order = db\select_record("v_orders_state", "id,shop_id,camp_id,shop_name,camp_name,country country_name", "id=$order_id");
		$shop_id = $order["shop_id"];
		$camp_id = $order["camp_id"];
		$order = array_merge($order, db\select_record("camps", "dl_produce delivery_date", "id=$camp_id"));
		$lbs_list = db\select_to_array("app_lbs", "id, lb_id, path, img_id, name_mini,l,t,r,b,name name_lbs", $lbs_id? "id=$lbs_id" : "shop_id=$shop_id and camp_id=$camp_id and img_id<>0");
		//if($role=="PRODUCTION") 	foreach($lbs_list as &$lbs)		$lbs["durl"] = base_url.proj_path_rel."download.php?link=".link_create("triple", $lbs["id"]);  // EMAIL_LINK durl will be used in templ to add dl link
		//if($role=="PRODUCTION") 	$order["durl"] = base_url.proj_path_rel."download.php?type=order&id=$order_id&portal=".get_portal_name();  // EMAIL_LINK dl whole order
		$order["lbs_list"] = $lbs_list; // lbs list 
		$event = db\select_record("events", "*", "id=$event_id");
		$subj = $event["message"].": ".$order["shop_name"];
		if($data) $order = array_merge($order, $data);
		send_user_emails($event_id, $order, $subj, "order_info", $msg);
	}
?>
