<?php
/*
	Created: 28.11.2021
	Author: Alex Nosurov
	Description: db model functions for the archive
*/
	require_once(dirname(__FILE__)."/../path.php");
	require_once(proj_path."utils/db_mysql.php");
	require_once(proj_path."view/lang.php");

	function lb_create($lb){
		db\execute("insert into lbc " . db\compile_insert($lb)); 
		return db\get_last_id();
	}
	function lb_update($lb, $id){
		db\execute("update lbc set " . db\compile_update($lb) . "where id = $id");
		lb_delete_lbs($id); // if lb size changed - lbs not valid
	}
	function lb_remove($lb_id){
		// if it's a cont - free childs
		$ids = db\select_record("lbc", "lb1_id, lb2_id", "id=$lb_id" );
		$id1 = $ids["lb1_id"]; $id2 = $ids["lb2_id"];
		db\execute("update lbc set istop = true where id = $id1 or id = $id2");
		// remove 
		db\execute("delete from lbc where id = $lb_id");
		lb_delete_lbs($lb_id);
	}
	// get top LBs of a shop
	function lb_get_shop($shop_id){return db\select_to_array("lbc", "*", "istop=1 AND shop_id=$shop_id", "name"); }
	function lb_get_childs($id){
		$ids = db\select_record("lbc", "lb1_id, lb2_id", "id=$id" );
		$id1 = $ids["lb1_id"]; $id2 = $ids["lb2_id"];
		$lb1 = db\select_record("lbc", "*", "id=$id1");
		$lb2 = db\select_record("lbc", "*", "id=$id2");
		return array($lb1,$lb2);
	}
	//
	function lb_join($id1, $id2, $isvert=0){
		lb_delete_lbs($id1);
		lb_delete_lbs($id2);
		$lb1 = db\select_record("lbc", "*", "id=$id1");
		$lb2 = db\select_record("lbc", "*", "id=$id2");
		db\execute("update lbc set istop = 0 where id=$id1 or id=$id2");
		$w = $lb1["width"]; $h = $lb1["height"];
		if($isvert) $h += $lb2["height"];
		else $w += $lb2["width"];
		$shop_id = $lb1["shop_id"];
		$name = $lb1["name"].', '.$lb2["name"];
		$lb_count = $lb1["lb_count"] + $lb2["lb_count"];
		db\execute("insert into lbc(lb1_id,lb2_id,name,width,height,istop,iscont,isvert,shop_id,lb_count) values ($id1,$id2,'$name',$w,$h,1,1,$isvert,$shop_id,$lb_count)");
		return db\get_last_id();
	}

	// delete lbs belonging to a lb
	function lb_delete_lbs($lb_id){ 
		foreach(db\select_field_to_array("lbs", "id", "lb_id=$lb_id") as $lbs_id)
			lbs_delete($lbs_id);
	}


	// ----------------------- LBS ------------------------------------

	function lbs_create($data){
		$lb_id = $data["lb_id"];
		$l = $data["l"];$t = $data["t"];
		$r = $data["r"];$b = $data["b"];
		// delete existing lbs occupying same sell (new lbs always has one sell only), so l=r, t=b
		db\execute("delete from lbs where lb_id=$lb_id and not ( $l>r or l>$r ) and not ( $t>b or t>$b )"); // del if rects intersect (from utils.js)
		// insert
		$data["lb_count"] = sizeof( preg_split("/,/", $data["name"]) ); // name contains comma-sep list of lb names; use it to deduce lb count
		db\execute("insert into lbs " . db\compile_insert($data));
	}
	function lbs_update_image($id, $img_id){ db\execute("update lbs set img_id = $img_id where id = $id"); }
	function lbs_remove($id){ db\execute("delete from lbs where id = $id"); }
	function lbs_get_lb($lbc_id, $camp_id){
		$sels = db\select_to_array("lbs", "*", "lb_id=$lbc_id and camp_id=$camp_id");
		foreach($sels as &$sel){
			$file = db\select_record("files", "path,name", "id=".$sel["img_id"]);
			$sel["src"] = get_files_path().$file["path"].get_file_thumb_path($sel["img_id"], $file["name"]);
		}
		return $sels;
	}
	function lbs_delete($id){
		db\execute("delete from approves where id = $id");
		db\execute("delete from lbs where id = $id");
		// TODO: may also delete files; 
	}
