<?php
	/*
		Author: Alex Nosurov
		Created: 13.01.20 
	*/
	
	require_once(dirname(__FILE__)."/path.php");
	require_once(proj_path."view/lang.php");
	require_once(proj_path."view/metadata.php");
	require_once(proj_path."contr/login.php");
	require_once(proj_path."utils/menu.php");

?>
<html lang="en">
	<head>
		<?php echo lang_html_load('html/standard_head.html', false, array("title" => project_title, "icon" => project_icon)); ?>
		<link href = 	"table_tree/css/style.css" rel="stylesheet">
		<link href = 	"table_tree/css/search.css" rel="stylesheet">
		<link href = 	"css/table.css" rel="stylesheet">
		<link href = 	"css/apap.css" rel="stylesheet">
		<?php echo lang_html_load('fu/index_head.html'); /* LOADSUB  TODO: move this stuff to standard to be used by all pages*/ ?>
	</head>
	<body style='background: url("img/bg_<?php echo get_portal_name(); ?>.jpeg") no-repeat center center fixed;'> 
                <!-- table_tree -->
                <script src="js/table.js"></script>
	
		<div class='bg_cover'></div>
		<?php echo file_get_contents('html/standard_scripts.html'); ?>
		<div class="mc_page_cont" style="height: 100%;">  <!-- if put height to mc_page_cont - preview shown male -->
			<!-- header: row: logo, menu, login  -->
			<div class="mc_page_head">
				<?php echo lang_html_load('html/standard_body_start.html' ); ?>
			</div>
			<div class="mc_page_body mc_page_cont_hor" style="width: 100%;">  <!-- if put height to mc_page_cont - preview shown male -->
				<div class="mc_page_head" id="mi_main_menu_vert"></div>
				<div class="mc_page_body mc_page_cont">
					<div id="tt_table_tree_div" class='mc_page_body mc_tt_cont ttc_fullscreen'> <!-- NOTE: without this cont appears another horiz scr bar -->
						<?php echo lang_html_load('html/table.html' ); ?>
					</div>
				</div>
			</div>
			<div class="mc_page_head mc_puh_div mc_page_cont_hor hidden"><div class='mc_puh_msg mc_page_body'></div><i class='mc_puh_close fas fa-times'></i></div>  <!-- DEF PUH Pop Up Help: shown as user does sms; depends on curr user action -->
		</div>

		<div id = 'kladovka' class='hidden'> <!-- just a div to hide stuff which is shown only temporarily; seems not nec, while add hidden instead -->
			<div id = "mi_load_image">  <?php echo lang_html_load('fu/index_html.html'); ?> </div> <!-- LOADSUB -->
		</div>

		<?php echo lang_html_load('fu/index_script.html'); /* LOADSUB */ ?>

		<script src="js/treeview.js"></script>
		<script type="text/javascript">

			<?php $od=isset($_GET["id"]) && ($id=$_GET["id"]) && !db\exists("orders","id=$id") && db\exists("events","order_id=$id"); $id=$od?0:get_or_def($_GET,'id',0);
			echo "var def_rec_id = $id;\n";  // DEFREC
			echo "var order_deleted = ".($od?$_GET["id"]:0).";\n";
			?>
			var def_camp_id = <?php echo get_or_def($_GET,'cid',0); ?>;
			var stat_cond = "<?php $sc = get_or_def($_GET,'filter',""); global $stat_conds; if($sc) echo $stat_conds[$sc]; ?>"; // STAT
			var files_path = "<?php echo get_files_path(); ?>";

			var rec,drec; // RD
			function get_order_state(rec){ return rec.find(".td-"+alias_name+"-order_state1").html(); }
			function get_lbs_state(rec){return rec.find(".td-"+detail_alias_name+"-app_state").html();}
			function get_lbs_order(lbs_rec){ return lbs_rec.closest(".ap_detail_row").data("id"); }
			// re-calc calculated fields after some order action (upload/approve/rej)
			function update_order_state(order_list, lbs_list){
				lbs_list.each( function(){set_lbs_rec_state(  $(this) ); } );
				order_list.addClass("mc_modified"); // ULR join modified rec and those with modified lbs ; TODO: does each() works when called on RD rec
				$(".mc_modified").each(function(){set_order_rec_state($(this) ); } ); 
			}
			function set_order_rec_state(order_rec){
				var ord = JSON.parse( call_php_sync("contr/main.php", {"action" : "get_order_state", id: order_rec.data("id") }, 'POST').resp_text );
				// DEF OS1 - show single order state order_state1 instead order_state + uploaded + approved + printed
				set_order_state_col(order_rec.find(".td-"+alias_name+"-order_state1").html( ord.order_state1 )); // 
				set_order_state_col(order_rec.find(".td-"+alias_name+"-date_done").html( ord.date_done)); // 
				order_rec.removeClass("mc_modfied"); // ULR
			}
			function set_lbs_rec_state(lbs_rec){
				var lbs = JSON.parse( call_php_sync("contr/main.php", {"action" : "get_lbs_state", id: lbs_rec.data("id") }, 'POST').resp_text );
				lbs_rec.find(".td-app_lbs-app_state").html( lbs.app_state);
				lbs_rec.data("app_id", lbs.app_id);
				set_lbs_action(lbs_rec);
				orders.find_rec(get_lbs_order(lbs_rec)).addClass("mc_modified"); // ULR - to update lbs order (may happen that no order selected, only lbs, but yet need update corresp order)
			}

			function show_load_triple(){
				drec = $(this).closest(".data-row");
				var lbs_id = drec.data("id");
				set_upload_path( "campaigns/" + rec.data("camp_id") + "/lbs/" + lbs_id + "/"); // TRIPLE_PATH get_triple_path
				$("#mi_fu_data").val( JSON.stringify( {client: "triple"} ) );  // set_fu_data
				show_select_string(function(){update_order_state(rec, drec);}, '', $("#mi_load_image"), lp("load_triples"));
				$("#mc_fu_custom_content").html("");
				$("#mc_fu_custom_content").append(  "<div>"+drec.find(".td-app_lbs-name_mini").html()+"</div>"  );
				$("#mc_fu_custom_content").append(  drec.find(".td-app_lbs-path").html()  );
			}
			var orders, apps = null;
			// TODO: to main.js
			function set_order_state_col(td){
				var oc = {"draft" : "c5d9ed", "accepted" : "i4f94d4", "uploaded" : "f5e6ab", "approved" : "b8e6bf", "rejected" : "ff8085", "printed" : "00a32a"};
				var col = oc[td.html()]; td.css("background-color", col);
			}
			function on_show(){
				$("#table-"+alias_name).find(".td-"+alias_name+"-RES_detail").html("<button class='btn btn-primary mc_detail_btn'><i class='fas fa-caret-right'></i></button>");
				$(".td-"+alias_name+"-RES_detail").click( function(){ show_detail_click( $(this).closest(".data-row").data("id") ); } );
				var table = $("#table-"+alias_name);
				table.find(".td-"+alias_name+"-order_state1").each(function(){ set_order_state_col($(this)); });
				// DEFREC
				if(def_rec_id){
					// rec has already been made active by DR1
					show_detail_click(def_rec_id);
					def_rec_id = 0; // avoid set def rec on each show
				}
				if(!$("#table-"+alias_name).find(".data-row").length)
					alert(lp("no_order_created"));
			}

			// TODO: simila to lbs_set_size code
			function fit_img_div(div, img, dw, dh, i_rect){
				div.css("width", dw);
				div.css("height", dh);
				img.css("width", i_rect.w);
				img.css("height", i_rect.h);
				img.css("left",  - i_rect.dw);
				img.css("top",  - i_rect.dh);
			}

			var apap_r, apap_dr; function apap_cb(){ update_order_state(apap_r, apap_dr); } // COF
			function show_approve(){
				var apid = $(this).data("app_id");
				var apap = window.open( "apap.php?id=" + apid, '_blank');
				apap_r = rec, apap_dr = $(this).closest(".data-row");
				// apap.on_action = function(){ update_order_state(r,dr); }   TODO: DEF NCF no child funcs, ch fu not accessible; use COF call opener funcs instead
			}

				// DETAIL_ROW
			// action buttons
			function set_lbs_action(drec){
				if(is_archive) return; // ARCH
			// TODO: can use also flags uploaded/approvved along with state?
				var tda = drec.find(".td-app_lbs-RES_action").html("");
				var lbs_state = drec.find(".td-app_lbs-app_state").html(); // TODO: what if state field not shown - need data
				// prod may upload if not yet uploaded or already rejected
				if(ur_role.role=='PRODUCTION_INTERNAL' && (lbs_state!='approved' && lbs_state!='printed') )
					tda.append( $("<i class='fas fa-upload' title='"+lp("upload")+"'></i>").click(show_load_triple) );
				// may download if have been uploaded - any state but draft
				var dl_type = ur_role.role=="PRODUCTION" && (lbs_state=='approved' || lbs_state=='printed') || ( ur_role.role=="ADMIN" || ur_role.role=="GRAPHIC" ) && (lbs_state=='approved' || lbs_state=='printed' || lbs_state=='uploaded')? "triple" : "pdf"; // 28.09.22 added a/g to upload triples by fabr req
				var ondownload = (dl_type=="triple" && ur_role.role=="PRODUCTION")? function(){ 
					//call_php_sync("contr/main.php", {"action" : "print_lbs", id: drec.data("id") }, 'POST'); // TODO: seems not neccessary; print_lbs called from download.php, while it's also called by email-link
					update_order_state( orders.get_active_rec(), drec); 
				} : null; // when prod.int downloads - need update state
				var url = extract_path(window.location.href) + "/contr/download.php?type=" + dl_type + "&id="+drec.data("id");
				if(lbs_state!='draft' && lbs_state!='accepted')
					//tda.append( $("<a target='_blank' href='"+url+"' title='"+lp("download")+"' ><i class='fas fa-download'></i></a>") );
					tda.append( $("<i title='"+lp("download")+" "+dl_type+"' class='fas fa-download'></i>").click( function(){ load_file(url, null, "GET", ondownload  ) } ) );
				// may call apap to approve/disprove
				var order_state = rec.data("order_state1");
				if((ur_role.role=='PRODUCTION_INTERNAL' || ur_role.role=='GRAPHIC') && lbs_state!='draft' && lbs_state!='accepted') // prod may watch apap if lbs has been uploaded ; DEF REAPP - if approved/rejected - graphic may change state until order closed
					tda.append( $("<i class='fas fa-eye' data-app_id='" + drec.data("app_id") + "' title='"+lp("inspect")+"'></i>").click(show_approve) );
				if(ur_role.role=='PRODUCTION_INTERNAL' && lbs_state=='draft')
					tda.append( $("<i class='fas fa-check' data-app_id='" + drec.data("app_id") + "' title='"+lp("accept")+"'></i>").click( function(){set_state("accept_lbs", $([]), drec);} ) );
			}

			function show_detail(id, re){
				rec = re;
				var dd = $(".ap_detail_div");
				dd.html('<div class="tc_triples_form mc_tt_section mc_page_cont mc_clickable"><div class="tc_before_detail" style="display: none;"> </div></div>'); // tt wrapper
				if(fields_det=="")
					fields_det = JSON.parse( call_php_sync("contr/main.php", {"action" : "get_table_fields", alias: "app_lbs"}, 'POST').resp_text ); 
				apps = new Tablo(".tc_triples_form", null, detail_table_name, fields_det.list, null, on_lbs_rec_sel, null, detail_alias_name);
				apps.ro_set("name", "asc");   // FIORD
				apps.set_cond("camp_id="+rec.data("camp_id")+" AND shop_id="+rec.data("shop_id") + " AND img_id<>0" /*NOIMAGE*/);
				apps.show();
				apps.on_show = function(){
					var rc = $("#table-app_lbs").find(".td-app_lbs-path").length, rn=0; // RH - resize headers on last rec
					$("#table-app_lbs").find(".data-row").each( function(){
						var drec = $(this);
						// show image
						var tdp = drec.find(".td-app_lbs-path");
						var div = $("<div class='mc_triple_div'></div>");
						var img = new Image();
						img.src = files_path + tdp.html() + drec.data("name_mini"); // TODO: use here get_file_thumb_path
						img.classList.add("mc_triple_img");
						img.onload = function(){
							var H = 70; // all imgs of same height
							var lbs_w = drec.data("r")-drec.data("l")+1, lbs_h = drec.data("b")-drec.data("t")+1; // to find div proportion
							var div_h = H, div_w = H*lbs_w/lbs_h;
							var rect = fit_rect2( img.width, img.height, div_w, div_h); 
							fit_img_div(div, $(img), div_w, div_h, rect);
							if(++rn==rc) 
								fh_init_table( drec.closest(".tc_triples_form") );
						}
						tdp.html("").append(div);
						div.append(img);
						set_lbs_action(drec);
						dd.find("table.fh-header").css("top", "20px"); // DEF DET_IMG_OUT - img in detail table stuck out (up); donno now reason; use this quickfix TODO
					});
				}
				$(".ap_detail_div").on("mouseup", ".mc_triple_img", function(){ 
					show_preview( $(this).closest(".tr-app_lbs").data("img_id") ); 
				} ); // PREVIEW
				scroll_to_view(dd[0]);
			}

			// DEF SETCAMP - stuff to set camp id and re-filter records of main table; called from project.js -> show_sel_camp
			function set_camp(id){
				var cond = ["(camp_id="+id+")"];
				// UR
				if(ur_role.shops.length)
					cond.push( "shop_id in (" + ur_role.shops.join(",") + ")" );
				// LOCAL_VISUAL sees all orders  (if at all needs to see them; LV works with shops)
				// GRAPHIC also sees from first stage
				// if(ur_role.role=="GRAPHIC") cond += " and uploaded=1";   fab detto graph must se all; besides if one lbs rejected - order is in 'created' and not visib for graph DEF GSA
				if(ur_role.role=="PRODUCTION")
					cond.push("approved=1");
					//cond += " and (order_state='loaded' || order_state='printed')";
				if(stat_cond) cond.push(stat_cond); // STAT
				orders.set_cond( cond.filter(Boolean).join(" AND ") );
				orders.clear();
				orders.show(0, def_rec_id);  // DR1 DEFREC
			} 

			function set_action_buttons(){
				if(ur_role.role!="PRODUCTION_INTERNAL") $(".mc_accept_selection").addClass("hidden");
				if(ur_role.role!="GRAPHIC") $(".mc_approve_selection").addClass("hidden");
			}
			
			var is_archive = <?php echo isset($_GET["arch"])?1:0; ?>; // DEF ARCH stuff to archive orders; 
			var alias_name, table_name, detail_alias_name = "app_lbs", detail_table_name = is_archive? "app_lbs_arch" : "app_lbs"; // ARCH
			var fields_det="";

			function on_rec_sel(rec){ 
				puh("record_selected");
				if(get_order_state(rec)=="printed") 
					puh("order_complete");
			}
			function on_lbs_rec_sel(rec){ 
				var os = get_lbs_state(rec);
				//if(os=="draft") puh("lbs_draft");
				puh("lbs_" + os);
			}
			function set_state(action, sel_ords, sel_apps){
				call_php_sync("contr/main.php", {"action" : action, ids_ords: JSON.stringify(get_data_arr(sel_ords, "id")), ids: JSON.stringify(get_data_arr(sel_apps, "id")) }, 'POST'); 
				if(sel_ords && sel_ords.length) sel_ords.each( function(){ set_order_rec_state( $(this) ); } );
				if( orders.get_active_rec().hasClass("selected") )
					sel_apps = $(".ap_detail_row").find(".tr-app_lbs"); // if the active rec is selected - need update all inner lbs ONEDET
				if( sel_apps && sel_apps.length )
					update_order_state( orders.get_active_rec(), sel_apps ); // DEF ONEDET - stuff which works only when one opened detail is possible;
			}
			function get_selection(){ 
				var sel = {orders: orders.get_selection(), apps: apps? apps.get_selection() : $()};
				if(!sel.orders.length && !sel.apps.length)
					sel = {orders: orders.get_active_rec(), apps: apps? apps.get_active_rec() : $()}; // with SINGLE_ACTIVE only one of them is not empty
				return sel;
			}

			$(document).ready( function(){
				set_ajax_error_handler(); // def err handler for ajax   ; 24.12.19 pass empty  because DEF FIND_ERR_MSG shows alert when find res empty
				//
				show_sel_camp(is_archive?"archived":"opened");	// SETCAMP, ARCH
				//
				alias_name = "orders_" + ur_role.role, table_name = is_archive? "v_orders_state1_arch" : "v_orders_state1"; // ARCH
				var fields = JSON.parse( call_php_sync("contr/main.php", {"action" : "get_table_fields", alias: alias_name, table: table_name}, 'POST').resp_text ); 
				orders = new Tablo(".tc_thumbs_form", $(".mc_search_panel"), table_name, fields.list, fields.search, on_rec_sel, function(rec){show_detail_click(rec.data("id"));}, alias_name);
				cass_init(); // CASS
				orders.ro_set("date_done", "asc");   // FIORD
				orders.on_show = on_show;
				//orders.show();
				var cid = def_camp_id? def_camp_id : get_camp_id(); // TODO: as def camp may be passed a closed camp
				if(cid){
					$("#mi_camp").val(cid);
					set_camp(cid); // calls show() and sets def rec
				}else
					alert(lp("no_campaigns_found")+"!");

				// order actions
				$(".lbsp_rec_actions").append( $('<button type="button" class="mc_approve_selection btn btn-primary btn-sm"> <i class="fas fa-thumbs-up mc_page_head" title="'+lp("approve_selected_subjects")+'"></i></button>') );
				// DEF ACCORD accept order; field order_state is used now in fact as flag 'accepted' but technically has two states 'draft'/'accepted'; thus in future may extend set of states
				$(".lbsp_rec_actions").append( $('<button type="button" class="mc_accept_selection btn btn-primary btn-sm"> <i class="fas fa-check mc_page_head" title="'+lp("accept_selected_subjects")+'"></i></button>') );
				$(".mc_accept_selection").click( function(){
					var sel = get_selection(); 
					if( (sel.orders.length || sel.apps.length) && confirm(lpp("$accept_orders_lbs$", sel.orders.length, sel.apps.length)) ){
						set_state("accept_lbs", sel.orders, sel.apps );
					}else
						alert("no_record_selected");
				});
				$(".mc_approve_selection").click( function(){
					var sel = get_selection(); 
					if( (sel.orders.length || sel.apps.length) && confirm(lpp("$approve_orders_lbs$", sel.orders.length, sel.apps.length)) ){
						set_state("approve_lbs", sel.orders, sel.apps );
					}else
						alert("no_record_selected");
				});
				$(".lbsp_del").click( function(){
					var sel = get_selection(); 
					if( (sel.orders.length) ){
						if( confirm(lpp("$delete_orders$", sel.orders.length)) ){
							call_php_sync("contr/main.php", {"action" : "delete_orders", ids: JSON.stringify(get_data_arr(sel.orders, "id")) }, 'POST'); 
							location.reload();
						}
					}else
						alert("no_record_selected");
				});
				// DALL ; now made only for triples, so role must be P; TODO: put dl type to title (NOTE: similar code is in set_lbs_action() )
				if(ur_role.role=="PRODUCTION")
					$(".lbsp_rec_actions").append( $('<button type="button" class="mc_download_selection btn btn-primary btn-sm"> <i class="fas fa-download mc_page_head" title="'+lp("download_selected_subjects")+'"></i></button>') );
				$(".mc_download_selection").click( function(){
					var sel = get_selection(); 
					if( sel.orders.length || sel.apps.length){
						var data = {type: "triples", camp_id: get_camp_id(), orders: JSON.stringify(get_data_arr(sel.orders, "id")), apps: JSON.stringify(get_data_arr(sel.apps, "id")) }; 
						var url = extract_path(window.location.href) + "/contr/download.php";
						var ondownload = function(){ update_order_state(sel.orders, sel.apps) } // TODO: would be good to have dl result
						load_file(url, data, "POST", ondownload  );
					}
				});
				set_action_buttons();
				// no CRUD for orders
				$(".lbsp_edit, .lbsp_del, .lbsp_new").addClass("hidden");
				if(ur_role.role=="ENGINEERING" || ur_role.role=="ADMIN") // DEF ORDER_DEL del orders if necessary 14.10.22
					$(".lbsp_del").removeClass("hidden");
				if(order_deleted)
					alert(lpp("$order_deleted$", order_deleted));
			});
		</script>
	</body>
</html>
