<?php
	/*
		Author: Alex Nosurov
		Created: 20.11.19 
		SETTINGS WEB-interface
	*/
	
        require_once(dirname(__FILE__)."/path.php");
	require_once(proj_path."contr/login.php");
	require_once(proj_path."model/db.php");  // read_settings
	require_once(proj_path."view/metadata.php"); // change_pass
	require_once(proj_path."view/lang.php");
	require_once(proj_path."utils/filter_fields.php");
	//require_once(proj_path."utils/view.php"); // render_select_opts
?>
<html lang="en">
	<head>
		<?php echo lang_html_load('html/standard_head.html', false, array("title" => project_title, "icon" => project_icon)); ?>
		<link href = 	"table_tree/css/style.css" rel="stylesheet">
		<link href = 	"css/settings.css" rel="stylesheet">
		<!-- <link rel="Stylesheet" type="text/css" href="lib/htmlarea/jHtmlArea.css" /> -->
	</head>
	<body style='background: url("img/bg.jpeg") no-repeat center center fixed;'> 
                <!-- table_tree -->
                <script src="js/table.js"></script>
	
		<div class='bg_cover'></div>
		<?php echo file_get_contents('html/standard_scripts.html'); ?>
		<div class="mc_page_cont" style="height: 100%;">  <!-- if put height to mc_page_cont - preview shown male -->
			<!-- header: row: logo, menu, login  -->
			<div class="mc_page_head">
				<?php echo lang_html_load('html/standard_body_start.html' ); ?>
			</div>
			<div class="mc_page_body mc_page_cont_hor" style="width: 100%; overflow: auto;">  <!-- if put height to mc_page_cont - preview shown male -->
				<!-- <div class="mc_page_head" id="mi_main_menu_vert"></div> -->
				<div class="mc_page_body mc_page_cont">
					<!-- settings list FFF -->
					<div id="ms_settings" class="ttc_panel"> <!-- NOTE: can not use 'form' here - while it causes form send on counter button click -->
						<?php 
							function print_css_param_lp($matches, $name, $value, $mu, $params){  $matches["CAPTION"] = lp($matches["CAPTION"]); print_css_param($matches, $name, $value, $mu, $params); }
							// read sett from db
							$user_sett = read_settings( get_curr_user_id() );
							// insert values to the form
							foreach($user_sett as $rec)
								if( $sd = &find_array_key_value($sett_def, "id", $rec["pname"]) )
									$sd["default"] = $rec["pvalue"];
							//
							echo $r=render_search_form($sett_def);
							// change pass
							echo '<button style="margin-left: 15px;" type="button" class="btn btn-warning btn-sm" onclick="show_change_pass()">'.lpp('$change$ $password$').'</button>';
							// CSS_SETT
							echo "<div id='md_css_settings'><table>";
							$db_css = db\select_id_field_to_array("settings", "pname", "pvalue", "user_id=".get_curr_user_id()); // already existing params (if any) from db
							read_css_params(proj_path."css/main.css", "print_css_param_lp", null, $db_css);
							echo "</table></div>";
						?>
						<!-- buttons -->
						<div id="md_buttons" class="">
							<button type="button" class="btn btn-primary btn-sm" id="ms_ok_btn" data-tip="<?php echo lp("save_changes");?>" onclick="save_settings()">OK</button>
							<button type="button" class="btn btn-warning btn-sm" id="ms_ko_btn" data-tip="<?php echo lp("save_changes");?>" onclick="reset_settings()">Reset</button>
						</div>
					</div>
				</div>
			</div>
			<div class="mc_page_head mc_puh_div hidden"></div> <!-- DEF PUH Pop Up Help: shown as user does sms; depends on curr user action -->
		</div>
		<div class="hidden">

			<div id="ms_change_pass">
				<?php echo render_search_form($change_pass); ?>
			</div>

		</div>
	<body> 
		<!-- <script type="text/javascript" src="lib/htmlarea/jHtmlArea-0.8.js"></script> -->

		<script type="text/javascript">

			function reset_settings(){ location.reload(); }
			function save_settings(){
				var params = ff_params( $("#ms_settings") );
				// CSS_SETT css params just appended to other params
				// $("#md_css_settings .mc_css").each( function(){ css.push( {"id" : $(this).data("id"), "value" : $(this).val() + $(this).data("mu")} ); } );  // this shit not works - takes initial value
				var elems = document.getElementsByClassName("mc_css");
				for(var i = 0; i < elems.length; i++)
					params[elems[i].getAttribute("data-id")] = elems[i].value;
				params["lang"] = $("#mc_lang").data("lang");// LANG
				//
				call_php_sync("contr/main.php", {"action" : "save_settings", "settings" : JSON.stringify(params) });
				alert("Ok");
			}

			function change_pass(){
				if( !$("#ms_pass1").val() ){
					alert(lp("empty_pass"));
					return;
				}
				if( $("#ms_pass2").val()!=$("#ms_pass1").val() ){
					alert(lp("pass_not_corr"));
					return;
				}
				var params = {"passnew" : $("#ms_pass1").val(), "passold" : $("#ms_pass_old").val()};
				var res = call_php_sync("contr/main.php", {"action": "change_user_pass", "params" : JSON.stringify( params )} );
				alert( res.resp_text );
			}
			function show_change_pass(){
				show_select_string(change_pass,"",$("#ms_change_pass"));
			}

			function set_lang(code){
				$("#mc_lang").attr("src", "img/" + code + ".png");
				$("#mc_lang").data("lang", code);
			}
			function _set_lang(t,e){
				var t = $(e.target);
				set_lang(t.data("lang"));
			}
				

			$(document).ready(function(){ // all the rest of the file
				set_ajax_error_handler(); // def err handler for ajax   ; 24.12.19 pass empty  because DEF FIND_ERR_MSG shows alert when find res empty
				//ff_init();
				$(".ms_pass").attr("type", "password");
				// LANG
				lang_create_menu("mc_set_lang_db", _set_lang);
				$('#md_css_settings table').append($('<tr><td>' + lp("language") + '</td><td><img id="mc_lang" class="mc_set_lang_db"></td></tr>'));
				set_lang(lang_get_db());
				con_help_add("#ms_settings", "_Toc43289158");
			});

		</script>
	</body>
</html>
