<?php
	/*
		Author: Alex Nosurov
		Created: 13.01.20 
	*/
	
	require_once(dirname(__FILE__)."/path.php");
	require_once(proj_path."view/lang.php");
	require_once(proj_path."view/metadata.php");
	require_once(proj_path."contr/login.php");
	require_once(proj_path."utils/menu.php");
	require_once(proj_path."utils/view.php");


?>
<html lang="en">
	<head>
		<?php echo lang_html_load('html/standard_head.html', false, array("title" => project_title, "icon" => project_icon)); ?>
		<link href = 	"table_tree/css/style.css" rel="stylesheet">
		<link href = 	"table_tree/css/search.css" rel="stylesheet">
		<link href = 	"css/table.css" rel="stylesheet">
		<link href = 	"css/apap.css" rel="stylesheet">
		<?php echo lang_html_load('fu/index_head.html'); /* LOADSUB */ ?>
	</head>
	<body style='background: url("img/bg_<?php echo get_portal_name(); ?>.jpeg") no-repeat center center fixed;'> 
                <!-- table_tree -->
                <script src="js/table.js"></script>
	
		<div class='bg_cover'></div>
		<?php echo file_get_contents('html/standard_scripts.html'); ?>
		<div class="mc_page_cont" style="height: 100%;">  <!-- if put height to mc_page_cont - preview shown male -->
			<!-- header: row: logo, menu, login  -->
			<div class="mc_page_head">
				<?php echo lang_html_load('html/standard_body_start.html' ); ?>
			</div>
			<div class="mc_page_body mc_page_cont_hor" style="width: 100%;">  <!-- if put height to mc_page_cont - preview shown male -->
				<div class="mc_page_head" id="mi_main_menu_vert"></div>
				<div class="mc_page_body mc_page_cont">
					<div id="tt_table_tree_div" class='mc_page_body mc_tt_cont ttc_fullscreen'> <!-- NOTE: without this cont appears another horiz scr bar -->
						<?php echo lang_html_load('html/table.html' ); ?>
					</div>
				</div>
				<div class='lb_img_list_cont hidden mc_page_head mc_page_cont'>
					<div class='mc_page_head mc_mwd'>
						<?php echo render_radio_group( array( array("text" => "man", "value" => "man"), array("text" => "woman", "value" => "woman")  ), "man_woman"); ?>
					</div>  <!-- man/woman -->
					<div class='mc_page_head mc_nid'></div>  <!-- NOIMAGE -->
					<div class='lb_img_list_div mc_page_body'>
						<div style='width:100px!important;'></div> <!-- TINY_IMG this stuff used as quick fix: sometimes img div has w=15 -->
					</div>
				</div>
			</div>
			<div class="mc_page_head mc_puh_div mc_page_cont_hor hidden"><div class='mc_puh_msg mc_page_body'></div><i class='mc_puh_close fas fa-times'></i></div>  <!-- DEF PUH Pop Up Help: shown as user does sms; depends on curr user action -->
		</div>

		<!-- Dialogs -->
		<div class='hidden'>
			<!-- DEF NEWLB newi/edit lightbox -->
			<div id="lb_new_lb" style='display: flex; flex-direction: row;'>
				<!-- LB  -->
				<div id = "lb_new_table" class='lb_lbc lb_lb' data-width='100' data-height='100'> </div>
				<!-- params -->
				<div id="lb_new_prm"> <!-- LB params -->
					<div><label>name</label></div>
					<div><input type='text' id='lb_new_name'> </div>
					<div><label>dimensions</label></div>
					<div><input type='text' id='lb_new_width' value="100">x<input type='text' id='lb_new_height' value="100"> </div>
					<div><label>container size</label></div>
				</div>
			</div>
		</div>
		<div id = 'kladovka' class='hidden'> <!-- just a div to hide stuff which is shown only temporarily; seems not nec, while add hidden instead -->
			<!-- LB_RESIZE -->
			<div class='lb_resize_div hidden'></div>
			<div class='lb_resize_rect hidden'></div> 
			<div id = "mi_load_image">  <?php echo lang_html_load('fu/index_html.html'); ?> </div> <!-- LOADSUB -->
			<div id='mi_dima' class='hidden' style='position:absolute;'></div> <!-- DIMA -->
		</div>

		<?php echo lang_html_load('fu/index_script.html'); /* LOADSUB */ ?>

		<script type="text/javascript">

			var def_rec_id = <?php echo get_or_def($_GET,'id',0); ?>; // DEFREC
			var def_camp_id = <?php echo get_or_def($_GET,'cid',0); ?>;
			var stat_cond = "<?php $sc = get_or_def($_GET,'filter',""); global $stat_conds; if($sc) echo $stat_conds[$sc]; ?>"; // STAT

			var table_name="", alias_name;
			
			// -------------------------------------------------------------------------------
			// --------------------------------- SHOPS ---------------------------------------
			// -------------------------------------------------------------------------------

			// DEF SHOPER_VIEW: personal view; for each camp is used its own view v_shop_camp_<id>; thus need re-init tablo on camp change
			function shop_on_enter(rec){
				if(ur_role.is_admin) shop_edit_dialog(rec.data("id"));
				else show_detail_click(rec.data("id"));
			}
			function init_shop_table(visual, admin){
				if(admin)
					table_name = "shops_groups";
				// else set individually for each camp
				alias_name = admin? "shops" : "shops_camp"; // need different aliases to store two sets of fields in cookies (TABCOL_WS_COOKIE)
				var fields = JSON.parse( call_php_sync("contr/main.php", {"action" : "get_table_fields", alias: alias_name, table: table_name}, 'POST').resp_text ); 
				shops = new Tablo(".tc_thumbs_form", $(".mc_search_panel"), table_name, fields.list, fields.search, on_rec_sel, shop_on_enter, alias_name);
				cass_init(); // CASS
				shops.ro_set("name", "asc");   // FIORD
				//
				shops.on_show = shops_on_show;
				shops.clear();
				if(admin){ // else - on set camp (and set camp table)
					shops.show();
					$(".lbsp_del, .lbsp_edit").removeClass("hidden");
				}else{
					// buttons
					$(".lbsp_rec_actions").remove();
					show_sel_camp();	// SETCAMP
				}
				if(visual){
					$(".mc_table_control").append( $('<button type="button" class="lbsp_make_order btn btn-primary btn-sm disabled"> <i class="fa fa-play mc_page_head" title="create order"></i></button>') );
					$(".lbsp_make_order").click( order_create_click );
				}
				// CRUD
				$(".lbsp_new").click( shop_create_dialog );
				$(".lbsp_edit").click( 
					function(){
						var rec = $(".tc_thumbs_form").find(".data-row.active");
						if(rec.length==1)
							shop_edit_dialog( rec.data("id") );
				});
				$(".lbsp_del").click( 
					function(){
						var rec = $(".tc_thumbs_form").find(".data-row.active");
						if(rec.length==1){
							if(!check_order(rec.data("id")))return; // DOO
							shop_delete( rec.data("id"), rec.find(".td-" + alias_name + "-name").html() );
						}
				});
			}
			function set_shop_autocomplete(){
				var locations = JSON.parse( call_php_sync("contr/main.php", {"action" : "locations"}, 'POST').resp_text );
				$("#ns_area").parent().addClass("autocomplete"); autocomplete($("#ns_area")[0], locations.area);
				$("#ns_country").parent().addClass("autocomplete"); autocomplete($("#ns_country")[0], locations.country);
				$("#ns_city").parent().addClass("autocomplete"); autocomplete($("#ns_city")[0], locations.city);
				$("#ns_area").attr("autocomplete", "off");
				$("#ns_country").attr("autocomplete", "off");
				$("#ns_city").attr("autocomplete", "off");
			}
			function shop_create_dialog(){
				var ns = call_php_sync("contr/main.php", {"action" : "shop_edit_dialog"}, 'POST'); 
				var ef = $(ns.resp_text);
				show_select_string(function(){ return shop_save(0); }, '', ef, lp("create_store"));
				ff_init(ef);
				set_shop_autocomplete();
			}
			function shop_edit_dialog(id){
				var ns = call_php_sync("contr/main.php", {"action" : "shop_edit_dialog", "id" : id}, 'POST'); 
				var ef = $(ns.resp_text);
				ff_init(ef);
				show_select_string(function(){ return shop_save(id); }, '', ef, lp("edit_store"));
				set_shop_autocomplete();
			}
			function on_rec_sel(rec){
				if( detail_shown() && get_detail_id()==rec.data("id") ) return; // avoid situ when user clicks det btn and detail msg overwritten with this msg
				show_img_usage( rec.data("id") );  // IMG_LIST IMG_USAGE
				puh("record_selected");
				set_rec_puh(rec);
			}
			function set_rec_puh(rec){
				if(ur_role.is_visual){
					var nd = need_do_order(rec);
					$(".lbsp_make_order").prop("disabled", !nd);
					if(nd) puh("need_create_order");
					if(order_done(rec)) puh("order_complete");
				}
			}
			function shop_save(id){
				var panel = $("#md_ss_div");
				var fields = ff_params(panel, true);
				if(!fields.visual_id) fields.visual_id = "0"; if(!fields.production_id) fields.production_id = "0"; // TODO: normally ff_params not passes null values; added include_empty param to do it; still need a way to provide valid def (empty) val for a field (here need 0 instead of null)
				var res = true;
				$.ajax({
					"type": "POST",
					"async": false,
					"url": "contr/main.php",
					"data": {action : "shop_save", id: id, fields: JSON.stringify(fields)},
					"success": function(res, dummy, request){
						shops.clear();
						shops.show(0, res);
					},
					"error": function(jqxhr, settings, thrownError){
						//alert(lpp(thrownError));
						res = false; // using async=false and ret res false to not close the dialog
					}
				});
				return res;
			}
			function shop_delete(id, name){
				if(!confirm(lpp("$Delete$ $store$ '$1'?", name))) return;
				$.ajax({
					"type": "POST",
					"url": "contr/main.php",
					"data": {action : "shop_delete", id: id},
					"success": function(res, dummy, request){
						shops.clear();
						shops.show();
					}
				});
			}
			function shops_on_show(){
				$("#table-" + alias_name).find(".td-" + alias_name + "-RES_lb").html("<i class='far fa-window-maximize'></i>");
				$(".td-" + alias_name + "-RES_lb").click( function(){ show_detail_click( $(this).closest(".data-row").data("id") ); } );
				// DEFREC
				if(def_rec_id){
					// rec has already been made active by DR1
					show_detail_click(def_rec_id);
					def_rec_id = 0; // avoid set def rec on each show
				}
				$("#table-" + alias_name).find(".td-" + alias_name + "-lbc_todo_count").each(function(){ var t=$(this); var done=t.html()=="0"; var cap = lp(done?"done":"todo"),cl=done?"check":"minus"; t.html("<i class='fas fa-"+cl+"' title='"+cap+"'></i>"); } );
				// DEF POB pers ord btn: visible if order not yet created, enabled if todo cnt = 0; need set it on show and on lbs done cnt change; on create order is replaced by ord num;
				$("#table-" + alias_name).find(".tr-" + alias_name).each(function(){ set_order_rec_button($(this)); } );
			}

			// -------------------------------------------------------------------------------
			// ---------------------------------- IMG_LIST ----------------------------------
			// -------------------------------------------------------------------------------

			function img_list_init(){
				$(".lb_img_list_cont").on("dragstart", ".lb_vl_img", function(e){
					e.preventDefault();
					var img = $(e.target);
					e = e.originalEvent;
					img_drag_init(img, img.data("id"), getMouseRelPos(e.target, e.clientX, e.clientY));
				});
				// man-woman
				$(".mc_mwd .rg_item").click( function(){  
					$(".lb_img_list_div .lb_vl_img_div").addClass("hidden"); 
					var cat=$(".mc_mwd input:checked").val(); $(".lb_img_list_div .lb_vl_img_div.mc_"+cat).removeClass("hidden"); 
					$(".lb_img_list_div .lb_vl_img_div.mc_noimage").removeClass("hidden"); 
				} );
			}
			// set img list visible and refresh table width
			function show_img_list(){
				if( $(".lb_img_list_cont").hasClass("hidden") ){
					$(".lb_img_list_cont").removeClass("hidden");
					fh_init_table(shops.mainform); // or else get resized only table body
				}
			}
			function hide_img_list(){
				if( !$(".lb_img_list_cont").hasClass("hidden") ){
					$(".lb_img_list_cont").addClass("hidden");
					fh_init_table(shops.mainform); // or else get resized only table body
				}
			}
			// build img list
			function set_img_list(ci){
				$.ajax({
					"type": "POST",
					"url": "contr/main.php",
					"data": {action : "get_img_list", camp_id: ci}, // TODO: camp id
					"success": function(res, dummy, request){
						$(".lb_img_list_div").html(res);
						$(".lb_img_list_div").prepend("<div style='width:235px!important;'></div>"); // TINY_IMAGE problem: css which sets img list w not works; so found this quickfix TODO
						$(".lb_img_list_div img").on("mouseup", function(){ if(!dima_started) show_preview( $(this).data("id") ); } ); // PREVIEW
						var noim = $(".lb_img_list_div").find(".mc_noimage");
						noim.find(".mc_img_list_title").remove();
						$(".mc_nid").html(""); $(".mc_nid").append( noim ) ;
						$(".lb_vl_img_div.mc_woman").addClass("hidden"); // man-woman
						// now shown only on show detail show_img_list();  DEF IL_ON_DET
						noim.find(".lb_vl_img").data("id", "0"); // contr returns it empty (fault of replace_keys, seems)
					}
				});
			}
			// DEF IMG_USAGE: indicate for each img if it's used in some lb
			function show_img_usage(shop_id){
				if( !ur_role.is_visual ) return;
				$(".lb_img_list_div .mc_img_usage").remove();
				var stat = JSON.parse( call_php_sync("contr/main.php", {"action" : "img_usage", shop_id: shop_id, camp_id: get_camp_id()}, 'POST').resp_text ); 
				for(i in stat)
					$(".lb_img_list_div .lb_vl_img[data-id='" + stat[i].img_id + "'").parent().append( "<div class='mc_img_usage'><i class='fas fa-check'></i></div>" );
			}

			// -------------------------------------------------------------------------------
			// ------------------------------------ CAMP -------------------------------------
			// -------------------------------------------------------------------------------

			// DEF SETCAMP - stuff to set camp id and re-filter records of main table; called from show_sel_camp
			// only for visuals
			function find_def_camp(is_admin){
				if(!is_admin){
					var cid = def_camp_id? def_camp_id : get_camp_id(); // TODO: as def camp may be passed a closed camp
					if(cid){
						$("#mi_camp").val(null);
						$("#mi_camp").val(cid);
						return cid;
					}else
						alert(lp("no_campaigns_found")+"!");
				}
				return 0;
			}
			function set_camp(id){
				hide_detail();
				set_img_list(id);
				// TODO: this cond should be done in contr (show_table) and be shared with STAT; also for other pages (also for security)
				table_name = call_php_sync("contr/main.php", {"action" : "create_shop_camp_view", camp_id: id}, 'POST').resp_text;  // SHOPER_VIEW
				shops.table = table_name;
				var cond = [];
				if(ur_role.shops.length) cond.push( "id in (" + ur_role.shops.join(",") + ")");  // used for LV TODO: may happen that a user (lv) has no shops
				cond.push( call_php_sync("contr/main.php", {"action" : "get_camp_shops", id: id}, 'POST').resp_text ); // TODO: if camp has no shops?
				if(stat_cond) cond.push(stat_cond); // STAT
				shops.set_cond( cond.filter(Boolean).join(" AND ") );
				shops.clear();
				shops.show(0, def_rec_id); // DR1 DEFREC
			} 

			// -------------------------------------------------------------------------------
			// ------------------------------------ LB --------------------------------------
			// -------------------------------------------------------------------------------
			// DEF LB lightboxes and containers

			// coefficient - display width vs real img width
			function lbk(tlbc){var toplb = tlbc.find(".lb_toplb"); return toplb.outerWidth()/toplb.data("width"); }

			function lb_init(){
				lb_render_size( $("#lb_new_table") ); // TODO: why it's here - could be called from lb_create (but each time)
				// show lbs
				// this works only on enter press $("#lb_new_width,#lb_new_height").on("change", lb_size_click);
				$("#lb_new_width,#lb_new_height").on("keyup", function(e){ lb_size_click(); });
				$("#lb_new_name").on("change", function(){$("#lb_new_table").data("name", $(this).val());} );
				$(".tc_thumbs_form").on("click", ".lb_del_lb", function(){
					if(!check_order())return; // DOO
					var lb = $(this).closest(".lb_div").find(".lb_lbc");
					var lb_id = lb.data("id");
					if(lb.data("iscont")=="0" && !confirm(lp("delete_lightbox"+" '"+lb.data("name")+"'?"))) return;  // if not cont (real lib) - ask confirm
					call_php_sync("contr/main.php", {"action" : "lb_delete", id:lb_id}, 'POST'); 
					update_lbs_done(); 
					// show_detail( get_detail_id() ); commented, while commented del lbs; besides, gave error shop_id not defined
				});
				$(".ap_detail_div").on("dblclick", ".lb_lb",  function(){ lb_edit_dialog( $(this).closest(".lb_lbc") ) } );
			}
			// ------------------- LBNEW -------------------------------
			// read data from "new table" form
			function get_new_table_data(){ return {id: $("#lb_new_table").data("id"), width: $("#lb_new_width").val(), height: $("#lb_new_height").val(), name: $("#lb_new_name").val() }; }
			// set data to "new table" form
			function set_new_table_data(data){ $("#lb_new_width").val(data.width); $("#lb_new_height").val(data.height); $("#lb_new_name").val(data.name); $("#lb_new_width").data("id", data.id); }
			// func used to create LB (not cont)
			function lb_create(){
				var lb = get_new_table_data();
				lb.shop_id = get_detail_id();
				call_php_sync("contr/main.php", {"action" : "lb_save", data: JSON.stringify(lb) }, 'POST');
				// refresh 
				show_detail( get_detail_id() );
			}
			// lb = lb_lbc
			function lb_edit_dialog(lb){
				if(!check_order())return; // DOO
				var prm = get_data( lb );
				if(prm.istop!="1"){ alert(lp("not_top_cont")); return; }
				set_new_table_data(prm);
				set_data( $("#lb_new_table"), prm, true ); // this is only necessary for lb_render_size
				lb_render_size( $("#lb_new_table") );
				show_select_string(lb_create, "new lightbox", $("#lb_new_lb"), "", lb_validate);
			}
			function lb_create_dialog(){
				if(!check_order())return; // DOO
				$("#lb_new_table").data("id", "0");
				$("#lb_new_name").val("");
				show_select_string(lb_create, "new lightbox", $("#lb_new_lb"), "", lb_validate);
				$("#lb_new_name").focus();
			}
			// if data ok - returns true; else - shows alert and returns false
			function lb_validate(ok){
				if(!ok) return true;
				var res = "";
				var lb = get_new_table_data();
				if( isNaN(lb.width) || isNaN(lb.height) ) res = lp("size_not_valid");
				if( !lb.name ) res = lp("name_not_valid");
				$(".ap_detail_div .lb_lb").each( function(){
					if($(this).data("id")!=lb.id && $(this).data("name")==lb.name) 
						res=lpp("$lightbox$ $name_exists$");
				} ); 
				if(res)
					alert(res);
				return res=="";
			}
			// set LB size
			function lb_size_click(){
				var w = parseInt($("#lb_new_width").val());
				var h = parseInt($("#lb_new_height").val());
				if(w && h && w/h<10 && h/w<10){
					$("#lb_new_table").data("width", w);
					$("#lb_new_table").data("height", h);
					lb_render_size($("#lb_new_table"));
				}
			}
			// read all (ar arrays of params)
			function lb_read_all(shop_id){
				var lbl = call_php_sync("contr/main.php", {"action" : "get_shop_lbc", shop_id: shop_id}, 'POST');
				return JSON.parse(lbl.resp_text); // array of all LBs (params)
			}


			// ----------------- LBSHOW -------------------------
			// used to draw LB basing on its data
			// why not do it directly on create? - used on create/reconf LB to react on user param change
			function lb_render_size(lbc, height=200){
				var prm = get_data(lbc);
				var ts = {w: height*prm.width/prm.height, h: height}; // DEF LB_COHEI lb const height - same h for al lb
				lbc.css("width", ts.w);
				lbc.css("height", ts.h);
				//lbc.css("flex-basis", ts.w);
			}
			// render lbc (calls contr to find childs)
			function lbc_render(prm, height=200, left=0, top=0){ 
				var lbc = $("<div draggable=false class='lb_lbc'></div>");
				if(prm.iscont!="1"){
					lbc.addClass("lb_lb"); 
					lbc.addClass("lb_drop_img");  // only lb can accept images (not conts); thus smallest piece accepts image
				}else
					lbc.addClass(prm.isvert=="1"? "lb_vert" : "lb_hor"); 
				if(prm.istop=="1")
					lbc.addClass("lb_toplb"); 
				set_data(lbc, prm);
				lbc.data("left", left); lbc.data("top",top); // track lbc global pos in cont
				lb_render_size(lbc, height);
				if(prm.iscont=="1"){
					var k = lbc.height()/prm.height;
					var lbl = call_php_sync("contr/main.php", {"action" : "get_cont_childs", id: prm.id}, 'POST');
					lbl = JSON.parse(lbl.resp_text);
					var dx = 0, dy = 0;
					for(var i = 0;i<lbl.length;i++){
						lbc.append( lbc_render( lbl[i], lbl[i].height*k, left+dx, top+dy ) );
						if(prm.isvert=="1") dy += parseInt(lbl[i].height);
						else dx += parseInt(lbl[i].width);
					}
				}
				return lbc;
			}
			// render top lb inside lb list - name+table
			function lb_render_cont(prm, content){
				var edit = prm.iscont=="1"? "" : "bul_edit"; // only admin can delete lb, but conts may be deleted also by visual
				var header = $("<div class='lb_header'> <i class='lb_del_lb " + edit + " fa fa-trash'></i><label class='lb_name'>" + prm.name + "</label></div>");
				var body = $("<div class='lb_tlbc_cont'></div>").append(content);
				var footer = $("<div class='lb_header lb_bottom'> <label class='lb_name'>" + prm.width+"x"+prm.height + "</label></div>");
				var lb_div = $("<div class='lb_div'>  </div>").append(header).append(body).append(footer);
				return lb_div;
			}

			// ------------------------------------ DDLB ------------------------------------
			// joing LBs to containers by drag&drop
			function ddlb_start(e){
				var src = $(e.target).closest(".lb_div").find(".lb_lbc");
				var w = src.data("width"), h = src.data("height");
				drag_id = src.data("id");
				// TODO: also set drag target type
				drag_lb_started = true;
				// DIMA the image representing the dragged lb
				var didi = $("<div id='mi_ddlb' style='width:50px;height:50px;border:5px solid black;background:transparent;cursor:grab;'></div>");
				dima_init({left: e.pageX-25, top: e.pageY-25}, {left: 25, top: 25}, didi);// DIMA
				// show drop areas
				$(".tc_thumbs_form").find(".lb_lbc").each( function(){
					var tbl = $(this);
					if(!tbl.data("istop"))return;
					var dst = $(this).closest(".lb_div").find(".lb_lbc");
					if(src.data("id")==dst.data("id")) return;
					var w1 = dst.data("width"), h1 = dst.data("height");
					if(h==h1){
						dst.closest(".lb_tlbc_cont").append($("<div class='lb_drop lb_drop_hor lb_drop_left'><div>"));
						dst.closest(".lb_tlbc_cont").append($("<div class='lb_drop lb_drop_hor lb_drop_rite'><div>"));
					}
					if(w==w1){
						dst.closest(".lb_tlbc_cont").append($("<div class='lb_drop lb_drop_vert lb_drop_top'><div>"));
						dst.closest(".lb_tlbc_cont").append($("<div class='lb_drop lb_drop_vert lb_drop_bot'><div>"));
					}
					dst.closest(".lb_tlbc_cont").find(".lb_drop").data("id", dst.data("id"));
					if(h!=h1 && w!=w1) // DEF OFL during d&d show only fitting dests; now with DDLB_DIMA have a problem - no automatic scrolling
						dst.closest(".lb_div").addClass("hidden");
				} );
				puh("drop_lb");
			}
			function ddlb_drop(tt){
				if(!check_order())return; // DOO
				var lb1,lb2;
				var shop_id = get_detail_id();
				var dst = $(tt);
				//var dst = $(event.target).closest(".lb_div").find(".lb_lbc");
				var dst_id = dst.data("id");
				if( dst.hasClass("lb_drop_top") || dst.hasClass("lb_drop_left") ) { lb1 = drag_id; lb2 = dst_id; }
				else { lb2 = drag_id; lb1 = dst_id; }
				call_php_sync("contr/main.php", {"action" : "lb_join", lb1_id: lb1, lb2_id: lb2, shop_id: shop_id, isvert: dst.hasClass("lb_drop_vert")?1:0 }, 'POST'); 
				update_lbs_done(); 
				show_detail( shop_id );
				puh("container_created");
			}
			// if drop made on non suitable elem (drag cancelled); if drop on suitable target - no need to reset (now), detail is repainted
			function ddlb_reset(){ 
				$(".lb_div").removeClass("hidden"); // OFL
				$(".lb_drop").remove();
			}
			// hilite ddlb drag rect's side if over some droppable lb side
			function ddlb_hilite(pageX, pageY){
				var ds = $("#mi_ddlb");
				$(".lb_drop").each( function(){
					var rect = getGlobalPos( this ), rect1 = getGlobalPos(ds[0]);
					//if( rect_intersect( rect.top, rect.left + $(this).width(), rect.top + $(this).height(), rect.left, rect1.top, rect1.left + ds.width(), rect1.top + ds.height(), rect1.left ) ){
					if( point_in_rect( pageX, pageY, rect.top, rect.left + $(this).width(), rect.top + $(this).height(), rect.left ) ){
						ds.css("border","5px solid black");
						if( $(this).hasClass("lb_drop_left") ) ds.css("border-right", "5px solid yellow");
						if( $(this).hasClass("lb_drop_rite") ) ds.css("border-left", "5px solid yellow");
						if( $(this).hasClass("lb_drop_top") ) ds.css("border-bottom", "5px solid yellow");
						if( $(this).hasClass("lb_drop_bot") ) ds.css("border-top", "5px solid yellow");
						return false; // avoid that other rects which are out are processed
					}else
						ds.css("border","5px solid black");
				});
			}
			//
			function refresh_lbs(lbs){
				lbs_render_all( lbs.closest(".lb_tlbc_cont") );
				update_lbs_done(); 
				show_img_usage( shops.get_active_rec().data("id") );  // IMG_USAGE
			}

			// -------------------------------------------------------------------------------
			// ------------------------------------ LBS -------------------------------------
			// -------------------------------------------------------------------------------
/* typical struct: example with cont with 2 LBs; each contains a lbs; lb_lbs_div (LBS) are parallel to lb_lbc which contains LBs
<div class="lb_div">
	<div class="lb_header"> <i class="lb_del_lb  fa fa-trash"></i><label class="lb_name">LB03, LB04</label></div>
	<div class="lb_tlbc_cont">
		<div draggable="false" class="lb_lbc lb_hor lb_toplb" style="width: 380.531px; height: 200px;">
			<div draggable="false" class="lb_lbc lb_lb lb_drop_img" style="width: 190.265px; height: 200px;"></div>
			<div draggable="false" class="lb_lbc lb_lb lb_drop_img" style="width: 190.265px; height: 200px;"></div>
		</div>
		<div class="lb_lbs_div" ><img src="files_prada/campaigns/11/232.jpg" class="lb_image lb_drop_img" ><i class="lb_del_lbs fa fa-times"></i></div>
		<div class="lb_lbs_div" ><img src="files_prada/campaigns/11/234.jpg" class="lb_image lb_drop_img" ><i class="lb_del_lbs fa fa-times"></i></div>
	</div>
	<div class="lb_header lb_bottom"> <label class="lb_name">430x226</label></div>
</div>
*/
			// DDI, IMGMV
			// mouse_pos is pos of mouse within img
			function img_drag_init(img, img_id, mouse_pos, _src_lbs=null){
				puh("drop_image_to_lightbox");
				drag_id = img_id;
				img_drag_started = true;
				var drag_img = new Image();
				$(drag_img).css("width", img.width())
				$(drag_img).css("height", img.height())
				$(drag_img).css("opacity", '0.5')
				drag_img.src = img[0].src;
				dima_init(getGlobalPos(img[0]), mouse_pos, drag_img);// DIMA
				src_lbs = _src_lbs; // IMGMV
			}
			function lbs_on_img_drop(target){ // TODO: rename to imgMouseUp
				if(!img_drag_started) return;
				if(!check_order())return; // DOO
				var ttt = get_target_lbc(target);
				img_drag_started = false;
				var tt = $(target); // lb_drop_img; may be an empty cell (td) or an exiting img TODO: now need no such form of param
				var ttd = get_data(tt), data;
				var lb_top = tt.closest(".lb_tlbc_cont").find(".lb_toplb"); // TODO: this finds list of all lbc hoping that 0 is the top one; better use .lb_toplb
				if( tt.hasClass("lb_lb") ){ // if img is dropped on a lb; in this case lb_id is top lbc and which sub-lbc is determined in contr by passed coords
					var l = parseInt(ttd.left), t = parseInt(ttd.top);
					data = {l:l, t:t, r: l+parseInt(ttd.width)-1, b:t+parseInt(ttd.height)-1, img_id: drag_id, lb_id: lb_top.data("id"), name: tt.data("name"), camp_id: get_camp_id()};
					call_php_sync("contr/main.php", {"action" : "lbs_create", data:data }, 'POST'); 
				}else if(tt.closest(".lb_lbs_div").length){ // if img dropped on another img - means replace just img keeping the same conf
					call_php_sync("contr/main.php", {"action" : "lbs_update", img_id: drag_id, id: tt.closest(".lb_lbs_div").data("id")}, 'POST');  // TODO: in case if lbs was deleted in check_order - this not works (what is tried to be updated - not exists); too many opers in one action
				}else
					return; // wrong target TODO: control it also on mousemove
				// IMGMV: remove src lbs if it was move from one lbs to another
				if(src_lbs){
					lbs_delete(src_lbs.data("id"));
					lbs_render_all(src_lbs.closest(".lb_tlbc_cont"));
				}
				refresh_lbs(lb_top);
				if(lb_top.data("iscont") && lb_top.data("iscont")!="0")
					puh("image_dropped_resize");
				else
					puh("image_dropped");
			}
			// DEF HILITE_DDI: hilite target lbc during DDI; TODO: now not works while if mouse over img - may happen it occupies several lbc (parent=top lb)
			// so not exists some tag which represents target area (now works so that dropped img will have same size that curr img, not single lbc over mouse)
			// also can't use img itself while it's normal larger then lbc
			// actually could create temp tag, parallel to lbs
			function get_target_lbc(target){
				if( $(target).hasClass("lb_lb") ) return target;
				var id = $(target).closest(".lb_lbs_div").data("lb_id");
				return $(target).closest(".lb_tlbc_cont").find(".lb_lbc[data-id='" + id + "']");
			}
			// lb_lbs_div, array of lbs params (l t r b), td w/h
			function lbs_set_size(lbs, lbs_param, k){
				var img = lbs.find('img');
				var uc_w = lbs_param.r-lbs_param.l+1, uc_h = lbs_param.b-lbs_param.t+1; // unit count by width / height
				var lbs_w = uc_w*k, lbs_h = uc_h*k;
				var rect = fit_rect2(img[0].width, img[0].height, lbs_w, lbs_h );
				lbs.css("width", lbs_w);
				lbs.css("height", lbs_h);
				lbs.css("top", lbs_param.t*k);
				lbs.css("left", lbs_param.l*k);
				img.css("width", rect.w);
				img.css("height", rect.h);
				img.css("left",  - rect.dw);
				img.css("top",  - rect.dh);
			}
			// lb = .lb_tlbc_cont
			function lbs_render(lb, lbs){
				var img = new Image();
				var div = $("<div class='lb_lbs_div'></div>");
				div.attr("title", lbs.name + " " + (lbs.r-lbs.l+1) + "x" + (lbs.b-lbs.t+1) + " " + lbs.src.replace(/^.*[\\\/]/, '') );
				img.src = lbs.src;
				var k = lbk(lb);
				//var toplb = lb.find(".lb_toplb"); var k = toplb.width()/toplb.data("width");
				img.onload = function(){
					lbs_set_size(div, lbs, k); // uses img acutal size, so need do after onload
				}
				set_data(div, lbs); // used in LBSD
				div.append(img);
				lb.append(div);
				// drag&drop TOOD: duplicate
				//$(img).on("mouseup", lbs_on_img_drop); // the case when img dropped on a unit which already has an img
				// TODO: img.addEventListener("dragover", function(e){e.preventDefault();} );
				// NEXT
				$(img).addClass("lb_image");
				$(img).addClass("lb_drop_img");
				//$(img).prop("draggable", false);
				$(img).data("x", lbs.l); $(img).data("y", lbs.t); // used in lbs_on_img_drop TODO: actually are duplicated in lbs
				//img.setAttribute('draggable', false); // to allows custom drag DEF CUDRA
				// del lbs
				div.append( $("<i class='lb_del_lbs fa fa-times'></i>") );
			}
			// lb = .lb_tlbc_cont
			function lbs_render_all(lb){
				lb.find(".lb_lbs_div").remove();
				// TODO: called for each single lbs, takes much time
				var lbsl = call_php_sync("contr/main.php", {"action" : "get_lbs", lb_id:lb.find(".lb_lbc").data("id"), camp_id: get_camp_id() }, 'POST');
				lbsl = JSON.parse(lbsl.resp_text);
				for(var j = 0;j<lbsl.length;j++)
					lbs_render(lb, lbsl[j]);
			}
			function update_lbs_done(){
				if(!ur_role.is_visual) return; 
				var tdc = call_php_sync("contr/main.php", {"action" : "get_lbs_todo", shop_id: get_detail_id(), camp_id: get_camp_id() }, 'POST');
				tdc = JSON.parse(tdc.resp_text);
				var rec = shops.get_active_rec();
				update_td(rec, "lbc_todo_count", tdc.lbc_todo_count);
				update_td(rec, "lbc_count", tdc.lbc_count);
				rec.find(".td-" + alias_name + "-lbc_todo_count").each(function(){ var t=$(this); var done=t.html()=="0"; var cap=done? "done":"todo",cl=done?"check":"minus"; t.html("<i class='fas fa-"+cl+"' title='"+cap+"'></i>"); } );
				set_order_rec_button(rec);
				set_rec_puh(rec);
			}
			// LB_RESIZE 2
			var in_resize_area = false;
			var lbs_resized = null; // currently resized lbs
			function lbs_resize_init(){
				// check if mouse in LBS-resize area (mouse not yet pressed and got into resize area)
				$(".tc_thumbs_form").on("mousemove", ".lb_lbs_div", function(e){
					e = e.originalEvent;
					if(!mouse_down){ // resize happens on canvas .lb_resize_div
						lbs_in_resize(e.target, e.clientX, e.clientY);
					}
				});
				// start resize (mouse was pressed in resize area and dragged)
				$(".tc_thumbs_form").on("mousedown", ".lb_lbs_div", function(e){
					e = e.originalEvent;
					if(in_resize_area){
						lbs_start_resize(e.target, e.clientX, e.clientY);
					}
				});
				// resize
				$(".lb_resize_div").on("mousemove", function(e){
					// mouse is always down
					e = e.originalEvent;
					lbs_resize_move(e.target, e.clientX, e.clientY);
				});
				// finish resize
				$(".lb_resize_div").on("mouseup", function(e){
					if( lbs_resize() ){
						refresh_lbs(lbs_resized);
					}
					lbs_resize_reset();
				});
				// this maybe is some quickfix to hide not-hidden resize rect
				$(".tc_thumbs_form").on("mouseup", ".lb_lbc", function(e){
					lbs_resize_reset();
				});
			}
			function lbs_in_resize(target, clientX, clientY){
				var lbs = $(target).closest(".lb_lbs_div");
				var rect = lbs[0].getBoundingClientRect();
				var x = clientX - rect.left;
				var y = clientY - rect.top;
				if( (rect.width-x) < delta && (rect.height-y) < delta ){
					// (1) - track mouse
					in_resize_area = true;
					$(target).css("cursor", "move");
					puh("start_subject_resize");
				}else{
					in_resize_area = false;
					$(target).css("cursor", "default");
				}
			}
			function lbs_start_resize(target, clientX, clientY){
				// (2) init resize
				var lbs = $(target).closest(".lb_lbs_div");
				var tbd = $(target).closest(".lb_tlbc_cont"); // all possible area for lbs
				var rd = $(".lb_resize_div"), rr = $(".lb_resize_rect");
				rd.removeClass("hidden");
				rr.removeClass("hidden");
				tbd.append( rd );
				tbd.append( rr );
				lbs.addClass("lb_lbs_resized"); // maybe necessary to keep it on top of others
				// align rr with lbs
				var p = lbs.position();
				rr.css("left", p.left);
				rr.css("top", p.top);
				rr.css("width", lbs.width());
				rr.css("height", lbs.height());
				// save data
				var rect = lbs[0].getBoundingClientRect();
				drag_x = clientX - rect.left;
				drag_y = clientY - rect.top;
				lbsl0 = lbs.data("l"), lbst0 = lbs.data("t");  // LBSD
				lbsr0 = lbs.data("r"), lbsb0 = lbs.data("b");  // LBSD
				lbsrc = lbsr0; lbsbc = lbsb0; 
				lbs_resized = lbs;
			}
			function lbs_resize_move(target, clientX, clientY){
				var rect = target.getBoundingClientRect();
				var x = clientX - rect.left;
				var y = clientY - rect.top;
				var rr = $(".lb_resize_rect");
				var p = rr.position();
				var rrw = x-p.left, rrh = y-p.top;
				rr.css("width", rrw);
				rr.css("height", rrh);
				// check if neeed reconf
				// check all LBs covered to more then half by tt and find max rect
				var tlbc = $(lbs_resized).closest(".lb_tlbc_cont");
				var k = lbk(tlbc);
				//var toplb = tlbc.find(".lb_toplb"); var k = toplb.width()/toplb.data("width");
				var maxr=0, maxb=0, rrR = (p.left+rrw)/k, rrB = (p.top+rrh)/k; // which would be real w/h of rr
				lbs_name = [];
				tlbc.find(".lb_lb").each( function(){
					var lbd = get_data( $(this) );
					if( lbd.left >= lbsl0 && lbd.top >= lbst0 && rrR > lbd.left + lbd.width/2 && rrB > lbd.top + lbd.height/2 ){
						maxr = Math.max(maxr, parseInt(lbd.left) + parseInt(lbd.width) - 1);
						maxb = Math.max(maxb, parseInt(lbd.top) + parseInt(lbd.height) - 1);
						lbs_name.push( lbd.name );
					}
				});
				//
				var lbs_param = get_data(lbs_resized);
				if(maxr>lbs_param.l && maxb>lbs_param.t && (maxr!=lbsrc || maxb!=lbsbc) ){
					lbs_param.r = maxr;
					lbs_param.b = maxb;
					lbs_set_size(lbs_resized, lbs_param, k);
					lbsrc = maxr; lbsbc = maxb; 
				}
			}
			function lbs_resize(){
				// (5) finish resize TODO: move to global listener
				// save to db (just create new one, covered LBs will beleted
				if(lbsrc!=lbsr0 || lbsbc!=lbsb0){ // if conf changed
					if(!check_order())return false; // DOO
					var prm = get_data(lbs_resized); // XX
					var data = {l:prm.l, t:prm.t, r:lbsrc, b:lbsbc, img_id:prm.img_id, lb_id:prm.lb_id, name: lbs_name.join(", "), camp_id: get_camp_id()  };
					call_php_sync("contr/main.php", {"action" : "lbs_create", data:data}, 'POST'); 
					puh("subject_resized");
					return true;
				}
				return false; // no resize done
			}
			function lbs_resize_reset(){
				if(!lbs_resized) return;
				var rd = $(".lb_resize_div"), rr = $(".lb_resize_rect");
				$("#kladovka").append( rd.addClass("hidden") ); // put back to kladovka or else will be deleted on lb list clear
				$("#kladovka").append( rr.addClass("hidden") );
				lbs_resized.removeClass("lb_lbs_resized");
				lbs_resized = null;
			}

			function lbs_delete(lbs_id){ call_php_sync("contr/main.php", {"action" : "lbs_delete", id:lbs_id}, 'POST'); }
			
			// DEF DOO check if a change depends on order; after fabro req to allow edit shop from admin page - need make checks - if a change invalidates order (then need cancel or del order)
			function check_order(id=0){
				// var rec = shops.find_rec(get_detail_id());	var order_id = rec.data("order_id"); this not works for admin role ; logically need find if exists some order in some camp for this shop
				if(!id) id = get_detail_id();
				var order = call_php_sync("contr/main.php", {"action" : "find_shop_order", id:id}, 'POST').resp_text;
				if( order){
					order = JSON.parse(order);
					if(confirm(lpp('$confirm_delete_order$', order.id, order.camp_name))){
						call_php_sync("contr/main.php", {"action" : "order_delete", id:order.id}, 'POST');
						var rec = shops.get_active_rec();
						rec.data("order_id", 0); // also removes the button
						set_order_rec_button(rec);
						//hide_detail(); now lbs are not deleted, besides if hide detail - lbs del request not works on XX
					}else
						return 0; // can't delete
				}
				return 1; // may delete
			}


			// -------------------------------------------------------------------------------
			// ------------------------------------  MAP -------------------------------------
			// -------------------------------------------------------------------------------
			function map_read_all(shop_id){
				var ml = call_php_sync("contr/main.php", {"action" : "get_shop_maps", id: shop_id}, 'POST');
				return JSON.parse(ml.resp_text);
			}

			function map_render(prm){
				var header = $("<div class='lb_header'> <i class='lb_del_img bul_edit fa fa-trash'></i><label class='lb_name' title='" + prm.name + "'>" + prm.name + "</label></div>");
				header.find(".lb_del_img").on("click", function(){  
					if(confirm(lpp("$Delete$ $image$?"))){
						call_php_sync("contr/main.php", {"action" : "delete_shop_map", id: prm.id}, 'POST'); 
						$(".lb_div[data-id='" + prm.id + "']").remove();
					}
				});
				var body = $("<div class='lb_tlbc_cont'></div>");
				body.append( create_boxed_image(prm.src) );
				body.find(".ap_detail_elem").on("click", function(){
					show_preview_url( $(this).attr("src"), "" );
				});
				return $("<div class='lb_div' data-id='" + prm.id + "'>  </div>").append(header).append(body);
			}

			// -------------------------------------------------------------------------------
			// -----------------------------------  ORDER ------------------------------------
			// -------------------------------------------------------------------------------
			function order_create(rec, say=true){
				var order = call_php_sync("contr/main.php", {"action" : "order_create", "fields": JSON.stringify({shop_id: rec.data("id"), camp_id: get_camp_id()} ) }, 'POST'); 
				var order_id = order.resp_text;
				rec.find(".td-" + alias_name + "-order_id").html(order_id);
				rec.data("order_id", order.resp_text); // also removes the button
				//set_order_button();
				if(say)
					alert( lpp("$order_created$", order.resp_text) );
				return order_id;
			}
			function order_create_click(){
				var sel = shops.get_target_recs();
				var cnt = 0;
				if(sel.length && confirm(lpp("$create_store_orders$", sel.length))){
					sel.each( function(){ 
						var rec = $(this);
						if( !rec.data("order_id") && !rec.data("lbc_todo_count")  && rec.data("lbc_count") ){
							order_create( $(this), false );
							cnt++;
						}
					} );
					alert(lpp("$created_orders$", cnt));
				}
				// order_create( shops.get_active_rec() );  was used for single selected order
			}
			// POB
			function set_order_rec_button(r){
				var rec = r;
				var td = rec.find(".td-" + alias_name + "-order_id");
				if( !rec.data("order_id") ){ // if order not created - add btn which is enabled only if todo cnt=0
					td.html("");  // remove if present
					var btn = $('<button '+(need_do_order(rec)?"":"disabled")+' type="button" class="mc_create_order btn btn-primary btn-sm"> <i class="fa fa-play mc_page_head" title="create order"></i></button>');
					btn.click( function(){ order_create(rec); } );
					td.append( btn );
				}
			}	
			// general order btn for selected orders
			function need_do_lb(rec){ return rec.data("lbc_todo_count")=="1"; } // note: lbc_todo_count is 0 or 1 (=exists sms todo)
			function order_done(rec){ return rec.data("order_id") && rec.data("order_id")!="0"; } 
			function need_do_order(rec){ return !need_do_lb(rec) && !order_done(rec); } // lb done, but order not created yet


			// -------------------------------------------------------------------------------
			// ----------------------------------  DETAIL ------------------------------------
			// -------------------------------------------------------------------------------

			// TODO: contains functions from different functionalities
			// called from project.js - show_detail_click
			function show_detail(shop_id){
				$(".ap_detail_row").find(".ap_detail_div").html("");
				var det_tabs = create_tabs([{name:"Lightboxes", classname: "mc_lbc_tab", content: "<div class='mc_lbc_div lb_img_list_hor'></div>"}, 
											{name:"Maps", 		classname: "mc_map_tab", content: "<div class='mc_map_div lb_img_list_hor'></div>"} ]);
				var dd = $(".ap_detail_div");
				dd.append(det_tabs);

				var list = dd.find(".mc_lbc_div");
				list.append( $("<div class='lb_add bul_edit'><i class='fa fa-plus'></i> </div>") ); // add new
				var lbl = lb_read_all(shop_id);
				for(var i = 0;i<lbl.length;i++){
					var lb = lb_render_cont(lbl[i], lbc_render( lbl[i] ) ); // rendere the LBC wrapper
					lbs_render_all(lb.find(".lb_tlbc_cont"));  // show LBSs
					list.append(lb);
					//lb.find(".lb_lbc[data-iscont='0']").on("dblclick", function(){ lb_edit_dialog( $(this) ) } ); donno why shit not wors
					lb.find(".lb_lbc").each( function(){ if($(this).data("iscont")=="0") $(this).on("dblclick", function(){ lb_edit_dialog( $(this) ) } );  } );
				}
				list.find(".lb_add").click( lb_create_dialog );
				// MAPS
				var md = dd.find(".mc_map_div");
				// maps html
				md.append( $("<div class='lb_add bul_edit'><i class='fa fa-plus'></i> </div>") ); // add new
				md.find(".lb_add").click( function(){
					$("#mi_user_path").val("maps/"); // LOADSUB
					$("#mi_fu_data").val( JSON.stringify({client: "map", shop_id: get_detail_id()}) ); 
					show_select_string(update_detail, '', $("#mi_load_image"), lp("load_maps"));
				});
				var maps = map_read_all(shop_id);
				for(var i = 0;i<maps.length;i++)
					md.append(map_render(maps[i]));

				// DEF IMGMV - move image from one lbs to another by d&d
				$(".ap_detail_div").on("dragstart", ".lb_image", function(e){
					e.preventDefault();
					if(in_resize_area) return;
					var img = $(e.target);
					var lbs = img.closest(".lb_lbs_div");
					img_id = lbs.data("img_id");
					e = e.originalEvent;
					img_drag_init(img, img_id, getMouseRelPos(e.target, e.clientX, e.clientY), lbs);
				});
				if(!ur_role.is_admin)
					$(".bul_edit").remove();
				$(".ap_detail_row").on("mouseup", ".lb_image", function(){ 
					if(!dima_started) show_preview( $(this).closest(".lb_lbs_div").data("img_id") ); 
				} ); // PREVIEW
				if(ur_role.is_visual)
					show_img_list();   //  IL_ON_DET
				show_img_usage( shop_id );  // IMG_USAGE
				scroll_to_view(dd[0]);
				//
				if( ur_role.is_visual ){
					var rec = shops.find_rec(shop_id);
					if( need_do_lb( rec ) )
						puh("lb_start_drag", 30);
				}
			}

			// -------------------------------------------------------------------------------
			// ------------------------------------  DIMA ------------------------------------
			// -------------------------------------------------------------------------------

			// inits drag image; img - the immage which drag should be imitated
			var dmp, dima_started = false; // initial mouse pos within the drag rect {left, top}
			function dima_init(rect_pos, mouse_pos, drag_img){
				dmp = mouse_pos;
				dima_started = true;
				var dr = $("#mi_dima");
				dr.html("");
				dr.appendTo($("body"));
				dr.append(drag_img);
				dr.removeClass("hidden");
				setElemPos( dr, rect_pos );
				return dr;
			}
			function dima_move(clientX, clientY){
				var dr = $("#mi_dima");
				var dmpc = getMouseRelPos(dr[0], clientX, clientY);
				if(dmp && Math.abs(dmp.left-dmpc.left)<10 && Math.abs(dmp.top - dmpc.top)<10 )
					return;
				// next move; now dmp is prev rel pos
				else{ 
					dr.css("left", clientX - dmp.left);
					dr.css("top", clientY - dmp.top);
				}
			}
			function dima_reset(){ 
				dima_started = false;
				$("#mi_dima").addClass("hidden");
			}

			// -------------------------------------------------------------------------------
			// ------------------------------------  VAR -------------------------------------
			// -------------------------------------------------------------------------------

			var shops;
			var drag_x, drag_y; // DEF LB_RESIZE
			var drag_target; // noticed a bug DEF FCJ false cont join: when try to d&d image - lb drag is triggered (blues are hilited); happend when made some joins, then selected another rec, then returned to prev rec and tried d&d image;
			var lbsr0, lbsb0, lbsrc, lbsbc; // initial cell count in lbs and current
			var lbs_name;
			var delta = 20;
			var border_w = 5; // TODO: temp, better take this val from css - td border width
			var drag_id, drag_txt, img_drag_started = false, drag_lb_started=false; // used for DEF DDI drag&drop image

			var dmp; // mouse pos; is mouse pos inside drag image; DEF: DIMA drag image; show it manually; 
			var src_lbs = null; // IMGMV remember dragged lbs to del it on drop


			// -------------------------------------------------------------------------------
			// -----------------------------------  INIT -------------------------------------
			// -------------------------------------------------------------------------------

			$(document).ready( function(){
				// TODO: ur_role is set in onload in archive.js, is it secured that called before this?
				ur_role.is_visual = ur_role.role=="LOCAL_VISUAL" || ur_role.role=="VISUAL_ADMINISTRATOR"; // UR in prev syst there are 2 diff roles va & lv which are in fact the same;
				ur_role.is_admin = ur_role.role=="ENGINEERING" || ur_role.role=="ADMIN";  // who has right to edit shops

				set_ajax_error_handler(); // def err handler for ajax   ; 24.12.19 pass empty  because DEF FIND_ERR_MSG shows alert when find res empty
				document.addEventListener("mousedown", function(event) { mouse_down = true; img_drag_started=false;drag_lb_started=false;dima_reset();});
				document.addEventListener("mouseup", function(event) { mouse_down = false; });

				//-------------------  SHOP _---------------------
				init_shop_table(ur_role.is_visual, ur_role.is_admin);
				on_hide_detail = function(){hide_img_list(); puh_close();}

				var cid = find_def_camp(ur_role.is_admin); // also shows camp shops
				if(cid)
					set_camp(cid); // calls show() and sets def rec

				// TODO: add clear wait_screen on ajax done

				lb_init(); // lb crud (may check if admin)

				//-------------------  LBS LBS_DEL ---------------------
				$(".tc_thumbs_form").on("click", ".lb_del_lbs", function(){
					if(!check_order())return; // DOO
					lbs_delete( $(this).closest(".lb_lbs_div").data("id") );
					refresh_lbs($(this));
				});


				var ci = get_camp_id();
				if( ur_role.is_visual && ci || ur_role.is_admin){ // TODO: move this to sep func, maybe this and other set-lb stuff to sep js file

					if( ur_role.is_visual )
						img_list_init();

					// ---------------- DDI, DDLB -------------------------------
					// DEF DDLB drag&drop LB : interface to join lightboxes to containers
					$(".tc_thumbs_form").on("mousedown", ".lb_header", function(e){ drag_x = e.clientX; drag_y = e.clientY; drag_target = e.currentTarget;});
					$(".tc_thumbs_form").on("mousemove", ".lb_header", function(e){ 
						var drag_delta = 5;
						if( !drag_lb_started && mouse_down && (Math.abs(drag_x-e.clientX)>drag_delta || Math.abs(drag_y-e.clientY)>drag_delta) && e.currentTarget==drag_target /*FCJ*/)
							ddlb_start(e);
							clearSelection(); // there remains some unnecessary text-selection
					});
					document.addEventListener("mousemove", function(e) { 
						// DIMA: DDI, DDLB
						if(dima_started)
							dima_move(e.clientX, e.clientY);
						// DDLB: hilite rect side
						if(drag_lb_started)
							ddlb_hilite(e.pageX, e.pageY);
					});
					// happens when drag is over
					document.addEventListener("mouseup", function(e) { 
						if(!dima_started) return;
						//e = e.originalEvent;
						dima_reset(); // DIMA
						var target = document.elementFromPoint(e.clientX, e.clientY); // this is the way to find out the drop target
						// DDI
						if(img_drag_started)
							lbs_on_img_drop(target);
						// DDLB
						if( drag_lb_started )
							if( $(target).hasClass("lb_drop") )
								ddlb_drop(target);
							else
								ddlb_reset();
					});

					// ----------  LBS_RESIZE --------------
					lbs_resize_init();
				}
				// EO INIT
			});
		</script>
	</body>
</html>
