/*
	21.09.18 aggiungo selezione parziale
	se una cartella viene de/selezionata - devo aggiornare a) tutti i descendenti (incluse se stesso);  b) la catena dei parenti
	a) i descendenti perdono 'indeterminate" e ottengono lo stato schelto
	b) il parente e': 
		- selezionato se tutti i child sono selezionati (quindi determinati)
		- de-selezionato se tutti sono deselezionati
		- de-selezionato e indeterminato se i primi due non veri
	se un elemento si cambia - deve essere aggiornato il parente (con algo precedente), cioe' ricorsivamente
 */
/*
 * .tree-cont - div containing <li>; contains data
 * .tree-item (tree-item-file, tree-item-dir) - <li> which receives folder onclick event
 * .tree-elem (tree-file, tree-dir) - <input> checkbox, contains 'checked' state, receives check/uncheck events
*/


// TODO 1: separate interface from methods
// DEF CV - class version

// DEPENDENCIES: wait_screen, archive.js, popup.js, utils.js

//------------------------------------------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------- SECT VARS (getters, setters, simples) -----------------------------------------------------------------
//------------------------------------------------------------------------------------------------------------------------------------------------------------

class table_tree{
	main_form;
	popup_div;
	name; // should be passed unique name to distinguish from other instances
	project_name = ""; // SHARE must equal to the name of php file in ./share/ folder
	detail_view = "thumbs"; // to switch thumbs/details;  = [thumbs,details] TODO: what is 'details' - table view?
	list_view_on = false; // indicates if LIST_VIEW is on; works only for detail_view = thumbs mode
	// NOTE: it should be path (string, not dom elem)
	current_dir_item = null; // .tree-item CURREL DEF for MH it's necessary to track the current directory (last selected);  note: javascript object (not jquery) NOTE: do not need it actually, may just use $(".tree-item.active")[0]
	root_dir = ""; // sometimes it's necessary to restrict access to upper dirs; eg each user has it's own dir and can't go further up; must hide '..' to upper dirs; also avoid processing upper dirs in selection/cache routines
	set_root_dir(dir){this.root_dir = dir;}
	get_root_dir(){return this.root_dir;}
	current_dir = ""; // added 24.01.20 ; properly path; 
	prev_current_dir_item = null; // .tree-item CURREL DEF for MH it's necessary to track the current directory (last selected);  note: javascript object (not jquery) NOTE: do not need it actually, may just use $(".tree-item.active")[0]
	target_dir = null; // the dir upon which last right click was made (popup target); js (not jquery) elem
	current_item = null; // CURREL NOTE: now it's id; may happen that curr elem not present in tree (show_files=0)
	// NOTE: now use_paths in fact is equivalent to: 'allow show empty folders' (= do not check if a folder is empty (to hide it))
	use_paths = 0; // indicates how open folder: using paths table (open_dir_paths) or usual way (open_dir)
	set_use_paths(val){ this.use_paths=val; }
	shm_table_num = 0; // '0' now means not use shm
	set_shm_table_num(num){this.shm_table_num=num;}
	show_files = null;   // HIDEFILES indicates if need show files in tree view; (in MS normall only folders are shown)
	set_show_files(sf=true){this.show_files=sf;} // client should call it to set up if show files (def is yes (in contr))
	on_show_plain=null; // client callback to call after show plain
	set_on_show_plain(f){this.on_show_plain = f;} // ex-set_on_show_table
	user_dir = ""; // 14.01.20 MUSD    
	set_user_dir(sd){this.user_dir = sd;} 
	get_user_dir(){return this.user_dir;}
	// used in space: hide tree explorer
	table_tree = "";
	table_files = ""; // corresponds to = of model/db.php
	table_where = ""; // additional condition applied when a node is opened; NOTE: now is applied only for opening and not for find/stat
	files_order = null; // FIORD
	table_tree_path = "table_tree/";
	contr_path = "table_tree/contr/main.php";
	xhr = null; // TODO: used to control active requests? not realized now, seems (.. used in .tt_search_cancel_btn)
	client_show_details_func; // DEF CLIENTSHOWDET allso client to set its own show_details function; params: (file_id); used in mailstore to show mail contents in an inline panel
	tree_hidden = false; // CV: seems this indicates if explorer is shown (if not - there is no info about folder struct and no need to sync explorer with detail )
	// TODO: files_path used now only by client, tt has no its built-in func to download selection (although download_zip is under tt folder)
	files_path; thumb_small_path = ""; thumb_medium_path = ""; // SHARE 30.08.2022 ; allows to set individual source and th. paths for each proj; if not set - used default (in table_tree/contr/main.php); NOTE: src path is where files are physically; that is full path = src path + path from db
	set_paths(src,sm,me){ this.files_path = src; this.thumb_small_path = sm; this.thumb_medium_path = me;}
	pager = null; // use var to hold it while create_counter requests id which is unique
	clear_pager(){if(this.pager && this.pager.length)this.pager.remove();this.pager=null;}
	create_pager(max){ this.pager = create_counter("tt_pager_"+this.name, this.show_page, 1, max, 1); this.pager.addClass(".ttc_pager"); return this.pager;}
	hide_tree(){
		this.tree_hidden = true;
		this.set_show_files(false); // thus shrink data exchange
		this.get_tree_form().addClass("hidden");
		this.main_form.find(".tt_exp_btn_div .musd").detach().appendTo(this.main_form.find(".tt_thumbs_header"));  // move buttons to thumb sect
	}
	get_root_item(){ return $(this.main_form.find('.tt_explore_root_item')[0]); }  // TODO 1: this elem present in old ver but here not
	get_tree_form(){ return $(this.main_form.find(".tt_explore_form")[0]); }
	get_thumb_sect(){return $(this.main_form.find(".tt_thumbs_section")[0]); } // contains thumbs (is cleared/filled on show)
	get_thumb_form(){return $(this.main_form.find(".tt_thumbs_form")[0]); } // contains get_thumb_sect and other detail controls
	get_preview_div(){ return $(this.main_form.find(".tt_preview_body")[0]); }
	get_before_detail(){return $(this.main_form.find(".tt_before_detail")[0]); } 
	get_search_form(){ return $(this.main_form.find(".tt_search_form")[0]); }
	get_quick_search_form(){ return $(this.main_form.find(".lbsp_form")[0]); }
	get_cont(elem){
		return elem.closest('.tree-cont');
	}
	get_data(elem, param){
		var res = this.get_cont(elem).data(param);
		return (typeof res === "undefined")? "" : res;
	}
	set_data(elem, param, value){
		this.get_cont(elem).data(param, value);
	}
	get_item(cont){
		return cont.children('.tree-item').first();
	}
	get_elem(cont){
		return cont.children('.tree-item').children('.tree-elem').first();
	}
	// returns jq elem or empty object
	get_parent(cont){
		if(!cont.length) return $();
		var res = cont.parent('.tree-cont');
		if(res.length && res.data("path").length < this.root_dir.length) return $(); // if go further allowed dir
		return res;
	}
	get_thumb_cont(thumb_child){ // thumb_child is some inner elem - img or ref..
		return thumb_child.closest('.thumb');
	}
	get_detail_class(){return this.detail_view=="thumbs"? "thumb" : "clickable-row";}
	get_id_detail(id){	return this.get_thumb_form().find("." + this.get_detail_class() + "[data-id='" + id + "']"); }
	get_id_elem(id){return this.get_tree_form().find('.tree-file.id'+id);} // return elem by file id
	get_thumb_elem(thumb){
		var id = this.get_thumb_cont(thumb).data('id');
		return this.get_tree_form().find('.tree-file.id'+id);
	}
	// DIRTHUMB  find elem in dir-tree corresponding to a folder in thumb panel
	// note the trick: for a file this gives parent elem, for a dir - itself (while for files path is only path without name)
	get_path_cont(path){ return this.get_tree_form().find(".tree-cont[data-path='" + path + "']");	}
	is_dir(elem){
		return elem.hasClass('tree-dir') || elem.hasClass('thumb-dir'); // latter is for detail elem
	}
	is_file(elem){
		return elem.hasClass('tree-file');
	}
	// 
	dir_opened(cont){ // shows if the cont (from explorer) was opend and then closed; CORRECTION: seems now used to indicate if currently opened; for opened/closed is used opened_closed() 
		return get_item(cont).hasClass("ttc_folder_opened");
	}
	set_table_files(tf){ this.table_files = tf; } // by def is same that table_tree
	get_table(){return this.table_tree;}
	set_where(w=""){ this.table_where = w; }
	get_where(){return this.table_where;}
	get_target_dir(){return this.target_dir;}  //CURREL returns
	set_target_dir(td){ return (this.target_dir=td); }
	get_curr_dir_item(){return this.current_dir_item;}  //CURREL returns
	set_curr_dir(path){this.current_dir=path;}
	get_curr_dir(){return this.current_dir;}
	set_curr_dir_item(jquery_obj){ this.prev_current_dir_item = this.current_dir_item; this.current_dir_item = jquery_obj[0]; this.main_form.find(".tree-item.active").removeClass("active"); jquery_obj.addClass("active"); this.set_curr_dir(this.get_data(jquery_obj, "path"));}
	get_curr_item(){return this.current_item;}  //CURREL returns
	set_curr_item(item){ this.current_item = item;} // TODO: need sync curr item table-tree
	ro_set(fo){this.files_order = {"field" : fo.field, "order" : fo.order}; } // added 3.10.19 for MS; allow custom sort order; this func must be called by client;  DEF FIORD NOTE: actually more likely will be called innerly by table column click
	// CLIENTSHOWDET 
	set_show_details( shd ){
		this.client_show_details_func = shd;
	}
	// SELIN
	on_select = 0;
	set_on_select(f){
		this.on_select = f;
	}
	set_name(pn){this.name=pn;}
	set_table_tree_path(tp){ this.table_tree_path = tp; this.contr_path = tp + "contr/main.php"; }

	// TODO 1: how related with mc_focused?
	set_active_section(sel){
		this.main_form.find(".mc_tt_section").removeClass("mc_tt_active_section");
		this.main_form.find(sel).addClass("mc_tt_active_section");
	}
	// now used only in sd_, but may may be used overall DEF MFB move files bug, found 26.06; to the contr is passed path without end-slash; firstly, found here that data-path not contains end-slash (not that name may be empty and needs no es), but bug persists
	create_emtpy_folder(parent_path,name){ var es = name? '/':''; return $("<div class='tree-cont' data-path='" + parent_path + name + es + "'><li class='tree-item tree-item-dir'>" + name + "</li></div>"); }
	tt_get_elem_name(elem){ return elem.hasClass("mc_file")? elem.find(".file-ref").html() : elem.data("path"); }
	// set tree elem sel state TODO: Use it
	set_elem_sel(elem, sel, ind=false){
		elem.prop('checked',sel);
		elem.prop("indeterminate", ind); 
	}
	// set detail elem sel state TODO: Use it
	set_detail_select(elem, sel=true){
		if(sel) elem.addClass('selected');
		else elem.removeClass('selected');
	}
	get_active_detail(){ return this.get_thumb_sect().find(".active.thumb"/* + this.alias*/); } // TODO: use tr for table-view ;; not checked

	//--------------------------------------------------- ESECT VARS (getters, setters, simples) -----------------------------------------------------------------


	//------------------------------------------------------------------------------------------------------------------------------------------------------------
	//--------------------------------------------------- SECT UTILS  --------------------------------------------------------------------------------------------
	//------------------------------------------------------------------------------------------------------------------------------------------------------------

	//--------------------------------------------------------- SUBSECT ADD_INFO --------------------------------------------------------------------------------
	// DEF ADD_INFO stuff used to show some additional info for files/folders; user should provide funcs func(elem) and pass them by add_info_handler; normally user funcs use ajax
	// object containing custom callback which is used to display additional info; the client should set the callback for each application
	add_data;
	// adds 'additional info handler' - the function which adds some non-standard info about an element
	// elem_type = file/dir/all
	add_info_handler(handler, element_type='all'){
		switch(element_type){
			case 'file': this.add_data.process_file = handler; break;
			case 'dir' : this.add_data.process_dir  = handler; break;
			case 'all' : this.add_data.process_file  = handler; this.add_data.process_dir  = handler;  // TODO: only this is used now;
		}
	}

	//--------------------------------------------------------- SUBSECT TABCOL ----------------------------------------------------------------
	// DEF TABCOL setting up visible table columns
	visible_columns; // commented 24.04.20; now read from server;  = ["RES_checked", "date_mod", "subject", "correspondent", "attach_exist"]; // CB_SEL_REC  TODO: setter
	col_visible(name){ return this.visible_columns.includes(name); } // TODO: not used; info saved in pm?
	col_show(name){ this.visible_columns.push(name);}
	col_hide(name){ for(i=0;i<this.visible_columns.length;i++) if(this.visible_columns[i]==name) this.visible_columns.splice(i,1);}
	repeate_show_table(){  this.show_page(this.pager? get_counter_val( pager ) : 0) }
	tabcol_click(target, name, state){
		if(state)
			this.col_show(name);
		else
			this.col_hide(name);
		this.repeate_show_table();
	}
	// set initially visible columns and create popup to add/rem a col
	tabcol_init(){
		var vc = call_php_sync(this.contr_path, {'action' : 'visible_columns', 'project' : this.project_name}, 'POST');
		this.visible_columns = JSON.parse(vc.resp_text);
		var tc = create_popup_div(); // TODO 1: uses exernal func
		init_popup(tc, "mc_field_capt", null, true, ".tt_thumbs_form");
		var req = call_php_sync(this.contr_path, {'action' : 'table_fields', 'project' : this.project_name}, 'POST');
		var fields = JSON.parse(req.resp_text);
		for( let name in fields)
			add_popup_checkbox(tc, fields[name], name, this.visible_columns.includes(name), this.tabcol_click);
	}

	//--------------------------------------------------------- SUBSECT FIORD ---------------------------------------------  
	ro_extract(_header){ // used to find out (possible new) order field; this singled out to be used by others, TODO: maybe move to utils
		var header = _header.closest(".fh_header");
		var field_name = $(header).data("fhid");
		var new_dir = $(header).hasClass("mc_desc")? "asc" : "desc" ; // TODO: more correctly is to find dir so: if new_field==old_field => !old_order; else => asc (=def)
		return {"field" : field_name, "order" : new_dir};
	}
	ro_show_order(parent_, tname, order){ // called once after table is shown, adds the corresp class to order-field (to show it)
		// $(".th-tt_detail-" + files_order.field).data("order", files_order.order); // also may use '#tt_thumbs_form .fh-header th[data-fhid]=<field>' (not checked) ; TODO: not works.. data attr change (run-time) - css not works
		if(order)
			parent_.find(".th-" + tname + "-" + order.field).addClass("mc_" + order.order);
	}
	ro_to_str(files_order){ return files_order? files_order.field + " " + files_order.order : ""; }

	//--------------------------------------------------------- SUBSECT ADD ACTION --------------------------------------------
	// DEF AA adding action button 
	// action is an obj: {id, handler (function defined in client), caption}
	add_action(id, handler, caption=''){
		var t = this;
		var bd = this.main_form.find('.tt_buttons');
		bd.removeClass('hidden'); // gets visible if at a button added
		var btn = bd.append('<button type="button" class="btn btn-success btn-sm" id="' + id + '">' + caption + '</button>&nbsp;');
		// onclick contains some validation logic and then calls user handler, passing to it the list of selected paths
		btn.on('click',function(){
			var selection = t.find_selection();
			if( selection===0 )
				t.show_alert(lp("no_file_sel"));
			else
				handler(selection.paths, selection.files); // TODO: maybe call it by ajax (wait screen)
		})
		return btn;
	}

	//--------------------------------------------------------- SUBSECT REQUEST DATA ------------------------------------------------
	// DEF RD sometimes it's necessary to repeate request; eg when user requests re-order files
	request_data = null;
	rd_set(data){ this.request_data = data; }
	rd_get(){ return this.request_data; }
	rd_run(){
		if(this.request_data)
		switch(this.request_data.type){
			case "open": 	this.open_dir(this.request_data.path, this.request_data.cont); break;
			case "open_rec": 	this.open_dir_recursive(this.request_data.item); break;
			case "find": 	this.find_files(this.request_data.params); break;
			case "refresh_cache": 	this.refresh_cache(this.request_data.childs); break;
		}
	}

	//--------------------------------------------------------- SUBSECT CLEAR -----------------------------------------
	// DEF H&B - to make flex work - table elems (header and body) must be on same level with other elems (header and pager), so can't just replace whole html, but need remove old stuff and add new (after marker)
	clear_detail(clear_pager=true){ // TODO: check how works for both details
		this.get_thumb_form().find(".fh-elem").remove(); // remove table header/body
		this.get_thumb_sect().html("");
		if(clear_pager)
			this.clear_pager();
		this.get_preview_div().html(""); 
	}
	close_cont(cont){
		cont.children('.tree-cont').addClass('hidden');
	}

	//--------------------------------------------------------- SUBSECT POPUP (PUMA) ----------------------------------

	// PUMA this wrapper only encapsulates popup_div id; is to be used by client  ex tt_add_popup_item
	add_popup_item(caption, action, files=true, folders=true, notarget=false, custom_class=""){ // TODO: notarget is used to perform ops with selection; here also need control if there are some selected
		var cl = (files?"ttc_pu_file ":"") + (folders?"ttc_pu_folder ":"") + (notarget?"ttc_pu_notarget":"") + " " + custom_class;
		return add_popup_item( this.popup_div, caption, action).addClass(cl);
	}
	/* hides/shows items depending on item classes; user should add classes 
		ttc_pu_notarget: shown if clicked on empty place
		ttc_pu_file: showed only if target is file
		ttc_pu_dir: showed only if target is dir  
	*/
	set_pu_items(target, popup_div){
		if( $(target).closest("#md_ss_div").length ){ this.popup_div.addClass("hidden"); return; } // TODO: quickfix not to show pm in SEL_FOL
		if( $(target).hasClass("tt_emp_explore_menu") ){ // if user clicked menu icon (not folder/file item) - then use active elem  DEF PM_EMB   NOTE: in momo first select then click menu; TODO: quite tricky, may do it without pm
			target = this.get_curr_dir_item();
			set_popup_target(target);
		}
		var td = $(target).closest(".mc_dir");
		var is_dir = this.set_target_dir(td.length? td[0] : null)!=null; 
		var tf = $(target).closest(".mc_file");
		var is_file = this.set_target_dir(tf.length? tf[0] : null)!=null; 
		var is_tree = $(target).closest(".tree-cont").length;  // OPEN_ALL_TREE
		this.popup_div.find(".ttc_pu_item").each( function() { 
			if($(this).hasClass("ttc_pu_notarget") || is_dir && $(this).hasClass("ttc_pu_folder") || is_file && $(this).hasClass("ttc_pu_file") ) // NOTE: some items visible only if have active file/folder
				$(this).removeClass("hidden");
			else
				$(this).addClass("hidden");
			if($(this).hasClass("mc_tree_only") && !is_tree) // DEF OPEN_ALL_TREE: open/close all must be enabled only if invoked on a tree elem
				$(this).addClass("hidden");
		} );
	}

	//--------------------------------------------------------- SUBSECT UTILS MISC TODO-----------------------------------------

	add_slash(s){ return s[s.length-1]=='/'? s : s+"/"; } // adds slash if not yet contains; at the moment it's disorder with having/not having end-slash
	// handle search error situation
	search_error(j,errorS,p){
		var msg = '';	
		if(p == 'abort')
			msg = lp("search_stop");
		else if(j.status == 400 && p.indexOf('max_count')==0)
			msg = lpp("$too_many_found$", p.substring(10));
		else if(j.status == 400 && p.indexOf('not_found')==0)
			msg = lp("no_file_found");
		// some unhandled error
		else msg = lpp(p);
		if(p=="no_user"){ // LOGONEXP
			show_login();
			return;
		}
		// show msg
		show_alert(msg);
		j.done();
		//alert(msg);
	}

	// elem = js object 
	scroll_top_if_hidden(elem){
		if( typeof scrollIntoViewIfNeeded === 'function' )
			elem.scrollIntoViewIfNeeded(true);
		else
			elem.scrollIntoView(true);
	}
	// TODO: why not used?
	reset_table_tree(){
		this.get_root_item().html("");
		this.clear_detail();
		this.si_reset();
	}
	show_search_panel(){
		var sp = this.main_form.find(".mc_search_panel"); sp.css({'top': (this.main_form.offset().top + 'px') }); sp.removeClass("hidden");
	}
	hide_search_panel(){
		this.main_form.find(".mc_search_panel").addClass("hidden");
	}
	show_folder_search(item){
		$(".ttc_filter_path").val( get_data(item, "path") );
		show_search_panel();
	}	

	// ex tt_download_file
	download_file(){
		var id = this.get_curr_item();
		if(!id){ alert(lp("no_file_sel")); return;}
		download_file(this.table_tree_path + "download_file.php?id=" + id + "&t=" + this.table_tree);
	}

	// usage: when user requests some action on selected items (eg delete selected files); the func finds selection and performs passed action-callback
	selection_action(action, confirm_msg=lpp("$continue$?"), ok_msg="OK", error_msg="error"){
		var sel = this.find_selection(); // tt funcs
		var snap_info = {'paths': JSON.stringify(sel.paths), 'files': JSON.stringify(sel.files) }; // NOTE: paths are not used now, maybe; need control if selecting folders in thumb form works
		// stat selected files
		wait_screen.add_operation(action);
		var t = this;
		this.xhr = $.ajax({
			type: "POST",
			data: {'action' : action, 'paths' : snap_info.paths, 'files' : snap_info.files, "user_dir": t.user_dir, 'summary' : 1},
			url: 'contr/main.php',
			success: function(res){
				var count = res;
				if(confirm(lpp("$sel_n_files$, $2", res, confirm_msg))){
					t.xhr = $.ajax({
						type: "POST",
						data: {'action' : action, 'paths' : snap_info.paths, 'files' : snap_info.files, "user_dir": t.user_dir, 'summary' : 0},
						url: 'contr/main.php',
						success: function(res){
							alert(ok_msg);
							t.open_root_dir();
						}})
				}
			},
			complete: function(){
				wait_screen.remove_operation(action);
			}
		})
	}

	// used in REDI ; note: would be better to get file cache of curr dir, but wihtout root item (another reason to have always root item) it may be null
	get_all_shown_thumbs(){return this.get_thumb_sect().find(".thumb.mc_file");}
	set_thumb_add_info(thumb, html, title=''){ thumb.append( $("<div class='ttc_thumb_add_info' title='" + title + "'>" + html + "</div>") ); }
	reset_thumb_add_info(){this.get_thumb_sect().find(".ttc_thumb_add_info").remove();}

	// ---- ALERT _----  TODO: move to a util lib
	// 26.03.20 had to give tt_alert up while search panel (which holds it) is hidden normally; also other panels are shown/hidden dynamically, so hard to find some to hold it permanently; note: also search panel now hides upper screen part, so even can't use to container to show alert
	show_alert(msg, sel=".tt_alert"){
		alert(msg); return;
		var html = '<div class="alert alert-danger" role="alert">';
		html +='<button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>';
		html +='<strong>' + lp('attention') + '!</strong><br>' + msg;
		html +='</div>';
		this.main_form.find(sel).html(html);
	}
	clear_alert(sel=".tt_alert"){
		this.main_form.find(sel).html("");
	}
	// DEF SHARE: tricks to allow the same code to use for different projects (like needed in mh - to explore files and explore mails);
	// acid (Add Controller Data) is just used to add the data which is sent in each controller call
	// NOTE: in js params passed by ref note that sometimes data passed to contr is enormous, so passing to and fro by value would be costful
	acid(action,  params ){
		params.type = "POST";
		params.url = this.contr_path;
		if(!("data" in params))
			params.data = {};
		params.data.action = action;
		params.data.table = this.table_tree;
		params.data.table_files = this.table_files;
		params.data.project = this.project_name; // SHARE
		params.data.order = this.ro_to_str(this.files_order); // FIORD
		params.data.user_dir = this.user_dir; // MUSD
		if(this.show_files!==null) params.data.show_files = this.show_files?1:0; // HIDEFILES
		params.data.thumb_small_path = this.thumb_small_path;// SHARE
		params.data.thumb_medium_path = this.thumb_medium_path;
		return params;
	}

	//--------------------------------------------------- ESECT UTILS  -------------------------------------------------------------------------------

	//------------------------------------------------------------------------------------------------------------------------------------------------
	//--------------------------------------------------- SECT OPEN / FIND  -------------------------------------------------------------------------
	//----------------------------------------------------------------------------------------------------------------------------------------------

	//--------------------------------------------------------- SUBSECT OPEN / FIND MISC  --------------------------------------------------------------

	thumbs_list; // FIRE
	page_size = 50; // FIRE CASE  after each data fetch this should be re-set to 0;

	// TODO: this should be counted in SARE?
	open_root_dir(cond=''){ // cond is set when making 'recursive search' 
		this.set_where(cond); // 3.10.19; added to solve prob: if make search then click 'explore' - keeps using filter; TODO: need bring in order all uses of cond/table_where
		this.get_root_item().html(''); 
		this.open_dir(this.root_dir, this.get_root_item());
		this.si_reset();
	}
	show_plain(json_list, id=0){ // can pass list of paths or ids (id=true)
		this.thumbs_list = json_list; // FIRE save thumb list to use to show next portion TODO: id=0/1 => json_list may have different formats, so thumb_list also may have diff. form?.. turns out that 'id' flag arrives always to show_thumbs_portion (but by params); the fact that thumb_list is global while 'id' local - makes some confusion
		// clear_detail(); commented: can't be here: if have 2 requests at same time - they both clear and then both add
		if(this.detail_view=="thumbs"){
			this.show_thumbs_portion(0, this.page_size, id); // FIRE next portion
		}else
			this.show_table_portion(); // DETA
	}
	// this function is called by pager and should call all other funcs which page output of files
	show_page(page){ // FIRE CASE TODO: do not get: now pages work only for DETA (not for thumbs)?
		this.clear_detail(false);
		this.show_table_portion((page-1)*this.page_size, false);
	}
	// closes removing (not hiding) child elems
	close_dir_recursive(item){
		var cont = this.get_cont(item);
		cont.children('.tree-cont').remove();
		this.get_elem(cont).prop('indeterminate', false);
		this.update_parent_selection(cont);
	}
	show_panels(){
		if( !this.tree_hidden && this.get_tree_form().find('.tree-cont').length )
			this.get_tree_form().removeClass('hidden');
		if( this.get_thumb_form().html()!="" )
			this.get_thumb_form().removeClass('hidden');
	}
	// hides and clears panels
	hide_panels(hideTree=false){
		// return; TODO: commented this; why it was here?
		if(hideTree){
			this.get_tree_form().addClass('hidden');
			this.get_root_item().html('');
		}
		if(!this.tree_hidden)
			this.get_thumb_form().addClass('hidden');
		this.clear_detail();
	}
	def_search_fields(){
		var params = this.acid("search_fields", {}); // normally acid is used to return array for ajax; here is used only .data (while call_php_async takes several params instead of one object)
		var resp = call_php_sync(this.contr_path, params.data, 'POST'); 
		return resp.resp_text;
	}



	//--------------------------------------------------------- SUBSECT USER ACTIONS ------------------------------------------------

	// EVENT HANDLERS EXPLORER
	// explorer: dir click
	// e = tree-item; logic of opening a dir: if already was opened - show hidden childs and their thumbs; else - open_dir
	dir_click(e){ // NOTE: input not receives event on name click - it's out of input
		//var dir = $(this);
		var dir = $(e.target); // TEST
		e.preventDefault();
		if(dir[0]==this.get_curr_dir_item()) // DBLOPEN
			this.switch_dir_state( dir , e.ctrlKey, e.shiftKey);
		else if( this.dir_opened( this.get_cont(dir) ) )
			this.show_opened_plain(this.get_cont(dir) ); // need show thumbs; not like at firs open - now find all ids and send to php TODO: it now uses HIDEFILES_CACHE, so maybe may be used even if !dir_opened 
		//
		this.set_curr_dir_item(dir); // CURREL
	}

	//--------------------------------------------------------- SEARCH ------------------------------------------------
	
	search_init(search_fields_html){
		if(!search_fields_html){
			t.get_quick_search_form().remove();
			return;
		}
		var t = this;
		// SEARCH
		t.get_search_form().prepend(search_fields_html);
		ff_init(t.get_search_form(), function(){t.find_files_click()} , false); // false means do not search on select/date change 
		this.main_form.find('.tt_search_btn').click( function(){t.find_files_click()} );
		this.main_form.find('.tt_search_clear_btn').on('click',function(){ 	ff_clear( t.get_search_form() );})
		this.main_form.find('.tt_show_search_btn').on('click', function(){t.show_search_panel()}); // TODO: should be visible only if quick search hidden
		this.main_form.find('.tt_search_close_btn').on('click', function(){t.hide_search_panel()}); // note: wrap in func to avoid pass event obj as param 
		this.main_form.find('.tt_search_cancel_btn').on('click',function(){ t.cancel_search(t.get_search_form()) })
		// LBSP
		ff_init(t.get_quick_search_form(), function(){ t.find_files_quick_click(); } , false); // false means do not search on select/date change 
		t.main_form.find(".lbsp_search_btn").click( function(){ t.find_files_quick_click(); } );
		t.main_form.find(".lbsp_cancel_btn").click( function(){t.cancel_search(t.get_quick_search_form())} );
		t.main_form.find(".lbsp_expand").click( function(){ t.show_search_panel(); } );
	}
	  // RECSUR TODO 1 where is .tt_find_recursive?
	find_files_click(){ this.find_files_by_form(	this.get_search_form(), this.main_form.find(".tt_find_recursive").prop("checked") ); }
	find_files_quick_click(){ this.find_files_by_form(this.get_quick_search_form()); }
	// 	find files action
	find_files_by_form(form, recursive_search=false){
		if(ff_empty( form ) ){
			this.show_alert(lp("no_filter_cond"));
			return false;
		}
		var params = ff_params(form);
		this.reset_table_tree(); // new, not checked
		if(recursive_search){ // ex-start_recursive_search()
			var where = this.compile_search(params);
			this.open_root_dir(where);
		}else
			this.find_files(params);
	}
	// TODO 1: this actually can't be called by btn click during search, while during search there is a wait screen (should realize eg esc btn)
	cancel_search(form){
		if(this.xhr && this.xhr.readyState!=4)
			this.xhr.abort(); // TODO: at the moment it may be empty
		ff_clear( form );
		this.open_root_dir();
	}

	row_order_click(header){
		this.ro_set(this.ro_extract(header)); // FIORD
		// TODO: refresh...
		this.rd_run();
	}

	opened_closed(cont){ 
		var cache = cont.children('.ttc_file_cache').length > 0;   // use this while ttc_folder_opened is not yet finished (not works for find)  HIDEFILES_CACHE; if PFCA - this suffies
		var hidden = cont.children('.tree-cont:hidden').length > 0; // note: when emtpy dirs possible (in MH) may be opened without files-chiles; need add some class to opened dir - ttc_folder_opened; TODO: seems this was used before intro of ttc_folder_opened, now not necessary
		return !this.get_item(cont).hasClass("ttc_folder_opened") && (cache || hidden);
	}
	open_reopen(cont){
		if(this.opened_closed(cont) ){  // opened&closed
			cont.children('.tree-cont').removeClass('hidden'); // show childs (need only .tree-cont of next level)
			this.show_opened_plain(cont); // need show thumbs; not like at firs open - now find all ids and send to php
		}else // not ever opened
			this.open_dir(this.get_data(cont, "path"), cont);
	}

	// dir - explorer element
	switch_dir_state(dir, ctrl, shift){
		var path = this.get_data(dir, 'path');
		var level = this.get_data(dir, 'level');
		var cont = this.get_cont(dir);
		var opened = this.dir_opened(cont);
		// special reaction if ctrl pressed - open/close recursively
		if(ctrl){
			if(opened) this.close_dir_recursive( dir );
			else        this.open_dir_recursive( dir );
			return;
		}
		// normal open/close
		if(opened){
			this.close_cont(cont);
			this.hide_panels(false); // hide only thumbs panel
		}else{ // not ever opened or opened/closed
			this.open_reopen(cont);
		}
		// DEF SAVEOPEN need a way to say if a folder is opened independently on if it has some childs; reason: in MS diplaying files (=mails) in explorer may be turned off, so the old way "child.count>0" not works
		// TODO: now it's realized only for simple user click case; need also: recursive open; find-, find+ ...
		dir.toggleClass("ttc_folder_opened");
		dir.addClass("ttc_folder_once_opened"); // indicates if was opened at least once (and thus contains already info about childs) TODO: not used now; to use it need also set it true when showing already opened folders (show_tree)
	}
	// callbacks passed to clickable table
	// make_clickable does basic work, these callbacs perform sync with explorer (maybe call client callbacks)
	// on checkbox select
	on_row_select(selected, id, path){
		// 1. sync the item itself: thumb->tree
		var is_dir = id==0; // DEF TODO: here 'if is path' detected by id==0 which is against DEF USE_PATH_ID - using also ids of paths
		var t = this;
		if(!this.tree_hidden && (is_dir || this.show_files) ){ // if expl hidden - no need to sync; if shown - only if elem present in expl
			var cont = this.get_path_cont(path); 
			var elem = is_dir? this.get_elem(this.get_path_cont(path)) : this.get_id_elem(id); // path not contains name
			this.set_elem_sel(elem, selected);
		}
		// si
		if( is_dir ){
			if(selected)
				this.si_add_path(path, function(){t.path_to_detail_selection();}); // ajax! thus can call path_to_detail_selection only as callback
			else
				this.si_remove_path(path);
		}else{
			if(selected)
				this.si_add_id(path, id);
			else
				this.si_remove_id(path, id);
			// SEL_SYNC TREE-DETAIL  TODO 1 move to this.cascade_elem_sel?
			var det = this.get_id_detail(id);
			this.set_detail_select(det, selected); // quick way to sync - only change one elem  TODO 1 TEST : why need it if on_row_select is called by detail (when detail selects it itself)
		}

		// if(is_path && path=="") this.select_all(state); TODO 1 donno what was for 
		// 2. sync parents (stalk) and child elements
		if(!this.tree_hidden)
			this.cascade_elem_sel1(id, path, selected);
		else{
			this.update_thumb_root(); // this is for the case when user clicks a thumb-file 
			if(selected && is_dir) this.si_add_path(path, function(){t.path_to_detail_selection()} );
			if(!selected && is_dir) {this.si_remove_path(path);t.path_to_detail_selection();}
		}
		// 27.07.22 ; found out that on_select not called when select thumb	
		if( this.on_select ) 
			this.on_select( this.find_selection() );
	}
	update_thumb_root(){
		var t = this, root;
		if( (root = this.get_thumb_sect().find(".mc_root")).length ) // if expl hidden - just refresh '.' state
			this.si_check_path_sel(root.data("path"), function(sel){ t.set_detail_select(root, sel) } );
	}

	// on focus: by mouse click or by arrove move
	on_row_focus(elem){
		var path = elem.data("path");
		var cont = this.get_path_cont( path );
		if( this.is_dir(elem) ){
			if(!this.tree_hidden)  // 17.10; found bug DEF TREH: open_reopen() tries to ind tree elem with given path
				this.open_reopen(cont);
			else
				this.open_dir(path, cont);
			this.set_curr_dir(path);  // B open_dir(path, cont); replaced with A ; 
		}else{
			var id = elem.data("id");
			if(this.list_view_on)
				this.show_details(id, false);
			this.set_curr_item(id);
		}
		if(cont.length) // DEF HIDETREE in space version explorer not shown ; need forsee situations when it not exists
			this.scroll_top_if_hidden(elem[0]);
	}

	// when check box selected
	on_select_item(e){ // on_item_click on_click_item
		e.stopPropagation();
		this.cascade_elem_sel($(this));
	}

	// NOTE on_row_enter not realized

	//--------------------------------------------------------- SUBSECT SERVER DATA REQUESTS  ------------------------------------------------------------------------

	open_dir(path, cont){ // TODO: by idea cont.data("path") = path, so no need to pass it
		this.rd_set( {type:"open",path:path,cont:cont} ) ; // DEF SARE Save Request used for FIORD; save data of request to re-run when user requests change show order
		this.clear_alert();
		this.hide_panels(false); 
		wait_screen.add_operation("open_dir");
		var t = this;
		this.xhr = $.ajax(this.acid("open_dir", {
			data: {'path': path, 'cond' : this.table_where, 'use_paths': this.use_paths, 'shm_table_num': this.shm_table_num},  // table_where is for RECSUR
			success: function(res){
				if( res.length>2 ){ // empty json may be """"
					// show child elems 
					t.render_childs('show_dir', path, res, cont, false, function(){
						// 20.11.18 select newly opened folders if parent was selected; this also selects thumbs OD1
						if(  /* 17.10.222 TREH*/ !t.tree_hidden  &&  path!="" && t.get_elem(cont).prop("checked") )
							t.set_childs_selected( cont, true ); // here not need yet set thumb state - they are not yet shown  OD2
							// TODO: OD1 controverses OD2? 
					});
					// show plain 
					//show_plain(res); moved to render_childs
				}
			},
			complete: function(xhr, stat){
				wait_screen.remove_operation("open_dir");
				// show_panels();  TODO: wrong place for this: show_childs/thumbs only fire ajax which will be called asyncr.
			},
			//error: search_error,  commented 13.04.20 - if open empty ws - shows error; this is rather for empty search 
			global: false
		}))
	}
	open_dir_recursive(item){
		this.rd_set( {type:"open_rec",item:item} ) ; // SARE 
		var path = this.get_data(item, "path");
		var cont = this.get_cont(item);
		var elem = this.get_elem(cont);
		this.clear_alert();
		this.hide_panels(false); 
		wait_screen.add_operation("open_dir");
		this.xhr = $.ajax(this.acid("open_dir_recursive", {
			data: {'path': path, "cond" : this.table_where},   // table_where is for RECSUR
			success: function(res){
				this.render_childs('show_tree', path, res, cont, false, function(){this.set_childs_selected(cont, elem.prop('checked') );}); // show_tree selects items by default, need deselect them
			},
			complete: function(xhr, stat){
				wait_screen.remove_operation("open_dir");
			},
			error: function(j,errorS,p){} // TODO: send 400 on empty res and catch it here
		}))
	}
	// RECSUR sets table_where; input = array of params (in format of search form); normally controller receives data in raw format (from form) and compiles, but sometimes compiled format is also necessary here (or rather always) 
	// TODO: in fact it's called anyway if called find_files_click, so could call it from there, the only exception is that find_files may fail (in this case need table_where still = ''); but may unset where in search_error()
	// TODO: the 'compile_search' action in contr uses the standard get_filter_fields() func, so can't be used to compile any search
	compile_search(params){
		var params_compiled_json = call_php_sync(this.contr_path, {'action' : 'compile_search', 'table' : this.table_tree, 'params' : JSON.stringify(params), 'project' : this.project_name}, 'POST');
		return JSON.parse(params_compiled_json.resp_text);
	}
	// performs search of files (calls php) according to filter form
	find_files(params){
		var t = this;
		this.rd_set( {type:"find",params:params} ) ; // SARE 
	// params - conditions from search form (not yet compiled, that is without info from metadata)
		this.set_where(); // cancel possible prev recursive search RECSUR
		this.clear_alert();
		this.hide_panels(true);
		wait_screen.add_operation("search");
		this.xhr = $.ajax(this.acid("find", {
			data: {'params' : JSON.stringify(params) , 'max_count': 7000, 'shm_table_num': this.shm_table_num},
			success: function(res){
				t.set_where( t.compile_search(params) ); // new 12.03 this is only used when finding statistics   DEF FIND_COND save find params in table_where to use them on folder opers like stats, size (now may select also folders in find res)
				// show tree 
				t.get_root_item().html('');
				var renderer = $("#tt_full_view").prop("checked")? "show_tree_complete" : "show_tree"; // tt_full_view - button "+" (search plus)   TODO 1: tt_full_view not use here, from arch?
				t.render_childs(renderer, "", res, t.get_root_item(), true, null, true);
				// show thumbs
				t.show_plain(res);
			},
			error: this.search_error,
			complete: function(xhr, stat){
				wait_screen.remove_operation("search");
			}
		}))
	}

	//--------------------------------------------------------- SUBSECT SERVER VIEW REQUESTS ------------------------------------------------------------------------
	//INITIAL VIEW REQUEST (show as tree and call other (plain) views (table/thumbs) ---------------------------------------------------------------------------------

	// shows files; input: files list in json format (found previously by open_dir or find_files); output: result html is added to the cont
	// TODO: donno why, wait screen show is made only by search_started (not show_started), so need call former before calling render_childs; or need show screen also in show_started (better)
	// INC DEF : when files are res of search - that means that a folder childs are (may be) incomplete - exist other, not displayed files of this folder; when a file is deselected and the selected and it's the only file in its folder - the parent folder is set selected by update_parent_selection); that causes wrong selection result: folder is sent as selected and all files in it are included; possible solutions: 1. disable parent selection in 'find mode' or 2: not send at all paths in 'find mode'; may happen that user may want to select the whole folder on purpose, meaning that needs all files from it, thus the (2) not fits, so use (1); Realization: find_files passes further info that folders may be incomplete and the 'incomplete' class is added to files and accounted for in update_parent_selection(). 
	found_count = 0; // FIND_COUNT found in render_childs but used in show_thumbs_portion (while takes much time between these calls and info already fades); TODO: need some better way to sync
	// renderer = show_dir/show_tree/show_tree_complete
	render_childs(renderer, path, json_list, cont, close_selected=true, call_back=null, incomplete=false){ // renderer - is the name of contr/main function which should process json list
		wait_screen.add_operation("show_tree");
		var t = this;
		this.xhr = $.ajax(this.acid(renderer, {
			data: {'path' : path, 'childs' : json_list}, // TODO: was used encodeURI... which not works  TODO: path seems not used; but now use it as "start_path" for the open_dir_recursive (contr/main show_tree/show_tree_id)
			success: function(res){
				cont.children('.tree-cont').remove(); // this may be useful when re-request SARE
				cont.append(res);
				t.add_data.run(cont);
				t.found_count = cont.find(".tree-item-file").length; // FIND_COUNT remember count
				if(incomplete) $(".tree-cont").addClass("incomplete");  // INC
				$('.indeterminate').prop("indeterminate", true); // NEW to show half-selected state
				// new 21.09.18 after showing a sub-tree may be convenient not to display contents fully selected nodes; note: can't just call it after render_childs call, the latter is async
				if(close_selected)
					cont.find('.tree-dir:checked').each( function(){  t.close_cont(get_cont( $(this) ) ) ;	});
				// HIS Hidable Instrument Panel // this event indicates that need close nagiv panel (this happens only on successfull search)
				$(".tt_hide_on_render").addClass("hidden"); // TODO: what is this
				// now used only to select child files in open_dir
				if( call_back ) call_back(); // call it before show_plain, while latter makes selection synch
				// new: show thumbs is here now; othewise selection synch not works (starts when files not yet shown) TODO: bug: before, it wasn't called for case: renderer=show_tree_id - here need call show_plain(list, true)
				var id = renderer=="show_tree_id" || renderer=="show_tree_complete_id"? 1 : 0; // show_plain need to know what is in list - full info or ids TODO: temp solution
				t.show_plain(json_list, id);
			},
			complete: function(xhr, stat){
				wait_screen.remove_operation("show_tree");
				t.show_panels();
			}

		}))
	}

	// FIRE need two separate funcs: one which resets fire, other - which proceeds
	show_thumbs_portion(from, cnt, id=0){ // can pass list of paths of ids (id=true)
		wait_screen.add_operation("show_thumbs");
		var t = this;
		var rd = this.rd_get();
		var path = "path" in rd? rd["path"] : ""; // THUMB_UP need pass the opened path (is null in find)	
		this.xhr = $.ajax(this.acid("show_thumbs", {
			data: {'childs': this.thumbs_list, 'id': id, "start" : from, "max_count" : cnt, "path" : path}, // TODO with server cache no need of thumbs_list, id
			success: function(res, bla, request){
				t.set_active_section(".tt_thumbs_form"); // TOGSCT
				if(from==0) t.clear_detail();
				t.get_thumb_sect().append(res)
				t.path_to_detail_selection(); // select recs/thumbs depending on selected folders
				t.show_panels();
				// FIRE
				var remain = request.getResponseHeader("remain"), mtd = t.main_form.find('.tt_more_thumbs_div');
				if(remain) mtd.removeClass("hidden"); else mtd.addClass("hidden");
				if(remain)
					t.main_form.find('.tt_more_thumbs').data("from", from+cnt).data("count", cnt).data("id", id);
				if(t.on_show_plain)
					t.on_show_plain();
				// hide '..' if it's over top dir
				var level_up = t.get_thumb_sect().find(".mc_level_up");
				if( level_up.length && level_up.data("path").length < t.root_dir.length)  // new 21.06.22; restrict shown level
					level_up.remove();
				if(this.list_view_on)
					list_view();
			},
			complete: function(xhr, stat){
				wait_screen.remove_operation("show_thumbs");
				// TODO 1: show_info needs #tt_info_div
				if(t.found_count>t.page_size) show_info(lpp("$found_n_files$", t.found_count)); t.found_count=0; // FIND_COUNT TODO: uses a function of archive.js ; need inject some function instead
			}
		}))
	}
	// DEF LIST_VIEW ; enable show thumbs as list; the solution is js-side; modify thumbs to look like list; problem is that conversion thumb-list keeps selection/active where as list-thumb needs refresh
	list_view(){
		this.get_thumb_sect().addClass("mc_list_view");
		this.get_thumb_sect().css("display", "flex");
		this.get_thumb_sect().css("flex-direction", "column");
		this.get_thumb_sect().css("flex-wrap", "wrap");
		//this.get_thumb_sect().css("align-items", "baseline");
		this.main_form.find(".thumb").each( function(){
			$(this).css("display", "flex");
			$(this).css("border-width", "0px");
			$(this).css("margin", "0px 5px 5px 5px");
			$(this).find(".RES_checked").css("position", "unset"); // -relative
			$(this).find(".RES_checked").css("margin-right", "5px"); // -relative
			$(this).find(".mc_thumb_image").remove();
			// avoid that item occupies whole width
			// thus all have different width $(this).css("max-width", "max-content"); $(this).css("padding-right", "30px"); // because download btn not belongs to content but needs space
			$(this).css("max-width", "370px");
		} );
	}
	thumb_view(){
		this.get_thumb_sect().removeClass("mc_list_view");
		this.get_thumb_sect().css("display", "block");
		this.rd_run();
	}

	more_thumbs_click(){var mt = this.main_form.find('.tt_more_thumbs'); this.show_thumbs_portion(mt.data("from"), mt.data("count"), mt.data("id"));} 
	// DETA show details as table
	show_table_portion(start = 0, first_time=true){ 
		wait_screen.add_operation("show_table");
		var t = this;
		this.xhr = $.ajax(this.acid("show_details_table", {
			data: {"start" : start, "max_count" : this.page_size, "visible_columns" : JSON.stringify(this.visible_columns)},
			success: function(res, bla, request){
				if(res){
					t.clear_detail(); // TODO: moved from show_plain, not tested for table-view
					$(res).insertAfter(t.get_before_detail());
					t.set_active_section(".tt_thumbs_form"); // TOGSCT
					t.get_thumb_form().find(".fh-header tr").addClass("mc_section_header"); // height/color
					t.show_panels();
					// FIXHEAD necessary only for DETA need call it after show_panels()
					t.ro_show_order(t.get_thumb_form(), "tt_detail", t.files_order);
					t.get_thumb_form().find(".td-tt_detail-date_mod").each( function(){ $(this).html( shrink_date( $(this).html() ) );  }  );
					fh_init_table( t.get_thumb_form() );
					// make_clickable( on_row_select, on_row_focus);  // SEL_SYNC  commented 26.02; now should work that call in init()
					if(t.on_show_plain)
						t.on_show_plain(); // 22/11/19 add user callback; used to show attachment image
					t.get_thumb_form().find(".fh-header").addClass("tt_demo_hidden"); // DEHO
					t.path_to_detail_selection(); // select recs/thumbs depending on selected folders
				}
				if(first_time){
					var count = request.getResponseHeader("count"); // total count; server returns only portion
					t.clear_pager();
					var max = Math.trunc( parseInt(count)/t.page_size + 0.99999);
					if(max>1) // if need pager
						t.get_thumb_form().append( create_pager(max) ); 
				}
			},
			complete: function(xhr, stat){ // TODO: guess need move some stuff to 'success:'
				wait_screen.remove_operation("show_table"); 
			}
		}))
	}

	show_details(file_id, modal=true){
		if(this.client_show_details_func){
			this.client_show_details_func(file_id);
			return;
		}
		var t = this;
		//window.open(table_tree_path + 'show_file_details.php?id='+file_id + t, "File details"); // here better use files table (default) (not some view)
		//document.getElementById('tt_preview_body').src = table_tree_path + 'show_file_details.php?id='+file_id; // show in same tab but in another frame
		if(modal){
			var content = $("<div style='max-width:500px;max-height:500px;'></div>");
			var url = call_php_sync(this.contr_path, {"action" : "get_thumb_url", id: file_id, thumb_medium_path: this.thumb_medium_path}, 'POST').resp_text;
			var img = create_boxed_image(url, 500, 500);
			$(img).removeClass("ap_detail_elem");
			content.append(img);
			show_select_string(null, '', content, name); // TODO: works only if on the page is present md_ss html
			
		}else{
			this.main_form.find(".tt_preview_form").removeClass("hidden");
			this.get_preview_div().html( call_php_sync(this.contr_path, {"action": "print_preview", "id": file_id, "table": this.table_tree, "thumb_medium_path": this.thumb_medium_path}).resp_text) ;
			this.main_form.find(".tt_preview_close").click( function(){ t.main_form.find(".tt_preview_form").addClass("hidden") } );
		}
	}
	hide_details(){ this.main_form.find(".tt_preview_form").addClass("hidden"); } 

	//--------------------------------------------------- ESECT OPEN / FIND ----------------------------------------------------------------------------------

	//--------------------------------------------------------------------------------------------------------------------------------------------------------------
	//--------------------------------------------------- SECT SELECTION  -------------------------------------------------------------------------------
	//--------------------------------------------------------------------------------------------------------------------------------------------------------------

	//--------------------------------------------------------- SUBSECT SEL_CACHE ---------------------------------------------------------------------
	/* DEF SEL_CACHE SI_ 31.12.19 ; problems at the moment:
		- if folder in explorer selected and show next page - files of next page not selected (in detail);
		- page selection not saved (if show next page)
	  to resolve that - need add selection cache; need save selection independently on shown items (page) ; 
	  also convenient to save folder content in cache (or else need re-query... or use selection cache?
	  NOTE: if a file is present in detail - that means exists its immediate parent folder in explorer (but if explorer hidden? - exists anyway?)
	  NOTE: selection may be changed by both explorer and thumbs; probably in both cases that should affect first the si cache and then update both (or only the other)
	  NOTE: why not use two cache arrays - paths and ids; eg if path is selected and then one file de-selected - in this case anyway need request all path ids and then remove that deselected
	  	yet here is a problem: sometimes need to know if a path is completely selected, so TODO 1: DEF CSP maybe also save in si completely selected paths (si_path_list); also use this in si_get_selection
		CSP maybe may save traffic if there are folders with huge num of files (in arch they are millions);
		but a complex situation: eg there is a tree of folders and top dir is sel and then some file is desel: means instead of one sel dir there will be maybe many sel subdir, and many indeterminate subdir; it prob should be managed to explorer
	*/
	si_list = {}; // list of all selected ids; map: path -> [ids] ; this struct allows to also use it as cache of ids for a path (not yet opened) ; paths have endslashe - it allows to easily find if one path contains another
	si_list_all = {}; // same struct as si_list; cache of all ids (not only selected); need to detect if dir completely selected (in situation when an id added to selection)
	//si_path_list{}; // additional array to know completely selected paths; CSP
	// NOTE: is async ; to use it's result - need pass callback
	si_add_path(path,callback=null,add_sel=true){
		var t = this;
		// TODO 1: why call ajax if already in si_list_all?
		if(!add_sel && (path in this.si_list_all)){ callback(); return; } // if func was used only to refresh all files cache and cache already contains it - just all callback
		this.xhr = $.ajax(this.acid("find_path_ids", { //returns ids grouped by path, each path contains immediate childs ids
			data: {'path': path, 'cond' : this.table_where}, // need it in recursive search; NOTE: in normal search it's better to take info from file cache
			success: function(res, bla, request){
				var stat = JSON.parse(res);
				if( (typeof stat)==='object'){
					if(add_sel)
					merge_object( t.si_list, stat, true );
					merge_object( t.si_list_all, stat );
					//if(!(path in this.si_path_list)) si_path_list.push(path);  // CSP TODO: check if already contains super path?
				}
				if(callback)
					callback();
			}
		}))
	}
	// checks if a path is fully selected comparing cache of all files (must be already set) with cache of sel files ; TODO: this is an std algo to compare two arrays, could move to utils
	si_check_path_sel1(path){ 
		for(let cp in this.si_list_all)
			if( cp.startsWith(path) )
				if( !(cp in this.si_list) || this.si_list_all[cp].length > this.si_list[cp].length )
					return false;
		return true;
	}
	// checks if a path is fully selected comparing cache of all files; if necessary - refreshes cache by ajax
	si_check_path_sel(path, callback){
		var t = this;
		this.si_add_path(path, function(){
			callback(t.si_check_path_sel1(path));
			// 27.07.22 ; this is called also from on_row_select, but latter may use ajax and not update info at call moment
			if( t.on_select ) 
				t.on_select( t.find_selection() );
			}, false );
	}
			
	// remove path and all subpaths
	si_remove_path(path){
		var paths = Object.keys(this.si_list); // NOTE: pre-select keys, while object will be modified
		for(i=0;i<paths.length;i++)
			if( paths[i].startsWith(path) )
				delete this.si_list[paths[i]];
		//this.si_path_list.splice( si_path_list.indexOf(path), 1 ); // CSP TODO: remove subpaths?
	}	
	si_add_id(path, id){
		id = id.toString();
		if( !(path in this.si_list) ) 
			this.si_list[path] = [];
		if( !this.si_list[path].includes(id) )
			this.si_list[path].push(id);
		// TODO 1: CSP actually here also need update path list; need request all path ids and check if now path is compl selected; dono if it's obligatory; anyway ids are present; what about subfolders....
	}

	si_remove_id(path, id){
		id = id.toString();
		if( !(path in this.si_list) ) throw "bug, path missing in si";
		this.si_list[path].splice( this.si_list[path].indexOf(id), 1 );
		//this.si_path_list.splice( si_path_list.indexOf(path), 1 ); // CSP ; now not completely selected ; subfolders?...
	}
	si_reset(){ this.si_list = {}; this.si_list_all= {}; }
	si_find_all(){
		var res = [];
		for(let path in this.si_list)
			res = res.concat( this.si_list[path] ); // TEST
		return res;
	}
	si_get_path(path){ /*path = append_slash(path);*/ return path in this.si_list? this.si_list[path] : []; } // normally path always present

	//--------------------------------------------------------- SUBSECT SELECTION BASIC ---------------------------------------------------------------------

	// returns lists of selected files folders {paths:, files:} ; performs also exclusion of selected sub-paths
	// as source, uses the tree and also si_list
	// TODO 1: seems no SEL_CACHE used only on select in detail; need use also when select in explorer, so that could rely only on SEL_CACHE to find selection
	find_selection(include_active=false){
		var t = this;
		// get what is selected in explorer
		var sel_paths = [], sel_files = [];
		this.get_tree_form().find(".tree-dir:checked").each( function(index){ var path = t.get_data($(this), 'path'); sel_paths.push( path ); }) // TODO: DEF PTI Path To Id - use path_id instead of path;
		this.get_tree_form().find(".tree-file:checked").each( function(index){ var path = t.get_data($(this), 'path');  sel_files.push( t.get_data($(this), 'id') ) }) // 

		// get what is in SEL_CACHE (represents now detail selection)
		// this is for the case when tree hidden or files hidden and explorer not contains all info about selection; in this case it should be in si_list 
		for(let path in this.si_list){
			var ins = false; for(i=0;i<sel_paths.length;i++) if( path.startsWith(sel_paths[i]) ){ins=true;break;} if(ins)continue;// omit file if under some sel path TODO 1: what is this shit with ins
			for(var i=0;i<this.si_list[path].length;i++)
				if( sel_files.indexOf( this.si_list[path][i] )<0) // rec path isn't in sel folders and id isn't yet in sel files
					sel_files.push(this.si_list[path][i]);
		}
		//
		if(include_active && !sel_paths.length && !sel_files.length && t.get_active_detail().length)
			sel_files = [t.get_active_detail().data("id")];
		//	
		return {"paths": sel_paths, "files": sel_files};
	}

	// NOTE: can't use it always instead of cascade_elem_sel1 while may happen that explorer has no corresp elem (if elem is file and exp not shows files) 
	cascade_elem_sel(elem){
		var path = this.get_data(elem, "path");
		var id = this.get_data(elem, "id");
		var selected = elem.prop('checked');
		this.cascade_elem_sel1(id, path, selected, this.is_dir(elem));
	}

	// selection logic: if some elem is unselected - all chain of its parents is unselected
	// NOTE: when no files shown and the target is a file - can't pass target tree-elem, instead find and pass the parent folder (parent_cont)
	// used also for SEL_SYNC detail -> tree (called from on_row_select
	// this func is called when the target elem has already been updated and it's necessary to update sel state of childs/parents
	// this func is called only if tree_hidden = false (because uses update_parent_selection which relies upon tree); but maybe show_files = false 
	cascade_elem_sel1(id, path, selected, is_dir){
		// update childs
		var cont = this.get_path_cont(path); // note that if is_dir - this is the parent, if file - elem itself
		var parent_cont = is_dir? this.get_parent(path_cont) : path_cont;
		// cascade down: set childs of a dir in same state 
		if(is_dir) 
			this.set_childs_selected(cont, selected );
		// cascade up: update stalk;   some old NOTE: moved it after sel cache, parent sel should be updated after sel cache is set
		this.update_parent_selection(parent_cont, false);		
		// TODO 1: si_ works with async ajax, so at this point sel may be yet not updated
		if( this.on_select ) // client callback; now used only for SELIN NOTE: could call it from set_childs_selected - but sometimes it's just extra work (when all childs of selected parent are set selected)
			this.on_select( this.find_selection() );
	}
	// set all childs of given cont to given state
	set_childs_selected(cont, selected){
		var t = this;
		cont.find('.tree-elem').each(function( index ) { // this selects checkbox of the container and its childs
			if(index!=0){ // this is to avoid changing state of the parent-cont itself, which may be undesirable (in open_dir_recursive)
				t.set_elem_sel($(this));
				//$(this).trigger("change"); // onchange isn't envoked when state changed by js, so call it here; commented while onchange is for single elem click; besides not always necessary
			}
		});
	}
	// 

	// used only if tree_hidden = false while uses tree struct
	// find_parent false allows to update selection of passed elem (not of parent); used (maybe temp) in on_row_select
	update_parent_selection(cont, find_parent=true){
		if(!cont) return; // used by on_row_select
		var t = this;
		// if( cont.hasClass("incomplete") ) return; // INC parents remain always unselected (only may select manually)    DEF INC_CORR - correction: instead of keep folders 'incomplete' always de-selected - do not add them at all (in find_selection); when a folder selected - all files in it will be selected (and added); thus have same logic as in 'search minus' and other similar; thus can't select whole folder (including files not satisf. cond), which yet may be necessary. for this - need use 'search plus' mode
		var par = find_parent? this.get_parent(cont) : cont;
		if(!par.length) return;
		// var re = $('#tt_explore_root_item');	if(!par.length)	if(cont[0]==re[0]) // top level reached	return;	else	par = re; thought it would resolve the SEL_ANIMALS, but nope (it's updating of the parent not item itself (no need to update root container))
		// A: check selection state of all immediate childs (files/folders)
		// NOTE: with SELECTION this is used only to check dirs; TODO: when SELECTION tested - need remove checking files from here (use .tree-cont.tree-dir seems)
		var all_sel = true;
		var all_desel = true;
		par.children('.tree-cont').each( function(){
			var elem = t.get_elem( $(this) );
			if(t.is_dir(elem)){ // 10.01.20; found out that counting files here makes bug: tree elem hasn't yet changed its state, so disinforms; besides, files are counted in "C"
				var sel = elem.prop('checked')
				var ind = elem.prop('indeterminate')
				all_sel = all_sel && sel && !ind; // here actually ind === false
				all_desel = all_desel && !sel && !ind;
			}
		} );

		// C NEW: need also count selected recs (when HIDEFILES) 1. find all selected 2. filter those of curr fold (by idea table shows only active folder)
		// NOTE: by idea this func is called only when 'par' is already opened, thus has file cache
		// NOTE: used only to check immediate files (not folders); TODO: may instead check all selection files of path/* - in this case do not need check dir selection state ( A ).. but thus will need to find path/* childs for each path elem (slow)
		var cache_files = [];
		if( this.get_file_cache_arr(par, cache_files) ){ // TODO 1: file cache now also may be obtained by si_add_path(path,callback=null,addsel=false), but now works only by async ajax; besides if here - then folder tree is present, so 
			var cont_sel = this.si_get_path( this.get_data(par, "path") ); // NOTE: so both cache files and selection cache represent only immediate childs
			all_sel = all_sel && cont_sel.length==cache_files.length;
			all_desel = all_desel && cont_sel.length==0;
		}

		// set found selection and recurse to parent
		var par_elem = this.get_elem(par);
		this.set_elem_sel(all_sel,  !all_sel && !all_desel);
		// go up
		this.update_parent_selection( par );
	}

	select_all(state=1){ // this would be much easier if having always root element TODO:
		this.get_thumb_form().find(".thumb").not(".mc_root").each(function(){
			var elem = $(this);
			if(state) elem.addClass("selected"); else elem.removeClass("selected");
			on_row_select(state, elem.data("id"), elem.data("path"));
		});
	}

	// HIDEFILES_CACHE for the given folder (cont) finds its files saved in cache; ouputs to the output param 'files'; return res = 'some files present' TODO 1: now used only in update_parent_selection and should be replaced with si_ 
	get_file_cache_arr(cont, files, recursive=false){ // NOTE: designed to be used for find_opened_childs, so files is the output param
		var file_cache =  cont.children(".ttc_file_cache");
		if(file_cache.length){ // NOTE: can't just concat - it returns new array; TODO: actually useless conversion, need pass string to server
			var nf = file_cache.html().split(",");
			for(i=0;i<nf.length;i++)
				if(nf[i]!="")
					files.push(parseInt(nf[i]));
		}
		if(recursive){
			var childs = cont.find(".tree-item-dir");
			for(i=0;i<childs.length;i++)
				this.get_file_cache_arr( childs[i], files, true );
		}
		return files.length>0;
	}

	//--------------------------------------------------------- SUBSECT SEL_SYNC --------------------------------------------------------
	// sync selection tree -> detail
	// NOTE: need call it even if selection was made by detail (clickable -> on_row_select -> sync to explorer -> sync to detail (again) ); 
		// this is necessary because explorer may have made cascade selections (if eg thumb is clicked and whole dir gets selected - need set "." folder to fully selected state ecc)
	// TODO: guess need realize it also for thumbs while they also are shown in portions
	// elem: explorer item; is passed from folder onchange - need deselect files of this folder if it gets unchecked (may be other details selected not of this folder)
	// NOTE: 
	path_to_detail_selection(elem=null){
		//if(this.tree_hidden) return; // added 16.06.22; this func duplicates and breaks the work of make_clickable
		var detail_class = "."+this.get_detail_class();
		// X new 28.01.20 ; need first deselect all, or else sync not works on deselect sms in tree
		this.get_thumb_form().find(detail_class + ".selected").removeClass("selected"); // DEAL
		//
		var sel = this.find_selection(); // retrieves sel files as from tree as from si_
		this.get_thumb_form().find(detail_class).each(function(){
			var path = $(this).data("path");
			var id = $(this).data("id").toString();
			if( id && id!="0" && sel.files.includes(id) )
				$(this).addClass("selected");
			else
				for(var i=0;i<sel.paths.length;i++)
					if( path.startsWith( sel.paths[i] ) )
						$(this).addClass("selected");
		});
		this.update_thumb_root(); // this is for the case when user clicks the root-thumb itself; si_ calls async ajax and the calls this func as callback, so must have it here 
	}
	//--------------------------------------------------- ESECT SELECTION  -------------------------------------------------------------------------------


	// --------------------------------------------------------------------------------------------------------------------------------------------------
	//--------------------------------------------------- SECT INIT -------------------------------------------------------------------------------
	// --------------------------------------------------------------------------------------------------------------------------------------------------

	// TODO: passing search fields here is now useless, while need same fields both in 'build form request' and in 'find' request; see get_filter_fields in contr/main.php; thus at the moment need change get_filter_fields in contr/<project.php>
	//init_table_tree(
	constructor(
			project_name, 
			holder_sel, 
			table_tree,
			type = "details",  //   [thumbs,details] 
			search_fields_html=null // pass null to use def_search_fields(), "" to not use search
		){ // sets handlers
		this.project_name = project_name;
		this.name = project_name; // NOTE: may happen that in an app there are two instances using same project name (but they need unique names); in this case should call set_name(some_unique_name)
		this.table_tree = table_tree;
		this.table_files = table_tree; // change by set_table_files if diff from table_tree
		this.detail_view = type;
		this.main_form = $(holder_sel);
		var t = this;

		// html
		var resp = call_php_sync(t.contr_path, {'action' : 'render_new'}, 'POST'); 
		$(holder_sel).html(resp.resp_text);
		if(t.detail_view=="thumbs"){
			this.main_form.find(".tt_thumbs_header").removeClass("hidden");
			this.get_thumb_sect().removeClass("hidden"); // TODO 1: and if detail(table)? where are recs shown?
		}
		if(t.detail_view=="detail"){
			this.main_form.find(".lbsp_crud").removeClass("hidden");
		}
		make_clickable( 
			function(sel,id,path){ t.on_row_select(sel,id,path) }, 
			function(elem){	t.on_row_focus(elem) }, 
			".tt_thumbs_form", 
			"."+t.get_detail_class() 
		);  // SEL_SYNC
		his_init(); // call manually while here html is added by js and may be added before automatic call (when yet no elems added)

		this.search_init(search_fields_html===null? this.def_search_fields() : search_fields_html);

		// TIPS TODO 1: check what is it and if need 
		//$("#sf_path").data("tip", "path_filter"); // TODO: not works! (js works) this only sets data-tip=..
		var sfp = document.getElementById("sf_path");
		if(sfp) sfp.dataset.tip = "path_filter";
		set_tips();

		/// click of the link Esplora cartelle
		this.main_form.find('.tt_explore_btn').on('click', function(){t.open_root_dir()}); // note: wrap in func to avoid pass event obj as param 
		//
		// open/close item
		this.get_tree_form().on('click','.tree-item-dir',function(e){t.dir_click(e);} );   // DEF DBLOPEN  first click on a dir (not yet current) only selects it; second - switches state; thus dbl click on non current element switches its state
		// logic of selecting
		this.get_tree_form().on('click','.tree-elem', function(e){t.on_select_item(e)}); // TODO: better onchange?
		// SHOW DETAILS 
		this.get_tree_form().on('click','.tree-item-file',function(e){
			e.preventDefault();
			var file_id = t.get_data($(this), 'id');
			t.show_details(file_id);
		})
		// TODO: not used in archive
		this.get_tree_form().on('click', '.download', function(e){
			e.stopPropagation(); // avoid call of tree-item handler
			//$.post(table_tree_path + 'contr/download.php', {'path': get_data($(this), 'path')})
		})

		//
		// thumb of file under cursor  IMG_HINT 
		this.get_tree_form().on('mouseenter','.tree-item-file',function(e){
			var thumb = call_php_sync(t.contr_path, {'action': 'file_thumb', 'id': t.get_data( $(this), 'id'), 'quiet':1} );
			img_hint_show(thumb.resp_text, e.pageX, e.pageY, ".tt_file_popup" );
		});
		this.get_tree_form().on('mouseleave','.tree-item-file',function(e){
			img_hint_hide();
		});

		/* DEF TODO BUG DOUBLE_SEL don'tunderstand why sel logic is both here in tt and in make_clickable (called from here) */
		// DEF SELALL - stuff to select all recs (checkbox in header) TODO: make same for thumbs?
		this.get_thumb_form().on("click", ".th-tt_detail-RES_checked", function(){
			$(this).toggleClass("selected");
			var sel = $(this).hasClass("selected");
			t.get_thumb_form().find(".fh-body tr").each( function(){
				if(sel) $(this).addClass("selected"); else $(this).removeClass("selected");
				t.on_row_select(sel, $(this).data("id"), $(this).data("path") );
			});
		} ); 

		this.main_form.find(".tt_more_thumbs").click( function(){ t.more_thumbs_click() } );
		this.main_form.find(".tc_download_current").click( function(){ t.download_file()} );

		// hide instrument panel 
		//$("#tt_explore_btn").on("click", function(){ hide_id('tt_left_header'); });  // HIS Hidable Instrument Panel
		//$("#tt_search_btn").on("click", function(){ hide_id('tt_left_header'); });  // HIS
		// this not works, focus is on some inner elems instead // $("#tt_left_header").focusout(function(){ hide_id('tt_left_header'); });  document.getElementById('tt_left_header').focus(); // HIS

		//spinner = new Spinner(); moved to wait_screen TODO 1: wait_screen is in ext file
		 
		//PUMA  this is necessary to show popup (now is done by ctrl-left click); if use - need also add checks opened/closed 
		t.popup_div = create_popup_div("tt_popup_div_"+name); // id is only necessary to add css
		init_popup(t.popup_div, "mc_file"			, function(tr,p){t.set_pu_items(tr,p)}, false, holder_sel);
		init_popup(t.popup_div, "mc_dir"			, function(tr,p){t.set_pu_items(tr,p)}, false, holder_sel); // SELREC
		init_popup(t.popup_div, "ttc_emb_pm_detail"	, function(tr,p){t.set_pu_items(tr,p)}, true , holder_sel); // in MOMO pm is called on special icon click (embedded popup menu fro detail) 
		t.add_popup_item(lp("close_all_folders"), function(item){t.close_dir_recursive(item)}, false, true, false, "mc_tree_only");
		t.add_popup_item(lp("open_all_folders"), function(item){t.open_dir_recursive(item)}, false, true, false, "mc_tree_only");
		t.add_popup_item(lp("search_folder"), function(item){t.show_folder_search(item)}, false, true); // FILTERPATH add button
		
		// RECSUR clear search condition when toggle button unpressed  TODO 1: selector not in html prob used only for archive
		this.main_form.find(".tt_find_recursive").on("change", function(){ 
			if(!$(this).prop("checked")) t.set_where();
		});
		// allow unset both radio buttons
		//add_untoggle( $("#tt_search_modes") );  TODO 1: not in html
		// FIORD sorting by table header click
		this.get_thumb_form().on("click", ".mc_row_order", function(){t.row_order_click($(this))});
		// TABCOL
		t.tabcol_init();
		// TOGSCT buttons < >
		this.main_form.find(".mc_togsect").each( function(){
			var b = $(this); 
			var ts = b.data("ts");
			b.click( function(){ t.set_active_section(ts); }	);
		} );
		// ARROW_MOVE  TODO 1: isn't it duplication of mc_focused in archive.js
		this.main_form.find(".mc_tt_section").on("click", "*", function(){
			var section = $(this).closest(".mc_tt_section");
			$(this).removeClass("mc_focused"); section.addClass("mc_focused");
		}); // need manually track which section is  focused

		t.main_form.find(".tt_toggle_detail").click( function(){ t.get_thumb_form().find(".fh-header").toggleClass('tt_demo_hidden'); } );
		//
		this.add_data = {
			// called each time a result is added to the tree; param = parent element;
			// selects not processed file/dir items - <li> elements which contain visual data; calles user defined handlers; marks elements as processed;
			// then does same thing for folders
			run : function(parent_cont){
				parent_cont.find('.tree-item').each(function(index){
					var elem = $(this);
					var processed = elem.data('processed');
					if( typeof processed == 'undefined' || processed == false){ // not yet processed ~ attr 'processed' not yet exists 
						if( elem.hasClass('tree-item-file') )
							t.add_data.process_file( elem );
						if( elem.hasClass('tree-item-dir') )
							t.add_data.process_dir( elem );
						t.set_data(parent_cont, 'processed', true);
					}
				});
			},
			// THIS IS THE PART THAT USER MUST REDEFINE if necessary to add some additional visual data to html (or somehow process each added file/dir)
			// to get some data use get_data: 
			process_file: function(file){return true},
			process_dir : function(dir ){return true}
		}
		// LIST_VIEW
		t.main_form.find(".mc_sal").click( function(){t.list_view(); t.list_view_on = true; t.main_form.find(".mc_sal").addClass("hidden"); t.main_form.find(".mc_sat").removeClass("hidden");t.hide_details();} );
		t.main_form.find(".mc_sat").click( function(){t.thumb_view();t.list_view_on = false;t.main_form.find(".mc_sat").addClass("hidden"); t.main_form.find(".mc_sal").removeClass("hidden");t.hide_details();} );
		$(".tt_thumbs_form").on("dblclick", ".thumb", function(){  t.show_details( $(this).data("id"), true ) } );
	}
}
//--------------------------------------------------- ESECT INIT -------------------------------------------------------------------------------

