<?php
	require_once(dirname(__FILE__)."/../path.php");
        require_once(proj_path."view/lang.php");

	// ---------------------------------------------------------------------------
	//		MODEL	
	// ---------------------------------------------------------------------------

	function get_file_types(){
		db\select('file_types','name','clean=1','round(num/10000) desc, name asc');
		return db\response_to_array('name');
	}

	// ---------------------------------------------------------------------------
	//			VIEW
	// ---------------------------------------------------------------------------

	function basic_fields_captions(){
		//return array("id" => "#id", "date_mod" => "data", "subject" => "oggetto"); // FIDE format
		// NOTE: this fields must be in tt/model/db.php field_list_basic
		return array(
			"id" => "#id",
			"date_mod" => lp("date"),
			"name" => lp("name")
		); // FIDE format
	}

	// MUSD
	function get_def_user_dir($user_id){ return db\select_field("users", "user_dir", "id=$user_id"); } // NOTE: for archive it's ""
	function user_dir_allowed($user_id, $check_dir, $write=false){ 
		log\debug("checking '$user_id' '$check_dir'");
		$user = db\select_record("users", "admin, worker, user_dir, email", "id=$user_id");
		$email = $user["email"]; $user_dir = $user["user_dir"];
		if($user["worker"]) return starts_with($check_dir, ws_path_rel) || starts_with($check_dir, cloud_path_rel) || starts_with($check_dir, cache_path_rel) || starts_with($check_dir, $user_dir); // a worker has access to all other TODO: although maybe only for public
		if(!$check_dir) return $user["admin"]; // only admin can access root dir
		$now = (new DateTime())->format(db\get_date_format());
		$wc = $write? "and can_upload=1" : "";
		return
			starts_with($check_dir, $user_dir) ||  // for the case when no user_dir passed to contr (now used in cases when contr action is not requesting dir content (eg filter fields) - in this case user_dir is checked anyway)
			starts_with($check_dir, ws_path_rel.$user_dir) || // requested dir must be =/contain user dir
			starts_with($check_dir, cloud_path_rel.$user_dir) ||
			starts_with($check_dir, cache_path_rel.$user_dir) ||
			db\exists("ws_in", "user_email='$email' and date_expire>'$now' and locate(path, '".db\escape($check_dir)."') = 1  $wc");   // dir in db starts with check_dir
	}
	function get_filter_fields(){ // when only need compile where - do not need file types // TODO: sometimes (when only build user request) do not need options; in this case no need to read file types; so maybe pass some param here: $req_only=false
		$file_types = get_file_types();
		return array (
			 // NOTE: 'predicative' added 29.11.18 to realize ability to 'and' (instead of usual 'or') the search criterion (for the case when it's an array)
			 array('id' => "sf_path", 	"type" => "text", 	"field" => "path", 	"operation" => "like",	"caption" => lp("path"), 	"string" => 1, 	"class" => "ttc_filter_path", 	'placeholder' => lp("name_part"), 'predicative' => 'and'), 
			 array('id' => "sf_name", 	"type" => "text", 	"field" => "name", 	"operation" => "like",	"caption" => lp("name"), 		"string" => 1, 	"class" => "", 	'placeholder' => lp("path_part"), 	   'predicative' => 'and'),  // PATH/NAME
			 array('id' => "sf_data_from","type" => "date", 	"field" => "date_mod", 	"operation" => ">=", 	"caption" => lp("from"),		"string" => 1, 	"class" => "ttc_search_datepicker"),
			 array('id' => "sf_data_till","type" => "date", 	"field" => "date_mod", 	"operation" => "<=",	"caption" => lp("till"),		"string" => 1, 	"class" => "ttc_search_datepicker"),
			 array('id' => "sf_file_type","type" => "select", 	"field" => "file_type",	"operation" => "=",	"caption" => lp("file_type"),	"string" => 1, 	"class" => "ttc_search_select", 'options' => $file_types , "default" => ""), // NOTE: 'options' are set dynamically
		);
	}
?>
