<?php
	require_once(dirname(__FILE__)."/../path.php");

	// ---------------------------------------------------------------------------
	//		MODEL	
	// ---------------------------------------------------------------------------

	define('field_list_basic', 'id, name, date_mod, path, online, thumb_small, thumb_medium, sender, receiver, subject, cc, correspondent, attach_exist');
	define('paths_trivial', 1); // MS here no need to use paths table - it not contains any info

	// ---------------------------------------------------------------------------
	//			VIEW
	// ---------------------------------------------------------------------------

	function basic_fields_captions(){
		//return array("id" => "#id", "date_mod" => "data", "subject" => "oggetto"); // FIDE format
		// NOTE: this fields must be in tt/model/db.php field_list_basic
		return array(
			"RES_checked" => "C", // SPETAFI DEF CB_SEL_REC used to add checkbox in mails table; make_clickable expects a class *RES_checked ; css is used to make the elem look like checkbox (with fontawesome)
			"id" => "#id",
			"date_mod" => "data",
			"subject" => "oggetto",
			"sender" => "mittente",
			"receiver" => "destinatario",
			"correspondent" => "corrispondente",
			"cc" => "cc",
			"attach_exist" => "A",
			"path" => "#percorso"  // path is necessary for SEL_SYNC - need know paths of selected  recs to substract from selected folders
		); // FIDE format
	}

	function get_filter_fields(){
			 $opts = array('presenti', 'non presenti');
			$reps = array(1 => 'presenti', 0 => 'non presenti'); // the direction is perverted but this is for easier compatibility with 'without reps case'
		$res = array (
			 // NOTE: 'predicative' added 29.11.18 to realize ability to 'and' (instead of usual 'or') the search criterion (for the case when it's an array)
			 // NOTE: FILTERPATH to enable it use ttc_filter_path class
			 array('id' => "sf_subject", 	"type" => "text", 	"field" => "subject", 	"operation" => "like",	"caption" => 'oggetto', 	"string" => 1, 	"class" => "", 	'placeholder' => 'hi+ciao', 'predicative' => 'and'), 
			 array('id' => "sf_data_from","type" => "date", 	"field" => "date_mod", 	"operation" => ">=", 	"caption" => 'da',		"string" => 1, 	"class" => "ttc_search_datepicker"),
			 array('id' => "sf_data_till","type" => "date", 	"field" => "date_mod", 	"operation" => "<=",	"caption" => 'a',		"string" => 1, 	"class" => "ttc_search_datepicker"),
			 array('id' => "sf_sender", 	"type" => "text", 	"field" => "sender", 	"operation" => "like",	"caption" => 'mittente', 	"string" => 1, 	"class" => "", 	'placeholder' => '', 'predicative' => 'and'), 
			 array('id' => "sf_receiver", 	"type" => "text", 	"field" => "receiver", 	"operation" => "like",	"caption" => 'destinatario', 	"string" => 1, 	"class" => "", 	'placeholder' => '', 'predicative' => 'and'),
			 array('id' => "sf_cc", 	"type" => "text", 	"field" => "cc", 	"operation" => "like",	"caption" => 'cc',	 	"string" => 1, 	"class" => "", 	'placeholder' => '', 'predicative' => 'and'),
			 array('id' => "sf_text", 	"type" => "text", 	"field" => "mail_text",	"operation" => "like",	"caption" => 'testo mail', 		"string" => 1, 	"class" => "", 	'placeholder' => '', 'predicative' => 'and'), 
			 array('id' => "sf_attach_text", 	"type" => "text", 	"field" => "attach_text",	"operation" => "like",	"caption" => 'testo allegati', 		"string" => 1, 	"class" => "", 	'placeholder' => '', 'predicative' => 'and'), 
			 array('id' => "sf_attach_list", 	"type" => "text", 	"field" => "attach_list",	"operation" => "like",	"caption" => 'nomi allegati', 		"string" => 1, 	"class" => "", 	'placeholder' => '', 'predicative' => 'and'), 
			 array('id' => "sf_attach_exist",  "type" => "select",     "field" => "attach_exist",             "operation" => "=",     "caption" => 'presenza allegati',             "string" => 0, "class" => "ttc_search_select", 'options' => $opts, 'replaces' => $reps),
			 array('id' => "sf_path", 	"type" => "text", 	"field" => "path", 	"operation" => "like",	"caption" => 'percorso', 	"string" => 1, 	"class" => "ttc_filter_path", 	'placeholder' => 'inbox/clienti', 'predicative' => 'and'), 
			 array('id' => "sf_id", 	"type" => "text", 	"field" => "id", 	"operation" => "=",	"caption" => 'id', 	"string" => 0, 	"class" => "", 	'placeholder' => '') 
		);
		return $res;
	}
?>
