<?php
// Alex Nosurov 12.02.18

require_once dirname(__FILE__)."/../path.php";
require_once(proj_path."utils/utils.php");

//	SHARE this function is set individually by each project
if(!function_exists("get_filter_fields")){
function get_filter_fields(){ // when only need compile where - do not need file types
	$res = array (
		 // NOTE: 'predicative' added 29.11.18 to realize ability to 'and' (instead of usual 'or') the search criterion (for the case when it's an array)
		 array('id' => "sf_name", 	"type" => "text", 	"field" => "name", 	"operation" => "like",	"caption" => 'nome', 	"string" => 1, 	"class" => "", 	'placeholder' => 'una parte del nome', 'predicative' => 'and'), 
		 array('id' => "sf_path", 	"type" => "text", 	"field" => "path", 	"operation" => "like",	"caption" => 'percorso', 	"string" => 1, 	"class" => "", 	'placeholder' => 'una parte del percorso', 'predicative' => 'and'), 
		 array('id' => "sf_data_from","type" => "date", 	"field" => "date_mod", 	"operation" => ">=", 	"caption" => 'da',		"string" => 1, 	"class" => "ttc_search_datepicker"),
		 array('id' => "sf_data_till","type" => "date", 	"field" => "date_mod", 	"operation" => "<=",	"caption" => 'a',		"string" => 1, 	"class" => "ttc_search_datepicker"),
		 array('id' => "sf_file_type","type" => "select", 	"field" => "file_type",	"operation" => "=",	"caption" => 'tipo file',	"string" => 1, 	"class" => "ttc_search_select"), 
	);
	return $res;
}
	}

// DETA capts are similar to those from filter fields but not always
// this array defines which columns are shown in details table
// TODO: there is a similar definition in show_file_details.php (not used now), should unite them
if(!function_exists("basic_fields_captions")){
function basic_fields_captions(){
	return array("name" => "name", "date_mod" => "modified", "online" => "online"); // FIDE format
}
}
// function which returns list of columns initially visible; used when details in form of table
if(!function_exists("visible_columns")){
function visible_columns(){ return array_keys( basic_fields_captions() ); } // TABCOL  this should be replaced with actual list of necessary columns in each project
}
function filter_visible_columns($user_cols){
	$cols = basic_fields_captions(); // default - show all cols from def list
	if(!$user_cols)
		return $cols;
	$cols_res = $cols; // if user requested to show certain columns TABCOL
	//log\debug("user cols: ", $user_cols);
	foreach($cols as $name => $capt)
		if( !in_array($name, $user_cols) )
			if( !starts_with($capt,"#") ) // note: invisible cols are added anyway
				unset($cols_res[$name]);
			else
				$cols_res[$name] = "#"; // 
	return $cols_res;
}
// returns array which is similar to filed defs from metadata, but also contains values
function build_find_array( $params_json , $filter_fields=''){
	$params = json_decode($params_json, $convert_to_array=true);
	// now params are form serialization; need to build an array which accepts compile_where; also take data from search field definitions
	//log\debug('params: '.array_to_string($params));
	if(!$filter_fields) // added this param to re-use this func to build cond for any ff definition
		$filter_fields = get_filter_fields(); // reads also file types
	// search
	// for the path if the pattern consists of several words - it will be transformed into array of values	
	if( isset($params['sf_path']) ){
		/* normal version: separator = whitespace, unless within double quotes
		preg_match_all('/"(?:\\\\.|[^\\\\"])*"|\S+/', $params['sf_path'], $matches);// https://stackoverflow.com/questions/2202435/php-explode-the-string-but-treat-words-in-quotes-as-a-single-word
		$path = array(); // without "
		foreach($matches[0] as $param) $path[] = trim($param,'"');
		$params['sf_path'] = $path; // it's already an array and will be treated by db.php as array (or-join)
		*/
		// fabro-bzik; wants to use '+' as separator
		$params['sf_path'] = explode("+", $params['sf_path']);  
	}
	if( isset($params['sf_name']))  // TODO: in ws it's named differently: sf_ws_name
		$params['sf_name'] = explode("+", $params['sf_name']);  // PATH/NAME
	return  get_where_array($filter_fields, $params);  // TODO: saving in var instead of passing directrly to json_encode may have overhead; so if not use count check - pass directly
}
?>
