<?php
	/*
		Author: Alex Nosurov
		Created: 13.01.20 
	*/
	
        require_once(dirname(__FILE__)."/path.php");
	require_once(proj_path."view/lang.php");
	require_once(proj_path."view/metadata.php");
	require_once(proj_path."contr/login.php");
	require_once(proj_path."utils/menu.php");

?>
<html lang="en">
	<head>
		<?php echo lang_html_load('html/standard_head.html', false, array("title" => project_title, "icon" => project_icon)); ?>
		<link href = 	"table_tree/css/style.css" rel="stylesheet">
		<link href = 	"table_tree/css/search.css" rel="stylesheet">
		<link href = 	"css/table.css" rel="stylesheet">
		<link href = 	"css/apap.css" rel="stylesheet">
	</head>
	<body style='background: url("img/bg_<?php echo get_portal_name(); ?>.jpeg") no-repeat center center fixed;'> 
                <!-- table_tree -->
                <script src="js/table.js"></script>
	
		<div class='bg_cover'></div>
		<?php echo file_get_contents('html/standard_scripts.html'); ?>
		<div class="mc_page_cont" style="height: 100%;">  <!-- if put height to mc_page_cont - preview shown male -->
			<!-- header: row: logo, menu, login  -->
			<div class="mc_page_head">
				<?php echo lang_html_load('html/standard_body_start.html' ); ?>
			</div>
			<div class="mc_page_body mc_page_cont_hor" style="width: 100%;">  <!-- if put height to mc_page_cont - preview shown male -->
				<div class="mc_page_head" id="mi_main_menu_vert"></div>
				<div class="mc_page_body mc_page_cont">
					<div id="tt_table_tree_div" class='mc_page_body mc_tt_cont ttc_fullscreen'> <!-- TODO maybe non need this cont -->
						<?php echo lang_html_load('html/table.html' ); ?>
					</div>
				</div>
			</div>
		</div>
		<script src="js/treeview.js"></script>
		<script type="text/javascript">
			var user_role;
			function show_edit_user(id=0){
				var nu = call_php_sync("contr/main.php", {"action" : "show_edit_user", "id" : id}, 'POST'); 
				var tabs = create_tabs([
					{name: "INFO", content: nu.resp_text, classname: "mc_info_tab"},
					{name: "COUNTRIES", content: "<div id = 'mi_set_country'></div>", classname: "mc_country_tab"}
				]);
				//
				// to use if save shop list in users field;  var ids = tabs.find("#nc_countries").val(); // hidden input in edit camp form
				user_role = tabs.find("#nu_user_role").val();
				if(user_role=="ENGINEERING" || user_role=="ADMIN"){ 
					if(id){
						var ids = call_php_sync("contr/main.php", {"action" : "get_user_shops", id: id, role: user_role}, 'POST');
						select_ids( JSON.parse(ids.resp_text) );
					}
				}else{
					user_role = "";
				}
				//
				show_select_string(function(){ return save_user(id); }, '', tabs, lp("edit_user"));
				ff_init(tabs);
				$("#nu_user_group_role")/*.prop("disabled", true)*/.prop("title", lp("to_set_group_role"));
				if(user_role=="") $(".mc_tab_name.mc_country_tab").addClass("hidden"); // if call it before sss - not works
				if(!id) $("#nu_pass").val( get_random_str() ) ; 
				$("#nu_pass").prop("autocomplete", "off");
				// DEF SHS_PAS show hide pass
				$("#nu_pass").closest("tr").append( $("<td></td>").append( make_pass_toggle( $("#nu_pass"), lp("show"), lp("hide") ) ) );
			}
			function save_user(id){
				var panel = $("#md_ss_div");
				var fields = ff_params(panel);
				var res = true;
				$.ajax({
					"type": "POST",
					"async": false,
					"url": "contr/main.php",
					"data": {action : "save_user", id: id, fields: JSON.stringify(fields)},
					"success": function(res, dummy, request){
						users.refresh(res);
					},
					"error": function(jqxhr, settings, thrownError){
						res = false; // using async=false and ret res false to not close the dialog
					}
				});
				if(res && user_role){
					var shops = get_selected_files().join(";");
					call_php_sync("contr/main.php", {"action" : "set_user_shops", id: id, role: user_role, shops: JSON.stringify(shops)}, 'POST');
				}
				return res;
			}
			function delete_user(id, name){
				var restr = JSON.parse( call_php_sync("contr/main.php", {"action" : "check_user_delete", id: id}, 'POST').resp_text );
				if(!confirm(lpp("$Delete$ $user$ '$1'?", name))) return;
				if(restr.groups.length && !confirm(lp("delete_from_groups") + ": " + restr.groups.join(", "))) return;
				$.ajax({
					"type": "POST",
					"url": "contr/main.php",
					"data": {action : "delete_user", id: id},
					"success": function(res, dummy, request){
						users.clear();
						users.show();
					}
				});
			}
			function send_credentials(id){
				$.ajax({
					"type": "POST",
					"url": "contr/main.php",
					"data": {action : "send_credentials", id: id},
					"success": function(res, dummy, request){
						alert("ok");
					}
				});
			}
			var users;
			var table_name = "users_users", alias_name = "users";
			$(document).ready( function(){
				set_ajax_error_handler();
				//
				var fields = JSON.parse( call_php_sync("contr/main.php", {"action" : "get_table_fields", alias: alias_name, table: table_name}, 'POST').resp_text ); 
				users = new Tablo(".tc_thumbs_form", $(".mc_search_panel"), table_name, fields.list, fields.search, null, function(rec){show_edit_user(rec.data("id"));}, alias_name);
				users.ro_set("name", "asc");   // FIORD
				users.show();
				users.on_show = function(){ 
					$("#table-"+alias_name).find(".td-"+alias_name+"-RES_email").html("<i class='fas fa-envelope' title='"+lp("send_access_credentials")+"'></i>").click( function(){ send_credentials( $(this).closest(".data-row").data("id") )  } );
				}

				// CRUD
				$(".lbsp_new").click( function(){show_edit_user(0);} );
				$(".lbsp_edit").click( 
					function(){
						var rec = $(".tc_thumbs_form").find(".data-row.active");
						if(rec.length==1)
							show_edit_user( rec.data("id") );
				});
				$(".lbsp_del").click( 
					function(){
						var rec = $(".tc_thumbs_form").find(".data-row.active");
						if(rec.length==1)
							delete_user( rec.data("id"), rec.find(".td-users-name").html() );
				});
				if(ur_role.role=="ADMIN")
					$(".lbsp_del, .lbsp_edit").removeClass("hidden"); // NOTE: donno why now in html/table.html they are hidden by default
			});
		</script>
	</body>
</html>
