<?php
namespace db;
require_once(dirname(__FILE__)."/exception.php");
require_once(dirname(__FILE__)."/db.php");
$connection = null;
$response = null;
$record = null;

//----------------------------------------------------------------------------------------------
//function connect($settings){ must be run on every inclusion, so out of function
$settings = parse_ini_file('/var/www/html/frame/settings.ini', true);
$dbs = $settings['db'];
$conn_string = 'host='.$dbs['host'].' user='.$dbs['user'].' dbname='.$dbs['dbname'].' password='.$dbs['password'];
$connection = pg_connect($conn_string);
if(!$connection){
	throw new db_exception("Failed to connect database: $conn_string; error: ".pg_last_error());
}
//----------------------------------------------------------------------------------------------

function execute($sql){
	global $connection;
        global $response;
        //
	\log\debug($sql);
        $response = pg_query($connection, $sql);
	if( !$response )
		throw new \db_exception(pg_last_error());
	return $response;
}

// not saves result to 'response' but just returns it; used to perform another query when 'response' is already busy
function execute_to($sql){
	global $connection;
        //
	\log\debug($sql);
        $response_local = pg_query($connection, $sql);
	if( !$response_local )
		throw new \db_exception(pg_last_error());
	return $response_local;
}

function get_count(){
	global $response;
	return $response? pg_num_rows($response): 0;
}

function fetch(){
	global $response;
	global $record;
	return $record = pg_fetch_assoc($response);
}

function fetch_from(&$response){
	return pg_fetch_assoc($response);
}

function escape(&$str){ 
	return pg_escape_string($str);
}

function escape_literal(&$str){ 
	return pg_escape_literal($str);
}

// returns database specific date format (in PHP codings, to be used by date() function); used instead of date_to_str
function get_date_format(){
	return "Y-m-d h:i:s"
}
// this function works after an insert query was executed which ends with 'RETURNING <id>'
function get_last_id(){
        global $response;
	$row = pg_fetch_row($response);
	if( !isset($row) )
		throw db_excepion("Failed to get last inserted id; use 'RETURNING id' at the end of the query!");
	return  $row[0];
}
?>
