<?php
/*
	Author: Alex
	requires: js FIXHEAD

	renders table with the header that is always visible and header fields widths are adjusted to those of columns   FIXHEAD
	works in conjunction with js fh_* functions. 
	to appear that functionality - must be put into flex container (vertical) (NOTE the flex in html code here)
*/
//
//		INTERFACE
//

// field order/presence is ruled by $captions, so the structure of captions may differ from that of values (but compatible)
// NOTE: for TASMA holder pos must be 'relative' 
function render_table(
		$table_name, 
		$captions, // assoc array: field name (from db) => caption;  also REGULATES VISIBILITY and data-val: if capt is empty (or only diez) - not show it; if diez present - data-val is added 
		$values){  // array of X; X: assoc array: field name => value (ret res of db\select)
	if( !sizeof($values) ) return render_empty();
	$header = render_header($captions, $table_name);
	$body = "";
	foreach($values as $record)
		$body.= render_row($record, $captions, $table_name);
	// NOTE! this should be wrapped into container with .fh-table to make fh_init, fh_on_resize work
	// DEF TASMA pos abs added 16/02/22 - or else table not resized when wind gets smaller: header retains bigger size and thus the holder remains big to hold the header
	$tasma_header = "position: absolute; top: 50px;"; $tasma_body = "margin-top: 50px;";
	$table = "<table class='fh-header fh-elem' style='flex: 0 1 auto; $tasma_header'> $header </table>";
	$table.= "<div class='fh-body-div fh-elem' style='overflow-y: auto; flex: 1 1 auto; $tasma_body'>"; //without div header moves away with scroller; div has class while need refere it in state.php to put scroller to bottom  ; fh-elem used only to delete all elems of table H&B
	$table.= "	<table class='fh-body table clickable-table' id=table-$table_name> $body </table>";
	$table.= "</div>";
	return $table;
}

//
//	PRIVATE
//
function render_row($values, $captions, $table_name=''){
	if(isset($values['id'])) $id = $values['id']; else $id='';
	// data
	$data = '';
	foreach($captions as $name => $caption)
		if( substr($caption,0,1)=="#" ){
			$val = htmlspecialchars( ($v=$values[$name])?$v:"", ENT_QUOTES);
			$data .= " data-$name = \"$val\"";
		}
	// row
	$result = "";
	foreach($captions as $name => $caption)
		if( ltrim($caption, '#') != '' ){ // cut diez; diez witout caption means not print field 
			$cap = trim($caption,'#'); 
			$val = starts_with($name, "RES_")? "" : $values[$name]; // DEF SPETAFI special table field; to add a field which is not in values - add standard prefic 'RES_' to field name; introduced to add checkbox
			$result .= "<td class='td-$table_name-$name $id' data-fhid='$name' title='$cap'>$val</td>";
		}
	return "<tr class='$id clickable-row data-row tr-$table_name' $data> $result </tr>"; // data-row is used to select all data rows (not header)
}

// captions in FIDE format
/*function render_header($captions, $table_name=''){
	$result = "";
	foreach($captions as $name => $caption){
		$caption= ltrim($caption, '#'); // remove 'add data' flag
		$order = "<i class='fas fa-long-arrow-alt-up'></i>";
		$order.= "<i class='fas fa-long-arrow-alt-down'></i>";
		if($caption!="")
			$result .= "<th id='th-$table_name-$name' data-fhid='$name'><span class='fh_header'>$caption $order</span> </th>";
		// else maybe show it as hidden
	}
	return "<tr> $result </tr>";
}*/
function render_header($captions, $table_name=''){ // version with ORD_LEFT show order at left (in MOMO order must be distant from caption)
	$result = "";
	foreach($captions as $name => $caption){
		$caption= ltrim($caption, '#'); // remove 'add data' flag
		$order = "<i class='fas fa-long-arrow-alt-up'></i>";
		$order.= "<i class='fas fa-long-arrow-alt-down'></i>";
		$header = starts_with($name, "RES_")? "" : "<span class='mc_field_capt $table_name'>$caption</span> <span class='mc_row_order'> $order</span>"; // SPETAFI // 11.01.22 added $table_name to be able to addres headers of specific table
		if($caption!="")
			$result .= "<th class='th-$table_name-$name fh_header' data-fhid='$name'>$header</th>"; // NOTE header struct must be in FHHS 
		// else maybe show it as hidden
	}
	return "<tr class='thr-$table_name'> $result </tr>";
}

// function render_empty(){return "<img width=32 height=32 src='img/empty_page.png'></img>";}   comm while need know if res empty (TOGSCT) (res=='')
function render_empty(){return "";} 

// create simple table
function tab_simple_table($recs, $id="", $class=""){
	$res = "";
	foreach($recs as $rec){
		$row="";
		foreach($rec as $field => $val)
			$row .= "<td class='td-$field'>$val</td>";
		$res .= "<tr>$row</tr>";
	}
	return "<table id='$id' class='mc_simple_table $class'>$res</table>";
}

function filter_user_cols(&$fields, $user_cols){
	if( $user_cols ){ // if user requested to show certain columns TABCOL
		$user_cols = json_decode($user_cols, true);
		foreach($fields as $name => $capt) // TODO: $fields is modified while iterated?
			if( !in_array($name, $user_cols) ){
				if( !starts_with($capt,"#") ) // note: invisible cols are added anyway
					unset($fields[$name]);
				else
					$fields[$name] = "#"; // 
			}else{ // if some field (like id) is defined in meta as f => # which means present in data but not visible, and need yet show it (present in $fields) - then need appends some name to # to make it visible
				if($capt=="#")
					$fields[$name]= "#$name";
			}
	}
	return $fields;
}

?>
