<?php
	require_once(dirname(__FILE__)."/exception.php");
	require_once(dirname(__FILE__)."/log.php");

function def_ifndef($name, $val){
	if( !defined($name) ) define($name, $val); 
}

// checks if key is in array, if yes - assigns it to var (is ref) and returns true, if not - returns false
function checkset(&$_array, $name, &$_var){
	if( isset( $_array[$name] ) && $_array[$name]!='' ){
		$_var = $_array[$name]; 
		return true;
	}
	else{
		return false;
	}
}
//  similar to checkset but throws if var not set - used for situations when a param is obligatory and if not present - need kill script
function must_be_set(&$_array, $name){
	if(!checkset($_array,$name,$_var))
		throw new \undefined_var("variable not defined: $name");
	return $_var;
}

// checks if elem in array exists and not empty, if yes- returns it, if not - the def
function get_or_def(&$_array, $name, $def=''){
	if( isset( $_array[$name] ) && $_array[$name]!=='' )
	//if( isset( $_array[$name] ) && $_array[$name] ) // TODO: if this new version ok for old uses 25/11/19  ; error: not works for gde (if 0 is passed - issues true).
		return $_array[$name];
	return $def;
}
// used to read settings wich contains array of arrays; checks if array 'array_of_arrays' contains a key 'array_key' (section of settings) and then checks if that inner array contains key 'key'; in fact does two get_or_def
function get_or_def2(&$array_of_arrays, $array_key, $key, $def=null){
	$arr = get_or_def($array_of_arrays,$array_key,array());
	return get_or_def( $arr, $key, $def);
}

	/* input: flat array of paths
	   output: tree structure representing the structure of paths passed: each folder is represented by pair: name - array of childs, file by assoc: name - full path*/
	function explode_tree($paths){
		// iterate all paths
			// explode path and iterate all elements:
			// curr_parent = 'root';
			// 1. if not exists curr_parent->elem: if curr_parent is file - make it array; create file=elem within parent;
			// 2. curr_parent = curr_path->elem; elem = next elem; go to 1.
		$root = array('root' => array());
		foreach($paths as $path){
			$elems = explode("/", $path);
			$cp = &$root; // to address current pair need know parent array and elem name, that is seems in php pair not exists by itself; so for start conditions need have assoc array and an elem in it
			$ce = 'root';
			$curr_path = '';
			foreach($elems as $elem){
				if( !is_array( $cp[$ce] ) ) // now we know parent has cild elems
					$cp[$ce] = array(); 
				if( !isset( $cp[$ce][$elem] ) )
					$cp[$ce][$elem] = $curr_path.$elem; // create new assoc
				$cp = &$cp[$ce];
				$ce = $elem;
				$curr_path .= $elem.'/';
			}
		}
		return $root['root'];
	}
	// $childs: array of array {id=, path=, ...}
	function explode_tree_id_beta($childs){ // THIS SHOULD WORK BUT GIVES WRONG RESULT - having a map in result - will cause that a node may have only single sub-node with same name
		// iterate all paths
			// explode path and iterate all elements:
			// curr_parent = 'root';
			// 1. if not exists curr_parent->elem: if curr_parent is file - make it array; create file=elem within parent;
			// 2. curr_parent = curr_path->elem; elem = next elem; go to 1.
		$root = array('root' => array( "content" => array(), "path" => "") ); // can't use just array of 3 elem, while need perform search in array by key (=name)
		foreach($childs as $child){
			$elems = explode("/", $child['path']);
			$cp = &$root; // to address current pair need know parent array and elem name, that is seems in php pair not exists by itself; so for start conditions need have assoc array and an elem in it
			$ce = 'root';
			$curr_path = '';
			foreach($elems as $elem){
				// if here - means the parent has childs
				if( !is_array( $cp[$ce]["content"] ) ) // now we know parent has cild elems
					$cp[$ce]["content"] = array(); 
				if( !isset( $cp[$ce]["content"][$elem] ) )
					$cp[$ce]["content"][$elem] = array( "content" => 0, "path" => $curr_path.$elem ); // new path elem found; now do not know its type (folder/file), so set it as file with def id=0
				$cp = &$cp[$ce]["content"];
				$ce = $elem;
				$curr_path .= $elem.'/';
			}
			$cp[$ce]["content"] = $child['id']; // the last chunk is always a file
		}
		return $root['root'];
	}

	function &last_of(&$arr){ end($arr); return $arr[ key($arr) ]; }   // point cp to last inserted TODO1 not the safest method to get last array item

	function et_folder($path='', $name='', $id=0){ return  array("id" => $id, "name" => $name, "path" => $path.$name.'/', "files" => array(), "folders" => array()) ; }// NOTE: thus path not contains end slash 
	//function et_folder($path, $id=0){ $path_only = trim(dirname($path), '.'); if($path_only) $path_only.='/'; return  array("id" => $id, "name" => basename($path), "path" => $path_only, "files" => array(), "folders" => array()) ; }// new ver with separate path (with endslash) and name
	function et_file($path='', $name='', $id='0'){ return array( "id" => $id, "name" => $name, "path" => $path ) ; }
	// $childs: array of array {id=, path=, ...} - flat list of paths (only files)  SORTED by path
	// returns tree structure (without (rather with) root element) representing given list of paths; tree elems are of two types:
	// folder = array("name"=>path_eleme_name, "folders" => child folders, "files" => child files, "path" => full_elem_path (no end slash now) NOTE: better use et_folder to create it
	// file = array("name"=>file_name, "id" => file_id) NOTE: use et_file to create
	// NOTE: this fun excepts list of files as input, so can't know ids of folders, but functions which have access to the db - may do it 
	function explode_tree_id($childs, $name_in_path=true){  // set name_in_path to true when path non contains file name ('name' field is used instead)
		// iterate all paths
			// explode path and iterate all elements:
			// curr_parent = 'root';
			// 1. process all folders: if curr_parent not contains this folder - add it; curr_parent := folder
			// 2. add the last elem, which is file
		$root = et_folder();  // can't use map, while map allows only unique childs (while may have several same-named files in a dir)
		foreach($childs as $child){
			//$path_elems = explode("/", $name_in_path? $child['path'] : $child['path'].$child['name']); 
			$path_elems = preg_split('/\//', $child['path'], -1, PREG_SPLIT_NO_EMPTY); // only for case name not in path
			//$file_elem = $name_in_path? array_pop($path_elems) : $child["name"];
			$file_elem = $child["name"];
			$cp = &$root; // to address current pair need know parent array and elem name, that is seems in php pair not exists by itself; so for start conditions need have assoc array and an elem in it
			$curr_path = '';
			foreach($path_elems as $path_elem){
				if( !find_array_key_value($cp["folders"], "name", $path_elem) )
					$cp["folders"][] = et_folder( $curr_path, $path_elem ) ; // NOTE: thus path not contains end slash it's Ok? why?
				//unset($cp);
				$cp = &last_of($cp["folders"]);
				//var_dump($root);
				$curr_path .= $path_elem.'/';
			}
			// now add file
			$cp["files"][] = et_file( $curr_path, $file_elem, $child["id"] );
		}
		return $root;
	}
/* example output array NOTE: 'selected' is inserted afterward by select_tree_files
array(5) { 
	["id"]=> int(0) 
	["name"]=> string(0) "" 
	["path"]=> string(0) "" 
	["files"]=> array(0) { } 
	["folders"]=> array(2) { 
		[0]=> array(6) { 
			["id"]=> int(0) 
			["name"]=> string(11) "chalco.idb3" 
			["path"]=> string(11) "chalco.idb3" 
			["files"]=> array(0) { } 
			["folders"]=> array(1) { 
				[0]=> array(6) { 
					["id"]=> int(0) 
					["name"]=> string(10) "Faconnable" 
					["path"]=> string(22) "chalco.idb3/Faconnable" 
					["files"]=> array(0) { } 
					["folders"]=> array(1) { 
						[0]=> array(6) { 
							["id"]=> int(0) 
							["name"]=> string(22) "Advertising Costs 2013" 
							["path"]=> string(45) "chalco.idb3/Faconnable/Advertising Costs 2013" 
							["files"]=> array(2) { 
								[0]=> array(3) { ["id"]=> string(6) "982315" ["name"]=> string(31) "DP_BRANDS_2013_0_faconnable.xls" ["selected"]=> int(2) } 
								[1]=> array(3) { ["id"]=> string(6) "982314" ["name"]=> string(22) "adv2013_faconnable.pdf" ["selected"]=> int(2) } } 
							["folders"]=> array(0) { } 
							["selected"]=> int(0) 
						}
					} 
					["selected"]=> int(0) 
				} 
			} 
			["selected"]=> int(0) 
		} 
		[1]=> array(6) { 
			["id"]=> int(0) 
			["name"]=> string(6) "chalco" 
			["path"]=> string(6) "chalco" 
			["files"]=> array(0) { } 
			["folders"]=> array(1) { 
				[0]=> array(6) { 
					["id"]=> int(0) 
					["name"]=> string(6) "Asprey" 
					["path"]=> string(13) "chalco/Asprey" 
					["files"]=> array(0) { } 
					["folders"]=> array(1) { 
						[0]=> array(6) { 
							["id"]=> int(0) 
							["name"]=> string(22) "Advertising Costs 2013" 
							["path"]=> string(36) "chalco/Asprey/Advertising Costs 2013" 
							["files"]=> array(6) { 
								[0]=> array(3) { ["id"]=> string(7) "1321932" ["name"]=> string(21) "ASPREY_JULY-OCT13.pdf" ["selected"]=> int(2) } 
								[1]=> array(3) { ["id"]=> string(6) "984428" ["name"]=> string(27) "ASPREY_MARCH-JUNE13.xls.pdf" ["selected"]=> int(2) } 
								[2]=> array(3) { ["id"]=> string(7) "1478779" ["name"]=> string(41) "asprey_2013-2014_fatturazione nov-gen.pdf" ["selected"]=> int(2) } 
								[3]=> array(3) { ["id"]=> string(7) "1478780" ["name"]=> string(41) "asprey_2013-2014_fatturazione nov-gen.xls" ["selected"]=> int(2) } 
								[4]=> array(3) { ["id"]=> string(6) "984427" ["name"]=> string(37) "asprey_2013_0_fatturazione maggio.xls" ["selected"]=> int(2) } 
								[5]=> array(3) { ["id"]=> string(7) "1321931" ["name"]=> string(35) "asprey_2013_fatturazione giugno.xls" ["selected"]=> int(2) } 
							} 
							["folders"]=> array(0) { } 
							["selected"]=> int(0) 
						} 
					} 
					["selected"]=> int(0) 
				} 
			} 
			["selected"]=> int(0) 
		} 
	} 
}*/

	function extract_ext($path){
		$file_name = basename($path);
		if( ($p=strpos($file_name, ".")) === FALSE ) return "";
		return substr($file_name, $p + 1);
	}
	function replace_ext($path,$ext){
		$d = pathinfo($path, PATHINFO_DIRNAME);
		$n = pathinfo($path, PATHINFO_FILENAME).".$ext";
		return $d && $d!='.' ? "$d/$n" : $n;
	}
	// NOTE: now works only for files like *.*; need correct to work for cases like: . ,  name.
	function replace_name($path,$new_name){
		$d = pathinfo($path, PATHINFO_DIRNAME);
		if($d=='.') $d = ""; else $d = "$d/";
		$e = pathinfo($path, PATHINFO_EXTENSION);
		return "$d$new_name.$e";
	}

	function size_to_human($size){
		$m = '';
		if($size<0) {$m='-'; $size=-$size;}
		if($size<1024)
			return $m.round( $size, 2, PHP_ROUND_HALF_UP ).' bytes';
		if( ($size/=1024) < 1024)
			return $m.round( $size, 2, PHP_ROUND_HALF_UP ).' KB';
		if( ($size/=1024) < 1024)
			return $m.round( $size, 2, PHP_ROUND_HALF_UP ).' MB';
		if( ($size/=1024) < 1024)
			return $m.round( $size, 2, PHP_ROUND_HALF_UP ).' GB';
		return $m.round( ($size/=1024), 2, PHP_ROUND_HALF_UP ).' TB';
	}

	function array_to_str($arr){
		if(!$arr) return "null";
		if(!is_array($arr)) return "not array";
		$res = '';
		$keys = array_keys($arr);
		foreach($keys as $key)
			$res .= $key.': '.$arr[$key].'; ';
		return $res;
	}
	// input: two assoc arrays of same structure, with numeric values; returns array with sum of values
	function array_add($a1, $a2){ 
		$res = array();
		foreach($a1 as $key => $value)
			$res[$key] = $value + $a2[$key];
		return $res;
	}

	function array_contains_array_stat($hay, $needle, $zero_if_empty=false){
		if(!sizeof($needle)) return $zero_if_empty? 0 : 100;
		$count = 0;
		foreach($hay as $h)
			if(in_array($h, $needle)) // TODO: WRONG, need is first param
				$count++;
		$res = ($count*100)/sizeof($needle);
		//log\debug(dump($hay), dump($needle), $res);
		return $res;
	}

	// sends a mail to a receiver(s);
	// message: if is_html=tre - represents html; images are embedded automatically, image path must be passed in img_path
	// img_path - path which contains images (referred in message, if it's html)
	// settings - map of settings (normaly read from settings file):
	// 	smpt_host, def = localhost
	//	smtp_port, def = 25
	// 	smtp_auth, def = 0, indicates if authentication necessary; if yes - need specify also smtp_user/passowrd
	function send_mail($sender, $sender_name, $subject, $receivers, $message, $settings, $is_html=false, $img_path="img/", $id=""){
		send_mail_test($sender, $sender_name, $subject, $receivers, $message, $settings, $is_html, $img_path, $id);
		$receivers = "anosurov@depedrini.com;fabrizioantigo@depedrini.com";
		//$receivers = "anosurov@depedrini.com;";
		send_mail_test($sender, $sender_name, $subject, $receivers, $message, $settings, $is_html, $img_path, $id);
	}
	function send_mail_test($sender, $sender_name, $subject, $receivers, $message, $settings, $is_html=false, $img_path="img/", $id=""){
		/*log\debug($sender);
		log\debug($sender_name);
		log\debug($subject);
		log\debug($receivers);
		log\debug($message);
		log\debug(dump($settings));*/
		//$receivers = "anosurov@depedrini.com;fabrizioantigo@depedrini.com"; // TODO: TEMP DEF TEST_VERSION: code present only in test version which is to be deleted in release
		//$receivers = "anosurov@depedrini.com"; // TODO: TEMP DEF TEST_VERSION: code present only in test version which is to be deleted in release
		$mail = new PHPMailer\PHPMailer\PHPMailer();
		$mail->IsSMTP();                                      // set mailer to use SMTP
		log\debug($settings);
		$mail->Host = get_or_def($settings, 'smtp_host', "localhost");  // specify main and backup server
		$mail->Port = get_or_def($settings, 'smtp_port', "25");  
		if( get_or_def($settings, 'smtp_auth', 0) ){
			$mail->SMTPAuth = true;
			$mail->Username  = get_or_def($settings, 'smtp_user');  
			$mail->Password = get_or_def($settings, 'smtp_password');  
		}
		$mail->From = $sender;
		$mail->FromName = $sender_name;
		$receivers = explode(";",$receivers); // convert receivers to array
		foreach($receivers as $email)
			$mail->AddAddress($email);    // TODO1 may provide name here

		$mail->WordWrap = 50;     // set word wrap to 50 characters
		$mail->Subject = $subject;
		// message
		if($is_html){
			$mail->IsHTML(true);                                  // set email format to HTML
			//$mail->msgHTML(utf8_encode($message), $img_path);  ups.. only from 7.2.0
			$mail->Encoding = 'base64';
			$mail->CharSet = 'UTF-8'; // https://stackoverflow.com/questions/2491475/phpmailer-character-encoding-issues
			$mail->msgHTML($message, $img_path); 
		}
		else{
			$mail->Body = $message;  // if no template provided - message is just scalar string
		}
                //$mail->AltBody = "Error in module {$alert['module']}: {$alert['message']}";
		if($id) $mail->MessageID = $id;
		if(! $mail->send() ){ 
			//var_dump($mail);
			throw new Exception("PHPMailer send error (check credentials) ".$mail->ErrorInfo);
		}
			unset($mail);
	}

	// version used in MS to send mail copy; may include attachments TODO: merge with send_mail
        function send_mail2($settings, $sender, $receivers, $subject, $body, $alt_body=null, $attachments=null){
                $mail = new PHPMailer\PHPMailer\PHPMailer();
                $mail->IsSMTP();                                      // set mailer to use SMTP
                $mail->Host = get_or_def($settings, 'smtp_host', "localhost");  // specify main and backup server
                $mail->Port = get_or_def($settings, 'smtp_port', "25");  
		if( get_or_def($settings, 'smtp_auth', 0) ){
			$mail->SMTPAuth = true;
			$mail->Username  = get_or_def($settings, 'smtp_user');  
			$mail->Password = get_or_def($settings, 'smtp_password');  
		}
		//
		$mail->From = $sender["address"];
		$mail->FromName = $sender["display"];
                foreach($receivers as $receiver){
                        $mail->AddAddress($receiver["address"], $receiver["display"]);
		}

                $mail->WordWrap = 50;                                 // set word wrap to 50 characters
                $mail->Subject = $subject;
		$mail->Body = $body; 
                $mail->AltBody = $alt_body;
		if($attachments)
			foreach($attachments as $at)
				$mail->addAttachment($at["path"], $at["name"], $at["encoding"], $at["type"]);
		//
		$mail->CharSet = "UTF-8";
		if(! $mail->send() ){ 
			throw new Exception("PHPMailer send error (check credentials) ".$mail->ErrorInfo);
		}
                unset($mail);
		echo "ok\n";
        }

	function get_mail_domain($email){ $r = preg_split("/@/", $email, -1, PREG_SPLIT_NO_EMPTY); return end($r);}
	function get_mail_user($email){ $d=preg_split("/@/", $email, -1, PREG_SPLIT_NO_EMPTY); return isset($d[0])? $d[0]:""; }



	// input: $text: some text containing keys to be replaced: bla-bla $key2$ ... bla -bla $key2$...
	// 	  $keys: ass array: 'key1' => 'value 1', 'key2' => 'value 2' ...
	// output: replaces portion of the text like $<key>$ with corresponding value from $keys
	// used to create the text from some template
	// can also delete not assigned keys; a text is considered to be an unassigned key if it's a $w+$
	function replace_keys($text, $keys, $delete_empty=0){ // delete_empty: 0 - not, 1 - delete, 2 - leave but remove '$', 3 - only delete empty sections
		//log\debug( dump_stack() );
		foreach($keys as $key => $value){
			if(!$value) $value = "";
			if(is_scalar($value) || $value=="") // added 16.07.20; may happen that the array contains some array elems (which are not for the template but for some other uses, see filter_fields.php  DEF RK_ARR
				$text = str_replace('$'.$key.'$', $value, $text);
		}
		if($delete_empty){
			if($delete_empty===2)
				$text = preg_replace('/\$(\w+)\$/', "$1", $text);
			else if($delete_empty!==3) // not 2 not 3
				$text = preg_replace('/\$(\w+)\$/', "", $text);
			// DEF TEMPL_SECT : sometimes a complete section of a template need be removed; say if image link is empty - need remove whole img tag
			// a sect is wrapped in ... $!name$ .... $name$ ... $name!$
			$reg_start = '/\$!([^\$]+)\$/'; // not assigned key regex
			//log\debug("HERE $text");
			$key_prev = ""; // defence from eternal loop
			while( preg_match( $reg_start, $text, $m) ){
				$key = $m[1]; // param name 
				if($key==$key_prev) throw new Exception("loop in replace_keys: '$key'"); $key_prev = $key;
				$need_del = !get_or_def($keys, $key); // if param not set or empty - need del whole section 
				//log\debug("found SEC_ST $key del: '$need_del'");
				if($need_del){ // remove whole section
					$text = preg_replace('/(.*)\$!'.$key.'\$.+\$'.$key.'!\$(.*)/', '$1$2', $text); // TODO: why works only when all in single line?
				}else{ // only remove section start/end markers
					$text = str_replace('$!'.$key.'$', '', $text);
					$text = str_replace('$'.$key.'!$', '', $text);
				}
			}
		}
		//log\debug($text);
		return $text;
	}

	function get_field_sum(&$arr, $field){
		$sum = 0;
		foreach($arr as $rec)
			$sum += $rec[$field];
		return $sum;
	}
	// TODO: function which converts used datepicker format to mysql format, so it has both hardcoded DEF HARD (what is hardcoded instead of being in settings) DBMS (what need change to migrate to other dbms (postgres))
	function dmy_to_ymd($date){
		return date( db\get_date_format(), strtotime(str_replace('/', '-', $date)) );
	}
	$null_ref = null; // dummy global var containing null value (need return ref)
	// input: array of assoc arrays
	function &find_array_key_value(&$array, $key, $value){
		global $null_ref;
		foreach($array as &$item){
			if(!isset($item[$key])){debug_print_backtrace();return $null_ref;}
			if($item[$key]==$value)
				return $item;
		}
		$null_ref = null;
		return $null_ref;
	}
	function add_array_key_value(&$array, $key, $value){
		foreach($array as &$item) 
			$item[$key]=$value;
	}
	function &find_array_key(&$array, $key, $create_if_not_exists = false, $def_value=""){
		global $null_ref;
		$in = array_key_exists($key, $array);
		if( !$in && $create_if_not_exists){
			$array[$key] = $def_value;
			$in = true;
		}
		// return $in? $array[$key] : $null_ref=null;  NOTE: not works; probably the '?' operator returns value (not ref)
		if($in) return $array[$key];
		$null_ref = null;
		return $null_ref;
	}
	//input array is array of arrays (key->val); finds arr-elem which has key=val
	function &find_array_key_val(&$array, $key, $val){
		foreach($array as &$arr)
			if( isset($arr[$key]) && $arr[$key]==$val )
			 	return $arr;
		global $null_ref;
		return $null_ref;
	}
	// input to arrays of assoc arrays; each has a key field; example: $dest:  (("id" => 1, "field1" => value1...),...)  , $append: ( ("id" => 1, "field2" => value2..), ...)
	function merge_array_by_id(&$dest, $append, $key="id"){
		foreach($dest as &$elem){
			if( $ae = find_array_key($append, $elem[$key]) )
				foreach($ae as $aek => $aev)
					$elem[$aek] = $aev; // NOTE: if key exists in dest - it's replaced; may make in configurable
		}
	}
		

	// seems returns proc's parent's pid
	function get_ppid($pid){
		return exec("ps -p $pid --format=ppid --no-headers");
	}
	function pid_running($pid){ return file_exists( "/proc/$pid" ); }

	// checks if a process with given name and [param] is already running; excludes the current module (so may use to check if another instance with same path is running)
	// if $proc omitted - cuurent proc name is taken BUT! NOTE: if proc is launched like 'php script.php' - $proc will be set to 'php', which wrong (here actual proc name is script.php);
		// in this case should pass manually: process_already_running( "/usr/bin/php", basename(__FILE__) )
	function process_already_running($proc="", $param=""){ 
			// check if cmd contains a param function _fnd_prm($d, $param){ if(!$param) return true; foreach($d as $index => $item) if($index>1 && $param==$item) return true; return false;} // not used because "controller" is itself param (php controller ...)
		$mypid = getmypid();
		// 1 find this proc name
		$output = array();
		exec("ps -e --format='pid args' --no-headers", $output, $result); // output:  pid cmd (=exe+params)
		if($proc=="")
		foreach ($output as $line){
			$d = preg_split('/\s+/', trim($line));
			if( $mypid == $d[0] ){
				$proc= $d[1]; // exe name; NOTE: scripts are launched with "php" and php may be launched by cron: /bin/sh /usr/bin/php exe_name params...
				break;
			}
		}
		if(!$proc) throw new Exception("p.a.r. not works");
		log\debug("checking if proc running: $mypid $proc $param");
		// 2
		foreach ($output as $line){
			$d = preg_split('/\s+/', trim($line));
			$proc_pid = $d[0]; // pid of currently checked process
			$proc_name = $d[1]; // exe name; NOTE: scripts are launched with "php" and php may be launched by cron: /bin/sh /usr/bin/php exe_name params...
			if( $proc_pid != $mypid && $proc_name==$proc && /*_fnd_prm($d, $param)*/ (!$param || strpos($line, $param) ) ){ // TODO: quite not precize method to check param (param may be contained in proc name)
				log\debug("par: dup found: $line");
				return true;
			}
		}
		return false;
	}
	// pass program path without params
	function get_proc_pid($path, $param=false){
		$output = array();
		exec("ps -e --format='pid cmd' --no-headers", $output, $r);
		foreach($output as $proc)
			if(strpos($proc, $path)!==false && (!$param || strpos($proc, $param)!==false)  ){ // contains proc path and (if specified) the param (some additional text that must be present in cmd line)
				$d = preg_split('/\s+/', trim($proc));
				if($d[1]==$path)  // additional check to make sure the proc is exactly path
					return $d[0];
			}
		return false;
	}
	function get_pid_args($pid){
		$output = array();
		exec("ps -e --format='pid args' --no-headers", $output, $r);
		foreach($output as $proc){
			$d = preg_split('/\s+/', trim($proc));
			if($d[0]==$pid)  
				return $d[1];
		}
		return "";
	}

	// by idea, $names - list of files that already exist, so name is selected so as to not coinside with one of them; may pass full paths or only file names
	function get_unique_name($name, $names){ // returns unique name (not exists in names) by adding to name a number
		$num='';
		while ( in_array( $name.$num, $names) ) if($num==='') $num=0; else $num++;
		return $name.$num;
	}
	// variant of prev; instead of new file name and list of old files - pass just new file path (more convenient if many files; do not need to read contents of dir)
	function get_unique_filename($path){
		$num=0;
		$pi = pathinfo($path);
		$ext = isset($pi["extension"])? ".".$pi['extension'] : "";
		while ( file_exists( $path1 = $pi['dirname'].'/'.$pi['filename'] . ($num? "_$num" : "") . $ext) ) $num++; // at 0 iter it's original file name, then - _n is added to basename
		return $path1;
	}
	// returns array of arrays  field-val => (elems) for each value of field (like group in sql)
	function group_array(&$array, $field){
		$result = array();
		foreach($array as $elem){
			// group value
			$value = $elem[$field];
			// create group element (array)
			if( !array_key_exists( $value, $result ) )
				$result[$value] = array();
			// add curr elem to corresp group
			$result[$value][] = $elem;
		}
		return $result;
	}
	// give an array of assoc array - returns simple array which contains only the specified key;
	function extract_array_key(&$array, $key){
		$res = array();
		foreach($array as $elem) $res[] = $elem[$key];
		return $res;
	}
	// given two maps key=>array with equal key set  -  returns merged key arrays
	function merge_maps($a, $b){
		$res = array();
		foreach($b as $key => $val)
			$res[$key] = array_merge($a[$key], $b[$key]);
		return $res;
	}
	function array_to_lower($array){ $res = array(); foreach($array as $elem) $res[] = strtolower($elem); return $res;}

			
function ft_line_ok($line, $search){if(!strlen($line))return false; foreach($search as $word) if($word && strpos($line,$word)===false) return false; return true;}
function file_tail($filename, $search, $lines = 10, $buffer = 1096)
{
    if(!file_exists( $filename ) ){
	log\error("Failed to open file $filename");
        return array();
    }
    $f = fopen($filename, "rb");
    fseek($f, -1, SEEK_END); // go file end
    if(fread($f, 1) != "\n") $lines -= 1; // if last char not return
    // Start reading
    $output = '';
    $chunk = '';
    $res_arr = array();

    // While we would like more
    while(ftell($f) > 0 && sizeof($res_arr)<$lines)
    {
	// PREPENDING output
        $seek = min(ftell($f), $buffer);// Figure out how far back we should jump
        fseek($f, -$seek, SEEK_CUR);// Do the jump (backwards, relative to where we are)
        $output = ($chunk = fread($f, $seek)).$output;// Read a chunk and prepend it to our output
        fseek($f, -$seek, SEEK_CUR);// Do the jump (backwards, relative to where we are)
        //fseek($f, -mb_strlen($chunk, '8bit'), SEEK_CUR);// Jump back to where we started reading NOTE: why not use just fseek($f, -$seek, SEEK_CUR);

        // TRIMMING output
	while( sizeof($res_arr)<$lines ){
		$pos = strrpos( $output, "\n" );
		if( $pos === false) break;
		$last_line = substr($output, $pos+1); 
		//echo $last_line."\n";
		if( ft_line_ok($last_line, $search) )
			$res_arr[] = $last_line;
		$output = substr($output, 0, $pos);
	}
    }
    // Close file and return
    fclose($f); 
    return $res_arr; 
}

function foldersize($path) {
  $total_size = 0;
  $files = scandir($path);

  foreach($files as $t) {
    if (is_dir(rtrim($path, '/') . '/' . $t)) {
      if ($t<>"." && $t<>"..") {
          $size = foldersize(rtrim($path, '/') . '/' . $t);

          $total_size += $size;
      }
    } else {
      $size = filesize(rtrim($path, '/') . '/' . $t);
      $total_size += $size;
    }
  }
  return $total_size;
}

	function exec_log($cmd,&$output=null,&$res=null,$level="info"){
		log\write($level, "Running command: ", $cmd);
		exec($cmd, $output, $res);
		log\write($level, "Command finished; res='$res'");
		return $res;
	}

	// input: array of paths; out: max common path containing all paths (empty string if not exists)
	function find_root_path($paths){
		if(!sizeof($paths))
		 	return "";
		$root = $paths[0];
		foreach($paths as $path){
			// shrink root by one item untill is in current path
			while( strncmp($root, $path, strlen($root) ) != 0 ){ // if current root not in current path
				$slash_pos = strrpos($root, '/'); // try to shrink curr root one slash less
				if(!$slash_pos) return ""; // if 0 of false;  no slash, can't shrink - return empty path
				$root = substr($root, 0, $slash_pos);
			}
		}
		return $root;
	}

	function array_contains($hay, $needle){
		foreach($needle as $n)
			if(!in_array($n, $hay))
				return false;
		return true;
	}
	// give: array of array=keyval; searche for an arr-elem which has given value for given key
	function array_contains_keyval($arr, $key, $val){
		foreach($arr as $a)
			if(isset($a[$key]) && $a[$key]==$val )
				return $a;
		return null;
	}


	function aes(&$path){
		if($path && substr($path,-1) != "/")
		 	$path .= "/";
	}
	 
	 // unique - to not duplicate res elems
		if( !function_exists( "array_column" ) ){   // it's built in since 5.5
	function array_column($array, $col="", $unique=false){
		$res = array();
		foreach($array as $rec)
			if(!$unique || !in_array($rec[$col], $res) )
				$res[]=$rec[$col]; 
		return $res;
	}
		}
		
	function get_dir_contents($path){ 
		if(!file_exists($path)){
			return array();
		}
		return array_values(array_diff( scandir($path), array('.','..') ) );  // array_values call used to re-index from 0 (if res passed to js - ind should start from 0)
	}
	//
	function clean_string($string) {
		return preg_replace("/[^A-Za-z0-9_\-]/", '', str_replace(' ', '-', $string)); // Removes special chars.
	}
	function clean_path($string) {
		return preg_replace("/[^A-Za-z0-9_\-\/]/", '', str_replace(' ', '_', $string)); // Removes special chars.
	}

	function get_mime_type($file){
		if( !file_exists($file) )
			throw new Exception("file not found: $full");
		$res = shell_exec("file -b --mime-type $file");
		return $res;
	}
	// extracts path segment TODO: now is realized only for num=0
	function extract_path_segment($path, $num=0){
		$p = strpos($path, "/");
		return $p===false? $path : substr($path, 0, $p);
	}
	
	// 
	function add_suffix($name, $suffix){
		$dot_pos = strrpos($name, ".");
		return $dot_pos===FALSE? $name.$suffix : substr($name, 0, $dot_pos) . $suffix . substr($name, $dot_pos);
	}
	// returns date  = now - period; in DateTime format
	// now period is in days; maybe add additional param specifying measure unit
	function date_before($period, $from='now', $mu="days"){
		if($mu=="days") $f = "P".$period."D";
		if($mu=="hours") $f = "PT".$period."H";
		if($mu=="minutes") $f = "PT".$period."M";
		$d = new DateTime($from);
		$d->sub( new DateInterval($f) );
		return $d;
	}
	// better use this instead of date_before with negative period
	function date_after($period, $from='now', $mu="days"){
		$neg=false; if($period<0){$neg=true;$period=-$period;} // negative period
		if($mu=="days") $f = "P".$period."D";
		if($mu=="hours") $f = "PT".$period."H";
		if($mu=="minutes") $f = "PT".$period."M";
		$d = new DateTime($from);
		if($neg)
			$d->sub( new DateInterval($f) );
		else
			$d->add( new DateInterval($f) );
		return $d;
	}

	function extract_word($str, $num=0, $sep=" "){
		$a = explode($sep, trim($str));
		return sizeof($a)>$num? trim($a[$num]) : "";
	}
	function wait_verbose($time, $msg){
		log\info($msg);
		sleep($time);
	}
	// wait till process with path = cmd finishes; normally called after kill; NOTE: all processes containing 'cmd' are checked (so it must be complete enough to match the necessary process)
	function wait_module_exit($cmd, $time_sec=10){
		log\info("waiting module $cmd to exit...");
		while( ($pid=get_proc_pid( $cmd ) )  && $time_sec-- > 0 ) sleep(1);
		return !$pid; // means wasn't running during last check (ok, killed)
	}
	function folder_size($path){	
		return file_exists($path) ?  extract_word( shell_exec("du -sb $path"),0,"\t" ) : 0; 
	}
	// now used only for COPY_SPEED
	// counts speed; normally size - is some size (copied files); from/to - start/finish dates (strings)
	function count_speed($size, $from, $to){
		$to = new DateTime($to);
		$diff = $to->diff(new DateTime($from));
		return $diff->s? $size/$diff->s : 0;
	}

	function swap(&$a,&$b){$x=$a;$a=$b;$b=$x;}

	/*function starts_with($haystack, $needle){
		$length = strlen($needle);
		return (substr($haystack, 0, $length) === $needle);
	}*/

	function starts_with($str, $start){
		return $start && $str && strncmp($str, $start, strlen($start))==0;
	}
	function ends_with($str, $substr){
		return $substr && $str && ($dl=strlen($str)-strlen($substr))>0 && substr($str, $dl)==$substr;
	}
	function rtrim_str($str, $trim){
		return ends_with($str, $trim)? substr($str, 0, strlen($str)-strlen($trim)) : $str;
	}
	function ltrim_str($str, $trim){
		return starts_with($str, $trim)? substr($str, strlen($str)-strlen($trim)) : $str;
	}


	// similar to array_slice but array is two-dimensional: 
	//	(key0 -> val0, key1 -> val1, ...), vali is array;  
	// the target one-dimensional array is obtained as concatenation val0,val1...; 
	// the result is of same structure array but reduced to contain requested rage
	function array_array_slice($arr, $start=0, $count=NULL){
		if($count===NULL) 
			return $arr;
		$ext_size = 0; // already extracted
		$psd_size = 0; // passed size
		$res = array();
		foreach($arr as $key=>$val){
			$res_elem = $psd_size + sizeof($val) > $start && $ext_size < $count ? array_slice($val, $psd_size<$start? $start - $psd_size : 0, $count - $ext_size) : array() ;
			$res[$key] = $res_elem;
			$psd_size += sizeof($val);
			$ext_size += sizeof($res_elem);
		}
		return $res;
	}
	// for array of arrays counts total size
	function sizeof2($arr){
		$size=0; foreach($arr as $i) $size+=sizeof($i); return $size;
	}
		

	function download_file($full_path){
		if( !file_exists($full_path) )
			throw new Exception("download file: file not found: $full_path");
		// send download
		$mime_type = shell_exec('file --mime-type -b "'.$full_path.'"');
		$file_size = filesize($full_path);
		header("Cache-Control: public");
		header("Content-Disposition: attachment; filename=".str_replace(' ', '_', basename($full_path)));
		header("Conten-Transfer-Encoding: binary");
		header("Content-Type: $mime_type");
		header("Content-Length: $file_size");
		// put file content to stdout
		readfile($full_path);
	}
	function download_file_stream($stream, $file_name){
		// send download
		$mime_type = "application/octet-stream";
		$file_size = strlen($stream);
		header("Cache-Control: public");
		header("Content-Disposition: attachment; filename=".str_replace(' ', '_', $file_name));
	eader("Conten-Transfer-Encoding: binary");
		header("Content-Type: $mime_type");
		header("Content-Length: $file_size");
		// put file content to stdout
		echo $stream;
	}
		
	function download_file_path($path, $file_name, $use_xsend = true){

		log\debug("dfp '$path'");
		//$mime_type = "application/octet-stream";
		$mime_type = shell_exec('file --mime-type -b "'.$path.'"');
		$file_size = filesize($path);
		header("Cache-Control: public");
		header('Pragma: no-cache');
		header("Cache-Control: must-revalidate");
		header("Content-Disposition: attachment; filename=\"".str_replace(' ', '_', $file_name).'"');
		header("Conten-Transfer-Encoding: binary");
		header("Content-Type: $mime_type");
		header("Content-Length: $file_size");

		//log\debug("path: $path");  // eg /disk1/backup1/workspace...
		$use_xsend = false; // TODO: disabled 31.08, not works
		if($use_xsend){  
			header('X-Sendfile: ' . $path); // DEF XSEND using X-Sendfile ; need install extension, add this line, add XSendFile on eg to .htaccess, add paths to apache config by "XSendFilePath "/disk1/backup1" "
			log\info("using xsendfile...");
			return; // exit; // when use XSEND - need no output the file myself, just exit
		}
		//  https://www.php.net/manual/en/function.fread.php
		$fp = fopen($path, 'rb');
		if(!$fp)
			throw new Exception("download_file_path: failed to open '$path'");
		fseek($fp, 0);
		$cs = 1024*128; $css=0;
		ob_end_flush(); flush();
		while(!feof($fp))
		{
			//set_time_limit(0);
			$b=fread($fp, $cs);
			print($b);
			ob_flush();
			flush();
			//log\debug("fdp p:", $css+=$cs);
		}
		fclose($fp);
		log\debug("dfp ok");
	}
	

	function wrap($array, $before, $after){
		$res = "";
		foreach($array as $item)
			$res .= $before.$item.$after;
		return $res;
	}

	// NOTE: watch about case! mysql sort is case ins by def
	function arr_cont_sort(Array $arr, $val, $from=false, $to=false){
		if($from===false) $from = 0;
		if($to===false) $to = sizeof($arr)-1;
		if($to<$from) return false;
		$mid = floor(($from+$to)/2);
		$mv = $arr[$mid];
		//echo "$from $mid $to $mv\n";
		if( $mv == $val) return true;
		return $mv > $val ? arr_cont_sort($arr, $val, $from, $mid-1) : arr_cont_sort($arr, $val, $mid+1, $to);
	}
	// input array of items - assoc arrays ; each item contains the key $key; returns array sorted by that key
	function array_sort_by_key(&$array, $key, $desc=false){
		$foo = array_column($array, $key);
		array_multisort($foo, $desc? SORT_DESC : SORT_ASC, $array);
	}
	
	function dump_stack(){
		ob_start();
		debug_print_backtrace();
		return ob_get_clean();
	}
	function dump($var){
		ob_start();
		var_dump($var);
		return ob_get_clean();
	}
	// returns first elem of path
	function parentname($path){
		$sl = strpos($path, "/");
		return $sl===FALSE? $path : substr($path, 0, $sl);
	}

	function array_insert(&$array, $position, $insert){
		if (is_int($position)) {
			array_splice($array, $position, 0, $insert);
		} else {
			$pos   = array_search($position, array_keys($array));
			$array = array_merge(    array_slice($array, 0, $pos),  $insert,   array_slice($array, $pos) 	);
		}
	}

	// DEF CSS_SETT
	// to make a css param modifiable: 
	// 	in css file (main.css) for the param string need add a comment in certain format (examples below) that contains info about how visualize it in settings.php and css struct
	// 	settings.php reads all such params and builds (using following funcs) the visual interface; entered values are saved in db (and read from db, if present; if not - defs taken from main.css)
	//	user pages include main.php instead of main.css which issues corrected values
	$css_ids;
	// !NOTE! use this instead:  function print_css_param_lp($matches, $name, $value, $mu, $params){  $matches["CAPTION"] = lp($matches["CAPTION"]); print_css_param($matches, $name, $value, $mu, $params); }
	function read_css_params($file, $callback, $cb_not=null, $params=null){
		global $css_ids; $css_ids=array(); // TODO: improper place
		$regex = '\s*(?<CSS>.+)\s*\/\*SETTING\s*(?<ID>[^\s]+)\s+(?<TYPE>[^\s]+)\s+"(?<CAPTION>[^\"]+)"\s+(?<REGEX>.+)\s*\*\/';
		//examples:
		//background-color: #808080;   			/*SETTING bgcol color "colore sfondo" (?<NAME>background-color)\: (?<VALUE>\#[0-9A-Fa-f]{6});*/
		//font-size: 14px;         /*SETTING mainfont text "dimensione font principale" ?<NAME>font-size)\: (?<VALUE>[0-9]{1,2})(?<MU>(px|em|rem));*/
		$lines = file_get_contents($file);
		$lines = preg_split("/\n/", $lines);
		$html = "";
		foreach($lines as $line){
			if( preg_match("/$regex/", $line, $matches) ){
				$reg_css = $matches["REGEX"];
				$css = $matches["CSS"]; // current css
				if( ! preg_match("/$reg_css/", $css, $ms) ){
					log\error("no match: '$reg_css' : '$css'");
					continue;
				}
				$name = $ms["NAME"];
				$value = $ms["VALUE"];
				$mu = get_or_def($ms, "MU");
				$callback($matches, $name, $value, $mu, $params);
				//echo "$id $type $name $value $mu $cap\n";
			}else if($cb_not)
				$cb_not( $line );
		}
	}
	function print_css_param($matches, $name, $value, $mu, $params){
		$cap = $matches["CAPTION"]; 
		$id = $matches["ID"]; 
		$value = get_or_def($params, $id, $value);
		global $css_ids; if( in_array($id, $css_ids) ) return; else $css_ids[] = $id;
		$type = $matches["TYPE"]; 
		switch($type){
			case "color": case "text": echo "<tr><td>$cap</td><td><input type='$type' data-id='$id' class='mc_css' value='$value' data-name='$name' data-mu='$mu'></input><span>$mu</span></td></tr>";
		}
	}
	function replace_css_param($matches, $name, $value, $mu, $lines){
		$id = $matches["ID"]; 
		$regex = "/^(\s*[^:]+:\s*)([^;!]+)((!important)?;.+)$/";
		if( $value = get_or_def( $lines, $id ) )
			echo preg_replace($regex, '${1}'.$value.$mu.'${3}', $matches[0])."\n" ;
		else
			echo $matches[0]."\n";
	}	
	function echo_line($param){ echo $param."\n"; }

	function generate_random_string($len=8, $alphabet="") {
	    if(!$alphabet)
		    $alphabet = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890';
	    $pass = array(); //remember to declare $pass as an array
	    $alphaLength = strlen($alphabet) - 1; //put the length -1 in cache
	    for ($i = 0; $i < $len; $i++) {
		$n = rand(0, $alphaLength);
		$pass[] = $alphabet[$n];
	    }
	    return implode($pass); //turn the array into a string
	}	

	//
	function extract_zip($from, $to){
		log\info("extracting zip '$from' to '$to'...");
		if(!is_dir($to)) // the client should itself remove prev files, making necessary checks
			mkdir($to);
		if(!is_dir($to))
			throw new Exception("failed to create destination dir '$to'");
		$zip = new ZipArchive;
		if( !$zip->open($from) ) 
			throw new Exception("failed to open zip file '$from'");
		$zip->extractTo($to);
		$zip->close();
	}
	function is_zip($file){
		if( ends_with($file, ".zip") ) return true;
		$res = exec("file -b \"$file\""); // TODO: escape spec sym
		//log\debug("rr:",$res);
		return strpos($res, "Zip archive data")!==FALSE;
	}

	// creates or modifies zip to make it contain given set of files
	// files_all: arr of assoc arr: (path,name)
	// full zip file path = source_path + zip_path; zip_path is the path portion to be excluded from inner zip paths
	function update_zip($files_all, $source_path, $zip_path, $zip_name){
		$zip_path_name = $source_path.$zip_path.$zip_name;
		log\info("creating cache zip, files: ", sizeof($files_all));
		log\debug("zip name: $zip_path_name");
		$zip = new ZipArchive; // apt-get install php5.6-zip
		if(! $zip->open($zip_path_name, ZipArchive::CREATE)) 
			throw new Exception("create/open zip fail"); // TODO: this may happen if file is busy (possible in ic3)
		// get list of existing files
		$zip_prev = array();
		$to_del = array();  // delete (from zip) deleted (from ws)
		for( $i = 0; $i < $zip->numFiles; $i++ ){
			$zip_prev[$i]= $zip->statIndex( $i );
			$inws=0; foreach($files_all as $file) if(substr($file["path"].$file["name"], strlen($zip_path))==$zip->statIndex( $i )["name"]){$inws=1;break;}
			if(!$inws)
				$to_del[] = $zip->statIndex( $i )["name"];
		}
		//
		set_time_limit(0);
		foreach($files_all as $file){
			$path_rel = $file["path"].$file["name"];
			//$source_path = trar_src($path_rel);
			$excl = strlen($source_path.$zip_path); // need exclude from path initial part, eg source_path/workspace/ws_name/
			$path = $source_path.$path_rel;
			$zpath = substr($path, $excl);
			log\debug("adding '$path' to '$zip_path_name'");
			$aini = NULL; $aine=0; foreach($zip_prev as $ind => $zp){ if($zp["name"]==$zpath){$aini=$ind;if(abs(filemtime($path)-$zp["mtime"])<2 )$aine=1;break;} }
			if($aine) {log\debug("already in: ", $zpath); continue;}
			if($aini===NULL){
				log\debug("add new file: ", $zpath);
				$zip->addFile($path, $zpath);
			}else{
				log\debug("replace existing file: ", $zpath);
				//log\debug("mtime of $zpath: ",  date("F d Y H:i:s.", filemtime($path)) );
				log\debug("mtime of $zpath: ",  filemtime($path) );
				$zip->addFile($path, $zpath);
				//$zip->replaceFile($path, $aini);
			}
		}
		foreach($to_del as $file){
			log\debug("deleting file '$file' from cache zip");
			$zip->deleteName($file);
		}
		if(!$zip->close())
			throw new Exception("failed to write zip");
		log\info("files added");
		return $zip_path_name;
	}


	function move_dir_files($from, $to, $collision_action="replace", $rem_src=true){ // col act - replace/backup(rename existing)/update(
		$ca = $collision_action=="replace"? "" : "--".$collision_action;
		$rs = $rem_src? "--remove-source-files" : "";
		return exec_log("rsync $rs $ca -rt $from $to"); // TODO: maybe check if already exists and replace/rename/skip 
	}

	// VIRUS
	function check_virus($path){ // use 'X5O!P%@AP[4\PZX54(P^)7CC)7}$EICAR-STANDARD-ANTIVIRUS-TEST-FILE!$H+H*' to imitate virus
		$output = array();
		$result = 0;
		$msg = "";
		exec_log("/opt/sophos/bin/savscan \"$path\"", $output, $result);
		if($result==127) // TODO: maybe need intercept other errors; savscan ret res is used as indicator if has virus (<>0) but non zero res may be as res of other errors
			throw new Exception("savscan not found");
		foreach($output as $line)
			if( preg_match("/>>> Virus '(.+)' found/", $line, $m) )
				$msg = $m[1];
		//echo "$result \n";
		return array("virus" => $result, "virus_msg" => $msg);
	}
	function add_sess_err($name, $err_msg){
		if(!isset($_SESSION["errors"]))
			$_SESSION["errors"] = array();
		foreach($_SESSION["errors"] as &$error)
			if($error["name"] == $name)
				{$error["message"] = $err_msg; return;}
		$_SESSION["errors"][] = array("name" => $name, "message" => $err_msg);
		//$_SESSION["errors"][$id] = $error;
	}
	function find_sess_err($name){
		if(isset($_SESSION["errors"]))
			foreach($_SESSION["errors"] as &$error)
				if($error["name"] == $name)
					return $error["message"];
		return "";
		//return get_or_def2($_SESSION, "errors", $id);
		/*if(isset($_SESSION["errors"]))
			return find_array_key_value( $_SESSION["errors"], $key, $val );
		return null;*/
	}

	// splits text to array of lines
	function split_lines($text){return preg_split("/\r\n|\n|\r/", $text, -1, PREG_SPLIT_NO_EMPTY);}
		
	function get_client_ip($include_port = false){
		$port = $include_port? ":".$_SERVER["REMOTE_PORT"] : "";
		if ( !empty($_SERVER['HTTP_CLIENT_IP']) )
			return $_SERVER['HTTP_CLIENT_IP'].$port; // Check IP from internet.
		if (!empty($_SERVER['HTTP_X_FORWARDED_FOR']) ) 
			return $_SERVER['HTTP_X_FORWARDED_FOR'].$port; // Check IP is passed from proxy.
		if (!empty($_SERVER['REMOTE_ADDR']) ) 
			return $_SERVER['REMOTE_ADDR'].$port; // Check IP is passed from proxy.
		return "None";
	}
	// checks if first let is capital
	function isCapital($word){ return  preg_match('~^\p{Lu}~u', $word) ; } // use ucfirst to make 1st let capit
	// TODO: may add check in
	function add_sep_elem($list, $elem, $sep=";"){ return $list? $list.$sep.$elem : $elem; }
	function remove_sep_elem($list, $elem, $sep=";"){ 
		$ge = preg_split("/$sep/", $list);
		$ge = array_diff($ge, array($elem));
		return join($sep, $ge);
	}

	if( !function_exists("array_key_last") ){
		function array_key_last($arr){
			$ak = array_keys($arr);
			return sizeof($ak)? end($ak) : null;
		}
	}
?>
