<?php
        require_once(dirname(__FILE__)."/../path.php");
        require_once(proj_path."utils/utils.php");
        require_once(proj_path."model/db.php"); // curr user, find_email_id

	$lang_tr; // to use in lp; cache, to avoid read trans file each time
	// find curr lang and read translations as an array;  () -> assoc. array
	function lang_read($lang=''){
		if($lang) // DEF USER_LANG using another lang (not that of curr user) to send an email to some receiver
			return lang_parse(proj_path."view/lang/$lang"); 
		if(session_id() == ''){
			session_start(); // TODO: this causes HAS problem if called after some output
			//log\debug("LANG");
			//log\debug( dump_stack() );
		}
		if( isset($_SESSION["lang_tr"]) ) {
			//log\debug(dump(   $_SESSION["lang_tr"] ));
			return $_SESSION["lang_tr"];
		} // avoid re-read same; lang_tr is reset after set  new lang
		$lang = lang_get();
		log\info("setting language '$lang'");
		$lang_file = proj_path."view/lang/$lang";
		$_SESSION["lang_tr"] = lang_parse($lang_file);
		//log\debug(dump(   $_SESSION["lang_tr"] ));
		return $_SESSION["lang_tr"];
	}
	function lang_set($code){
		if(session_id() == '')
			session_start();
		$lp = get_or_def($_SESSION, "lang");
		$_SESSION["lang"] = $code;
		if($lp!=$code)
			unset($_SESSION["lang_tr"]);
		lang_read();
	}
	function lang_get(){
		if(session_id() == '')
			session_start(); // TODO: guess no need
		if( isset( $_SESSION["lang"] ) ) return $_SESSION["lang"];
		$user_id = get_curr_user_id();
		$lang = "";
		if( $user_id )
			$lang = lang_get_db($user_id);
		if(!$lang)
			$lang = lang_def;
		lang_set($lang);
		return $lang;
	}
	function lang_get_email($user_email){ // get lang by email
		return ($uid=find_email_id($user_email))? lang_get_db($uid) : lang_def; // USER_LANG
	}
	function lang_reset(){
		unset($_SESSION["lang"]);
		unset($_SESSION["lang_tr"]);
	}
	function lang_get_db($user_id, $def=''){$lang=db\select_field("settings", "pvalue", "pname='lang' and user_id=$user_id") ; return $lang?$lang:$def; }
	function lang_get_curr(){return isset( $_SESSION["lang"] )? $_SESSION["lang"]  : lang_def; }
	// parse translations from raw text to array; full file name -> array
	function lang_parse($lang_file_name){
		$tr = array();
		if(file_exists($lang_file_name)){
			$raw = file_get_contents($lang_file_name);
			$lines = split_lines($raw);
			foreach($lines as $line){
				if(preg_match("/^(\w+)[\t\s]*([^\t\s].*)$/", $line, $m) // note : russian chars not matched by \w
				|| preg_match("/^(\w+)[\t\s]*\"([^\"]+)\"$/", $line, $m))
					$tr[$m[1]] = $m[2];
				else
					log\error("wrong line in '$lang_file_name': '$line'");
			}
		}
		return $tr;
	}
	// translate given html file; rel file name -> str
	// may pass additional key->val array in $vals
	function lang_html_load($html_file_name, $abs=false, $vals=array(), $lang=''){ // file name relative if abs=false
		if(!$abs) $html_file_name = proj_path.$html_file_name;
		$raw = file_get_contents($html_file_name);
		// values are replaced first; collisions are possible between passed values and translations; so values replaced first, while they are chosen so as to not duplicate translations used in the template
		if( sizeof($vals) )
			$raw = replace_keys($raw, $vals, $del_empt=3);  // empty not deleted (left to translate), only empty sections are deleted (while lang not uses sections)
		return lpp_html($raw, $lang); // 
	}
	//
	function lp($name, $lang_tr=null){
		if(!$lang_tr)
			$lang_tr = lang_read();
		$ic = isCapital($name); $name = strtolower($name);// now may pass first let capital to have it capital in result
		$res = isset($lang_tr[$name])? $lang_tr[$name] : str_replace("_"," ",$name);
		return $ic? ucfirst($res) : $res;
	}
	function lpp($str, $lang_tr=null){
		if(!$lang_tr)
			$lang_tr = lang_read();
		while( preg_match('/\$(\w+)\$/', $str, $m) ){ // NOTE: faster then replace_keys
			$str = str_replace('$'.$m[1].'$', lp($m[1], $lang_tr), $str);
		}
		return $str;
	}
		
	function lpp_html($str, $lang=""){ // $lang is for USER_LANG
		$lang_tr = lang_read($lang);
		while( preg_match('/\$(\w+)\$/', $str, $m) ){ // NOTE: faster then replace_keys
			$str = str_replace('$'.$m[1].'$', htmlspecialchars(lp($m[1], $lang_tr), ENT_SUBSTITUTE), $str);
		}
		return $str;
	}
		
?>
