<?php
// DEF FIDE FIelds DEfinitions format
// contains fields definitions for all used tables
// contains name => caption pairs; if caption is empty - is not to be shown (or invisible)
// if field caption is prepended by # - means need add data-field to the tr (and remove #)
// field declarations are passed by controller to view/table.php:render_table
// 6.06.18 added menu definition here (previoius was in controller)

        require_once(dirname(__FILE__)."/lang.php");

	// LB: here main menu (horizontal) contains only logo referring index.php
	function get_main_menu($is_admin=0){
		$menu = array(	
				// 'logo' => 'index.php', TODO TODO 1: use portal icon as main icon	
		); // menu handlers are in js (js/archive.js)
		return $menu;
	}
	function get_main_menu_mobile($is_admin=false){
		return array(	
			lp("settings") => "settings.php",
		); 
	}
	
	// UR
	$mainmenu = array(
		"home" => 		array("title" => lp("Home"), 		"icon" => "fa fa-home fa-fw-20", 		"class" => "mc_home", 		"url" => "index.php"),
		"campaigns" => 	array("title" => lp("Campaigns"), 	"icon" => "fa fa-globe fa-fw-20", 		"class" => "mc_campaigns", 	"url" => "campaigns.php"),
		"shops" => 	array("title" => lp("Layouts"), 		"icon" => "fa fa-shopping-bag fa-fw-20","class" => "mc_stores", 	"url" => "shops.php"),
		"orders" => 	array("title" => lp("Orders"), 		"icon" => "fas fa-calendar-check fa-fw-20","class" => "mc_apf", 	"url" => "orders.php"),
		"users" => 		array("title" => lp("Users"), 		"icon" => "fa fa-users fa-fw-20", 		"class" => "mc_users", 		"url" => "users.php"),
		"groups" => 	array("title" => lp("Groups"), 		"icon" => "fas fa-users-cog fa-fw-20", 	"class" => "mc_groups", 	"url" => "groups.php"),
		"hires" => 		array("title" => lp("High_resolution"), "icon" => "fas fa-image fa-fw-20", 	"class" => "mc_hires", 	"url" => "hires.php"),
		"archive" => 	array("title" => lp("Orders_archive"), "icon" => "fa fa-archive fa-fw-20", 	"class" => "mc_archive","url" => "orders.php?arch")
	);

	// LANG thus must correspond to installed langs; to install a lang: need have view/lang/code file with translations; need img/code.png file with image
	$lang_list = array("en" => "english"/*, "ru" => "русский"*/,"it" => "italiano");

	// -------------------------------   USER  ------------------------------------------

	$user_list_fields = array(
		"RES_checked" => "C", // CB_SEL_REC
		"id" => "#",
		"name" => lp("name"),
		"email" => lp("email"),
		"user_role" => lp("role"),
		"date_login" => '#'.lp("date_login"),
		"RES_email" => "email" // SEND_CREDENTIALS 
	);
	$user_search_fields = array (
		 // NOTE: 'predicative' added 29.11.18 to realize ability to 'and' (instead of usual 'or') the search criterion (for the case when it's an array)
		 // NOTE: FILTERPATH to enable it use ttc_filter_path class
		 array('id' => "sf_name", 	"type" => "text", 	"field" => "name", 	"operation" => "like",	"caption" => lp('name'), 	"string" => 1, 	"class" => "", 	'placeholder' => 'nome', 'predicative' => 'and'), 
		 array('id' => "sf_email", 	"type" => "text", 	"field" => "email", 	"operation" => "like",	"caption" => lp('email'), 	"string" => 1, 	"class" => "", 	'placeholder' => 'ping@pong.it', 'predicative' => 'and'), 
		 array('id' => "sf_role", 	"type" => "select", 	"field" => "user_role", 	"operation" => "like",	"caption" => lp('role'), 	"string" => 1, 	"class" => "ttc_search_select", 	'placeholder' => '', 'predicative' => 'or', "options" => get_user_roles("user"), "multiple" => "multiple"),  // TODO multisel
		 array('id' => "sf_data_from","type" => "date", 	"field" => "date_login", 	"operation" => ">=", 	"caption" => lp('from'),		"string" => 1, 	"class" => "ttc_search_datepicker"),
		 array('id' => "sf_data_till","type" => "date", 	"field" => "date_login", 	"operation" => "<=",	"caption" => lp('to'),		"string" => 1, 	"class" => "ttc_search_datepicker")
	);
	$new_user = array (
		 array('id' => "nu_lang",	"type" => "select", "field" => "lang", 	"operation" => "=",	"caption" => lp("language"),"string" => 1, 	"class" => "ttc_search_select", "options" => array_keys($lang_list)),  // DEF ADM_EDIT_LANG to allow admin to edit lang of a user
		 array('id' => "nu_name", 	"type" => "text", 	"field" => "name", 	"caption" => lp("name"), 	"string" => 1), 
		 array('id' => "nu_email", 	"type" => "text", 	"field" => "email", 	"caption" => lp("email"), 	"string" => 1), 
		 array('id' => "nu_pass", 	"type" => "text", 	"field" => "pass", 	"caption" => lp("password"), 	"string" => 1), 
		 array('id' => "nu_user_role",	"type" => "select", "field" => "user_role", 	"operation" => "=",	"caption" => lp("role"),"string" => 1, 	"class" => "ttc_search_select", "options" => get_user_roles("user"), "multiple" => "multiple"), 
		 array('id' => "nu_user_group_role",	"type" => "select", "field" => "user_group_role", 	"operation" => "=",	"caption" => lp("group_roles"),"string" => 1, 	"class" => "ttc_search_select", "keyval" => array(), "multiple" => "multiple")  // DEF SEL_USER_GROUP
	);

	// -------------------------------   SHOP  ------------------------------------------
	$shop_list_fields = array(
		"RES_checked" => "C", // CB_SEL_REC
		"RES_lb" => "Lightboxes", 
		"id" => "#id",
		"code" => lp("code"),
		"name" => lp("name"),
		"city" => lp("city"),
		"address" => lp("address"),
		"area" => lp("area"),
		"country" => lp("country"),
		"manager" => lp("manager"),
		"visual" => lp("visual"),
		"production" => lp("production"),
		"lbc_todo_count" => "#".lp("state"),
		"lbc_count" => "#".lp("count"),
		"order_id" => "#".lp("order")
	);
	function get_shop_search_fields($shops){
		cass_init($shops, $are, $cou, $cit, $sho); // CASS
		$class = "form-control"; // $class = "ttc_search_select"; 
		$shop_search_fields = array (
			// NOTE: 'predicative' added 29.11.18 to realize ability to 'and' (instead of usual 'or') the search criterion (for the case when it's an array)
			// NOTE: FILTERPATH to enable it use ttc_filter_path class
			array('id' => "sf_code", 	"type" => "text", 	"field" => "code", 	"operation" => "like",	"caption" => lp('code'), 	"string" => 1, 	"class" => "", 	'placeholder' => 'code', 'predicative' => 'and'), 
			array('id' => "sf_area",	 	"type" => "select",	"field" => "area",	 	"operation" => "like",	"caption" => lp('area'    ),	"string" => 1, 	"class" => $class, 'predicative' => 'and', "items" => $are), 
			array('id' => "sf_country", 	"type" => "select",	"field" => "country", 	"operation" => "like",	"caption" => lp('country' ),	"string" => 1, 	"class" => $class, 'predicative' => 'and', "items" => $cou), 
			array('id' => "sf_city", 		"type" => "select",	"field" => "city", 		"operation" => "like",	"caption" => lp('city'    ), 	"string" => 1, 	"class" => $class, 'predicative' => 'and', "items" => $cit), 
			array('id' => "sf_shop_name", 		"type" => "select",	"field" => "name", 		"operation" => "like",	"caption" => lp('name'    ), 	"string" => 1, 	"class" => $class, 'predicative' => 'and', "items" => $sho), 
			//array('id' => "sf_name", 	"type" => "text", 	"field" => "name", 	"operation" => "like",	"caption" => lp('name'), 	"string" => 1, 	"class" => "", 	'placeholder' => 'nome', 'predicative' => 'and'), 
			array('id' => "sf_address", 	"type" => "text", 	"field" => "address", 	"operation" => "like",	"caption" => lp('address'), 	"string" => 1, 	"class" => "", 	'placeholder' => 'address', 'predicative' => 'and') 
		);
		return $shop_search_fields;
	}
	// present only in admin mode
	function get_shop_search_fields_admin($visuals, $prods){
		return $shop_search_fields_vp = array (
			 array('id' => "sf_visual", 	"type" => "select", 	"field" => "visual", 	"operation" => "=",	"caption" => lp('visual'), 	"string" => 1, 	"class" => "ttc_search_select", 	'placeholder' => 'visual', 'predicative' => 'and', "options" => $visuals), 
			 array('id' => "sf_production", 	"type" => "select", 	"field" => "production", 	"operation" => "=",	"caption" => lp('production'), 	"string" => 1, 	"class" => "ttc_search_select", 	'placeholder' => 'production', 'predicative' => 'and', "options" => $prods) 
		);
	}
	// seen only for visuals (in context of campaign): 
	$shop_search_fields_camp = array (
		array('id' => "sf_lbc_todo_count", 	"type" => "select", 	"field" => "lbc_todo_count", 	"operation" => "=",	"caption" => 'done', 	"string" => 0, 	"class" => "ttc_search_select",    "keyval" => array("0"=>"yes","1"=>"no"), "default"=>'3') 
	);
	function get_new_shop_fields($visuals, $prods){ return
	$new_shop = array (
		 array('id' => "ns_name", 	"type" => "text", 	"field" => "name", 	"caption" => lp("name"), 	"string" => 1), 
		 array('id' => "ns_code", 	"type" => "text", 	"field" => "code", 	"caption" => lp("code"), 	"string" => 1), 
		 array('id' => "ns_area", 	"type" => "text", 	"field" => "area", 	"caption" => lp("area"), 	"string" => 1), 
		 array('id' => "ns_country", 	"type" => "text", 	"field" => "country", 	"caption" => lp("country"), 	"string" => 1), 
		 array('id' => "ns_city", 	"type" => "text", 	"field" => "city", 	"caption" => lp("city"), 	"string" => 1), 
		 array('id' => "ns_address", 	"type" => "text", 	"field" => "address", 	"caption" => lp("address"), 	"string" => 1), 
		 array('id' => "ns_manager", 	"type" => "text", 	"field" => "manager", 	"caption" => lp("manager"), 	"string" => 1), 
		 array('id' => "ns_visual_id",		"type" => "select", "field" => "visual_id",		"caption" => lp("visual"), 		"string" => 1, "class" => "ttc_search_select", "keyval" => $visuals), 
		 array('id' => "ns_production_id", "type" => "select",	"field" => "production_id",	"caption" => lp("production"), 	"string" => 1, "class" => "ttc_search_select", "keyval" => $prods) 
	);}


	// -------------------------------  CAMP  ------------------------------------------
	$camp_list_fields = array(
		"RES_checked" => "C", // CB_SEL_REC
		"RES_detail" => "Details", 
		"id" => "#",
		"name" => "#".lp("name"),
		"season" => lp("season"),
		"camp_year" => lp("year"),
		"date_from" => "#".lp("validity_date_from"), // NOTE: need dates in js to check validity on camp open
		"date_till" => "#".lp("validity_date_till"),
		"dl_visual" => "#".lp("visual_deadline"),
		"dl_produce" => "#".lp("produce_deadline"),
		"dl_approve" => "#".lp("approve_deadline"),
		"camp_state" => "#".lp("state")
	);
	$y = date("Y"); $ys = array($y-2, $y-1, $y, $y+1);
	$camp_search_fields = array (
		 array('id' => "sf_name", 	"type" => "text", 	"field" => "name", 	"operation" => "like",	"caption" => lp('name'), 	"string" => 1, 	"class" => "", 	'placeholder' => 'nome', 'predicative' => 'and'), 
		 array('id' => "sf_date_from", 	"type" => "date", 	"field" => "date_from", 	"operation" => ">=",	"caption" => lp('validity_date_from'), 	"string" => 1, 	"class" => "ttc_search_datepicker", 	'placeholder' => 'date', 'predicative' => 'and'), 
		 array('id' => "sf_date_till", 	"type" => "date", 	"field" => "date_till", 		"operation" => "<=",	"caption" => lp('validity_date_till'), 	"string" => 1, 	"class" => "ttc_search_datepicker", 	'placeholder' => 'date', 'predicative' => 'and'), 
		 array('id' => "sf_season",	"type" => "select",	"field" => "season",	"operation" => "=",	"caption" => lp('season'), 	"string" => 1, 	"class" => "ttc_search_select", 'predicative' => 'and', "options" => array("FW","SS")), 
		 array('id' => "sf_camp_year", 	"type" => "select",	"field" => "camp_year",	"operation" => "=",	"caption" => lp('year'), 	"string" => 0, 	"class" => "ttc_search_select", 'predicative' => 'and', "options" => $ys), 
		 array('id' => "sf_camp_state",	"type" => "select",	"field" => "camp_state","operation" => "=",	"caption" => lp('state'),"string" => 1,	"class" => "ttc_search_select", 'predicative' => 'and', "options" => array('draft','opened','published','closed','archived')) 
	);
	$new_camp = array (
		 array('id' => "nc_name", 		"type" => "text", 	"field" => "name", 			"caption" => lp("name"), 	"string" => 1), 
		 array('id' => "nc_camp_year", 		"type" => "text", 	"field" => "camp_year",		"caption" => lp("year"), 	"string" => 1, "default" => date("Y")), 
		 array('id' => "nc_season", 	"type" => "select", "field" => "season",		"operation" => "=",	"caption" => 'season',	"string" => 1, 	"class" => "ttc_search_select", "options" => array("SS", "FW") ),  // SBU 
		 array('id' => "nc_date_from", 	"type" => "date", 	"field" => "date_from", 	"caption" => lp("validity_date_from"), 	"string" => 1, 	"class" => "ttc_search_datepicker"), 
		 array('id' => "nc_date_till", 	"type" => "date", 	"field" => "date_till", 	"caption" => lp("validity_date_till"), 	"string" => 1, 	"class" => "ttc_search_datepicker"), 
		 array('id' => "nc_dl_visual", 	"type" => "date", 	"field" => "dl_visual", 	"caption" => lp("visual_deadline"), 	"string" => 1, 	"class" => "ttc_search_datepicker"), 
		 array('id' => "nc_dl_produce",	"type" => "date", 	"field" => "dl_produce", 	"caption" => lp("produce_deadline"), 	"string" => 1, 	"class" => "ttc_search_datepicker"), 
		 array('id' => "nc_dl_approve",	"type" => "date", 	"field" => "dl_approve", 	"caption" => lp("approve_deadline"), 	"string" => 1, 	"class" => "ttc_search_datepicker"),
		 array('id' => "nc_countries", 	"type" => "hidden", "field" => "countries", 	"caption" => "", 	"string" => 1) 
	);


	// -------------------------------  ORDERS ------------------------------------------
	// v_orders table
				// TODO: date_done only in graphic
	function get_order_list_fields($alias){
		$order_list_fields = array(
			"RES_checked" => "C", // CB_SEL_REC
			"RES_detail" => "Details", // show triples
			"id" => "#id",
			"date_create" => lp("date_create"),
			"date_done" => lp("date_done"),
			"camp_name" => lp("campaign"),
			"shop_name" => lp("store"),
			"city" => lp("city"),
			"country" => lp("country"),
			"order_user" => lp("user"),
			"camp_id" => "#",
			"shop_id" => "#",
			"order_state1" => "#".lp("state") // OS1
		);
		/* replaced by OS1
		//if($alias=="orders_PRODUCTION") 
			$order_list_fields["uploaded"] = "uploaded";
			$order_list_fields["order_state"] = "accepted"; // ACCORD
		//if($alias=="orders_PRODUCTION" || $alias=="orders_LOCAL_VISUAL" || $alias=="orders_GRAPHIC") 
			$order_list_fields["approved"] = "approved";
		//if($alias=="orders_LOCAL_VISUAL" || $alias=="orders_GRAPHIC") 
			$order_list_fields["printed"] = "printed";
		*/
		return $order_list_fields;
	}
	function cass_init($shops, &$are, &$cou, &$cit, &$sho){
		// DEF CASS - cascaded shop select; if usver eg select areay - show countries/cit/shops only of that area
		foreach($shops as &$shop) $shop["data"] = "data-area=\"".$shop["area"]."\" data-country=\"".$shop["country"]."\" data-city=\"".$shop["city"]."\"";
		$are = array(); $cou = array(); $cit = array(); $sho = array();
		foreach($shops as $shop){ 
			if( !array_contains_keyval($are, "value", $v=$shop["area"] 	 ) ){ $are[]= array("value"=>$v, "text"=>$v, "data"=>$shop["data"]); } // NOTE: eg for area data-country is not necessary - just rubbish = first country 
			if( !array_contains_keyval($cou, "value", $v=$shop["country"]) ){ $cou[]= array("value"=>$v, "text"=>$v, "data"=>$shop["data"]); }
			if( !array_contains_keyval($cit, "value", $v=$shop["city"] 	 ) ){ $cit[]= array("value"=>$v, "text"=>$v, "data"=>$shop["data"]); }
			if( !array_contains_keyval($sho, "value", $v=$shop["name"] 	 ) ){ $sho[]= array("value"=>$v, "text"=>$v, "data"=>$shop["data"]); }
		}
		array_sort_by_key($cou, "text");
		array_sort_by_key($cit, "text");
		array_sort_by_key($sho, "text");
	}
	function get_order_search_fields($shops){
		$order_states = array("draft", "accepted", "uploaded", "approved", "rejected", "printed");
		cass_init($shops, $are, $cou, $cit, $sho); // CASS
		$class = "form-control"; // $class = "ttc_search_select"; 
		$order_search_fields = array (
			 array('id' => "sf_id", 	"type" => "text", 	"field" => "id", 	"operation" => "=",	"caption" => lp('ID'), 	"string" => 0, 	"class" => "", 	'placeholder' => '123', 'predicative' => 'and'), 
			 array('id' => "sf_camp_name", 	"type" => "text", 	"field" => "camp_name", 	"operation" => "like",	"caption" => lp('campaign'), 	"string" => 1, 	"class" => "", 	'placeholder' => '', 'predicative' => 'and'), 
			 //array('id' => "sf_camp", 		"type" => "select",	"field" => "camp_id", 		"operation" => "=",		"caption" => lp('campaign'    ),"string" => 1, 	"class" => "ttc_search_select",*/ 'predicative' => 'and', "options" => $campaigns), 
			 array('id' => "sf_area",	 	"type" => "select",	"field" => "area",	 	"operation" => "like",	"caption" => lp('area'    ),	"string" => 1, 	"class" => $class, 'predicative' => 'and', "items" => $are), 
			 array('id' => "sf_country", 	"type" => "select",	"field" => "country", 	"operation" => "like",	"caption" => lp('country' ),	"string" => 1, 	"class" => $class, 'predicative' => 'and', "items" => $cou), 
			 array('id' => "sf_city", 		"type" => "select",	"field" => "city", 		"operation" => "like",	"caption" => lp('city'    ), 	"string" => 1, 	"class" => $class, 'predicative' => 'and', "items" => $cit), 
			 array('id' => "sf_shop_name", 	"type" => "select",	"field" => "shop_name",	"operation" => "like",	"caption" => lp('store'    ),	"string" => 1, 	"class" => $class, 'predicative' => 'and', "items" => $sho), 
			 array('id' => "sf_user", 		"type" => "text", 	"field" => "order_user","operation" => "like",	"caption" => lp('user'    ), 	"string" => 1, 	"class" => "", 'predicative' => 'and'), 
			 array('id' => "sf_date_from", 	"type" => "date", 	"field" => "date_create", 	"operation" => ">=",	"caption" => lp('validity_date_from'), 	"string" => 1, 	"class" => "ttc_search_datepicker", 	'placeholder' => 'date', 'predicative' => 'and'), 
			 array('id' => "sf_date_till", 	"type" => "date", 	"field" => "date_create", 	"operation" => "<=",	"caption" => lp('validity_date_till'), 	"string" => 1, 	"class" => "ttc_search_datepicker", 	'placeholder' => 'date', 'predicative' => 'and'), 
			 array('id' => "sf_order_state1", 	"type" => "select", 	"field" => "order_state1", 	"operation" => "=",	"caption" => 'state', 	"string" => 1, 	"class" => "ttc_search_select",    "options" => $order_states, "multiple" => "multiple") 
		);
		/* replaced by OS1
		$keyval = array("1"=>"yes","0"=>"no");
		$order_search_fields[]= array('id' => "sf_uploaded", 	"type" => "select", 	"field" => "uploaded", 	"operation" => "=",	"caption" => 'uploaded', 	"string" => 0, 	"class" => "ttc_search_select",    "keyval" => $keyval, "default"=>'3'); 
		$order_search_fields[]= array('id' => "sf_approved", 	"type" => "select", 	"field" => "approved", 	"operation" => "=",	"caption" => 'approved', 	"string" => 0, 	"class" => "ttc_search_select",    "keyval" => $keyval, "default"=>'3'); 
		$order_search_fields[]= array('id' => "sf_printed", 	"type" => "select", 	"field" => "printed", 	"operation" => "=",	"caption" => 'printed', 	"string" => 0, 	"class" => "ttc_search_select",    "keyval" => $keyval, "default"=>'3'); 
		*/

		/*//if($alias=="orders_PRODUCTION") $order_search_fields[]=
			 $order_search_fields[]= array('id' => "sf_uploaded", 	"type" => "checkbox", 	"field" => "uploaded", 	"operation" => "=",	"caption" => 'uploaded', 	"string" => 0, 	"class" => "",    "default" => "checked"); 
		//if($alias=="orders_PRODUCTION" || $alias=="orders_LOCAL_VISUAL" || $alias=="orders_GRAPHIC") $order_search_fields[]=
			 $order_search_fields[]= array('id' => "sf_approved", 	"type" => "checkbox", 	"field" => "approved", 	"operation" => "=",	"caption" => 'approved', 	"string" => 0, 	"class" => "",    "default" => "checked"); 
		// TODO: not sure this is used
		//if($alias=="orders_LOCAL_VISUAL" || $alias=="orders_GRAPHIC") $order_search_fields[]=
			 $order_search_fields[]= array('id' => "sf_printed", 	"type" => "checkbox", 	"field" => "printed", 	"operation" => "=",	"caption" => 'printed', 	"string" => 0, 	"class" => "",    "default" => "checked"); */
		return $order_search_fields;
	}

	// -------------------------------  TRIPLES ------------------------------------------
	// app_lbs table
	$triple_list_fields = array(
		"RES_checked" => "C", // CB_SEL_REC
		"id" => "#id",
		"path" => lp("preview"),
		"name_mini" => '#'.lp("subject_name"),
		"name" => lp("lightbox"),
		"app_state" => lp("status"),
		"date_done" => lp("delivery date"),
		"RES_action" => "action", // upload, approve/reject, download
		"app_id" => "#",
		"img_id" => "#", // PREVIEW
		"t" => "#",	"l" => "#",	"r" => "#",	"b" => "#"   // used to cals img size in
	);
	$triple_search_fields = array (
		 array('id' => "sf_camp_id","type" => "text","field" => "camp_id","operation" => "=","caption" => lp('ID'),	"string" => 0,"class" => "",'placeholder' => '123','predicative' => 'and'),
		 array('id' => "sf_shop_id","type" => "text","field" => "shop_id","operation" => "=","caption" => lp('ID'),	"string" => 0,"class" => "",'placeholder' => '123','predicative' => 'and')
	);


	$apf_search_fields = array (
		 // NOTE: 'predicative' added 29.11.18 to realize ability to 'and' (instead of usual 'or') the search criterion (for the case when it's an array)
		 // NOTE: FILTERPATH to enable it use ttc_filter_path class
		 array('id' => "sf_name", 	"type" => "text", 	"field" => "name", 		"operation" => "like",	"caption" => lp('name'), 	"string" => 1, 	"class" => "", 	'placeholder' => 'nome', 'predicative' => 'and'), 
		 array('id' => "sf_owner", 	"type" => "text", 	"field" => "owner", 	"operation" => "like",	"caption" => lp('owner'), 	"string" => 1, 	"class" => "", 	'placeholder' => 'ping@pong.it', 'predicative' => 'and'), 
		 array('id' => "sf_data_from","type" => "date",	"field" => "date_ins", 	"operation" => ">=", 	"caption" => lp('from'),	"string" => 1, 	"class" => "ttc_search_datepicker"),
		 array('id' => "sf_data_till","type" => "date",	"field" => "date_ins", 	"operation" => "<=",	"caption" => lp('to'),		"string" => 1, 	"class" => "ttc_search_datepicker")
	);
	$apf_list_fields = array(
		"RES_checked" => "C", // CB_SEL_REC
		"id" => "#",
		"name" => lp("name"),
		"owner" => lp("owner"),
		"date_ins" => '#'.lp("date_ins")
	);

	// ------------------------------- GROUPS ------------------------------------------
	$group_list_fields = array(
		"id" => "#id",
		"name" => "#".lp("name"),
		"email" => lp("emails"),
		"user_role" => lp("role"),
		"date_login" => '#'.lp("date_login")
	);

	// ------------------------------- EVENTS ------------------------------------------
	$event_list_fields = array(
		"RES_checked" => "C", // CB_SEL_REC
		"id" => "#",
		"date_event" => lp("date"),
		"order_id" => lp("order"),
		"camp_name" => lp("campaign"),
		"shop_name" => lp("store"),
		"message" => lp("event"),
		"source_group" => lp("from_group"),
		"source_group_id" => "#", // used to find out in or out
		"source_user" => lp("from_user"),
		"RES_dest" => lp("to"), 
		"RES_link" => lp("page_link"), // LINK_DUP
		"source_order_link" => "#"
		//"dest_group" => lp("to"),
	);

	$event_search_fields = array (
		 array('id' => "sf_date_event_from",	"type" => "date", 	"field" => "date_event", 	"operation" => ">=",	"caption" => lp('date_from'), 	"string" => 1, 	"class" => "ttc_search_datepicker", 	'placeholder' => 'date', 'predicative' => 'and'), 
		 array('id' => "sf_date_event_till",	"type" => "date", 	"field" => "date_event", 	"operation" => "<=",	"caption" => lp('date_till'), 	"string" => 1, 	"class" => "ttc_search_datepicker", 	'placeholder' => 'date', 'predicative' => 'and'), 
		 array('id' => "sf_order_id", 	"type" => "text", 	"field" => "order_id", 	"operation" => "=",	"caption" => lp("order_id"), 	"string" => 0, 	"class" => "", 	'placeholder' => '123', 'predicative' => 'and'), 
		 array('id' => "sf_camp_name", 	"type" => "text", 	"field" => "camp_name", 	"operation" => "like",	"caption" => lp('campaign'), 	"string" => 1, 	"class" => "", 	'placeholder' => '', 'predicative' => 'and'), 
		 array('id' => "sf_shop_name", 	"type" => "text", 	"field" => "shop_name", 	"operation" => "like",	"caption" => lp('store'), 	"string" => 1, 	"class" => "", 	'placeholder' => '', 'predicative' => 'and'), 
		 array('id' => "sf_message", 	"type" => "text", 	"field" => "message", 	"operation" => "like",	"caption" => lp('message'), 	"string" => 1, 	"class" => "", 	'placeholder' => '', 'predicative' => 'and'), 
		 array('id' => "sf_source_group", "type" => "text",	"field" => "source_group", "operation" => "like",	"caption" => lp('sender_group'), "string" => 1, 	"class" => "", 'predicative' => 'and'), 
		 array('id' => "sf_source_user", "type" => "text",	"field" => "source_user", "operation" => "like",	"caption" => lp('sender_user'), "string" => 1, 	"class" => "", 'predicative' => 'and')
		 //array('id' => "sf_dest_group", "type" => "text",	"field" => "dest_group", "operation" => "like",	"caption" => lp('receiver_group'), "string" => 1, 	"class" => "", 'predicative' => 'and') 
	);


	// ------------------------------- SETTINGS ------------------------------------------
	$change_pass = array(
		 array('id' => "ms_pass_old", 	"type" => "text",	"caption" => lp('old_password'), 'placeholder' => '', "class" => "ms_pass"),
		 array('id' => "ms_pass1", 	"type" => "text",	"caption" => lp('new_password'), 'placeholder' => '', "class" => "ms_pass"), 
		 array('id' => "ms_pass2", 	"type" => "text",	"caption" => lp('confirm_password'), 'placeholder' => '', "class" => "ms_pass") 
	);

?>

